 /* ++ BUILD Version: 0001                                            */
 /*    -- Increment this if a change has global effects               */
 /*                                                                   */
 /* Copyright (c) 1996-1999  Microsoft Corporation                    */
 /*                                                                   */
 /* Module Name:                                                      */
 /*                                                                   */
 /*     dsgetdc.cpy                                                   */
 /*                                                                   */
 /* Abstract:                                                         */
 /*                                                                   */
 /*     This file contains structures, function prototypes, and       */
 /*     definitions for the DsGetDcName API.                          */
 /*                                                                   */
 /* Environment:                                                      */
 /*                                                                   */
 /*     User Mode - Win32                                             */
 /*                                                                   */
 /* Notes:                                                            */
 /*                                                                   */
 /* --                                                                */


 %dcl #DSGETDC_ char ext;
 %if #DSGETDC_ = '' %then %do;
 %#DSGETDC_ = 'Y';

 %dcl UNICODE char ext;

 %dcl #WINDEF_ char ext;
 %if #WINDEF_ = '' %then %do;
 %include windef;
 %end;

 %dcl DSGETDCAPI char ext;
 %DSGETDCAPI = '';

 /* Structure definitions */

 /* Flags to passed to DsGetDcName */

 dcl DS_FORCE_REDISCOVERY           type ULONG value('00000001'xu);

 dcl DS_DIRECTORY_SERVICE_REQUIRED  type ULONG value('00000010'xu);
 dcl DS_DIRECTORY_SERVICE_PREFERRED type ULONG value('00000020'xu)
 ;
 dcl DS_GC_SERVER_REQUIRED          type ULONG value('00000040'xu);
 dcl DS_PDC_REQUIRED                type ULONG value('00000080'xu);
 dcl DS_IP_REQUIRED                 type ULONG value('00000200'xu);
 dcl DS_KDC_REQUIRED                type ULONG value('00000400'xu);
 dcl DS_TIMESERV_REQUIRED           type ULONG value('00000800'xu);
 dcl DS_WRITABLE_REQUIRED           type ULONG value('00001000'xu);
 dcl DS_GOOD_TIMESERV_PREFERRED     type ULONG value('00002000'xu);
 dcl DS_AVOID_SELF                  type ULONG value('00004000'xu);
 dcl DS_ONLY_LDAP_NEEDED            type ULONG value('00008000'xu);


 dcl DS_IS_FLAT_NAME                type ULONG value('00010000'xu);
 dcl DS_IS_DNS_NAME                 type ULONG value('00020000'xu);

 dcl DS_RETURN_DNS_NAME             type ULONG value('40000000'xu);
 dcl DS_RETURN_FLAT_NAME            type ULONG value('80000000'xu);

 dcl DSGETDC_VALID_FLAGS            type ULONG
        value (ior (DS_FORCE_REDISCOVERY,
                    DS_DIRECTORY_SERVICE_REQUIRED,
                    DS_DIRECTORY_SERVICE_PREFERRED,
                    DS_GC_SERVER_REQUIRED,
                    DS_PDC_REQUIRED,
                    DS_IP_REQUIRED,
                    DS_KDC_REQUIRED,
                    DS_TIMESERV_REQUIRED,
                    DS_WRITABLE_REQUIRED,
                    DS_GOOD_TIMESERV_PREFERRED,
                    DS_AVOID_SELF,
                    DS_ONLY_LDAP_NEEDED,
                    DS_IS_FLAT_NAME,
                    DS_IS_DNS_NAME,
                    DS_RETURN_FLAT_NAME,
                    DS_RETURN_DNS_NAME));


 /* Structure returned from DsGetDcName */

 define structure
   1 DOMAIN_CONTROLLER_INFOA,
     2 DomainControllerName        type LPSTR,
     2 DomainControllerAddress     type LPSTR,
     2 DomainControllerAddressType type ULONG,
     2 DomainGuid                  type GUID,
     2 DomainName                  type LPSTR,
     2 DnsForestName               type LPSTR,
     2 Flags                       type ULONG,
     2 DcSiteName                  type LPSTR,
     2 ClientSiteName              type LPSTR;
 define alias PDOMAIN_CONTROLLER_INFOA handle DOMAIN_CONTROLLER_INFOA;

 define structure
   1 DOMAIN_CONTROLLER_INFOW,
     2 DomainControllerName        type LPWSTR,
     2 DomainControllerAddress     type LPWSTR,
     2 DomainControllerAddressType type ULONG,
     2 DomainGuid                  type GUID,
     2 DomainName                  type LPWSTR,
     2 DnsForestName               type LPWSTR,
     2 Flags                       type ULONG,
     2 DcSiteName                  type LPWSTR,
     2 ClientSiteName              type LPWSTR;
 define alias PDOMAIN_CONTROLLER_INFOW handle DOMAIN_CONTROLLER_INFOW;

 %if UNICODE ^= '' %then %do;
 define alias  DOMAIN_CONTROLLER_INFO type  DOMAIN_CONTROLLER_INFOW;
 define alias PDOMAIN_CONTROLLER_INFO type PDOMAIN_CONTROLLER_INFOW;
 %end; %else %do;
 define alias  DOMAIN_CONTROLLER_INFO type  DOMAIN_CONTROLLER_INFOA;
 define alias PDOMAIN_CONTROLLER_INFO type PDOMAIN_CONTROLLER_INFOA;
 %end; /* !UNICODE */

 /* Values for DomainControllerAddressType */

 dcl DS_INET_ADDRESS        type ULONG value(1);
 dcl DS_NETBIOS_ADDRESS     type ULONG value(2);

 /* Values for returned Flags */

 dcl DS_PDC_FLAG            type ULONG value('00000001'xu);
     /* DC is PDC of Domain */
 dcl DS_GC_FLAG             type ULONG value('00000004'xu);
     /* DC is a GC of forest */
 dcl DS_LDAP_FLAG           type ULONG value('00000008'xu);
     /* Server supports an LDAP server */
 dcl DS_DS_FLAG             type ULONG value('00000010'xu);
     /* DC supports a DS and is a Domain Controller */
 dcl DS_KDC_FLAG            type ULONG value('00000020'xu);
     /* DC is running KDC service */
 dcl DS_TIMESERV_FLAG       type ULONG value('00000040'xu);
     /* DC is running time service */
 dcl DS_CLOSEST_FLAG        type ULONG value('00000080'xu);
     /* DC is in closest site to client */
 dcl DS_WRITABLE_FLAG       type ULONG value('00000100'xu);
     /* DC has a writable DS */
 dcl DS_GOOD_TIMESERV_FLAG  type ULONG value('00000200'xu);
     /* DC is running time service (and has clock hardware) */
 dcl DS_PING_FLAGS          type ULONG value('0000FFFF'xu);
     /* Flags returned on ping */

 dcl DS_DNS_CONTROLLER_FLAG type ULONG value('20000000'xu);
     /* DomainControllerName is a DNS name */
 dcl DS_DNS_DOMAIN_FLAG     type ULONG value('40000000'xu);
     /* DomainName is a DNS name */
 dcl DS_DNS_FOREST_FLAG     type ULONG value('80000000'xu);
     /* DnsForestName is a DNS name */


 /* Function Prototypes */

 dcl DsGetDcNameA
     entry (char(*) varz byaddr nonasgn optional,
            char(*) varz byaddr nonasgn optional,
            type GUID byaddr optional,
            char(*) varz byaddr nonasgn optional,
            type ULONG,
            type PDOMAIN_CONTROLLER_INFOA byaddr)
     returns (type DWORD byvalue optional)
     DSGETDCAPI WINAPI external('DsGetDcNameA');

 dcl DsGetDcNameW
     entry (WCHAR(*) varz byaddr nonasgn optional,
            WCHAR(*) varz byaddr nonasgn optional,
            type GUID byaddr optional,
            WCHAR(*) varz byaddr nonasgn optional,
            type ULONG,
            type PDOMAIN_CONTROLLER_INFOW byaddr)
     returns (type DWORD byvalue optional)
     DSGETDCAPI WINAPI external('DsGetDcNameW');


 %dcl DsGetDcName char ext;
 %if UNICODE ^= '' %then %do;
   %DsGetDcName='DsGetDcNameW';
 %end; %else %do;
   %DsGetDcName='DsGetDcNameA';
 %end; /* !UNICODE */

 dcl DsGetSiteNameA
     entry (char(*) varz byaddr nonasgn optional,
            type LPSTR byaddr)
     returns (type DWORD byvalue optional)
     DSGETDCAPI WINAPI external('DsGetSiteNameA');

 dcl DsGetSiteNameW
     entry (WCHAR(*) varz byaddr nonasgn optional,
            type LPWSTR byaddr)
     returns (type DWORD byvalue optional)
     DSGETDCAPI WINAPI external('DsGetSiteNameW');

 %dcl DsGetSiteName char ext;
 %if UNICODE ^= '' %then %do;
   %DsGetSiteName='DsGetSiteNameW';
 %end; %else %do;
   %DsGetSiteName='DsGetSiteNameA';
 %end; /* !UNICODE */


 dcl DsValidateSubnetNameW
     entry (WCHAR(*) varz byaddr nonasgn)
     returns (type DWORD byvalue optional)
     DSGETDCAPI WINAPI external('DsValidateSubnetNameW');

 dcl DsValidateSubnetNameA
     entry (char(*) varz byaddr nonasgn)
     returns (type DWORD byvalue optional)
     DSGETDCAPI WINAPI external('DsValidateSubnetNameA');

 %dcl DsValidateSubnetName char ext;
 %if UNICODE ^= '' %then %do;
   %DsValidateSubnetName='DsValidateSubnetNameW';
 %end; %else %do;
   %DsValidateSubnetName='DsValidateSubnetNameA';
 %end; /* !UNICODE */


 /* Only include if winsock2.cpy has been included */
 %dcl #WINSOCK2API_ char ext;
 %if #WINSOCK2API_ ^= '' %then %do;
 dcl DsAddressToSiteNamesW
     entry (WCHAR(*) varz byaddr nonasgn optional,
            type DWORD,
            type SOCKET_ADDRESS byaddr,
            type LPWSTR byaddr)
     returns (type DWORD byvalue optional)
     DSGETDCAPI WINAPI external('DsAddressToSiteNamesW');

 dcl DsAddressToSiteNamesA
     entry (char(*) varz byaddr nonasgn optional,
            type DWORD,
            type SOCKET_ADDRESS byaddr,
            type LPSTR byaddr)
     returns (type DWORD byvalue optional)
     DSGETDCAPI WINAPI external('DsAddressToSiteNamesA');

 %dcl DsAddressToSiteNames char ext;
 %if UNICODE ^= '' %then %do;
   %DsAddressToSiteNames='DsAddressToSiteNamesW';
 %end; %else %do;
   %DsAddressToSiteNames='DsAddressToSiteNamesA';
 %end; /* !UNICODE */

 dcl DsAddressToSiteNamesExW
     entry (WCHAR(*) varz byaddr nonasgn optional,
            type DWORD,
            type SOCKET_ADDRESS byaddr,
            type LPWSTR byaddr,
            type LPWSTR byaddr)
     returns (type DWORD byvalue optional)
     DSGETDCAPI WINAPI external('DsAddressToSiteNamesExW');

 dcl DsAddressToSiteNamesExA
     entry (char(*) varz byaddr nonasgn optional,
            type DWORD,
            type SOCKET_ADDRESS byaddr,
            type LPSTR byaddr,
            type LPSTR byaddr)
     returns (type DWORD byvalue optional)
     DSGETDCAPI WINAPI external('DsAddressToSiteNamesExA');

 %dcl DsAddressToSiteNamesEx char ext;
 %if UNICODE ^= '' %then %do;
   %DsAddressToSiteNamesEx='DsAddressToSiteNamesExW';
 %end; %else %do;
   %DsAddressToSiteNamesEx='DsAddressToSiteNamesExA';
 %end; /* !UNICODE */
 %end; /* _WINSOCK2API_ */

 /* API to enumerate trusted domains */

 dcl DS_DOMAIN_IN_FOREST       type ULONG value('0001'xu);
     /* Domain is a member of the forest */
 dcl DS_DOMAIN_DIRECT_OUTBOUND type ULONG value('0002'xu);
     /* Domain is directly trusted */
 dcl DS_DOMAIN_TREE_ROOT       type ULONG value('0004'xu);
     /* Domain is root of a tree in the forest */
 dcl DS_DOMAIN_PRIMARY         type ULONG value('0008'xu);
     /* Domain is the primary domain of queried server */
 dcl DS_DOMAIN_NATIVE_MODE     type ULONG value('0010'xu);
     /* Primary domain is running in native mode */
 dcl DS_DOMAIN_DIRECT_INBOUND  type ULONG value('0020'xu);
     /* Domain is directly trusting */
 dcl DS_DOMAIN_VALID_FLAGS     type ULONG
       value (ior (DS_DOMAIN_IN_FOREST,
                   DS_DOMAIN_DIRECT_OUTBOUND,
                   DS_DOMAIN_TREE_ROOT,
                   DS_DOMAIN_PRIMARY,
                   DS_DOMAIN_NATIVE_MODE,
                   DS_DOMAIN_DIRECT_INBOUND));


 define structure
   1 DS_DOMAIN_TRUSTSW,
     /* Name of the trusted domain. */
     2 NetbiosDomainName type LPWSTR,
     2 DnsDomainName     type LPWSTR,
     /* Flags defining attributes of the trust. */
     2 Flags             type ULONG,
     /* Index to the domain that is the parent of this domain. */
     /* Only defined if NETLOGON_DOMAIN_IN_FOREST is set and */
     /* NETLOGON_DOMAIN_TREE_ROOT is not set. */
     2 ParentIndex       type ULONG,
     /* The trust type and attributes of this trust. */
     /* If NETLOGON_DOMAIN_DIRECTLY_TRUSTED is not set, */
     /* these value are infered. */
     2 TrustType         type ULONG,
     2 TrustAttributes   type ULONG,
     /* The SID of the trusted domain. */
     /* If NETLOGON_DOMAIN_DIRECTLY_TRUSTED is not set, */
     /* this value will be NULL. */
     2 DomainSid         type PSID,
     /* The GUID of the trusted domain. */
     2 DomainGuid        type GUID;
 define alias PDS_DOMAIN_TRUSTSW handle DS_DOMAIN_TRUSTSW;


 /* ANSI version of the above struct */

 define structure
   1 DS_DOMAIN_TRUSTSA,
     2 NetbiosDomainName type LPSTR,
     2 DnsDomainName     type LPSTR,
     2 Flags             type ULONG,
     2 ParentIndex       type ULONG,
     2 TrustType         type ULONG,
     2 TrustAttributes   type ULONG,
     2 DomainSid         type PSID,
     2 DomainGuid        type GUID;
 define alias PDS_DOMAIN_TRUSTSA handle DS_DOMAIN_TRUSTSA;

 %if UNICODE ^= '' %then %do;
 define alias  DS_DOMAIN_TRUSTS type  DS_DOMAIN_TRUSTSW;
 define alias PDS_DOMAIN_TRUSTS type PDS_DOMAIN_TRUSTSW;
 %end; %else %do;
 define alias  DS_DOMAIN_TRUSTS type  DS_DOMAIN_TRUSTSA;
 define alias PDS_DOMAIN_TRUSTS type PDS_DOMAIN_TRUSTSA;
 %end; /* !UNICODE */

 dcl DsEnumerateDomainTrustsW
     entry (WCHAR(*) varz byaddr optional,
            type ULONG,
            type PDS_DOMAIN_TRUSTSW byaddr,
            type ULONG byaddr)
     returns (type DWORD byvalue optional)
     DSGETDCAPI WINAPI external('DsEnumerateDomainTrustsW');

 dcl DsEnumerateDomainTrustsA
     entry (char(*) varz byaddr optional,
            type ULONG,
            type PDS_DOMAIN_TRUSTSA byaddr,
            type ULONG byaddr)
     returns (type DWORD byvalue optional)
     DSGETDCAPI WINAPI external('DsEnumerateDomainTrustsA');

 %dcl DsEnumerateDomainTrusts char ext;
 %if UNICODE ^= '' %then %do;
   %DsEnumerateDomainTrusts='DsEnumerateDomainTrustsW';
 %end; %else %do;
   %DsEnumerateDomainTrusts='DsEnumerateDomainTrustsA';
 %end; /* !UNICODE */

 dcl DsGetDcSiteCoverageW
     entry (WCHAR(*) varz byaddr nonasgn optional,
            type ULONG byaddr,
            type LPWSTR byaddr)
     returns (type DWORD byvalue optional)
     DSGETDCAPI WINAPI external('DsGetDcSiteCoverageW');

 dcl DsGetDcSiteCoverageA
     entry (char(*) varz byaddr nonasgn optional,
            type ULONG byaddr,
            type LPSTR byaddr)
     returns (type DWORD byvalue optional)
     DSGETDCAPI WINAPI external('DsGetDcSiteCoverageA');

 %dcl DsGetDcSiteCoverage char ext;
 %if UNICODE ^= '' %then %do;
   %DsGetDcSiteCoverage='DsGetDcSiteCoverageW';
 %end; %else %do;
   %DsGetDcSiteCoverage='DsGetDcSiteCoverageA';
 %end;
 /* !UNICODE */

 dcl DsDeregisterDnsHostRecordsW
     entry (WCHAR(*) varz byaddr optional,
            WCHAR(*) varz byaddr optional,
            type GUID byaddr optional,
            type GUID byaddr optional,
            WCHAR(*) varz byaddr)
     returns (type DWORD byvalue optional)
     DSGETDCAPI WINAPI external('DsDeregisterDnsHostRecordsW');

 dcl DsDeregisterDnsHostRecordsA
     entry (char(*) varz byaddr optional,
            char(*) varz byaddr optional,
            type GUID byaddr optional,
            type GUID byaddr optional,
            char(*) varz byaddr)
     returns (type DWORD byvalue optional)
     DSGETDCAPI WINAPI external('DsDeregisterDnsHostRecordsA');

 %dcl DsDeregisterDnsHostRecords char ext;
 %if UNICODE ^= '' %then %do;
   %DsDeregisterDnsHostRecords='DsDeregisterDnsHostRecordsW';
 %end; %else %do;
   %DsDeregisterDnsHostRecords='DsDeregisterDnsHostRecordsA';
 %end; /* !UNICODE */

 %end; /* _DSGETDC_ */
