 /*++ BUILD Version: 0006                                             */
 /*   -- Increment this if a change has global effects                */
 /*                                                                   */
 /* Copyright 1991-1998 Microsoft Corporation                         */
 /*                                                                   */
 /* Module Name:                                                      */
 /*                                                                   */
 /*   lmwksta.cpy                                                     */
 /*                                                                   */
 /* Abstract:                                                         */
 /*                                                                   */
 /*   This file contains structures, function prototypes, and         */
 /*   definitions for the NetWorkstation and NetWkstaTransport API.   */
 /*                                                                   */
 /* Environment:                                                      */
 /*                                                                   */
 /*   User Mode - Win32                                               */
 /*   Portable to any flat, 32-bit environment. (Uses Win32 typedefs.)*/
 /*                                                                   */
 /* Notes:                                                            */
 /*                                                                   */
 /*   You must include NETCONS.CPY before this file, since this file  */
 /*   depends on values defined in NETCONS.CPY.                       */
 /*                                                                   */
 /* --                                                                */

 %dcl #LMWKSTA_ char ext;
 %if #LMWKSTA_ = '' %then %do;
 %#LMWKSTA_ = 'Y';


 %dcl #LMUSEFLG_ char ext;
 %if #LMUSEFLG_ = '' %then %do;
 %include lmuseflg; /* Deletion force level flags */
 %end;

 /* Function Prototypes */


 dcl NetWkstaGetInfo
     entry (WCHAR(*) varz byaddr optional,
            type DWORD,
            type LPBYTE byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetWkstaGetInfo');

 dcl NetWkstaSetInfo
     entry (WCHAR(*) varz byaddr optional,
            type DWORD,
            type LPBYTE,
            type DWORD byaddr optional)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetWkstaSetInfo');

 dcl NetWkstaUserGetInfo
     entry (WCHAR(*) varz byaddr optional,
            type DWORD,
            type LPBYTE byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetWkstaUserGetInfo');

 dcl NetWkstaUserSetInfo
     entry (WCHAR(*) varz byaddr optional,
            type DWORD,
            type LPBYTE,
            type DWORD byaddr optional)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetWkstaUserSetInfo');

 dcl NetWkstaUserEnum
     entry (WCHAR(*) varz byaddr optional,
            type DWORD,
            type LPBYTE byaddr,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr,
            type DWORD byaddr optional)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetWkstaUserEnum');

 dcl NetWkstaTransportAdd
     entry (WCHAR(*) varz byaddr optional,
            type DWORD,
            type LPBYTE,
            type DWORD byaddr)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetWkstaTransportAdd');

 dcl NetWkstaTransportDel
     entry (WCHAR(*) varz byaddr optional,
            WCHAR(*) varz byaddr,
            type DWORD)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetWkstaTransportDel');

 dcl NetWkstaTransportEnum
     entry (WCHAR(*) varz byaddr optional,
            type DWORD,
            type LPBYTE byaddr,
            type DWORD,
            type DWORD byaddr,
            type DWORD byaddr,
            type DWORD byaddr optional)
     returns (type NET_API_STATUS byvalue optional)
     NET_API_FUNCTION external('NetWkstaTransportEnum');

 /*  Data Structures */

 /* NetWkstaGetInfo and NetWkstaSetInfo */

 /* NetWkstaGetInfo only.  System information - guest access */

 define structure
   1 WKSTA_INFO_100,
     2 wki100_platform_id  type DWORD,
     2 wki100_computername type LPTSTR,
     2 wki100_langroup     type LPTSTR,
     2 wki100_ver_major    type DWORD,
     2 wki100_ver_minor    type DWORD;
 define alias  PWKSTA_INFO_100 handle WKSTA_INFO_100;
 define alias LPWKSTA_INFO_100 handle WKSTA_INFO_100;


 /* NetWkstaGetInfo only.  System information - user access */

 define structure
   1 WKSTA_INFO_101,
     2 wki101_platform_id  type DWORD,
     2 wki101_computername type LPTSTR,
     2 wki101_langroup     type LPTSTR,
     2 wki101_ver_major    type DWORD,
     2 wki101_ver_minor    type DWORD,
     2 wki101_lanroot      type LPTSTR;
 define alias  PWKSTA_INFO_101 handle WKSTA_INFO_101;
 define alias LPWKSTA_INFO_101 handle WKSTA_INFO_101;

 /* NetWkstaGetInfo only.                         */
 /* System information - admin or operator access */

 define structure
   1 WKSTA_INFO_102,
     2 wki102_platform_id     type DWORD,
     2 wki102_computername    type LPTSTR,
     2 wki102_langroup        type LPTSTR,
     2 wki102_ver_major       type DWORD,
     2 wki102_ver_minor       type DWORD,
     2 wki102_lanroot         type LPTSTR,
     2 wki102_logged_on_users type DWORD;
 define alias  PWKSTA_INFO_102 handle WKSTA_INFO_102;
 define alias LPWKSTA_INFO_102 handle WKSTA_INFO_102;


 /* Down-level NetWkstaGetInfo and NetWkstaSetInfo. */

 /* DOS specific workstation information - */
 /*    admin or domain operator access     */

 define structure
   1 WKSTA_INFO_302 ,
     2 wki302_char_wait                type DWORD,
     2 wki302_collection_time          type DWORD,
     2 wki302_maximum_collection_count type DWORD,
     2 wki302_keep_conn                type DWORD,
     2 wki302_keep_search              type DWORD,
     2 wki302_max_cmds                 type DWORD,
     2 wki302_num_work_buf             type DWORD,
     2 wki302_siz_work_buf             type DWORD,
     2 wki302_max_wrk_cache            type DWORD,
     2 wki302_sess_timeout             type DWORD,
     2 wki302_siz_error                type DWORD,
     2 wki302_num_alerts               type DWORD,
     2 wki302_num_services             type DWORD,
     2 wki302_errlog_sz                type DWORD,
     2 wki302_print_buf_time           type DWORD,
     2 wki302_num_char_buf             type DWORD,
     2 wki302_siz_char_buf             type DWORD,
     2 wki302_wrk_heuristics           type LPTSTR,
     2 wki302_mailslots                type DWORD,
     2 wki302_num_dgram_buf            type DWORD;
 define alias  PWKSTA_INFO_302 handle WKSTA_INFO_302;
 define alias LPWKSTA_INFO_302 handle WKSTA_INFO_302;


 /* Down-level NetWkstaGetInfo and NetWkstaSetInfo */

 /* OS/2 specific workstation information - */
 /*    admin or domain operator access      */

 define structure
   1 WKSTA_INFO_402,
     2 wki402_char_wait                type DWORD,
     2 wki402_collection_time          type DWORD,
     2 wki402_maximum_collection_count type DWORD,
     2 wki402_keep_conn                type DWORD,
     2 wki402_keep_search              type DWORD,
     2 wki402_max_cmds                 type DWORD,
     2 wki402_num_work_buf             type DWORD,
     2 wki402_siz_work_buf             type DWORD,
     2 wki402_max_wrk_cache            type DWORD,
     2 wki402_sess_timeout             type DWORD,
     2 wki402_siz_error                type DWORD,
     2 wki402_num_alerts               type DWORD,
     2 wki402_num_services             type DWORD,
     2 wki402_errlog_sz                type DWORD,
     2 wki402_print_buf_time           type DWORD,
     2 wki402_num_char_buf             type DWORD,
     2 wki402_siz_char_buf             type DWORD,
     2 wki402_wrk_heuristics           type LPTSTR,
     2 wki402_mailslots                type DWORD,
     2 wki402_num_dgram_buf            type DWORD,
     2 wki402_max_threads              type DWORD;
 define alias  PWKSTA_INFO_402 handle WKSTA_INFO_402;
 define alias LPWKSTA_INFO_402 handle WKSTA_INFO_402;


 /* Same-level NetWkstaGetInfo and NetWkstaSetInfo. */

 /* NT specific workstation information - */
 /*    admin or domain operator access    */

 define structure
   1 WKSTA_INFO_502,
     2 wki502_char_wait                              type DWORD,
     2 wki502_collection_time                        type DWORD,
     2 wki502_maximum_collection_count               type DWORD,
     2 wki502_keep_conn                              type DWORD,
     2 wki502_max_cmds                               type DWORD,
     2 wki502_sess_timeout                           type DWORD,
     2 wki502_siz_char_buf                           type DWORD,
     2 wki502_max_threads                            type DWORD,
     2 wki502_lock_quota                             type DWORD,
     2 wki502_lock_increment                         type DWORD,
     2 wki502_lock_maximum                           type DWORD,
     2 wki502_pipe_increment                         type DWORD,
     2 wki502_pipe_maximum                           type DWORD,
     2 wki502_cache_file_timeout                     type DWORD,
     2 wki502_dormant_file_limit                     type DWORD,
     2 wki502_read_ahead_throughput                  type DWORD,
     2 wki502_num_mailslot_buffers                   type DWORD,
     2 wki502_num_srv_announce_buffers               type DWORD,
     2 wki502_max_illegal_datagram_events            type DWORD,
     2 wki502_illegal_datagram_event_reset_frequency type DWORD,
     2 wki502_log_election_packets                   type BOOL,
     2 wki502_use_opportunistic_locking              type BOOL,
     2 wki502_use_unlock_behind                      type BOOL,
     2 wki502_use_close_behind                       type BOOL,
     2 wki502_buf_named_pipes                        type BOOL,
     2 wki502_use_lock_read_unlock                   type BOOL,
     2 wki502_utilize_nt_caching                     type BOOL,
     2 wki502_use_raw_read                           type BOOL,
     2 wki502_use_raw_write                          type BOOL,
     2 wki502_use_write_raw_data                     type BOOL,
     2 wki502_use_encryption                         type BOOL,
     2 wki502_buf_files_deny_write                   type BOOL,
     2 wki502_buf_read_only_files                    type BOOL,
     2 wki502_force_core_create_mode                 type BOOL,
     2 wki502_use_512_byte_max_transfer              type BOOL;
 define alias  PWKSTA_INFO_502 handle WKSTA_INFO_502;
 define alias LPWKSTA_INFO_502 handle WKSTA_INFO_502;


 /* The following info-levels are only valid for NetWkstaSetInfo */

 /* The following levels are supported on down-level systems */
 /* (LAN Man 2.x) as well as NT systems:                     */

 define structure
   1 WKSTA_INFO_1010,
     2 wki1010_char_wait type DWORD;
 define alias  PWKSTA_INFO_1010 handle WKSTA_INFO_1010;
 define alias LPWKSTA_INFO_1010 handle WKSTA_INFO_1010;

 define structure
   1 WKSTA_INFO_1011,
     2 wki1011_collection_time type DWORD;
 define alias  PWKSTA_INFO_1011 handle WKSTA_INFO_1011;
 define alias LPWKSTA_INFO_1011 handle WKSTA_INFO_1011;

 define structure
   1 WKSTA_INFO_1012,
     2 wki1012_maximum_collection_count type DWORD;
 define alias  PWKSTA_INFO_1012 handle WKSTA_INFO_1012;
 define alias LPWKSTA_INFO_1012 handle WKSTA_INFO_1012;


 /* The following level are supported on down-level systems */
 /* (LAN Man 2.x) only:                                     */

 define structure
   1 WKSTA_INFO_1027,
     2 wki1027_errlog_sz type DWORD;
 define alias  PWKSTA_INFO_1027 handle WKSTA_INFO_1027;
 define alias LPWKSTA_INFO_1027 handle WKSTA_INFO_1027;

 define structure
   1 WKSTA_INFO_1028,
     2 wki1028_print_buf_time type DWORD;
 define alias  PWKSTA_INFO_1028 handle WKSTA_INFO_1028;
 define alias LPWKSTA_INFO_1028 handle WKSTA_INFO_1028;

 define structure
   1 WKSTA_INFO_1032,
     2 wki1032_wrk_heuristics type DWORD;
 define alias  PWKSTA_INFO_1032 handle WKSTA_INFO_1032;
 define alias LPWKSTA_INFO_1032 handle WKSTA_INFO_1032;


 /* The following levels are settable on NT systems, and have no */
 /* effect on down-level systems (i.e. LANMan 2.x) since these   */
 /* fields cannot be set on them:                                */

 define structure
   1 WKSTA_INFO_1013,
     2 wki1013_keep_conn type DWORD;
 define alias  PWKSTA_INFO_1013 handle WKSTA_INFO_1013;
 define alias LPWKSTA_INFO_1013 handle WKSTA_INFO_1013;

 define structure
   1 WKSTA_INFO_1018,
     2 wki1018_sess_timeout type DWORD;
 define alias  PWKSTA_INFO_1018 handle WKSTA_INFO_1018;
 define alias LPWKSTA_INFO_1018 handle WKSTA_INFO_1018;

 define structure
   1 WKSTA_INFO_1023,
     2 wki1023_siz_char_buf type DWORD;
 define alias  PWKSTA_INFO_1023 handle WKSTA_INFO_1023;
 define alias LPWKSTA_INFO_1023 handle WKSTA_INFO_1023;

 define structure
   1 WKSTA_INFO_1033,
     2 wki1033_max_threads type DWORD;
 define alias  PWKSTA_INFO_1033 handle WKSTA_INFO_1033;
 define alias LPWKSTA_INFO_1033 handle WKSTA_INFO_1033;

 /* The following levels are only supported on NT systems: */

 define structure
   1 WKSTA_INFO_1041,
     2 wki1041_lock_quota type DWORD;
 define alias  PWKSTA_INFO_1041 handle WKSTA_INFO_1041;
 define alias LPWKSTA_INFO_1041 handle WKSTA_INFO_1041;

 define structure
   1 WKSTA_INFO_1042,
     2 wki1042_lock_increment type DWORD;
 define alias  PWKSTA_INFO_1042 handle WKSTA_INFO_1042;
 define alias LPWKSTA_INFO_1042 handle WKSTA_INFO_1042;

 define structure
   1 WKSTA_INFO_1043,
     2 wki1043_lock_maximum type DWORD;
 define alias  PWKSTA_INFO_1043 handle WKSTA_INFO_1043;
 define alias LPWKSTA_INFO_1043 handle WKSTA_INFO_1043;

 define structure
   1 WKSTA_INFO_1044,
     2 wki1044_pipe_increment type DWORD;
 define alias  PWKSTA_INFO_1044 handle WKSTA_INFO_1044;
 define alias LPWKSTA_INFO_1044 handle WKSTA_INFO_1044;

 define structure
   1 WKSTA_INFO_1045,
     2 wki1045_pipe_maximum type DWORD;
 define alias  PWKSTA_INFO_1045 handle WKSTA_INFO_1045;
 define alias LPWKSTA_INFO_1045 handle WKSTA_INFO_1045;

 define structure
   1 WKSTA_INFO_1046,
     2 wki1046_dormant_file_limit type DWORD;
 define alias  PWKSTA_INFO_1046 handle WKSTA_INFO_1046;
 define alias LPWKSTA_INFO_1046 handle WKSTA_INFO_1046;

 define structure
   1 WKSTA_INFO_1047,
     2 wki1047_cache_file_timeout type DWORD;
 define alias  PWKSTA_INFO_1047 handle WKSTA_INFO_1047;
 define alias LPWKSTA_INFO_1047 handle WKSTA_INFO_1047;

 define structure
   1 WKSTA_INFO_1048,
     2 wki1048_use_opportunistic_locking type BOOL;
 define alias  PWKSTA_INFO_1048 handle WKSTA_INFO_1048;
 define alias LPWKSTA_INFO_1048 handle WKSTA_INFO_1048;

 define structure
   1 WKSTA_INFO_1049,
     2 wki1049_use_unlock_behind type BOOL;
 define alias  PWKSTA_INFO_1049 handle WKSTA_INFO_1049;
 define alias LPWKSTA_INFO_1049 handle WKSTA_INFO_1049;

 define structure
   1 WKSTA_INFO_1050,
     2 wki1050_use_close_behind type BOOL;
 define alias  PWKSTA_INFO_1050 handle WKSTA_INFO_1050;
 define alias LPWKSTA_INFO_1050 handle WKSTA_INFO_1050;

 define structure
   1 WKSTA_INFO_1051,
     2 wki1051_buf_named_pipes type BOOL;
 define alias  PWKSTA_INFO_1051 handle WKSTA_INFO_1051;
 define alias LPWKSTA_INFO_1051 handle WKSTA_INFO_1051;

 define structure
   1 WKSTA_INFO_1052,
     2 wki1052_use_lock_read_unlock type BOOL;
 define alias  PWKSTA_INFO_1052 handle WKSTA_INFO_1052;
 define alias LPWKSTA_INFO_1052 handle WKSTA_INFO_1052;

 define structure
   1 WKSTA_INFO_1053,
     2 wki1053_utilize_nt_caching type BOOL;
 define alias  PWKSTA_INFO_1053 handle WKSTA_INFO_1053;
 define alias LPWKSTA_INFO_1053 handle WKSTA_INFO_1053;

 define structure
   1 WKSTA_INFO_1054,
     2 wki1054_use_raw_read type BOOL;
 define alias  PWKSTA_INFO_1054 handle WKSTA_INFO_1054;
 define alias LPWKSTA_INFO_1054 handle WKSTA_INFO_1054;

 define structure
   1 WKSTA_INFO_1055,
     2 wki1055_use_raw_write type BOOL;
 define alias  PWKSTA_INFO_1055 handle WKSTA_INFO_1055;
 define alias LPWKSTA_INFO_1055 handle WKSTA_INFO_1055;

 define structure
   1 WKSTA_INFO_1056,
     2 wki1056_use_write_raw_data type BOOL;
 define alias  PWKSTA_INFO_1056 handle WKSTA_INFO_1056;
 define alias LPWKSTA_INFO_1056 handle WKSTA_INFO_1056;

 define structure
   1 WKSTA_INFO_1057,
     2 wki1057_use_encryption type BOOL;
 define alias  PWKSTA_INFO_1057 handle WKSTA_INFO_1057;
 define alias LPWKSTA_INFO_1057 handle WKSTA_INFO_1057;

 define structure
   1 WKSTA_INFO_1058,
     2 wki1058_buf_files_deny_write type BOOL;
 define alias  PWKSTA_INFO_1058 handle WKSTA_INFO_1058;
 define alias LPWKSTA_INFO_1058 handle WKSTA_INFO_1058;

 define structure
   1 WKSTA_INFO_1059,
     2 wki1059_buf_read_only_files type BOOL;
 define alias  PWKSTA_INFO_1059 handle WKSTA_INFO_1059;
 define alias LPWKSTA_INFO_1059 handle WKSTA_INFO_1059;

 define structure
   1 WKSTA_INFO_1060,
     2 wki1060_force_core_create_mode type BOOL;
 define alias  PWKSTA_INFO_1060 handle WKSTA_INFO_1060;
 define alias LPWKSTA_INFO_1060 handle WKSTA_INFO_1060;

 define structure
   1 WKSTA_INFO_1061,
     2 wki1061_use_512_byte_max_transfer type BOOL;
 define alias  PWKSTA_INFO_1061 handle WKSTA_INFO_1061;
 define alias LPWKSTA_INFO_1061 handle WKSTA_INFO_1061;

 define structure
   1 WKSTA_INFO_1062,
     2 wki1062_read_ahead_throughput type DWORD;
 define alias  PWKSTA_INFO_1062 handle WKSTA_INFO_1062;
 define alias LPWKSTA_INFO_1062 handle WKSTA_INFO_1062;


 /* NetWkstaUserGetInfo (local only) and NetWkstaUserEnum - */
 /*     no access restrictions.                             */

 define structure
   1 WKSTA_USER_INFO_0,
     2 wkui0_username type LPTSTR;
 define alias  PWKSTA_USER_INFO_0 handle WKSTA_USER_INFO_0;
 define alias LPWKSTA_USER_INFO_0 handle WKSTA_USER_INFO_0;


 /* NetWkstaUserGetInfo (local only) and NetWkstaUserEnum - */
 /*     no access restrictions.                             */

 define structure
   1 WKSTA_USER_INFO_1,
     2 wkui1_username     type LPTSTR,
     2 wkui1_logon_domain type LPTSTR,
     2 wkui1_oth_domains  type LPTSTR,
     2 wkui1_logon_server type LPTSTR;
 define alias  PWKSTA_USER_INFO_1 handle WKSTA_USER_INFO_1;
 define alias LPWKSTA_USER_INFO_1 handle WKSTA_USER_INFO_1;


 /* NetWkstaUserSetInfo - local access. */

 define structure
   1 WKSTA_USER_INFO_1101,
     2 wkui1101_oth_domains type LPTSTR;
 define alias  PWKSTA_USER_INFO_1101 handle WKSTA_USER_INFO_1101;
 define alias LPWKSTA_USER_INFO_1101 handle WKSTA_USER_INFO_1101;


 /* NetWkstaTransportAdd - admin access */

 define structure
   1 WKSTA_TRANSPORT_INFO_0,
     2 wkti0_quality_of_service type DWORD,
     2 wkti0_number_of_vcs      type DWORD,
     2 wkti0_transport_name     type LPTSTR,
     2 wkti0_transport_address  type LPTSTR,
     2 wkti0_wan_ish type BOOL;
 define alias  PWKSTA_TRANSPORT_INFO_0 handle WKSTA_TRANSPORT_INFO_0;
 define alias LPWKSTA_TRANSPORT_INFO_0 handle WKSTA_TRANSPORT_INFO_0;


 /* Special Values and Constants */

 /* Identifiers for use as NetWkstaSetInfo parmnum parameter */

 /* One of these values indicates the parameter within an information */
 /* structure that is invalid when ERROR_INVALID_PARAMETER is         */
 /* returned by NetWkstaSetInfo.                                      */

 dcl WKSTA_PLATFORM_ID_PARMNUM             fixed bin(31) value(100);
 dcl WKSTA_COMPUTERNAME_PARMNUM            fixed bin(31) value(1);
 dcl WKSTA_LANGROUP_PARMNUM                fixed bin(31) value(2);
 dcl WKSTA_VER_MAJOR_PARMNUM               fixed bin(31) value(4);
 dcl WKSTA_VER_MINOR_PARMNUM               fixed bin(31) value(5);
 dcl WKSTA_LOGGED_ON_USERS_PARMNUM         fixed bin(31) value(6);
 dcl WKSTA_LANROOT_PARMNUM                 fixed bin(31) value(7);
 dcl WKSTA_LOGON_DOMAIN_PARMNUM            fixed bin(31) value(8);
 dcl WKSTA_LOGON_SERVER_PARMNUM            fixed bin(31) value(9);
 dcl WKSTA_CHARWAIT_PARMNUM                fixed bin(31) value(10);
     /* Supported by down-level. */
 dcl WKSTA_CHARTIME_PARMNUM                fixed bin(31) value(11);
     /* Supported by down-level. */
 dcl WKSTA_CHARCOUNT_PARMNUM               fixed bin(31) value(12);
     /* Supported by down-level. */
 dcl WKSTA_KEEPCONN_PARMNUM                fixed bin(31) value(13);
 dcl WKSTA_KEEPSEARCH_PARMNUM              fixed bin(31) value(14);
 dcl WKSTA_MAXCMDS_PARMNUM                 fixed bin(31) value(15);
 dcl WKSTA_NUMWORKBUF_PARMNUM              fixed bin(31) value(16);
 dcl WKSTA_MAXWRKCACHE_PARMNUM             fixed bin(31) value(17);
 dcl WKSTA_SESSTIMEOUT_PARMNUM             fixed bin(31) value(18);
 dcl WKSTA_SIZERROR_PARMNUM                fixed bin(31) value(19);
 dcl WKSTA_NUMALERTS_PARMNUM               fixed bin(31) value(20);
 dcl WKSTA_NUMSERVICES_PARMNUM             fixed bin(31) value(21);
 dcl WKSTA_NUMCHARBUF_PARMNUM              fixed bin(31) value(22);
 dcl WKSTA_SIZCHARBUF_PARMNUM              fixed bin(31) value(23);
 dcl WKSTA_ERRLOGSZ_PARMNUM                fixed bin(31) value(27);
     /* Supported by down-level. */
 dcl WKSTA_PRINTBUFTIME_PARMNUM            fixed bin(31) value(28);
     /* Supported by down-level. */
 dcl WKSTA_SIZWORKBUF_PARMNUM              fixed bin(31) value(29);
 dcl WKSTA_MAILSLOTS_PARMNUM               fixed bin(31) value(30);
 dcl WKSTA_NUMDGRAMBUF_PARMNUM             fixed bin(31) value(31);
 dcl WKSTA_WRKHEURISTICS_PARMNUM           fixed bin(31) value(32);
     /* Supported by down-level. */
 dcl WKSTA_MAXTHREADS_PARMNUM              fixed bin(31) value(33);

 dcl WKSTA_LOCKQUOTA_PARMNUM               fixed bin(31) value(41);
 dcl WKSTA_LOCKINCREMENT_PARMNUM           fixed bin(31) value(42);
 dcl WKSTA_LOCKMAXIMUM_PARMNUM             fixed bin(31) value(43);
 dcl WKSTA_PIPEINCREMENT_PARMNUM           fixed bin(31) value(44);
 dcl WKSTA_PIPEMAXIMUM_PARMNUM             fixed bin(31) value(45);
 dcl WKSTA_DORMANTFILELIMIT_PARMNUM        fixed bin(31) value(46);
 dcl WKSTA_CACHEFILETIMEOUT_PARMNUM        fixed bin(31) value(47);
 dcl WKSTA_USEOPPORTUNISTICLOCKING_PARMNUM fixed bin(31) value(48);
 dcl WKSTA_USEUNLOCKBEHIND_PARMNUM         fixed bin(31) value(49);
 dcl WKSTA_USECLOSEBEHIND_PARMNUM          fixed bin(31) value(50);
 dcl WKSTA_BUFFERNAMEDPIPES_PARMNUM        fixed bin(31) value(51);
 dcl WKSTA_USELOCKANDREADANDUNLOCK_PARMNUM fixed bin(31) value(52);
 dcl WKSTA_UTILIZENTCACHING_PARMNUM        fixed bin(31) value(53);
 dcl WKSTA_USERAWREAD_PARMNUM              fixed bin(31) value(54);
 dcl WKSTA_USERAWWRITE_PARMNUM             fixed bin(31) value(55);
 dcl WKSTA_USEWRITERAWWITHDATA_PARMNUM     fixed bin(31) value(56);
 dcl WKSTA_USEENCRYPTION_PARMNUM           fixed bin(31) value(57);
 dcl WKSTA_BUFFILESWITHDENYWRITE_PARMNUM   fixed bin(31) value(58);
 dcl WKSTA_BUFFERREADONLYFILES_PARMNUM     fixed bin(31) value(59);
 dcl WKSTA_FORCECORECREATEMODE_PARMNUM     fixed bin(31) value(60);
 dcl WKSTA_USE512BYTESMAXTRANSFER_PARMNUM  fixed bin(31) value(61);
 dcl WKSTA_READAHEADTHRUPUT_PARMNUM        fixed bin(31) value(62);


 /* One of these values indicates the parameter within an information */
 /* structure that is invalid when ERROR_INVALID_PARAMETER is         */
 /* returned by NetWkstaUserSetInfo.                                  */

 dcl WKSTA_OTH_DOMAINS_PARMNUM             fixed bin(31) value(101);


 /* One of these values indicates the parameter within an information */
 /* structure that is invalid when ERROR_INVALID_PARAMETER is         */
 /* returned by NetWkstaTransportAdd.                                 */

 dcl TRANSPORT_QUALITYOFSERVICE_PARMNUM    fixed bin(31) value(201);
 dcl TRANSPORT_NAME_PARMNUM                fixed bin(31) value(202);

 %end; /* _LMWKSTA_ */
