 /*****************************************************************/
 /** ODBCEXT.CPY - This is the include for applications using     */
 /**               Microsoft's SQL Extensions.                    */
 /**             - ODBC V 3.0 Level                               */
 /**                                                              */
 /*****************************************************************/
 /*                                                               */
 /*  Licensed Materials - Property of IBM                         */
 /*  5639-A83, 5639-A24 (C) Copyright IBM Corp. 1998.             */
 /*  All Rights Reserved.                                         */
 /*   (C) Copyright IBM Corp. 1998. All Rights Reserved.          */
 /*   US Government Users Restricted Rights-- Use, duplication or */
 /*   disclosure restricted by GSA ADP Schedule Contract with     */
 /*   IBM Corp.                                                   */
 /*                                                               */
 /* DISCLAIMER OF WARRANTIES                                      */
 /*   The following "enclosed" code is sample code created by IBM */
 /*   Corporation. This sample code is not part of any standard   */
 /*   IBM product and is provided to you solely for the purpose of*/
 /*   assisting you in the development of your applications.  The */
 /*   code is provided "AS IS", without warranty of any kind.     */
 /*   IBM shall not be liable for any damages arising out of your */
 /*   use of the sample code, even if IBM has been advised of the */
 /*   possibility of such damages.                                */
 /*                                                               */
 /*****************************************************************/

 %dcl #_SQLEXT char ext;
 %if #_SQLEXT = '' %then %do;
   %#_SQLEXT = 'Y';

 %dcl #_SQL char ext;
 %if #_SQL = '' %then %do;
   %include odbcsql;
 %end;


 /* generally useful constants */
 dcl SQL_SPEC_MAJOR  fixed bin(31) value(3);
     /* Major version of specification  */
 dcl SQL_SPEC_MINOR  fixed bin(31) value(52);
     /* Minor version of specification  */
 dcl SQL_SPEC_STRING char value("03.52");
     /* String constant for version */

 dcl SQL_SQLSTATE_SIZE  fixed bin(31) value(5);
 /* size of SQLSTATE */
 dcl SQL_MAX_DSN_LENGTH fixed bin(31) value(32);
 /* maximum data source name size */

 dcl SQL_MAX_OPTION_STRING_LENGTH fixed bin(31) value(256);

 /* return code SQL_NO_DATA_FOUND is the same as SQL_NO_DATA */
 %if (ODBCVER <  '0300'x) %then %do;
 dcl SQL_NO_DATA_FOUND fixed bin(31) value(100);
 %end; %else %do;
 dcl SQL_NO_DATA_FOUND fixed bin(31) value(SQL_NO_DATA);
 %end;

 /* an end handle type */
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_HANDLE_SENV fixed bin(31) value(5);
 %end; /* ODBCVER >= '0300'x */

 /* env attribute */
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_ATTR_ODBC_VERSION       fixed bin(31) value(200);
 dcl SQL_ATTR_CONNECTION_POOLING fixed bin(31) value(201);
 dcl SQL_ATTR_CP_MATCH           fixed bin(31) value(202);
 %end;  /* ODBCVER >= '0300'x */

 %if (ODBCVER >= '0300'x) %then %do;
 /* values for SQL_ATTR_CONNECTION_POOLING */
 dcl SQL_CP_OFF            fixed bin(31) value(0);
 dcl SQL_CP_ONE_PER_DRIVER fixed bin(31) value(1);
 dcl SQL_CP_ONE_PER_HENV   fixed bin(31) value(2);
 dcl SQL_CP_DEFAULT        fixed bin(31) value(SQL_CP_OFF);

 /* values for SQL_ATTR_CP_MATCH */
 dcl SQL_CP_STRICT_MATCH   fixed bin(31) value(0);
 dcl SQL_CP_RELAXED_MATCH  fixed bin(31) value(1);
 dcl SQL_CP_MATCH_DEFAULT  fixed bin(31) value(SQL_CP_STRICT_MATCH);

 /* values for SQL_ATTR_ODBC_VERSION */
 dcl SQL_OV_ODBC2  fixed bin(31) value(2);
 dcl SQL_OV_ODBC3  fixed bin(31) value(3);
 %end; /* ODBCVER >= '0300'x */

 /* connection attributes */
 dcl SQL_ACCESS_MODE             fixed bin(31) value(101);
 dcl SQL_AUTOCOMMIT              fixed bin(31) value(102);
 dcl SQL_LOGIN_TIMEOUT           fixed bin(31) value(103);
 dcl SQL_OPT_TRACE               fixed bin(31) value(104);
 dcl SQL_OPT_TRACEFILE           fixed bin(31) value(105);
 dcl SQL_TRANSLATE_DLL           fixed bin(31) value(106);
 dcl SQL_TRANSLATE_OPTION        fixed bin(31) value(107);
 dcl SQL_TXN_ISOLATION           fixed bin(31) value(108);
 dcl SQL_CURRENT_QUALIFIER       fixed bin(31) value(109);
 dcl SQL_ODBC_CURSORS            fixed bin(31) value(110);
 dcl SQL_QUIET_MODE              fixed bin(31) value(111);
 dcl SQL_PACKET_SIZE             fixed bin(31) value(112);

 /* connection attributes with new names */
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_ATTR_ACCESS_MODE        fixed bin(31)
     value(SQL_ACCESS_MODE);
 dcl SQL_ATTR_AUTOCOMMIT         fixed bin(31)
     value(SQL_AUTOCOMMIT);
 dcl SQL_ATTR_CONNECTION_TIMEOUT fixed bin(31) value(113);
 dcl SQL_ATTR_CURRENT_CATALOG    fixed bin(31)
     value(SQL_CURRENT_QUALIFIER);
 dcl SQL_ATTR_DISCONNECT_BEHAVIOR fixed bin(31) value(114);
 dcl SQL_ATTR_ENLIST_IN_DTC       fixed bin(31) value(1207);
 dcl SQL_ATTR_ENLIST_IN_XA        fixed bin(31) value(1208);
 dcl SQL_ATTR_LOGIN_TIMEOUT       fixed bin(31)
     value(SQL_LOGIN_TIMEOUT);
 dcl SQL_ATTR_ODBC_CURSORS        fixed bin(31)
     value(SQL_ODBC_CURSORS);
 dcl SQL_ATTR_PACKET_SIZE         fixed bin(31)
     value(SQL_PACKET_SIZE);
 dcl SQL_ATTR_QUIET_MODE          fixed bin(31)
     value(SQL_QUIET_MODE);
 dcl SQL_ATTR_TRACE               fixed bin(31)
     value(SQL_OPT_TRACE);
 dcl SQL_ATTR_TRACEFILE           fixed bin(31)
     value(SQL_OPT_TRACEFILE);
 dcl SQL_ATTR_TRANSLATE_LIB       fixed bin(31)
     value(SQL_TRANSLATE_DLL);
 dcl SQL_ATTR_TRANSLATE_OPTION    fixed bin(31)
     value(SQL_TRANSLATE_OPTION);
 dcl SQL_ATTR_TXN_ISOLATION       fixed bin(31)
     value(SQL_TXN_ISOLATION);
 %end; /* ODBCVER >= '0300'x */

 dcl SQL_ATTR_CONNECTION_DEAD     fixed bin (31) value (1209);
     /* GetConnectAttr only */

 %if (ODBCVER >= '0351'x) %then %do;
 /* ODBC Driver Manager sets this connection attribute to a unicode   */
 /* driver (which supports SQLConnectW) when the application is an    */
 /* ANSI application (which calls SQLConnect, SQLDriverConnect, or    */
 /* SQLBrowseConnect). This is SetConnectAttr only and application    */
 /* does not set this attribute. This attribute was introduced        */
 /* because some unicode driver's some APIs may need to behave        */
 /* differently on ANSI or Unicode applications. A unicode driver,    */
 /* which  has same behavior for both ANSI or Unicode applications,   */
 /* should return SQL_ERROR when the driver manager sets this         */
 /* connection attribute. When a unicode driver returns SQL_SUCCESS   */
 /* on this attribute, the driver manager treates ANSI and Unicode    */
 /* connections differently in connection pooling.                    */
 dcl SQL_ATTR_ANSI_APP            fixed bin (31) value (115);
 %end; /* ODBCVER >= '0300'x */

 /* SQL_CONNECT_OPT_DRVR_START is not meaningful for 3.0 driver */
 %if (ODBCVER < '0300'x) %then %do;
 dcl SQL_CONNECT_OPT_DRVR_START   fixed bin(31) value(1000);
 %end; /* ODBCVER < '0300'x */

 %if (ODBCVER < '0300'x) %then %do;
 dcl SQL_CONN_OPT_MAX fixed bin(31) value(SQL_PACKET_SIZE);
 dcl SQL_CONN_OPT_MIN fixed bin(31) value(SQL_ACCESS_MODE);
 %end; /* ODBCVER < '0300'x */

 /* SQL_ACCESS_MODE options */
 dcl SQL_MODE_READ_WRITE    fixed bin(31) value(0);
 dcl SQL_MODE_READ_ONLY     fixed bin(31) value(1);
 dcl SQL_MODE_DEFAULT       fixed bin(31) value(SQL_MODE_READ_WRITE);

 /* SQL_AUTOCOMMIT options */
 dcl SQL_AUTOCOMMIT_OFF     fixed bin(31) value(0);
 dcl SQL_AUTOCOMMIT_ON      fixed bin(31) value(1);
 dcl SQL_AUTOCOMMIT_DEFAULT fixed bin(31) value(SQL_AUTOCOMMIT_ON);

 /* SQL_LOGIN_TIMEOUT options */
 dcl SQL_LOGIN_TIMEOUT_DEFAULT fixed bin(31) value(15);

 /* SQL_OPT_TRACE options */
 dcl SQL_OPT_TRACE_OFF     fixed bin(31) value(0);
 dcl SQL_OPT_TRACE_ON      fixed bin(31) value(1);
 dcl SQL_OPT_TRACE_DEFAULT fixed bin(31) value(SQL_OPT_TRACE_OFF);
 dcl SQL_OPT_TRACE_FILE_DEFAULT char value('\SQL.LOG');

 /* SQL_ODBC_CURSORS options */
 dcl SQL_CUR_USE_IF_NEEDED fixed bin(31) value(0);
 dcl SQL_CUR_USE_ODBC      fixed bin(31) value(1);
 dcl SQL_CUR_USE_DRIVER    fixed bin(31) value(2);
 dcl SQL_CUR_DEFAULT       fixed bin(31) value(SQL_CUR_USE_DRIVER);

 %if (ODBCVER >= '0300'x) %then %do;
 /* values for SQL_ATTR_DISCONNECT_BEHAVIOR */
 dcl SQL_DB_RETURN_TO_POOL fixed bin(31) value(0);
 dcl SQL_DB_DISCONNECT     fixed bin(31) value(1);
 dcl SQL_DB_DEFAULT        fixed bin(31) value(SQL_DB_RETURN_TO_POOL);

 /* values for SQL_ATTR_ENLIST_IN_DTC */
 dcl SQL_DTC_DONE          fixed bin(31) value(0);
 %end; /* ODBCVER >= '0300'x */

 /* values for SQL_ATTR_CONNECTION_DEAD */
 dcl SQL_CD_TRUE           fixed bin(31) value(1);
     /* Connection is closed/dead */
 dcl SQL_CD_FALSE          fixed bin(31) value(0);
     /* Connection is open/available */

 /* values for SQL_ATTR_ANSI_APP */
 %if (ODBCVER >= '0351'x) %then %do;
 dcl SQL_AA_TRUE           fixed bin(31) value(1);
     /* the application is an ANSI app */
 dcl SQL_AA_FALSE          fixed bin(31) value(0);
     /* the application is a Unicode app */
 %end; /* ODBCVER >= '0351'x */

 /* statement attributes */
 dcl SQL_QUERY_TIMEOUT   fixed bin(31) value(0);
 dcl SQL_MAX_ROWS        fixed bin(31) value(1);
 dcl SQL_NOSCAN          fixed bin(31) value(2);
 dcl SQL_MAX_LENGTH      fixed bin(31) value(3);
 dcl SQL_ASYNC_ENABLE    fixed bin(31) value(4);
     /* same as SQL_ATTR_ASYNC_ENABLE */
 dcl SQL_BIND_TYPE       fixed bin(31) value(5);
 dcl SQL_CURSOR_TYPE     fixed bin(31) value(6);
 dcl SQL_CONCURRENCY     fixed bin(31) value(7);
 dcl SQL_KEYSET_SIZE     fixed bin(31) value(8);
 dcl SQL_ROWSET_SIZE     fixed bin(31) value(9);
 dcl SQL_SIMULATE_CURSOR fixed bin(31) value(10);
 dcl SQL_RETRIEVE_DATA   fixed bin(31) value(11);
 dcl SQL_USE_BOOKMARKS   fixed bin(31) value(12);
 dcl SQL_GET_BOOKMARK    fixed bin(31) value(13); /*GetStmtOption Only*/

 dcl SQL_ROW_NUMBER      fixed bin(31) value(14); /*GetStmtOption Only*/

 /* statement attributes for ODBC 3.0 */
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_ATTR_ASYNC_ENABLE          fixed bin(31) value(4);
 dcl SQL_ATTR_CONCURRENCY           fixed bin(31)
     value(SQL_CONCURRENCY);
 dcl SQL_ATTR_CURSOR_TYPE           fixed bin(31)
     value(SQL_CURSOR_TYPE);
 dcl SQL_ATTR_ENABLE_AUTO_IPD       fixed bin(31) value(15);
 dcl SQL_ATTR_FETCH_BOOKMARK_PTR    fixed bin(31) value(16);
 dcl SQL_ATTR_KEYSET_SIZE           fixed bin(31)
     value(SQL_KEYSET_SIZE);
 dcl SQL_ATTR_MAX_LENGTH            fixed bin(31) value(SQL_MAX_LENGTH);
 dcl SQL_ATTR_MAX_ROWS              fixed bin(31) value(SQL_MAX_ROWS);
 dcl SQL_ATTR_NOSCAN                fixed bin(31) value(SQL_NOSCAN);
 dcl SQL_ATTR_PARAM_BIND_OFFSET_PTR fixed bin(31) value(17);
 dcl SQL_ATTR_PARAM_BIND_TYPE       fixed bin(31) value(18);
 dcl SQL_ATTR_PARAM_OPERATION_PTR   fixed bin(31) value(19);
 dcl SQL_ATTR_PARAM_STATUS_PTR      fixed bin(31) value(20);
 dcl SQL_ATTR_PARAMS_PROCESSED_PTR  fixed bin(31) value(21);
 dcl SQL_ATTR_PARAMSET_SIZE         fixed bin(31) value(22);
 dcl SQL_ATTR_QUERY_TIMEOUT         fixed bin(31)
     value(SQL_QUERY_TIMEOUT);
 dcl SQL_ATTR_RETRIEVE_DATA         fixed bin(31)
     value(SQL_RETRIEVE_DATA);
 dcl SQL_ATTR_ROW_BIND_OFFSET_PTR   fixed bin(31) value(23);
 dcl SQL_ATTR_ROW_BIND_TYPE         fixed bin(31) value(SQL_BIND_TYPE);
 dcl SQL_ATTR_ROW_NUMBER            fixed bin(31) value(SQL_ROW_NUMBER);
 /* GetStmtAttr */
 dcl SQL_ATTR_ROW_OPERATION_PTR     fixed bin(31) value(24);
 dcl SQL_ATTR_ROW_STATUS_PTR        fixed bin(31) value(25);
 dcl SQL_ATTR_ROWS_FETCHED_PTR      fixed bin(31) value(26);
 dcl SQL_ATTR_ROW_ARRAY_SIZE        fixed bin(31) value(27);
 dcl SQL_ATTR_SIMULATE_CURSOR       fixed bin(31)
     value(SQL_SIMULATE_CURSOR);
 dcl SQL_ATTR_USE_BOOKMARKS         fixed bin(31)
     value(SQL_USE_BOOKMARKS);
 %end; /* ODBCVER >= '0300'x */

 %if (ODBCVER < '0300'x) %then %do;
 dcl SQL_STMT_OPT_MAX fixed bin(31) value(SQL_ROW_NUMBER);
 dcl SQL_STMT_OPT_MIN fixed bin(31) value(SQL_QUERY_TIMEOUT);
 %end; /* ODBCVER < '0300'x */

 /* whether an attribute is a pointer or not */
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_IS_POINTER   fixed bin(31) value(-4);
 dcl SQL_IS_UINTEGER  fixed bin(31) value(-5);
 dcl SQL_IS_INTEGER   fixed bin(31) value(-6);
 dcl SQL_IS_USMALLINT fixed bin(31) value(-7);
 dcl SQL_IS_SMALLINT  fixed bin(31) value(-8);
 %end; /* ODBCVER >= '0300'x */

 /* the value of SQL_ATTR_PARAM_BIND_TYPE */
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_PARAM_BIND_BY_COLUMN    fixed bin(31) value(0);
 dcl SQL_PARAM_BIND_TYPE_DEFAULT fixed bin(31)
     value(SQL_PARAM_BIND_BY_COLUMN);
 %end; /* ODBCVER >= '0300'x */

 /* SQL_QUERY_TIMEOUT options */
 dcl SQL_QUERY_TIMEOUT_DEFAULT  fixed bin(31) value(0);

 /* SQL_MAX_ROWS options */
 dcl SQL_MAX_ROWS_DEFAULT  fixed bin(31) value(0);

 /* SQL_NOSCAN options */
 dcl SQL_NOSCAN_OFF     fixed bin(31) value(0);    /*      1.0 FALSE */
 dcl SQL_NOSCAN_ON      fixed bin(31) value(1);    /*      1.0 TRUE */
 dcl SQL_NOSCAN_DEFAULT fixed bin(31) value(SQL_NOSCAN_OFF);

 /* SQL_MAX_LENGTH options */
 dcl SQL_MAX_LENGTH_DEFAULT   fixed bin(31) value(0);

 /* values for SQL_ATTR_ASYNC_ENABLE */
 dcl SQL_ASYNC_ENABLE_OFF     fixed bin(31) value(0);
 dcl SQL_ASYNC_ENABLE_ON      fixed bin(31) value(1);
 dcl SQL_ASYNC_ENABLE_DEFAULT fixed bin(31) value(SQL_ASYNC_ENABLE_OFF);

 /* SQL_BIND_TYPE options */
 dcl SQL_BIND_BY_COLUMN    fixed bin(31) value(0);
 /* Default value */
 dcl SQL_BIND_TYPE_DEFAULT fixed bin(31) value(SQL_BIND_BY_COLUMN);

 /* SQL_CONCURRENCY options */
 dcl SQL_CONCUR_READ_ONLY fixed bin(31) value(1);
 dcl SQL_CONCUR_LOCK      fixed bin(31) value(2);
 dcl SQL_CONCUR_ROWVER    fixed bin(31) value(3);
 dcl SQL_CONCUR_VALUES    fixed bin(31) value(4);
 /* Default value */
 dcl SQL_CONCUR_DEFAULT   fixed bin(31) value(SQL_CONCUR_READ_ONLY);

 /* SQL_CURSOR_TYPE options */
 dcl SQL_CURSOR_FORWARD_ONLY  fixed bin(31) value(0);
 dcl SQL_CURSOR_KEYSET_DRIVEN fixed bin(31) value(1);
 dcl SQL_CURSOR_DYNAMIC       fixed bin(31) value(2);
 dcl SQL_CURSOR_STATIC        fixed bin(31) value(3);
 /* Default value */
 dcl SQL_CURSOR_TYPE_DEFAULT  fixed bin(31)
                              value(SQL_CURSOR_FORWARD_ONLY);

 /* SQL_ROWSET_SIZE options */
 dcl SQL_ROWSET_SIZE_DEFAULT  fixed bin(31) value(1);

 /* SQL_KEYSET_SIZE options */
 dcl SQL_KEYSET_SIZE_DEFAULT  fixed bin(31) value(0);

 /* SQL_SIMULATE_CURSOR options */
 dcl SQL_SC_NON_UNIQUE fixed bin(31) value(0);
 dcl SQL_SC_TRY_UNIQUE fixed bin(31) value(1);
 dcl SQL_SC_UNIQUE     fixed bin(31) value(2);

 /* SQL_RETRIEVE_DATA options */
 dcl SQL_RD_OFF     fixed bin(31) value(0);
 dcl SQL_RD_ON      fixed bin(31) value(1);
 dcl SQL_RD_DEFAULT fixed bin(31) value(SQL_RD_ON);

 /* SQL_USE_BOOKMARKS options */
 dcl SQL_UB_OFF     fixed bin(31) value(0);
 dcl SQL_UB_ON      fixed bin(31) value(1);
 dcl SQL_UB_DEFAULT fixed bin(31) value(SQL_UB_OFF);

 /* New values for SQL_USE_BOOKMARKS attribute */
 %if (ODBCVER >=  '0300'x) %then %do;
 dcl SQL_UB_FIXED    fixed bin(31) value(SQL_UB_ON);
 dcl SQL_UB_VARIABLE fixed bin(31) value(2);
 %end; /* ODBCVER >= '0300'x */


 /* defines for diagnostics fields */
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_DIAG_CURSOR_ROW_COUNT fixed bin(31) value(-1249);
 dcl SQL_DIAG_ROW_NUMBER       fixed bin(31) value(-1248);
 dcl SQL_DIAG_COLUNM_NUMBER    fixed bin(31) value(-1247);
 %end; /* ODBCVER >= '0300'x */

 /* dynamic function codes */
 %if (ODBCVER >=  '0300'x) %then %do;
 dcl SQL_DIAG_CALL fixed bin(31) value(7);
 %end; /* ODBCVER >= '0300'x */

 /* SQL extended datatypes */
 dcl SQL_DATE                  fixed bin(31) value(9);
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_INTERVAL              fixed bin(31) value(10);
 %end; /* ODBCVER >= '0300'x */
 dcl SQL_TIME                  fixed bin(31) value(10);
 dcl SQL_TIMESTAMP             fixed bin(31) value(11);
 dcl SQL_LONGVARCHAR           fixed bin(31) value(-1);
 dcl SQL_BINARY                fixed bin(31) value(-2);
 dcl SQL_VARBINARY             fixed bin(31) value(-3);
 dcl SQL_LONGVARBINARY         fixed bin(31) value(-4);
 dcl SQL_BIGINT                fixed bin(31) value(-5);
 dcl SQL_TINYINT               fixed bin(31) value(-6);
 dcl SQL_BIT                   fixed bin(31) value(-7);
 %if (ODBCVER >= '0350'x) %then %do;
 dcl SQL_GUID                  fixed bin(31) value(-11);
 %end; /* ODBCVER >= '0350'x */

 %if (ODBCVER >= '0300'x) %then %do;
 /* interval code */
 dcl SQL_CODE_YEAR             fixed bin(31) value(1);
 dcl SQL_CODE_MONTH            fixed bin(31) value(2);
 dcl SQL_CODE_DAY              fixed bin(31) value(3);
 dcl SQL_CODE_HOUR             fixed bin(31) value(4);
 dcl SQL_CODE_MINUTE           fixed bin(31) value(5);
 dcl SQL_CODE_SECOND           fixed bin(31) value(6);
 dcl SQL_CODE_YEAR_TO_MONTH    fixed bin(31) value(7);
 dcl SQL_CODE_DAY_TO_HOUR      fixed bin(31) value(8);
 dcl SQL_CODE_DAY_TO_MINUTE    fixed bin(31) value(9);
 dcl SQL_CODE_DAY_TO_SECOND    fixed bin(31) value(10);
 dcl SQL_CODE_HOUR_TO_MINUTE   fixed bin(31) value(11);
 dcl SQL_CODE_HOUR_TO_SECOND   fixed bin(31) value(12);
 dcl SQL_CODE_MINUTE_TO_SECOND fixed bin(31) value(13);

 dcl SQL_INTERVAL_YEAR             fixed bin(31)
      value(100 + SQL_CODE_YEAR);
 dcl SQL_INTERVAL_MONTH            fixed bin(31)
     value(100 + SQL_CODE_MONTH);
 dcl SQL_INTERVAL_DAY              fixed bin(31)
     value(100 + SQL_CODE_DAY);
 dcl SQL_INTERVAL_HOUR             fixed bin(31)
     value(100 + SQL_CODE_HOUR);
 dcl SQL_INTERVAL_MINUTE           fixed bin(31)
     value(100 + SQL_CODE_MINUTE);
 dcl SQL_INTERVAL_SECOND           fixed bin(31)
     value(100 + SQL_CODE_SECOND);
 dcl SQL_INTERVAL_YEAR_TO_MONTH    fixed bin(31)
     value(100 + SQL_CODE_YEAR_TO_MONTH);
 dcl SQL_INTERVAL_DAY_TO_HOUR      fixed bin(31)
     value(100 + SQL_CODE_DAY_TO_HOUR);
 dcl SQL_INTERVAL_DAY_TO_MINUTE    fixed bin(31)
     value(100 + SQL_CODE_DAY_TO_MINUTE);
 dcl SQL_INTERVAL_DAY_TO_SECOND    fixed bin(31)
     value(100 + SQL_CODE_DAY_TO_SECOND);
 dcl SQL_INTERVAL_HOUR_TO_MINUTE   fixed bin(31)
     value(100 + SQL_CODE_HOUR_TO_MINUTE);
 dcl SQL_INTERVAL_HOUR_TO_SECOND   fixed bin(31)
     value(100 + SQL_CODE_HOUR_TO_SECOND);
 dcl SQL_INTERVAL_MINUTE_TO_SECOND fixed bin(31)
     value(100 + SQL_CODE_MINUTE_TO_SECOND);

 %end; %else %do;
 dcl SQL_INTERVAL_YEAR             fixed bin(31) value(-80);
 dcl SQL_INTERVAL_MONTH            fixed bin(31) value(-81);
 dcl SQL_INTERVAL_YEAR_TO_MONTH    fixed bin(31) value(-82);
 dcl SQL_INTERVAL_DAY              fixed bin(31) value(-83);
 dcl SQL_INTERVAL_HOUR             fixed bin(31) value(-84);
 dcl SQL_INTERVAL_MINUTE           fixed bin(31) value(-85);
 dcl SQL_INTERVAL_SECOND           fixed bin(31) value(-86);
 dcl SQL_INTERVAL_DAY_TO_HOUR      fixed bin(31) value(-87);
 dcl SQL_INTERVAL_DAY_TO_MINUTE    fixed bin(31) value(-88);
 dcl SQL_INTERVAL_DAY_TO_SECOND    fixed bin(31) value(-89);
 dcl SQL_INTERVAL_HOUR_TO_MINUTE   fixed bin(31) value(-90);
 dcl SQL_INTERVAL_HOUR_TO_SECOND   fixed bin(31) value(-91);
 dcl SQL_INTERVAL_MINUTE_TO_SECOND fixed bin(31) value(-92);
 %end; /* ODBCVER >= '0300'x */


 dcl SQL_UNICODE                   fixed bin(31) value(-95);
 dcl SQL_UNICODE_VARCHAR           fixed bin(31) value(-96);
 dcl SQL_UNICODE_LONGVARCHAR       fixed bin(31) value(-97);
 dcl SQL_UNICODE_CHAR              fixed bin(31) value(SQL_UNICODE);

 %if (ODBCVER < '0300'x) %then %do;
 dcl SQL_TYPE_DRIVER_START         fixed bin(31)
     value(SQL_INTERVAL_YEAR);
 dcl SQL_TYPE_DRIVER_END           fixed bin(31)
     value(SQL_UNICODE_LONGVARCHAR);
 %end; /* ODBCVER < '0300'x */

 /* C datatype to SQL datatype mapping      SQL types                */
 /*                                 -------------------------------- */
 /*                                  CHAR, VARCHAR, DECIMAL, NUMERIC */
 dcl SQL_C_CHAR    fixed bin(31) value(SQL_CHAR);
                                     /* INTEGER                      */
 dcl SQL_C_LONG    fixed bin(31) value(SQL_INTEGER);
                                     /* SMALLINT                     */
 dcl SQL_C_SHORT   fixed bin(31) value(SQL_SMALLINT);
                                     /* REAL                         */
 dcl SQL_C_FLOAT   fixed bin(31) value(SQL_REAL);
                                     /* FLOAT, DOUBLE                */
 dcl SQL_C_DOUBLE  fixed bin(31) value(SQL_DOUBLE);
 %if (ODBCVER >=  '0300'x) %then %do;
 dcl SQL_C_NUMERIC fixed bin(31) value(SQL_NUMERIC);
 %end; /* ODBCVER >= '0300'x */
 dcl SQL_C_DEFAULT fixed bin(31) value(99);

 dcl SQL_SIGNED_OFFSET   fixed bin(31) value(-20);
 dcl SQL_UNSIGNED_OFFSET fixed bin(31) value(-22);

 /* C datatype to SQL datatype mapping */

 dcl SQL_C_DATE            fixed bin(31) value(SQL_DATE);
 dcl SQL_C_TIME            fixed bin(31) value(SQL_TIME);
 dcl SQL_C_TIMESTAMP       fixed bin(31) value(SQL_TIMESTAMP);
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_C_TYPE_DATE       fixed bin(31) value(SQL_TYPE_DATE);
 dcl SQL_C_TYPE_TIME       fixed bin(31) value(SQL_TYPE_TIME);
 dcl SQL_C_TYPE_TIMESTAMP  fixed bin(31) value(SQL_TYPE_TIMESTAMP);
 dcl SQL_C_INTERVAL_YEAR   fixed bin(31) value(SQL_INTERVAL_YEAR);
 dcl SQL_C_INTERVAL_MONTH  fixed bin(31) value(SQL_INTERVAL_MONTH);
 dcl SQL_C_INTERVAL_DAY    fixed bin(31) value(SQL_INTERVAL_DAY);
 dcl SQL_C_INTERVAL_HOUR   fixed bin(31) value(SQL_INTERVAL_HOUR);
 dcl SQL_C_INTERVAL_MINUTE fixed bin(31) value(SQL_INTERVAL_MINUTE);
 dcl SQL_C_INTERVAL_SECOND fixed bin(31) value(SQL_INTERVAL_SECOND);
 dcl SQL_C_INTERVAL_YEAR_TO_MONTH    fixed bin(31)
     value(SQL_INTERVAL_YEAR_TO_MONTH);
 dcl SQL_C_INTERVAL_DAY_TO_HOUR      fixed bin(31)
     value(SQL_INTERVAL_DAY_TO_HOUR);
 dcl SQL_C_INTERVAL_DAY_TO_MINUTE    fixed bin(31)
     value(SQL_INTERVAL_DAY_TO_MINUTE);
 dcl SQL_C_INTERVAL_DAY_TO_SECOND    fixed bin(31)
     value(SQL_INTERVAL_DAY_TO_SECOND);
 dcl SQL_C_INTERVAL_HOUR_TO_MINUTE   fixed bin(31)
     value(SQL_INTERVAL_HOUR_TO_MINUTE);
 dcl SQL_C_INTERVAL_HOUR_TO_SECOND   fixed bin(31)
     value(SQL_INTERVAL_HOUR_TO_SECOND);
 dcl SQL_C_INTERVAL_MINUTE_TO_SECOND fixed bin(31)
     value(SQL_INTERVAL_MINUTE_TO_SECOND);
 %end; /* ODBCVER >= '0300'x */
 dcl SQL_C_BINARY fixed bin(31) value(SQL_BINARY);
 dcl SQL_C_BIT    fixed bin(31) value(SQL_BIT);

 %if (ODBCVER >=  '0300'x) %then %do;
 /* SIGNED BIGINT */
 dcl SQL_C_SBIGINT fixed bin(31)
     value(SQL_BIGINT+SQL_SIGNED_OFFSET);
 /* UNSIGNED BIGINT */
 dcl SQL_C_UBIGINT fixed bin(31)
     value(SQL_BIGINT+SQL_UNSIGNED_OFFSET);
 %end; /* ODBCVER >= '0300'x */
 dcl SQL_C_TINYINT  fixed bin(31) value(SQL_TINYINT);
 /* SIGNED INTEGER  */
 dcl SQL_C_SLONG    fixed bin(31)
     value(SQL_C_LONG+SQL_SIGNED_OFFSET);
 /* SIGNED SMALLINT */
 dcl SQL_C_SSHORT   fixed bin(31)
     value(SQL_C_SHORT+SQL_SIGNED_OFFSET);
 /* SIGNED TINYINT  */
 dcl SQL_C_STINYINT fixed bin(31)
     value(SQL_TINYINT+SQL_SIGNED_OFFSET);
 /* UNSIGNED INTEGER*/
 dcl SQL_C_ULONG    fixed bin(31)
     value(SQL_C_LONG+SQL_UNSIGNED_OFFSET);
 /* UNSIGNED SMALLINT*/
 dcl SQL_C_USHORT   fixed bin(31)
     value(SQL_C_SHORT+SQL_UNSIGNED_OFFSET);
 /* UNSIGNED TINYINT*/
 dcl SQL_C_UTINYINT fixed bin(31)
     value(SQL_TINYINT+SQL_UNSIGNED_OFFSET);
 /* BOOKMARK        */
 dcl SQL_C_BOOKMARK fixed bin(31) value(SQL_C_ULONG);

 %if (ODBCVER >= '0350'x) %then %do;
 dcl SQL_C_GUID  fixed bin(31) value(SQL_GUID);
 %end; /* ODBCVER >= '0350'x */

 dcl SQL_TYPE_NULL  fixed bin(31) value(0);
 %if (ODBCVER < '0300'x) %then %do;
 dcl SQL_TYPE_MIN   fixed bin(31) value(SQL_BIT);
 dcl SQL_TYPE_MAX   fixed bin(31) value(SQL_VARCHAR);
 %end;

 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_C_VARBOOKMARK fixed bin(31) value(SQL_C_BINARY);
 %end; /* ODBCVER >= '0300'x */

 /* define for SQL_DIAG_ROW_NUMBER and SQL_DIAG_COLUMN_NUMBER */
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_NO_ROW_NUMBER         fixed bin(31) value(-1);
 dcl SQL_NO_COLUMN_NUMBER      fixed bin(31) value(-1);
 dcl SQL_ROW_NUMBER_UNKNOWN    fixed bin(31) value(-2);
 dcl SQL_COLUMN_NUMBER_UNKNOWN fixed bin(31) value(-2);
 %end;

 /* SQLBindParameter extensions */
 dcl SQL_DEFAULT_PARAM fixed bin(31) value(-5);
 dcl SQL_IGNORE        fixed bin(31) value(-6);
 %if (ODBCVER >=  '0300'x) %then %do;
 dcl SQL_COLUMN_IGNORE fixed bin(31) value(SQL_IGNORE);
 %end; /* ODBCVER >= '0300'x */
 dcl SQL_LEN_DATA_AT_EXEC_OFFSET fixed bin(31) value(-100);

 SQL_LEN_DATA_AT_EXEC:
   proc (len)
   returns (fixed bin(31) )
   options (inline byvalue) internal;

   dcl len fixed bin(31) byvalue;

   return( -(len)+SQL_LEN_DATA_AT_EXEC_OFFSET );
 end SQL_LEN_DATA_AT_EXEC;

 /* binary length for driver specific attributes */
 dcl SQL_LEN_BINARY_ATTR_OFFSET fixed bin(31) value(-100);

 SQL_LEN_BINARY_ATTR:
   proc (len)
   returns (fixed bin(31))
   options (inline byvalue) internal;

   dcl len fixed bin(31) byvalue;

   return( -(len)+SQL_LEN_BINARY_ATTR_OFFSET );
 end SQL_LEN_BINARY_ATTR;

 /* SQLColAttributes defines */
 dcl SQL_COLUMN_COUNT                fixed bin(31) value(0);
 dcl SQL_COLUMN_NAME                 fixed bin(31) value(1);
 dcl SQL_COLUMN_TYPE                 fixed bin(31) value(2);
 dcl SQL_COLUMN_LENGTH               fixed bin(31) value(3);
 dcl SQL_COLUMN_PRECISION            fixed bin(31) value(4);
 dcl SQL_COLUMN_SCALE                fixed bin(31) value(5);
 dcl SQL_COLUMN_DISPLAY_SIZE         fixed bin(31) value(6);
 dcl SQL_COLUMN_NULLABLE             fixed bin(31) value(7);
 dcl SQL_COLUMN_UNSIGNED             fixed bin(31) value(8);
 dcl SQL_COLUMN_MONEY                fixed bin(31) value(9);
 dcl SQL_COLUMN_UPDATABLE            fixed bin(31) value(10);
 dcl SQL_COLUMN_AUTO_INCREMENT       fixed bin(31) value(11);
 dcl SQL_COLUMN_CASE_SENSITIVE       fixed bin(31) value(12);
 dcl SQL_COLUMN_SEARCHABLE           fixed bin(31) value(13);
 dcl SQL_COLUMN_TYPE_NAME            fixed bin(31) value(14);
 dcl SQL_COLUMN_TABLE_NAME           fixed bin(31) value(15);
 dcl SQL_COLUMN_OWNER_NAME           fixed bin(31) value(16);
 dcl SQL_COLUMN_QUALIFIER_NAME       fixed bin(31) value(17);
 dcl SQL_COLUMN_LABEL                fixed bin(31) value(18);
 dcl SQL_COLATT_OPT_MAX              fixed bin(31)
     value(SQL_COLUMN_LABEL);
 %if (ODBCVER < '0300'x) %then %do;
 dcl SQL_COLUMN_DRIVER_START         fixed bin(31) value(1000);
 %end; /* ODBCVER < '0300'x */

 /* extended descriptor field */
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_DESC_ARRAY_SIZE                   fixed bin(31) value(20);
 dcl SQL_DESC_ARRAY_STATUS_PTR             fixed bin(31) value(21);
 dcl SQL_DESC_AUTO_UNIQUE_VALUE            fixed bin(31)
     value(SQL_COLUMN_AUTO_INCREMENT);
 dcl SQL_DESC_BASE_COLUMN_NAME             fixed bin(31) value(22);
 dcl SQL_DESC_BASE_TABLE_NAME              fixed bin(31) value(23);
 dcl SQL_DESC_BIND_OFFSET_PTR              fixed bin(31) value(24);
 dcl SQL_DESC_BIND_TYPE                    fixed bin(31) value(25);
 dcl SQL_DESC_CASE_SENSITIVE               fixed bin(31)
     value(SQL_COLUMN_CASE_SENSITIVE);
 dcl SQL_DESC_CATALOG_NAME                 fixed bin(31)
     value(SQL_COLUMN_QUALIFIER_NAME);
 dcl SQL_DESC_CONCISE_TYPE                 fixed bin(31)
     value(SQL_COLUMN_TYPE);
 dcl SQL_DESC_DATETIME_INTERVAL_PRECISION  fixed bin(31) value(26);
 dcl SQL_DESC_DISPLAY_SIZE                 fixed bin(31)
     value(SQL_COLUMN_DISPLAY_SIZE);
 dcl SQL_DESC_FIXED_PREC_SCALE             fixed bin(31)
     value(SQL_COLUMN_MONEY);
 dcl SQL_DESC_LABEL                        fixed bin(31)
     value(SQL_COLUMN_LABEL);
 dcl SQL_DESC_LITERAL_PREFIX               fixed bin(31) value(27);
 dcl SQL_DESC_LITERAL_SUFFIX               fixed bin(31) value(28);
 dcl SQL_DESC_LOCAL_TYPE_NAME              fixed bin(31) value(29);
 dcl SQL_DESC_MAXIMUM_SCALE                fixed bin(31) value(30);
 dcl SQL_DESC_MINIMUM_SCALE                fixed bin(31) value(31);
 dcl SQL_DESC_NUM_PREC_RADIX               fixed bin(31) value(32);
 dcl SQL_DESC_PARAMETER_TYPE               fixed bin(31) value(33);
 dcl SQL_DESC_ROWS_PROCESSED_PTR           fixed bin(31) value(34);
 %if (ODBCVER >= '0350'x) %then %do;
 dcl SQL_DESC_ROWVER                       fixed bin(31) value(35);
 %end; /* ODBCVER >= '0350'x */
 dcl SQL_DESC_SCHEMA_NAME                  fixed bin(31)
     value(SQL_COLUMN_OWNER_NAME);
 dcl SQL_DESC_SEARCHABLE                   fixed bin(31)
     value(SQL_COLUMN_SEARCHABLE);
 dcl SQL_DESC_TYPE_NAME                    fixed bin(31)
     value(SQL_COLUMN_TYPE_NAME);
 dcl SQL_DESC_TABLE_NAME                   fixed bin(31)
     value(SQL_COLUMN_TABLE_NAME);
 dcl SQL_DESC_UNSIGNED                     fixed bin(31)
     value(SQL_COLUMN_UNSIGNED);
 dcl SQL_DESC_UPDATABLE                    fixed bin(31)
     value(SQL_COLUMN_UPDATABLE);
 %end;

 dcl SQL_COLATT_OPT_MIN         fixed bin(31) value(SQL_COLUMN_COUNT);

 /* SQLColAttributes subdefines for SQL_COLUMN_UPDATABLE */
 dcl SQL_ATTR_READONLY          fixed bin(31) value(0);
 dcl SQL_ATTR_WRITE             fixed bin(31) value(1);
 dcl SQL_ATTR_READWRITE_UNKNOWN fixed bin(31) value(2);

 /* SQLColAttributes subdefines for SQL_COLUMN_SEARCHABLE */
 /* These are also used by SQLGetInfo                     */
 dcl SQL_UNSEARCHABLE    fixed bin(31) value(0);
 dcl SQL_LIKE_ONLY       fixed bin(31) value(1);
 dcl SQL_ALL_EXCEPT_LIKE fixed bin(31) value(2);
 dcl SQL_SEARCHABLE      fixed bin(31) value(3);
 dcl SQL_PRED_SEARCHABLE fixed bin(31) value(SQL_SEARCHABLE);


 /* New defines for SEARCHABLE column in SQLGetTypeInfo */

 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_COL_PRED_CHAR  fixed bin(31) value(SQL_LIKE_ONLY);
 dcl SQL_COL_PRED_BASIC fixed bin(31) value(SQL_ALL_EXCEPT_LIKE);
 %end; /* ODBCVER >= '0300'x */

 /* Special return values for SQLGetData */
 dcl SQL_NO_TOTAL fixed bin(31) value(-4);

 /********************************************/
 /* SQLGetFunctions: additional values for   */
 /* fFunction to represent functions that    */
 /* are not in the X/Open spec.              */
 /********************************************/

 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_API_SQLALLOCHANDLESTD   fixed bin(31) value(73);
 dcl SQL_API_SQLBULKOPERATIONS   fixed bin(31) value(24);
 %end; /* ODBCVER >= '0300'x */
 dcl SQL_API_SQLBINDPARAMETER    fixed bin(31) value(72);
 dcl SQL_API_SQLBROWSECONNECT    fixed bin(31) value(55);
 dcl SQL_API_SQLCOLATTRIBUTES    fixed bin(31) value(6);
 dcl SQL_API_SQLCOLUMNPRIVILEGES fixed bin(31) value(56);
 dcl SQL_API_SQLDESCRIBEPARAM    fixed bin(31) value(58);
 dcl SQL_API_SQLDRIVERCONNECT    fixed bin(31) value(41);
 dcl SQL_API_SQLDRIVERS          fixed bin(31) value(71);
 dcl SQL_API_SQLEXTENDEDFETCH    fixed bin(31) value(59);
 dcl SQL_API_SQLFOREIGNKEYS      fixed bin(31) value(60);
 dcl SQL_API_SQLMORERESULTS      fixed bin(31) value(61);
 dcl SQL_API_SQLNATIVESQL        fixed bin(31) value(62);
 dcl SQL_API_SQLNUMPARAMS        fixed bin(31) value(63);
 dcl SQL_API_SQLPARAMOPTIONS     fixed bin(31) value(64);
 dcl SQL_API_SQLPRIMARYKEYS      fixed bin(31) value(65);
 dcl SQL_API_SQLPROCEDURECOLUMNS fixed bin(31) value(66);
 dcl SQL_API_SQLPROCEDURES       fixed bin(31) value(67);
 dcl SQL_API_SQLSETPOS           fixed bin(31) value(68);
 dcl SQL_API_SQLSETSCROLLOPTIONS fixed bin(31) value(69);
 dcl SQL_API_SQLTABLEPRIVILEGES  fixed bin(31) value(70);

 /*-------------------------------------------*/
 /* SQL_EXT_API_LAST is not useful with ODBC  */
 /* version 3.0 because some of the values    */
 /* from X/Open are in the 10000 range.       */
 /*-------------------------------------------*/

 %if (ODBCVER < '0300'x) %then %do;
 dcl SQL_EXT_API_LAST            fixed bin(31)
     value(SQL_API_SQLBINDPARAMETER);
 dcl SQL_NUM_FUNCTIONS           fixed bin(31) value(23);
 dcl SQL_EXT_API_START           fixed bin(31) value(40);
 dcl SQL_NUM_EXTENSIONS          fixed bin(31)
     value(SQL_EXT_API_LAST-SQL_EXT_API_START+1);
 %end;

 /*--------------------------------------------*/
 /* SQL_API_ALL_FUNCTIONS returns an array     */
 /* of 'booleans' representing whether a       */
 /* function is implemented by the driver.     */
 /*                                            */
 /* CAUTION: Only functions defined in ODBC    */
 /* version 2.0 and earlier are returned, the  */
 /* new high-range function numbers defined by */
 /* X/Open break this scheme.   See the new    */
 /* method -- SQL_API_ODBC3_ALL_FUNCTIONS      */
 /*--------------------------------------------*/

 /* See CAUTION above */
 dcl SQL_API_ALL_FUNCTIONS fixed bin(31) value(0);

 /*----------------------------------------------*/
 /* 2.X drivers export a dummy function with   */
 /* ordinal number SQL_API_LOADBYORDINAL to speed*/
 /* loading under the windows operating system.  */
 /*       */
 /* CAUTION: Loading by ordinal is not supported */
 /* for 3.0 and above drivers.   */
 /*----------------------------------------------*/

 /* See CAUTION above */
 dcl SQL_API_LOADBYORDINAL fixed bin(31) value(199);

 /*----------------------------------------------*/
 /* SQL_API_ODBC3_ALL_FUNCTIONS                  */
 /* This returns a bitmap, which allows us to    */
 /* handle the higher-valued function numbers.   */
 /* Use  SQL_FUNC_EXISTS3(bitmap,function_number)*/
 /* to determine if the function exists.         */
 /*----------------------------------------------*/

 dcl SQL_API_ODBC3_ALL_FUNCTIONS    fixed bin(31) value(999);
 /* array of 250 words */
 dcl SQL_API_ODBC3_ALL_FUNCTIONS_SZ fixed bin(31) value(250);

   SQL_FUNC_EXISTS3:
     proc (ptrExists, myuwAPI)
     returns (bit(1) nonvarying )
     options (inline byvalue) internal;

     dcl ptrExists pointer byvalue;
     dcl myBitExists(4000) bit(1) based(ptrExists);
     dcl myuwAPI    TYPE SQLUSMALLINT;

     return (myBitExists(myuwAPI));
   end;

 /*---------------------------------------------- */
 /* SQL_API_ALL_FUNCTIONS returns an array.       */
 /* Use  SQL_FUNC_EXISTS2(pointer,function_number)*/
 /* to determine if the function exists.          */
 /*---------------------------------------------- */

   SQL_FUNC_EXISTS2:
     proc (ptrExists, myuwAPI)
     returns (fixed bin(16) unsigned byvalue optional )
     options (inline byvalue) internal;

     dcl ptrExists pointer byvalue;
     dcl mypfExists(0:249) fixed bin(16) unsigned based(ptrExists);
     dcl myuwAPI    TYPE SQLUSMALLINT byvalue;

     return (mypfexists(myuwAPI));
   end;

 /************************************************/
 /* Extended definitions for SQLGetInfo          */
 /************************************************/

 /*---------------------------------*/
 /* Values in ODBC 2.0 that are not */
 /* in the X/Open spec              */
 /*---------------------------------*/

 dcl SQL_INFO_FIRST fixed bin(31) value(0);
 dcl SQL_ACTIVE_CONNECTIONS              fixed bin(31) value(0);
     /* MAX_DRIVER_CONNECTIONS */
 dcl SQL_ACTIVE_STATEMENTS               fixed bin(31) value(1);
     /* MAX_CONCURRENT_ACTIVITIES */
 dcl SQL_DRIVER_HDBC                     fixed bin(31) value(3);
 dcl SQL_DRIVER_HENV                     fixed bin(31) value(4);
 dcl SQL_DRIVER_HSTMT                    fixed bin(31) value(5);
 dcl SQL_DRIVER_NAME                     fixed bin(31) value(6);
 dcl SQL_DRIVER_VER                      fixed bin(31) value(7);
 dcl SQL_ODBC_API_CONFORMANCE            fixed bin(31) value(9);
 dcl SQL_ODBC_VER                        fixed bin(31) value(10);
 dcl SQL_ROW_UPDATES                     fixed bin(31) value(11);
 dcl SQL_ODBC_SAG_CLI_CONFORMANCE        fixed bin(31) value(12);
 dcl SQL_ODBC_SQL_CONFORMANCE            fixed bin(31) value(15);
 dcl SQL_PROCEDURES                      fixed bin(31) value(21);
 dcl SQL_CONCAT_NULL_BEHAVIOR            fixed bin(31) value(22);
 dcl SQL_CURSOR_ROLLBACK_BEHAVIOR        fixed bin(31) value(24);
 dcl SQL_EXPRESSIONS_IN_ORDERBY          fixed bin(31) value(27);
 dcl SQL_MAX_OWNER_NAME_LEN              fixed bin(31) value(32);
     /* MAX_SCHEMA_NAME_LEN */
 dcl SQL_MAX_PROCEDURE_NAME_LEN          fixed bin(31) value(33);
 dcl SQL_MAX_QUALIFIER_NAME_LEN          fixed bin(31) value(34);
     /* MAX_CATALOG_NAME_LEN */
 dcl SQL_MULT_RESULT_SETS                fixed bin(31) value(36);
 dcl SQL_MULTIPLE_ACTIVE_TXN             fixed bin(31) value(37);
 dcl SQL_OUTER_JOINS                     fixed bin(31) value(38);
 dcl SQL_OWNER_TERM                      fixed bin(31) value(39);
 dcl SQL_PROCEDURE_TERM                  fixed bin(31) value(40);
 dcl SQL_QUALIFIER_NAME_SEPARATOR        fixed bin(31) value(41);
 dcl SQL_QUALIFIER_TERM                  fixed bin(31) value(42);
 dcl SQL_SCROLL_OPTIONS                  fixed bin(31) value(44);
 dcl SQL_TABLE_TERM                      fixed bin(31) value(45);
 dcl SQL_CONVERT_FUNCTIONS               fixed bin(31) value(48);
 dcl SQL_NUMERIC_FUNCTIONS               fixed bin(31) value(49);
 dcl SQL_STRING_FUNCTIONS                fixed bin(31) value(50);
 dcl SQL_SYSTEM_FUNCTIONS                fixed bin(31) value(51);
 dcl SQL_TIMEDATE_FUNCTIONS              fixed bin(31) value(52);
 dcl SQL_CONVERT_BIGINT                  fixed bin(31) value(53);
 dcl SQL_CONVERT_BINARY                  fixed bin(31) value(54);
 dcl SQL_CONVERT_BIT                     fixed bin(31) value(55);
 dcl SQL_CONVERT_CHAR                    fixed bin(31) value(56);
 dcl SQL_CONVERT_DATE                    fixed bin(31) value(57);
 dcl SQL_CONVERT_DECIMAL                 fixed bin(31) value(58);
 dcl SQL_CONVERT_DOUBLE                  fixed bin(31) value(59);
 dcl SQL_CONVERT_FLOAT                   fixed bin(31) value(60);
 dcl SQL_CONVERT_INTEGER                 fixed bin(31) value(61);
 dcl SQL_CONVERT_LONGVARCHAR             fixed bin(31) value(62);
 dcl SQL_CONVERT_NUMERIC                 fixed bin(31) value(63);
 dcl SQL_CONVERT_REAL                    fixed bin(31) value(64);
 dcl SQL_CONVERT_SMALLINT                fixed bin(31) value(65);
 dcl SQL_CONVERT_TIME                    fixed bin(31) value(66);
 dcl SQL_CONVERT_TIMESTAMP               fixed bin(31) value(67);
 dcl SQL_CONVERT_TINYINT                 fixed bin(31) value(68);
 dcl SQL_CONVERT_VARBINARY               fixed bin(31) value(69);
 dcl SQL_CONVERT_VARCHAR                 fixed bin(31) value(70);
 dcl SQL_CONVERT_LONGVARBINARY           fixed bin(31) value(71);
 dcl SQL_ODBC_SQL_OPT_IEF                fixed bin(31) value(73);
     /* SQL_INTEGRITY */
 dcl SQL_CORRELATION_NAME                fixed bin(31) value(74);
 dcl SQL_NON_NULLABLE_COLUMNS            fixed bin(31) value(75);
 dcl SQL_DRIVER_HLIB                     fixed bin(31) value(76);
 dcl SQL_DRIVER_ODBC_VER                 fixed bin(31) value(77);
 dcl SQL_LOCK_TYPES                      fixed bin(31) value(78);
 dcl SQL_POS_OPERATIONS                  fixed bin(31) value(79);
 dcl SQL_POSITIONED_STATEMENTS           fixed bin(31) value(80);
 dcl SQL_BOOKMARK_PERSISTENCE            fixed bin(31) value(82);
 dcl SQL_STATIC_SENSITIVITY              fixed bin(31) value(83);
 dcl SQL_FILE_USAGE                      fixed bin(31) value(84);
 dcl SQL_COLUMN_ALIAS                    fixed bin(31) value(87);
 dcl SQL_GROUP_BY                        fixed bin(31) value(88);
 dcl SQL_KEYWORDS                        fixed bin(31) value(89);
 dcl SQL_OWNER_USAGE                     fixed bin(31) value(91);
 dcl SQL_QUALIFIER_USAGE                 fixed bin(31) value(92);
 dcl SQL_QUOTED_IDENTIFIER_CASE          fixed bin(31) value(93);
 dcl SQL_SUBQUERIES                      fixed bin(31) value(95);
 dcl SQL_UNION                           fixed bin(31) value(96);
 dcl SQL_MAX_ROW_SIZE_INCLUDES_LONG      fixed bin(31) value(103);
 dcl SQL_MAX_CHAR_LITERAL_LEN            fixed bin(31) value(108);
 dcl SQL_TIMEDATE_ADD_INTERVALS          fixed bin(31) value(109);
 dcl SQL_TIMEDATE_DIFF_INTERVALS         fixed bin(31) value(110);
 dcl SQL_NEED_LONG_DATA_LEN              fixed bin(31) value(111);
 dcl SQL_MAX_BINARY_LITERAL_LEN          fixed bin(31) value(112);
 dcl SQL_LIKE_ESCAPE_CLAUSE              fixed bin(31) value(113);
 dcl SQL_QUALIFIER_LOCATION              fixed bin(31) value(114);

 %if (ODBCVER >= '0201'x) & (ODBCVER < '0300'x) %then %do;
 /* Temp value until ODBC 3.0 */
 dcl SQL_OJ_CAPABILITIES                 fixed bin(31) value(65003);
 %end; /* ODBCVER >= '0201'x & ODBCVER < '0300'x */

 /*----------------------------------------------*/
 /* SQL_INFO_LAST and SQL_INFO_DRIVER_START are  */
 /* not useful anymore, because  X/Open has      */
 /* values in the 10000 range.   You     */
 /* must contact X/Open directly to get a range */
 /* of numbers for driver-specific values.     */
 /*----------------------------------------------*/

 %if (ODBCVER <  '0300'x) %then %do;
 dcl SQL_INFO_LAST                       fixed bin(31)
     value(SQL_QUALIFIER_LOCATION);
 dcl SQL_INFO_DRIVER_START               fixed bin(31) value(1000);
 %end; /* ODBCVER < '0300'x */

 /*-----------------------------------------------*/
 /* ODBC 3.0 SQLGetInfo values that are not part  */
 /* of the X/Open standard at this time.   X/Open */
 /* standard values are in ODBCSQL.CPY.           */
 /*-----------------------------------------------*/

 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_ACTIVE_ENVIRONMENTS             fixed bin(31) value(116);
 dcl SQL_ALTER_DOMAIN                    fixed bin(31) value(117);

 dcl SQL_SQL_CONFORMANCE                 fixed bin(31) value(118);
 dcl SQL_DATETIME_LITERALS               fixed bin(31) value(119);

 /* new X/Open spec */
 dcl SQL_ASYNC_MODE                      fixed bin(31) value(10021);
 dcl SQL_BATCH_ROW_COUNT                 fixed bin(31) value(120);
 dcl SQL_BATCH_SUPPORT                   fixed bin(31) value(121);
 dcl SQL_CATALOG_LOCATION                fixed bin(31)
     value(SQL_QUALIFIER_LOCATION);
 dcl SQL_CATALOG_NAME_SEPARATOR          fixed bin(31)
     value(SQL_QUALIFIER_NAME_SEPARATOR);
 dcl SQL_CATALOG_TERM                    fixed bin(31)
     value(SQL_QUALIFIER_TERM);
 dcl SQL_CATALOG_USAGE                   fixed bin(31)
     value(SQL_QUALIFIER_USAGE);
 dcl SQL_CONVERT_WCHAR                   fixed bin(31) value(122);
 dcl SQL_CONVERT_INTERVAL_DAY_TIME       fixed bin(31) value(123);
 dcl SQL_CONVERT_INTERVAL_YEAR_MONTH     fixed bin(31) value(124);
 dcl SQL_CONVERT_WLONGVARCHAR            fixed bin(31) value(125);
 dcl SQL_CONVERT_WVARCHAR                fixed bin(31) value(126);
 dcl SQL_CREATE_ASSERTION                fixed bin(31) value(127);
 dcl SQL_CREATE_CHARACTER_SET            fixed bin(31) value(128);
 dcl SQL_CREATE_COLLATION                fixed bin(31) value(129);
 dcl SQL_CREATE_DOMAIN                   fixed bin(31) value(130);
 dcl SQL_CREATE_SCHEMA                   fixed bin(31) value(131);
 dcl SQL_CREATE_TABLE                    fixed bin(31) value(132);
 dcl SQL_CREATE_TRANSLATION              fixed bin(31) value(133);
 dcl SQL_CREATE_VIEW                     fixed bin(31) value(134);
 dcl SQL_DRIVER_HDESC                    fixed bin(31) value(135);
 dcl SQL_DROP_ASSERTION                  fixed bin(31) value(136);
 dcl SQL_DROP_CHARACTER_SET              fixed bin(31) value(137);
 dcl SQL_DROP_COLLATION                  fixed bin(31) value(138);
 dcl SQL_DROP_DOMAIN                     fixed bin(31) value(139);
 dcl SQL_DROP_SCHEMA                     fixed bin(31) value(140);
 dcl SQL_DROP_TABLE                      fixed bin(31) value(141);
 dcl SQL_DROP_TRANSLATION                fixed bin(31) value(142);
 dcl SQL_DROP_VIEW                       fixed bin(31) value(143);
 dcl SQL_DYNAMIC_CURSOR_ATTRIBUTES1      fixed bin(31) value(144);
 dcl SQL_DYNAMIC_CURSOR_ATTRIBUTES2      fixed bin(31) value(145);
 dcl SQL_FORWARD_ONLY_CURSOR_ATTRIBUTES1 fixed bin(31) value(146);
 dcl SQL_FORWARD_ONLY_CURSOR_ATTRIBUTES2 fixed bin(31) value(147);
 dcl SQL_INDEX_KEYWORDS                  fixed bin(31) value(148);
 dcl SQL_INFO_SCHEMA_VIEWS               fixed bin(31) value(149);
 dcl SQL_KEYSET_CURSOR_ATTRIBUTES1       fixed bin(31) value(150);
 dcl SQL_KEYSET_CURSOR_ATTRIBUTES2       fixed bin(31) value(151);
 /* new X/Open spec */
 dcl SQL_MAX_ASYNC_CONCURRENT_STATEMENTS fixed bin(31) value(10022);
 dcl SQL_ODBC_INTERFACE_CONFORMANCE      fixed bin(31) value(152);
 dcl SQL_PARAM_ARRAY_ROW_COUNTS          fixed bin(31) value(153);
 dcl SQL_PARAM_ARRAY_SELECTS             fixed bin(31) value(154);
 dcl SQL_SCHEMA_TERM                     fixed bin(31)
     value(SQL_OWNER_TERM);
 dcl SQL_SCHEMA_USAGE                    fixed bin(31)
     value(SQL_OWNER_USAGE);
 dcl SQL_SQL92_DATETIME_FUNCTIONS        fixed bin(31) value(155);
 dcl SQL_SQL92_FOREIGN_KEY_DELETE_RULE   fixed bin(31) value(156);
 dcl SQL_SQL92_FOREIGN_KEY_UPDATE_RULE   fixed bin(31) value(157);
 dcl SQL_SQL92_GRANT                     fixed bin(31) value(158);
 dcl SQL_SQL92_NUMERIC_VALUE_FUNCTIONS   fixed bin(31) value(159);
 dcl SQL_SQL92_PREDICATES                fixed bin(31) value(160);
 dcl SQL_SQL92_RELATIONAL_JOIN_OPERATORS fixed bin(31) value(161);
 dcl SQL_SQL92_REVOKE                    fixed bin(31) value(162);
 dcl SQL_SQL92_ROW_VALUE_CONSTRUCTOR     fixed bin(31) value(163);
 dcl SQL_SQL92_STRING_FUNCTIONS          fixed bin(31) value(164);
 dcl SQL_SQL92_VALUE_EXPRESSIONS         fixed bin(31) value(165);
 dcl SQL_STANDARD_CLI_CONFORMANCE        fixed bin(31) value(166);
 dcl SQL_STATIC_CURSOR_ATTRIBUTES1       fixed bin(31) value(167);
 dcl SQL_STATIC_CURSOR_ATTRIBUTES2       fixed bin(31) value(168);

 dcl SQL_AGGREGATE_FUNCTIONS             fixed bin(31) value(169);
 dcl SQL_DDL_INDEX                       fixed bin(31) value(170);
 dcl SQL_DM_VER                          fixed bin(31) value(171);
 dcl SQL_INSERT_STATEMENT                fixed bin(31) value(172);
 dcl SQL_UNION_STATEMENT                 fixed bin(31) value(SQL_UNION);
 %end; /* ODBCVER >= '0300'x */

 dcl SQL_DTC_TRANSITION_COST             fixed bin (31) value(1750);

 /* SQL_ALTER_TABLE bitmasks */
 %if (ODBCVER >= '0300'x) %then %do;
 /* the following 3 bitmasks are defined in ODBCSQL.CPY          */
 /* dcl SQL_AT_ADD_COLUMN fixed bin(31) value('00000001'xn);     */
 /* dcl SQL_AT_DROP_COLUMN fixed bin(31) value('00000002'xn);    */
 /* dcl SQL_AT_ADD_CONSTRAINT fixed bin(31) value('00000008'xn); */

 dcl SQL_AT_ADD_COLUMN_SINGLE         fixed bin(31) value('00000020'xn);
 dcl SQL_AT_ADD_COLUMN_DEFAULT        fixed bin(31) value('00000040'xn);
 dcl SQL_AT_ADD_COLUMN_COLLATION      fixed bin(31) value('00000080'xn);
 dcl SQL_AT_SET_COLUMN_DEFAULT        fixed bin(31) value('00000100'xn);
 dcl SQL_AT_DROP_COLUMN_DEFAULT       fixed bin(31) value('00000200'xn);
 dcl SQL_AT_DROP_COLUMN_CASCADE       fixed bin(31) value('00000400'xn);
 dcl SQL_AT_DROP_COLUMN_RESTRICT      fixed bin(31) value('00000800'xn);
 dcl SQL_AT_ADD_TABLE_CONSTRAINT      fixed bin(31) value('00001000'xn);
 dcl SQL_AT_DROP_TABLE_CONSTRAINT_CASCADE
                                      fixed bin(31) value('00002000'xn);
 dcl SQL_AT_DROP_TABLE_CONSTRAINT_RESTRICT
                                      fixed bin(31) value('00004000'xn);
 dcl SQL_AT_CONSTRAINT_NAME_DEFINITION
                                      fixed bin(31) value('00008000'xn);
 dcl SQL_AT_CONSTRAINT_INITIALLY_DEFERRED
                                      fixed bin(31) value('00010000'xn);
 dcl SQL_AT_CONSTRAINT_INITIALLY_IMMEDIATE
                                      fixed bin(31) value('00020000'xn);
 dcl SQL_AT_CONSTRAINT_DEFERRABLE     fixed bin(31) value('00040000'xn);
 dcl SQL_AT_CONSTRAINT_NON_DEFERRABLE fixed bin(31) value('00080000'xn);
 %end; /* ODBCVER >= '0300'x */

 /* SQL_CONVERT_*  return value bitmasks */

 dcl SQL_CVT_CHAR                     fixed bin(31) value('00000001'xn);
 dcl SQL_CVT_NUMERIC                  fixed bin(31) value('00000002'xn);
 dcl SQL_CVT_DECIMAL                  fixed bin(31) value('00000004'xn);
 dcl SQL_CVT_INTEGER                  fixed bin(31) value('00000008'xn);
 dcl SQL_CVT_SMALLINT                 fixed bin(31) value('00000010'xn);
 dcl SQL_CVT_FLOAT                    fixed bin(31) value('00000020'xn);
 dcl SQL_CVT_REAL                     fixed bin(31) value('00000040'xn);
 dcl SQL_CVT_DOUBLE                   fixed bin(31) value('00000080'xn);
 dcl SQL_CVT_VARCHAR                  fixed bin(31) value('00000100'xn);
 dcl SQL_CVT_LONGVARCHAR              fixed bin(31) value('00000200'xn);
 dcl SQL_CVT_BINARY                   fixed bin(31) value('00000400'xn);
 dcl SQL_CVT_VARBINARY                fixed bin(31) value('00000800'xn);
 dcl SQL_CVT_BIT                      fixed bin(31) value('00001000'xn);
 dcl SQL_CVT_TINYINT                  fixed bin(31) value('00002000'xn);
 dcl SQL_CVT_BIGINT                   fixed bin(31) value('00004000'xn);
 dcl SQL_CVT_DATE                     fixed bin(31) value('00008000'xn);
 dcl SQL_CVT_TIME                     fixed bin(31) value('00010000'xn);
 dcl SQL_CVT_TIMESTAMP                fixed bin(31) value('00020000'xn);
 dcl SQL_CVT_LONGVARBINARY            fixed bin(31) value('00040000'xn);
 %if (ODBCVER >=  '0300'x) %then %do;
 dcl SQL_CVT_INTERVAL_YEAR_MONTH      fixed bin(31) value('00080000'xn);
 dcl SQL_CVT_INTERVAL_DAY_TIME        fixed bin(31) value('00100000'xn);
 dcl SQL_CVT_WCHAR                    fixed bin(31) value('00200000'xn);
 dcl SQL_CVT_WLONGVARCHAR             fixed bin(31) value('00400000'xn);
 dcl SQL_CVT_WVARCHAR                 fixed bin(31) value('00800000'xn);
 %end; /* ODBCVER >= '0300'x */


 /* SQL_CONVERT_FUNCTIONS functions */
 dcl SQL_FN_CVT_CONVERT               fixed bin(31) value('00000001'xn);
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_FN_CVT_CAST                  fixed bin(31) value('00000002'xn);
 %end; /* ODBCVER >= '0300'x */


 /* SQL_STRING_FUNCTIONS functions */

 dcl SQL_FN_STR_CONCAT                fixed bin(31) value('00000001'xn);
 dcl SQL_FN_STR_INSERT                fixed bin(31) value('00000002'xn);
 dcl SQL_FN_STR_LEFT                  fixed bin(31) value('00000004'xn);
 dcl SQL_FN_STR_LTRIM                 fixed bin(31) value('00000008'xn);
 dcl SQL_FN_STR_LENGTH                fixed bin(31) value('00000010'xn);
 dcl SQL_FN_STR_LOCATE                fixed bin(31) value('00000020'xn);
 dcl SQL_FN_STR_LCASE                 fixed bin(31) value('00000040'xn);
 dcl SQL_FN_STR_REPEAT                fixed bin(31) value('00000080'xn);
 dcl SQL_FN_STR_REPLACE               fixed bin(31) value('00000100'xn);
 dcl SQL_FN_STR_RIGHT                 fixed bin(31) value('00000200'xn);
 dcl SQL_FN_STR_RTRIM                 fixed bin(31) value('00000400'xn);
 dcl SQL_FN_STR_SUBSTRING             fixed bin(31) value('00000800'xn);
 dcl SQL_FN_STR_UCASE                 fixed bin(31) value('00001000'xn);
 dcl SQL_FN_STR_ASCII                 fixed bin(31) value('00002000'xn);
 dcl SQL_FN_STR_CHAR                  fixed bin(31) value('00004000'xn);
 dcl SQL_FN_STR_DIFFERENCE            fixed bin(31) value('00008000'xn);
 dcl SQL_FN_STR_LOCATE_2              fixed bin(31) value('00010000'xn);
 dcl SQL_FN_STR_SOUNDEX               fixed bin(31) value('00020000'xn);
 dcl SQL_FN_STR_SPACE                 fixed bin(31) value('00040000'xn);
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_FN_STR_BIT_LENGTH            fixed bin(31) value('00080000'xn);
 dcl SQL_FN_STR_CHAR_LENGTH           fixed bin(31) value('00100000'xn);
 dcl SQL_FN_STR_CHARACTER_LENGTH      fixed bin(31) value('00200000'xn);
 dcl SQL_FN_STR_OCTET_LENGTH          fixed bin(31) value('00400000'xn);
 dcl SQL_FN_STR_POSITION              fixed bin(31) value('00800000'xn);
 %end; /* ODBCVER >= '0300'x */

 /* SQL_SQL92_STRING_FUNCTIONS */
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_SSF_CONVERT                  fixed bin(31) value('00000001'xn);
 dcl SQL_SSF_LOWER                    fixed bin(31) value('00000002'xn);
 dcl SQL_SSF_UPPER                    fixed bin(31) value('00000004'xn);
 dcl SQL_SSF_SUBSTRING                fixed bin(31) value('00000008'xn);
 dcl SQL_SSF_TRANSLATE                fixed bin(31) value('00000010'xn);
 dcl SQL_SSF_TRIM_BOTH                fixed bin(31) value('00000020'xn);
 dcl SQL_SSF_TRIM_LEADING             fixed bin(31) value('00000040'xn);
 dcl SQL_SSF_TRIM_TRAILING            fixed bin(31) value('00000080'xn);
 %end; /* ODBCVER >= '0300'x */

 /* SQL_NUMERIC_FUNCTIONS functions */

 dcl SQL_FN_NUM_ABS                   fixed bin(31) value('00000001'xn);
 dcl SQL_FN_NUM_ACOS                  fixed bin(31) value('00000002'xn);
 dcl SQL_FN_NUM_ASIN                  fixed bin(31) value('00000004'xn);
 dcl SQL_FN_NUM_ATAN                  fixed bin(31) value('00000008'xn);
 dcl SQL_FN_NUM_ATAN2                 fixed bin(31) value('00000010'xn);
 dcl SQL_FN_NUM_CEILING               fixed bin(31) value('00000020'xn);
 dcl SQL_FN_NUM_COS                   fixed bin(31) value('00000040'xn);
 dcl SQL_FN_NUM_COT                   fixed bin(31) value('00000080'xn);
 dcl SQL_FN_NUM_EXP                   fixed bin(31) value('00000100'xn);
 dcl SQL_FN_NUM_FLOOR                 fixed bin(31) value('00000200'xn);
 dcl SQL_FN_NUM_LOG                   fixed bin(31) value('00000400'xn);
 dcl SQL_FN_NUM_MOD                   fixed bin(31) value('00000800'xn);
 dcl SQL_FN_NUM_SIGN                  fixed bin(31) value('00001000'xn);
 dcl SQL_FN_NUM_SIN                   fixed bin(31) value('00002000'xn);
 dcl SQL_FN_NUM_SQRT                  fixed bin(31) value('00004000'xn);
 dcl SQL_FN_NUM_TAN                   fixed bin(31) value('00008000'xn);
 dcl SQL_FN_NUM_PI                    fixed bin(31) value('00010000'xn);
 dcl SQL_FN_NUM_RAND                  fixed bin(31) value('00020000'xn);
 dcl SQL_FN_NUM_DEGREES               fixed bin(31) value('00040000'xn);
 dcl SQL_FN_NUM_LOG10                 fixed bin(31) value('00080000'xn);
 dcl SQL_FN_NUM_POWER                 fixed bin(31) value('00100000'xn);
 dcl SQL_FN_NUM_RADIANS               fixed bin(31) value('00200000'xn);
 dcl SQL_FN_NUM_ROUND                 fixed bin(31) value('00400000'xn);
 dcl SQL_FN_NUM_TRUNCATE              fixed bin(31) value('00800000'xn);

 /* SQL_SQL92_NUMERIC_VALUE_FUNCTIONS */
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_SNVF_BIT_LENGTH              fixed bin(31) value('00000001'xn);
 dcl SQL_SNVF_CHAR_LENGTH             fixed bin(31) value('00000002'xn);
 dcl SQL_SNVF_CHARACTER_LENGTH        fixed bin(31) value('00000004'xn);
 dcl SQL_SNVF_EXTRACT                 fixed bin(31) value('00000008'xn);
 dcl SQL_SNVF_OCTET_LENGTH            fixed bin(31) value('00000010'xn);
 dcl SQL_SNVF_POSITION                fixed bin(31) value('00000020'xn);
 %end; /* ODBCVER >= '0300'x */

 /* SQL_TIMEDATE_FUNCTIONS functions */

 dcl SQL_FN_TD_NOW                    fixed bin(31) value('00000001'xn);
 dcl SQL_FN_TD_CURDATE                fixed bin(31) value('00000002'xn);
 dcl SQL_FN_TD_DAYOFMONTH             fixed bin(31) value('00000004'xn);
 dcl SQL_FN_TD_DAYOFWEEK              fixed bin(31) value('00000008'xn);
 dcl SQL_FN_TD_DAYOFYEAR              fixed bin(31) value('00000010'xn);
 dcl SQL_FN_TD_MONTH                  fixed bin(31) value('00000020'xn);
 dcl SQL_FN_TD_QUARTER                fixed bin(31) value('00000040'xn);
 dcl SQL_FN_TD_WEEK                   fixed bin(31) value('00000080'xn);
 dcl SQL_FN_TD_YEAR                   fixed bin(31) value('00000100'xn);
 dcl SQL_FN_TD_CURTIME                fixed bin(31) value('00000200'xn);
 dcl SQL_FN_TD_HOUR                   fixed bin(31) value('00000400'xn);
 dcl SQL_FN_TD_MINUTE                 fixed bin(31) value('00000800'xn);
 dcl SQL_FN_TD_SECOND                 fixed bin(31) value('00001000'xn);
 dcl SQL_FN_TD_TIMESTAMPADD           fixed bin(31) value('00002000'xn);
 dcl SQL_FN_TD_TIMESTAMPDIFF          fixed bin(31) value('00004000'xn);
 dcl SQL_FN_TD_DAYNAME                fixed bin(31) value('00008000'xn);
 dcl SQL_FN_TD_MONTHNAME              fixed bin(31) value('00010000'xn);
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_FN_TD_CURRENT_DATE           fixed bin(31) value('00020000'xn);
 dcl SQL_FN_TD_CURRENT_TIME           fixed bin(31) value('00040000'xn);
 dcl SQL_FN_TD_CURRENT_TIMESTAMP      fixed bin(31) value('00080000'xn);
 dcl SQL_FN_TD_EXTRACT                fixed bin(31) value('00100000'xn);
 %end; /* ODBCVER >= '0300'x */

 /* SQL_SQL92_DATETIME_FUNCTIONS */
 %if (ODBCVER >=  '0300'x) %then %do;
 dcl SQL_SDF_CURRENT_DATE             fixed bin(31) value('00000001'xn);
 dcl SQL_SDF_CURRENT_TIME             fixed bin(31) value('00000002'xn);
 dcl SQL_SDF_CURRENT_TIMESTAMP        fixed bin(31) value('00000004'xn);
 %end; /* ODBCVER >= '0300'x */

 /* SQL_SYSTEM_FUNCTIONS functions */

 dcl SQL_FN_SYS_USERNAME              fixed bin(31) value('00000001'xn);
 dcl SQL_FN_SYS_DBNAME                fixed bin(31) value('00000002'xn);
 dcl SQL_FN_SYS_IFNULL                fixed bin(31) value('00000004'xn);

 /* SQL_TIMEDATE_ADD_INTERVALS and SQL_TIMEDATE_DIFF_INTERVALS */
 /* functions  */

 dcl SQL_FN_TSI_FRAC_SECOND           fixed bin(31) value('00000001'xn);
 dcl SQL_FN_TSI_SECOND                fixed bin(31) value('00000002'xn);
 dcl SQL_FN_TSI_MINUTE                fixed bin(31) value('00000004'xn);
 dcl SQL_FN_TSI_HOUR                  fixed bin(31) value('00000008'xn);
 dcl SQL_FN_TSI_DAY                   fixed bin(31) value('00000010'xn);
 dcl SQL_FN_TSI_WEEK                  fixed bin(31) value('00000020'xn);
 dcl SQL_FN_TSI_MONTH                 fixed bin(31) value('00000040'xn);
 dcl SQL_FN_TSI_QUARTER               fixed bin(31) value('00000080'xn);
 dcl SQL_FN_TSI_YEAR                  fixed bin(31) value('00000100'xn);

 /* bitmasks for SQL_DYNAMIC_CURSOR_ATTRIBUTES1,                     */
 /* SQL_FORWARD_ONLY_CURSOR_ATTRIBUTES1,                             */
 /* SQL_KEYSET_CURSOR_ATTRIBUTES1, and SQL_STATIC_CURSOR_ATTRIBUTES1 */
 %if (ODBCVER >=  '0300'x) %then %do;
 /* supported SQLFetchScroll FetchOrientation's */
 dcl SQL_CA1_NEXT                     fixed bin(31) value('00000001'xn);
 dcl SQL_CA1_ABSOLUTE                 fixed bin(31) value('00000002'xn);
 dcl SQL_CA1_RELATIVE                 fixed bin(31) value('00000004'xn);
 dcl SQL_CA1_BOOKMARK                 fixed bin(31) value('00000008'xn);

 /* supported SQLSetPos LockType's */
 dcl SQL_CA1_LOCK_NO_CHANGE           fixed bin(31) value('00000040'xn);
 dcl SQL_CA1_LOCK_EXCLUSIVE           fixed bin(31) value('00000080'xn);
 dcl SQL_CA1_LOCK_UNLOCK              fixed bin(31) value('00000100'xn);

 /* supported SQLSetPos Operations */
 dcl SQL_CA1_POS_POSITION             fixed bin(31) value('00000200'xn);
 dcl SQL_CA1_POS_UPDATE               fixed bin(31) value('00000400'xn);
 dcl SQL_CA1_POS_DELETE               fixed bin(31) value('00000800'xn);
 dcl SQL_CA1_POS_REFRESH              fixed bin(31) value('00001000'xn);

 /* positioned updates and deletes */
 dcl SQL_CA1_POSITIONED_UPDATE        fixed bin(31) value('00002000'xn);
 dcl SQL_CA1_POSITIONED_DELETE        fixed bin(31) value('00004000'xn);
 dcl SQL_CA1_SELECT_FOR_UPDATE        fixed bin(31) value('00008000'xn);

 /* supported SQLBulkOperations operations */
 dcl SQL_CA1_BULK_ADD fixed bin(31) value('00010000'xn);
 dcl SQL_CA1_BULK_UPDATE_BY_BOOKMARK  fixed bin(31) value('00020000'xn);
 dcl SQL_CA1_BULK_DELETE_BY_BOOKMARK  fixed bin(31) value('00040000'xn);
 dcl SQL_CA1_BULK_FETCH_BY_BOOKMARK   fixed bin(31) value('00080000'xn);
 %end; /* ODBCVER >= '0300'x */

 /* bitmasks for SQL_DYNAMIC_CURSOR_ATTRIBUTES2,                     */
 /* SQL_FORWARD_ONLY_CURSOR_ATTRIBUTES2,                             */
 /* SQL_KEYSET_CURSOR_ATTRIBUTES2, and SQL_STATIC_CURSOR_ATTRIBUTES2 */
 %if (ODBCVER >= '0300'x) %then %do;
 /* supported values for SQL_ATTR_SCROLL_CONCURRENCY */
 dcl SQL_CA2_READ_ONLY_CONCURRENCY    fixed bin(31) value('00000001'xn);
 dcl SQL_CA2_LOCK_CONCURRENCY         fixed bin(31) value('00000002'xn);
 dcl SQL_CA2_OPT_ROWVER_CONCURRENCY   fixed bin(31) value('00000004'xn);
 dcl SQL_CA2_OPT_VALUES_CONCURRENCY   fixed bin(31) value('00000008'xn);

 /* sensitivity of the cursor to its own inserts, deletes, */
 /* and updates */
 dcl SQL_CA2_SENSITIVITY_ADDITIONS    fixed bin(31) value('00000010'xn);
 dcl SQL_CA2_SENSITIVITY_DELETIONS    fixed bin(31) value('00000020'xn);
 dcl SQL_CA2_SENSITIVITY_UPDATES      fixed bin(31) value('00000040'xn);

 /* semantics of SQL_ATTR_MAX_ROWS */
 dcl SQL_CA2_MAX_ROWS_SELECT          fixed bin(31) value('00000080'xn);
 dcl SQL_CA2_MAX_ROWS_INSERT          fixed bin(31) value('00000100'xn);
 dcl SQL_CA2_MAX_ROWS_DELETE          fixed bin(31) value('00000200'xn);
 dcl SQL_CA2_MAX_ROWS_UPDATE          fixed bin(31) value('00000400'xn);
 dcl SQL_CA2_MAX_ROWS_CATALOG         fixed bin(31) value('00000800'xn);
 dcl SQL_CA2_MAX_ROWS_AFFECTS_ALL     fixed bin(31)
     value(ior(SQL_CA2_MAX_ROWS_SELECT,SQL_CA2_MAX_ROWS_INSERT,
               SQL_CA2_MAX_ROWS_DELETE,SQL_CA2_MAX_ROWS_UPDATE,
               SQL_CA2_MAX_ROWS_CATALOG));

 /* semantics of SQL_DIAG_CURSOR_ROW_COUNT */
 dcl SQL_CA2_CRC_EXACT                fixed bin(31) value('00001000'xn);
 dcl SQL_CA2_CRC_APPROXIMATE          fixed bin(31) value('00002000'xn);

 /* the kinds of positioned statements that can be simulated */
 dcl SQL_CA2_SIMULATE_NON_UNIQUE      fixed bin(31) value('00004000'xn);
 dcl SQL_CA2_SIMULATE_TRY_UNIQUE      fixed bin(31) value('00008000'xn);
 dcl SQL_CA2_SIMULATE_UNIQUE          fixed bin(31) value('00010000'xn);
 %end; /* ODBCVER >= '0300'x */

 /* SQL_ODBC_API_CONFORMANCE values */
 dcl SQL_OAC_NONE           fixed bin(15) value('0000'xn);
 dcl SQL_OAC_LEVEL1         fixed bin(15) value('0001'xn);
 dcl SQL_OAC_LEVEL2         fixed bin(15) value('0002'xn);

 /* SQL_ODBC_SAG_CLI_CONFORMANCE values */
 dcl SQL_OSCC_NOT_COMPLIANT fixed bin(15) value('0000'xn);
 dcl SQL_OSCC_COMPLIANT     fixed bin(15) value('0001'xn);

 /* SQL_ODBC_SQL_CONFORMANCE values */
 dcl SQL_OSC_MINIMUM        fixed bin(15) value('0000'xn);
 dcl SQL_OSC_CORE           fixed bin(15) value('0001'xn);
 dcl SQL_OSC_EXTENDED       fixed bin(15) value('0002'xn);


 /* SQL_CONCAT_NULL_BEHAVIOR values */
 dcl SQL_CB_NULL            fixed bin(15) value('0000'xn);
 dcl SQL_CB_NON_NULL        fixed bin(15) value('0001'xn);

 /* SQL_SCROLL_OPTIONS masks */
 dcl SQL_SO_FORWARD_ONLY    fixed bin(31) value('00000001'xn);
 dcl SQL_SO_KEYSET_DRIVEN   fixed bin(31) value('00000002'xn);
 dcl SQL_SO_DYNAMIC         fixed bin(31) value('00000004'xn);
 dcl SQL_SO_MIXED           fixed bin(31) value('00000008'xn);
 dcl SQL_SO_STATIC          fixed bin(31) value('00000010'xn);

 /* SQL_FETCH_DIRECTION masks */

 %if (ODBCVER <  '0300'x) %then %do;
 /* SQL_FETCH_RESUME is no longer supported */
 dcl SQL_FD_FETCH_RESUME    fixed bin(31) value('00000040'xn);
 %end;

 dcl SQL_FD_FETCH_BOOKMARK  fixed bin(31) value('00000080'xn);

 /* SQL_TXN_ISOLATION_OPTION masks */
 %if (ODBCVER <  '0300'x) %then %do;
 /* SQL_TXN_VERSIONING is no longer supported */
 dcl SQL_TXN_VERSIONING     fixed bin(31) value('00000010'xn);
 %end;

 /* SQL_CORRELATION_NAME values */
 dcl SQL_CN_NONE            fixed bin(15) value('0000'xn);
 dcl SQL_CN_DIFFERENT       fixed bin(15) value('0001'xn);
 dcl SQL_CN_ANY             fixed bin(15) value('0002'xn);

 /* SQL_NON_NULLABLE_COLUMNS values */
 dcl SQL_NNC_NULL           fixed bin(15) value('0000'xn);
 dcl SQL_NNC_NON_NULL       fixed bin(15) value('0001'xn);

 /* SQL_NULL_COLLATION values */
 dcl SQL_NC_START           fixed bin(15) value('0002'xn);
 dcl SQL_NC_END             fixed bin(15) value('0004'xn);

 /* SQL_FILE_USAGE values */
 dcl SQL_FILE_NOT_SUPPORTED fixed bin(15) value('0000'xn);
 dcl SQL_FILE_TABLE         fixed bin(15) value('0001'xn);
 dcl SQL_FILE_QUALIFIER     fixed bin(15) value('0002'xn);
 dcl SQL_FILE_CATALOG       fixed bin(31) value(SQL_FILE_QUALIFIER);
 /* ODBC 3.0 */


 /* SQL_GETDATA_EXTENSIONS values */
 dcl SQL_GD_BLOCK                     fixed bin(31) value('00000004'xn);
 dcl SQL_GD_BOUND                     fixed bin(31) value('00000008'xn);

 /* SQL_POSITIONED_STATEMENTS masks */
 dcl SQL_PS_POSITIONED_DELETE         fixed bin(31) value('00000001'xn);
 dcl SQL_PS_POSITIONED_UPDATE         fixed bin(31) value('00000002'xn);
 dcl SQL_PS_SELECT_FOR_UPDATE         fixed bin(31) value('00000004'xn);

 /* SQL_GROUP_BY values */
 dcl SQL_GB_NOT_SUPPORTED             fixed bin(15) value('0000'xn);
 dcl SQL_GB_GROUP_BY_EQUALS_SELECT    fixed bin(15) value('0001'xn);
 dcl SQL_GB_GROUP_BY_CONTAINS_SELECT  fixed bin(15) value('0002'xn);
 dcl SQL_GB_NO_RELATION               fixed bin(15) value('0003'xn);
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_GB_COLLATE                   fixed bin(15) value('0004'xn);
 %end; /* ODBCVER >= '0300'x */

 /* SQL_OWNER_USAGE masks */
 dcl SQL_OU_DML_STATEMENTS            fixed bin(31) value('00000001'xn);
 dcl SQL_OU_PROCEDURE_INVOCATION      fixed bin(31) value('00000002'xn);
 dcl SQL_OU_TABLE_DEFINITION          fixed bin(31) value('00000004'xn);
 dcl SQL_OU_INDEX_DEFINITION          fixed bin(31) value('00000008'xn);
 dcl SQL_OU_PRIVILEGE_DEFINITION      fixed bin(31) value('00000010'xn);

 /* SQL_SCHEMA_USAGE masks */
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_SU_DML_STATEMENTS       fixed bin(31)
     value(SQL_OU_DML_STATEMENTS);
 dcl SQL_SU_PROCEDURE_INVOCATION fixed bin(31)
     value(SQL_OU_PROCEDURE_INVOCATION);
 dcl SQL_SU_TABLE_DEFINITION     fixed bin(31)
     value(SQL_OU_TABLE_DEFINITION);
 dcl SQL_SU_INDEX_DEFINITION     fixed bin(31)
     value(SQL_OU_INDEX_DEFINITION);
 dcl SQL_SU_PRIVILEGE_DEFINITION fixed bin(31)
     value(SQL_OU_PRIVILEGE_DEFINITION);
 %end; /* ODBCVER >= '0300'x */

 /* SQL_QUALIFIER_USAGE masks */
 dcl SQL_QU_DML_STATEMENTS            fixed bin(31) value('00000001'xn);
 dcl SQL_QU_PROCEDURE_INVOCATION      fixed bin(31) value('00000002'xn);
 dcl SQL_QU_TABLE_DEFINITION          fixed bin(31) value('00000004'xn);
 dcl SQL_QU_INDEX_DEFINITION          fixed bin(31) value('00000008'xn);
 dcl SQL_QU_PRIVILEGE_DEFINITION      fixed bin(31) value('00000010'xn);

 %if (ODBCVER >= '0300'x) %then %do;
 /* SQL_CATALOG_USAGE masks */
 dcl SQL_CU_DML_STATEMENTS            fixed bin(31)
     value(SQL_QU_DML_STATEMENTS);
 dcl SQL_CU_PROCEDURE_INVOCATION      fixed bin(31)
     value(SQL_QU_PROCEDURE_INVOCATION);
 dcl SQL_CU_TABLE_DEFINITION          fixed bin(31)
     value(SQL_QU_TABLE_DEFINITION);
 dcl SQL_CU_INDEX_DEFINITION          fixed bin(31)
     value(SQL_QU_INDEX_DEFINITION);
 dcl SQL_CU_PRIVILEGE_DEFINITION      fixed bin(31)
     value(SQL_QU_PRIVILEGE_DEFINITION);
 %end; /* ODBCVER >= '0300'x */

 /* SQL_SUBQUERIES masks */
 dcl SQL_SQ_COMPARISON                fixed bin(31) value('00000001'xn);
 dcl SQL_SQ_EXISTS                    fixed bin(31) value('00000002'xn);
 dcl SQL_SQ_IN                        fixed bin(31) value('00000004'xn);
 dcl SQL_SQ_QUANTIFIED                fixed bin(31) value('00000008'xn);
 dcl SQL_SQ_CORRELATED_SUBQUERIES     fixed bin(31) value('00000010'xn);

 /* SQL_UNION masks */
 dcl SQL_U_UNION                      fixed bin(31) value('00000001'xn);
 dcl SQL_U_UNION_ALL                  fixed bin(31) value('00000002'xn);

 /* SQL_BOOKMARK_PERSISTENCE values */
 dcl SQL_BP_CLOSE                     fixed bin(31) value('00000001'xn);
 dcl SQL_BP_DELETE                    fixed bin(31) value('00000002'xn);
 dcl SQL_BP_DROP                      fixed bin(31) value('00000004'xn);
 dcl SQL_BP_TRANSACTION               fixed bin(31) value('00000008'xn);
 dcl SQL_BP_UPDATE                    fixed bin(31) value('00000010'xn);
 dcl SQL_BP_OTHER_HSTMT               fixed bin(31) value('00000020'xn);
 dcl SQL_BP_SCROLL                    fixed bin(31) value('00000040'xn);

 /* SQL_STATIC_SENSITIVITY values */
 dcl SQL_SS_ADDITIONS                 fixed bin(31) value('00000001'xn);
 dcl SQL_SS_DELETIONS                 fixed bin(31) value('00000002'xn);
 dcl SQL_SS_UPDATES                   fixed bin(31) value('00000004'xn);

 /* SQL_VIEW values */
 dcl SQL_CV_CREATE_VIEW               fixed bin(31) value('00000001'xn);
 dcl SQL_CV_CHECK_OPTION              fixed bin(31) value('00000002'xn);
 dcl SQL_CV_CASCADED                  fixed bin(31) value('00000004'xn);
 dcl SQL_CV_LOCAL                     fixed bin(31) value('00000008'xn);

 /* SQL_LOCK_TYPES masks */
 dcl SQL_LCK_NO_CHANGE                fixed bin(31) value('00000001'xn);
 dcl SQL_LCK_EXCLUSIVE                fixed bin(31) value('00000002'xn);
 dcl SQL_LCK_UNLOCK                   fixed bin(31) value('00000004'xn);

 /* SQL_POS_OPERATIONS masks */
 dcl SQL_POS_POSITION                 fixed bin(31) value('00000001'xn);
 dcl SQL_POS_REFRESH                  fixed bin(31) value('00000002'xn);
 dcl SQL_POS_UPDATE                   fixed bin(31) value('00000004'xn);
 dcl SQL_POS_DELETE                   fixed bin(31) value('00000008'xn);
 dcl SQL_POS_ADD                      fixed bin(31) value('00000010'xn);

 /* SQL_QUALIFIER_LOCATION values */
 dcl SQL_QL_START                     fixed bin(15) value('0001'xn);
 dcl SQL_QL_END                       fixed bin(15) value('0002'xn);

 /* Here start return values for ODBC 3.0 SQLGetInfo */

 %if (ODBCVER >= '0300'x) %then %do;
 /* SQL_AGGREGATE_FUNCTIONS bitmasks */
 dcl SQL_AF_AVG                       fixed bin(31) value('00000001'xn);
 dcl SQL_AF_COUNT                     fixed bin(31) value('00000002'xn);
 dcl SQL_AF_MAX                       fixed bin(31) value('00000004'xn);
 dcl SQL_AF_MIN                       fixed bin(31) value('00000008'xn);
 dcl SQL_AF_SUM                       fixed bin(31) value('00000010'xn);
 dcl SQL_AF_DISTINCT                  fixed bin(31) value('00000020'xn);
 dcl SQL_AF_ALL                       fixed bin(31)
     value(IOR(SQL_AF_AVG, SQL_AF_COUNT, SQL_AF_MAX, SQL_AF_MIN,
               SQL_AF_SUM, SQL_AF_DISTINCT));

 /* SQL_SQL_CONFORMANCE bit masks */
 dcl SQL_SC_SQL92_ENTRY               fixed bin(31) value('00000001'xn);
 dcl SQL_SC_FIPS127_2_TRANSITIONAL    fixed bin(31) value('00000002'xn);
 dcl SQL_SC_SQL92_INTERMEDIATE        fixed bin(31) value('00000004'xn);
 dcl SQL_SC_SQL92_FULL                fixed bin(31) value('00000008'xn);

 /* SQL_DATETIME_LITERALS masks */
 dcl SQL_DL_SQL92_DATE                fixed bin(31) value('00000001'xn);
 dcl SQL_DL_SQL92_TIME                fixed bin(31) value('00000002'xn);
 dcl SQL_DL_SQL92_TIMESTAMP           fixed bin(31) value('00000004'xn);
 dcl SQL_DL_SQL92_INTERVAL_YEAR       fixed bin(31) value('00000008'xn);
 dcl SQL_DL_SQL92_INTERVAL_MONTH      fixed bin(31) value('00000010'xn);
 dcl SQL_DL_SQL92_INTERVAL_DAY        fixed bin(31) value('00000020'xn);
 dcl SQL_DL_SQL92_INTERVAL_HOUR       fixed bin(31) value('00000040'xn);
 dcl SQL_DL_SQL92_INTERVAL_MINUTE     fixed bin(31) value('00000080'xn);
 dcl SQL_DL_SQL92_INTERVAL_SECOND     fixed bin(31) value('00000100'xn);
 dcl SQL_DL_SQL92_INTERVAL_YEAR_TO_MONTH
                                      fixed bin(31) value('00000200'xn);
 dcl SQL_DL_SQL92_INTERVAL_DAY_TO_HOUR
                                      fixed bin(31) value('00000400'xn);
 dcl SQL_DL_SQL92_INTERVAL_DAY_TO_MINUTE
                                      fixed bin(31) value('00000800'xn);
 dcl SQL_DL_SQL92_INTERVAL_DAY_TO_SECOND
                                      fixed bin(31) value('00001000'xn);
 dcl SQL_DL_SQL92_INTERVAL_HOUR_TO_MINUTE
                                      fixed bin(31) value('00002000'xn);
 dcl SQL_DL_SQL92_INTERVAL_HOUR_TO_SECOND
                                      fixed bin(31) value('00004000'xn);
 dcl SQL_DL_SQL92_INTERVAL_MINUTE_TO_SECOND
                                      fixed bin(31) value('00008000'xn);

 /* SQL_CATALOG_LOCATION values */
 dcl SQL_CL_START                     fixed bin(31) value(SQL_QL_START);
 dcl SQL_CL_END                       fixed bin(31) value(SQL_QL_END);

 /* values for SQL_BATCH_ROW_COUNT */
 dcl SQL_BRC_PROCEDURES               fixed bin(31) value('0000001'xn);
 dcl SQL_BRC_EXPLICIT                 fixed bin(31) value('0000002'xn);
 dcl SQL_BRC_ROLLED_UP                fixed bin(31) value('0000004'xn);

 /* bitmasks for SQL_BATCH_SUPPORT */
 dcl SQL_BS_SELECT_EXPLICIT           fixed bin(31) value('00000001'xn);
 dcl SQL_BS_ROW_COUNT_EXPLICIT        fixed bin(31) value('00000002'xn);
 dcl SQL_BS_SELECT_PROC               fixed bin(31) value('00000004'xn);
 dcl SQL_BS_ROW_COUNT_PROC            fixed bin(31) value('00000008'xn);

 /* Values for SQL_PARAM_ARRAY_ROW_COUNTS getinfo */
 dcl SQL_PARC_BATCH                   fixed bin(31) value(1);
 dcl SQL_PARC_NO_BATCH                fixed bin(31) value(2);

 /* values for SQL_PARAM_ARRAY_SELECT_BATCH*/
 dcl SQL_PAS_BATCH                    fixed bin(31) value(1);
 dcl SQL_PAS_NO_BATCH                 fixed bin(31) value(2);
 dcl SQL_PAS_NO_SELECT                fixed bin(31) value(3);

 /* Bitmasks for SQL_INDEX_KEYWORDS */
 dcl SQL_IK_NONE                      fixed bin(31) value('00000000'xn);
 dcl SQL_IK_ASC                       fixed bin(31) value('00000001'xn);
 dcl SQL_IK_DESC                      fixed bin(31) value('00000002'xn);
 dcl SQL_IK_ALL                       fixed bin(31)
     value(IOR(SQL_IK_NONE, SQL_IK_ASC, SQL_IK_DESC));

 /* Bitmasks for SQL_INFO_SCHEMA_VIEWS */
 dcl SQL_ISV_ASSERTIONS               fixed bin(31) value('00000001'xn);
 dcl SQL_ISV_CHARACTER_SETS           fixed bin(31) value('00000002'xn);
 dcl SQL_ISV_CHECK_CONSTRAINTS        fixed bin(31) value('00000004'xn);
 dcl SQL_ISV_COLLATIONS               fixed bin(31) value('00000008'xn);
 dcl SQL_ISV_COLUMN_DOMAIN_USAGE      fixed bin(31) value('00000010'xn);
 dcl SQL_ISV_COLUMN_PRIVILEGES        fixed bin(31) value('00000020'xn);
 dcl SQL_ISV_COLUMNS                  fixed bin(31) value('00000040'xn);
 dcl SQL_ISV_CONSTRAINT_COLUMN_USAGE  fixed bin(31) value('00000080'xn);
 dcl SQL_ISV_CONSTRAINT_TABLE_USAGE   fixed bin(31) value('00000100'xn);
 dcl SQL_ISV_DOMAIN_CONSTRAINTS       fixed bin(31) value('00000200'xn);
 dcl SQL_ISV_DOMAINS                  fixed bin(31) value('00000400'xn);
 dcl SQL_ISV_KEY_COLUMN_USAGE         fixed bin(31) value('00000800'xn);
 dcl SQL_ISV_REFERENTIAL_CONSTRAINTS  fixed bin(31) value('00001000'xn);
 dcl SQL_ISV_SCHEMATA                 fixed bin(31) value('00002000'xn);
 dcl SQL_ISV_SQL_LANGUAGES            fixed bin(31) value('00004000'xn);
 dcl SQL_ISV_TABLE_CONSTRAINTS        fixed bin(31) value('00008000'xn);
 dcl SQL_ISV_TABLE_PRIVILEGES         fixed bin(31) value('00010000'xn);
 dcl SQL_ISV_TABLES                   fixed bin(31) value('00020000'xn);
 dcl SQL_ISV_TRANSLATIONS             fixed bin(31) value('00040000'xn);
 dcl SQL_ISV_USAGE_PRIVILEGES         fixed bin(31) value('00080000'xn);
 dcl SQL_ISV_VIEW_COLUMN_USAGE        fixed bin(31) value('00100000'xn);
 dcl SQL_ISV_VIEW_TABLE_USAGE         fixed bin(31) value('00200000'xn);
 dcl SQL_ISV_VIEWS                    fixed bin(31) value('00400000'xn);

 /* Bitmasks for SQL_ASYNC_MODE */
 %dcl #_SQL  char ext;
 %if #_SQL='' %then %do;
 dcl SQL_AM_NONE       fixed bin(31) value(0);
 dcl SQL_AM_CONNECTION fixed bin(31) value(1);
 dcl SQL_AM_STATEMENT  fixed bin(31) value(2);
 %end;

 /* Bitmasks for SQL_ALTER_DOMAIN */
 dcl SQL_AD_CONSTRAINT_NAME_DEFINITION
                                      fixed bin(31) value('00000001'xn);
 dcl SQL_AD_ADD_DOMAIN_CONSTRAINT     fixed bin(31) value('00000002'xn);
 dcl SQL_AD_DROP_DOMAIN_CONSTRAINT    fixed bin(31) value('00000004'xn);
 dcl SQL_AD_ADD_DOMAIN_DEFAULT        fixed bin(31) value('00000008'xn);
 dcl SQL_AD_DROP_DOMAIN_DEFAULT       fixed bin(31) value('00000010'xn);
 dcl SQL_AD_ADD_CONSTRAINT_INITIALLY_DEFERRED
                                      fixed bin(31) value('00000020'xn);
 dcl SQL_AD_ADD_CONSTRAINT_INITIALLY_IMMEDIATE
                                      fixed bin(31) value('00000040'xn);
 dcl SQL_AD_ADD_CONSTRAINT_DEFERRABLE fixed bin(31) value('00000080'xn);
 dcl SQL_AD_ADD_CONSTRAINT_NON_DEFERRABLE
                                      fixed bin(31) value('00000100'xn);


 /* SQL_CREATE_SCHEMA bitmasks */
 dcl SQL_CS_CREATE_SCHEMA             fixed bin(31) value('00000001'xn);
 dcl SQL_CS_AUTHORIZATION             fixed bin(31) value('00000002'xn);
 dcl SQL_CS_DEFAULT_CHARACTER_SET     fixed bin(31) value('00000004'xn);

 /* SQL_CREATE_TRANSLATION bitmasks */
 dcl SQL_CTR_CREATE_TRANSLATION       fixed bin(31) value('00000001'xn);

 /* SQL_CREATE_ASSERTION bitmasks */
 dcl SQL_CA_CREATE_ASSERTION          fixed bin(31) value('00000001'xn);
 dcl SQL_CA_CONSTR_INITILY_DEFERRED   fixed bin(31) value('00000010'xn);
 dcl SQL_CA_CONSTR_INITILY_IMMEDIATE  fixed bin(31) value('00000020'xn);
 dcl SQL_CA_CONSTRAINT_DEFERRABLE     fixed bin(31) value('00000040'xn);
 dcl SQL_CA_CONSTR_NON_DEFERRABLE     fixed bin(31) value('00000080'xn);

 /* SQL_CREATE_CHARACTER_SET bitmasks */
 dcl SQL_CCS_CREATE_CHARACTER_SET     fixed bin(31) value('00000001'xn);
 dcl SQL_CCS_COLLATE_CLAUSE           fixed bin(31) value('00000002'xn);
 dcl SQL_CCS_LIMITED_COLLATION        fixed bin(31) value('00000004'xn);

 /* SQL_CREATE_COLLATION bitmasks */
 dcl SQL_CCOL_CREATE_COLLATION        fixed bin(31) value('00000001'xn);

 /* SQL_CREATE_DOMAIN bitmasks */
 dcl SQL_CDO_CREATE_DOMAIN            fixed bin(31) value('00000001'xn);
 dcl SQL_CDO_DEFAULT                  fixed bin(31) value('00000002'xn);
 dcl SQL_CDO_CONSTRAINT               fixed bin(31) value('00000004'xn);
 dcl SQL_CDO_COLLATION                fixed bin(31) value('00000008'xn);
 dcl SQL_CDO_CONSTRAINT_NAME_DEFINITION
                                      fixed bin(31) value('00000010'xn);
 dcl SQL_CDO_CONSTRAINT_INITIALLY_DEFERRED
                                      fixed bin(31) value('00000020'xn);
 dcl SQL_CDO_CONSTRAINT_INITIALLY_IMMEDIATE
                                      fixed bin(31) value('00000040'xn);
 dcl SQL_CDO_CONSTRAINT_DEFERRABLE    fixed bin(31) value('00000080'xn);
 dcl SQL_CDO_CONSTRAINT_NON_DEFERRABLE
                                      fixed bin(31) value('00000100'xn);

 /* SQL_CREATE_TABLE bitmasks */
 dcl SQL_CT_CREATE_TABLE              fixed bin(31) value('00000001'xn);
 dcl SQL_CT_COMMIT_PRESERVE           fixed bin(31) value('00000002'xn);
 dcl SQL_CT_COMMIT_DELETE             fixed bin(31) value('00000004'xn);
 dcl SQL_CT_GLOBAL_TEMPORARY          fixed bin(31) value('00000008'xn);
 dcl SQL_CT_LOCAL_TEMPORARY           fixed bin(31) value('00000010'xn);
 dcl SQL_CT_CONSTRAINT_INITIALLY_DEFERRED
                                      fixed bin(31) value('00000020'xn);
 dcl SQL_CT_CONSTRAINT_INITIALLY_IMMEDIATE
                                      fixed bin(31) value('00000040'xn);
 dcl SQL_CT_CONSTRAINT_DEFERRABLE     fixed bin(31) value('00000080'xn);
 dcl SQL_CT_CONSTRAINT_NON_DEFERRABLE fixed bin(31) value('00000100'xn);
 dcl SQL_CT_COLUMN_CONSTRAINT         fixed bin(31) value('00000200'xn);
 dcl SQL_CT_COLUMN_DEFAULT            fixed bin(31) value('00000400'xn);
 dcl SQL_CT_COLUMN_COLLATION          fixed bin(31) value('00000800'xn);
 dcl SQL_CT_TABLE_CONSTRAINT          fixed bin(31) value('00001000'xn);
 dcl SQL_CT_CONSTRAINT_NAME_DEFINITION
                                      fixed bin(31) value('00002000'xn);

 /* SQL_DDL_INDEX bitmasks */
 dcl SQL_DI_CREATE_INDEX              fixed bin(31) value('00000001'xn);
 dcl SQL_DI_DROP_INDEX                fixed bin(31) value('00000002'xn);

 /* SQL_DROP_COLLATION bitmasks */
 dcl SQL_DC_DROP_COLLATION            fixed bin(31) value('00000001'xn);

 /* SQL_DROP_DOMAIN bitmasks */
 dcl SQL_DD_DROP_DOMAIN               fixed bin(31) value('00000001'xn);
 dcl SQL_DD_RESTRICT                  fixed bin(31) value('00000002'xn);
 dcl SQL_DD_CASCADE                   fixed bin(31) value('00000004'xn);

 /* SQL_DROP_SCHEMA bitmasks */
 dcl SQL_DS_DROP_SCHEMA               fixed bin(31) value('00000001'xn);
 dcl SQL_DS_RESTRICT                  fixed bin(31) value('00000002'xn);
 dcl SQL_DS_CASCADE                   fixed bin(31) value('00000004'xn);

 /* SQL_DROP_CHARACTER_SET bitmasks */
 dcl SQL_DCS_DROP_CHARACTER_SET       fixed bin(31) value('00000001'xn);

 /* SQL_DROP_ASSERTION bitmasks */
 dcl SQL_DA_DROP_ASSERTION            fixed bin(31) value('00000001'xn);

 /* SQL_DROP_TABLE bitmasks */
 dcl SQL_DT_DROP_TABLE                fixed bin(31) value('00000001'xn);
 dcl SQL_DT_RESTRICT                  fixed bin(31) value('00000002'xn);
 dcl SQL_DT_CASCADE                   fixed bin(31) value('00000004'xn);

 /* SQL_DROP_TRANSLATION bitmasks */
 dcl SQL_DTR_DROP_TRANSLATION         fixed bin(31) value('00000001'xn);

 /* SQL_DROP_VIEW bitmasks */
 dcl SQL_DV_DROP_VIEW                 fixed bin(31) value('00000001'xn);
 dcl SQL_DV_RESTRICT                  fixed bin(31) value('00000002'xn);
 dcl SQL_DV_CASCADE                   fixed bin(31) value('00000004'xn);

 /* SQL_INSERT_STATEMENT bitmasks */
 dcl SQL_IS_INSERT_LITERALS           fixed bin(31) value('00000001'xn);
 dcl SQL_IS_INSERT_SEARCHED           fixed bin(31) value('00000002'xn);
 dcl SQL_IS_SELECT_INTO               fixed bin(31) value('00000004'xn);

 /* SQL_ODBC_INTERFACE_CONFORMANCE values */
 dcl SQL_OIC_CORE                     fixed bin(31) value(1);
 dcl SQL_OIC_LEVEL1                   fixed bin(31) value(2);
 dcl SQL_OIC_LEVEL2                   fixed bin(31) value(3);

 /* SQL_SQL92_FOREIGN_KEY_DELETE_RULE bitmasks */
 dcl SQL_SFKD_CASCADE                 fixed bin(31) value('00000001'xn);
 dcl SQL_SFKD_NO_ACTION               fixed bin(31) value('00000002'xn);
 dcl SQL_SFKD_SET_DEFAULT             fixed bin(31) value('00000004'xn);
 dcl SQL_SFKD_SET_NULL                fixed bin(31) value('00000008'xn);

 /* SQL_SQL92_FOREIGN_KEY_UPDATE_RULE bitmasks */
 dcl SQL_SFKU_CASCADE                 fixed bin(31) value('00000001'xn);
 dcl SQL_SFKU_NO_ACTION               fixed bin(31) value('00000002'xn);
 dcl SQL_SFKU_SET_DEFAULT             fixed bin(31) value('00000004'xn);
 dcl SQL_SFKU_SET_NULL                fixed bin(31) value('00000008'xn);

 /* SQL_SQL92_GRANT bitmasks */
 dcl SQL_SG_USAGE_ON_DOMAIN           fixed bin(31) value('00000001'xn);
 dcl SQL_SG_USAGE_ON_CHARACTER_SET    fixed bin(31) value('00000002'xn);
 dcl SQL_SG_USAGE_ON_COLLATION        fixed bin(31) value('00000004'xn);
 dcl SQL_SG_USAGE_ON_TRANSLATION      fixed bin(31) value('00000008'xn);
 dcl SQL_SG_WITH_GRANT_OPTION         fixed bin(31) value('00000010'xn);
 dcl SQL_SG_DELETE_TABLE              fixed bin(31) value('00000020'xn);
 dcl SQL_SG_INSERT_TABLE              fixed bin(31) value('00000040'xn);
 dcl SQL_SG_INSERT_COLUMN             fixed bin(31) value('00000080'xn);
 dcl SQL_SG_REFERENCES_TABLE          fixed bin(31) value('00000100'xn);
 dcl SQL_SG_REFERENCES_COLUMN         fixed bin(31) value('00000200'xn);
 dcl SQL_SG_SELECT_TABLE              fixed bin(31) value('00000400'xn);
 dcl SQL_SG_UPDATE_TABLE              fixed bin(31) value('00000800'xn);
 dcl SQL_SG_UPDATE_COLUMN             fixed bin(31) value('00001000'xn);

 /* SQL_SQL92_PREDICATES bitmasks */
 dcl SQL_SP_EXISTS                    fixed bin(31) value('00000001'xn);
 dcl SQL_SP_ISNOTNULL                 fixed bin(31) value('00000002'xn);
 dcl SQL_SP_ISNULL                    fixed bin(31) value('00000004'xn);
 dcl SQL_SP_MATCH_FULL                fixed bin(31) value('00000008'xn);
 dcl SQL_SP_MATCH_PARTIAL             fixed bin(31) value('00000010'xn);
 dcl SQL_SP_MATCH_UNIQUE_FULL         fixed bin(31) value('00000020'xn);
 dcl SQL_SP_MATCH_UNIQUE_PARTIAL      fixed bin(31) value('00000040'xn);
 dcl SQL_SP_OVERLAPS                  fixed bin(31) value('00000080'xn);
 dcl SQL_SP_UNIQUE                    fixed bin(31) value('00000100'xn);
 dcl SQL_SP_LIKE                      fixed bin(31) value('00000200'xn);
 dcl SQL_SP_IN                        fixed bin(31) value('00000400'xn);
 dcl SQL_SP_BETWEEN                   fixed bin(31) value('00000800'xn);
 dcl SQL_SP_COMPARISON                fixed bin(31) value('00001000'xn);
 dcl SQL_SP_QUANTIFIED_COMPARISON     fixed bin(31) value('00002000'xn);

 /* SQL_SQL92_RELATIONAL_JOIN_OPERATORS bitmasks */
 dcl SQL_SRJO_CORRESPONDING_CLAUSE    fixed bin(31) value('00000001'xn);
 dcl SQL_SRJO_CROSS_JOIN              fixed bin(31) value('00000002'xn);
 dcl SQL_SRJO_EXCEPT_JOIN             fixed bin(31) value('00000004'xn);
 dcl SQL_SRJO_FULL_OUTER_JOIN         fixed bin(31) value('00000008'xn);
 dcl SQL_SRJO_INNER_JOIN              fixed bin(31) value('00000010'xn);
 dcl SQL_SRJO_INTERSECT_JOIN          fixed bin(31) value('00000020'xn);
 dcl SQL_SRJO_LEFT_OUTER_JOIN         fixed bin(31) value('00000040'xn);
 dcl SQL_SRJO_NATURAL_JOIN            fixed bin(31) value('00000080'xn);
 dcl SQL_SRJO_RIGHT_OUTER_JOIN        fixed bin(31) value('00000100'xn);
 dcl SQL_SRJO_UNION_JOIN              fixed bin(31) value('00000200'xn);

 /* SQL_SQL92_REVOKE bitmasks */
 dcl SQL_SR_USAGE_ON_DOMAIN           fixed bin(31) value('00000001'xn);
 dcl SQL_SR_USAGE_ON_CHARACTER_SET    fixed bin(31) value('00000002'xn);
 dcl SQL_SR_USAGE_ON_COLLATION        fixed bin(31) value('00000004'xn);
 dcl SQL_SR_USAGE_ON_TRANSLATION      fixed bin(31) value('00000008'xn);
 dcl SQL_SR_GRANT_OPTION_FOR          fixed bin(31) value('00000010'xn);
 dcl SQL_SR_CASCADE                   fixed bin(31) value('00000020'xn);
 dcl SQL_SR_RESTRICT                  fixed bin(31) value('00000040'xn);
 dcl SQL_SR_DELETE_TABLE              fixed bin(31) value('00000080'xn);
 dcl SQL_SR_INSERT_TABLE              fixed bin(31) value('00000100'xn);
 dcl SQL_SR_INSERT_COLUMN             fixed bin(31) value('00000200'xn);
 dcl SQL_SR_REFERENCES_TABLE          fixed bin(31) value('00000400'xn);
 dcl SQL_SR_REFERENCES_COLUMN         fixed bin(31) value('00000800'xn);
 dcl SQL_SR_SELECT_TABLE              fixed bin(31) value('00001000'xn);
 dcl SQL_SR_UPDATE_TABLE              fixed bin(31) value('00002000'xn);
 dcl SQL_SR_UPDATE_COLUMN             fixed bin(31) value('00004000'xn);

 /* SQL_SQL92_ROW_VALUE_CONSTRUCTOR bitmasks */
 dcl SQL_SRVC_VALUE_EXPRESSION        fixed bin(31) value('00000001'xn);
 dcl SQL_SRVC_NULL                    fixed bin(31) value('00000002'xn);
 dcl SQL_SRVC_DEFAULT                 fixed bin(31) value('00000004'xn);
 dcl SQL_SRVC_ROW_SUBQUERY            fixed bin(31) value('00000008'xn);

 /* SQL_SQL92_VALUE_EXPRESSIONS bitmasks */
 dcl SQL_SVE_CASE                     fixed bin(31) value('00000001'xn);
 dcl SQL_SVE_CAST                     fixed bin(31) value('00000002'xn);
 dcl SQL_SVE_COALESCE                 fixed bin(31) value('00000004'xn);
 dcl SQL_SVE_NULLIF                   fixed bin(31) value('00000008'xn);

 /* SQL_STANDARD_CLI_CONFORMANCE bitmasks */
 dcl SQL_SCC_XOPEN_CLI_VERSION1       fixed bin(31) value('00000001'xn);
 dcl SQL_SCC_ISO92_CLI                fixed bin(31) value('00000002'xn);

 /* SQL_UNION_STATEMENT bitmasks */
 dcl SQL_US_UNION                  fixed bin(31) value(SQL_U_UNION);
 dcl SQL_US_UNION_ALL              fixed bin(31) value(SQL_U_UNION_ALL);

 %end; /* ODBCVER >= '0300'x */

 /* SQL_DTC_TRANSITION_COST bitmasks */
 dcl SQL_DTC_ENLIST_EXPENSIVE         fixed bin(31) value('00000001'xn);
 dcl SQL_DTC_UNENLIST_EXPENSIVE       fixed bin(31) value('00000002'xn);

 /* additional SQLDataSources fetch directions */
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_FETCH_FIRST_USER             fixed bin(31) value(31);
 dcl SQL_FETCH_FIRST_SYSTEM           fixed bin(31) value(32);
 %end; /* ODBCVER >= '0300'x */

 /* Defines for SQLSetPos */
 dcl SQL_ENTIRE_ROWSET                fixed bin(31) value(0);

 /* Operations in SQLSetPos */

 dcl SQL_POSITION                fixed bin(31) value(0); /* 1.0 FALSE */
 dcl SQL_REFRESH                 fixed bin(31) value(1); /* 1.0 TRUE  */
 dcl SQL_UPDATE                  fixed bin(31) value(2);
 dcl SQL_DELETE                  fixed bin(31) value(3);

 /* Operations in SQLBulkOperations */
 dcl SQL_ADD                     fixed bin(31) value(4);
 dcl SQL_SETPOS_MAX_OPTION_VALUE fixed bin(31) value(SQL_ADD);
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_UPDATE_BY_BOOKMARK      fixed bin(31) value(5);
 dcl SQL_DELETE_BY_BOOKMARK      fixed bin(31) value(6);
 dcl SQL_FETCH_BY_BOOKMARK       fixed bin(31) value(7);
 %end; /*  ODBCVER >= '0300'x */

 /* Lock options in SQLSetPos */

 dcl SQL_LOCK_NO_CHANGE          fixed bin(31) value(0); /* 1.0 FALSE */
 dcl SQL_LOCK_EXCLUSIVE          fixed bin(31) value(1); /* 1.0 TRUE  */
 dcl SQL_LOCK_UNLOCK             fixed bin(31) value(2);
 dcl SQL_SETPOS_MAX_LOCK_VALUE   fixed bin(31) value(SQL_LOCK_UNLOCK);


 /* "Macros" for SQLSetPos */

 SQL_POSITION_TO: Proc (hstmt, irow)
                  returns (type SQLRETURN optional)
                  options (inline reorder) internal;
   dcl hstmt type SQLHSTMT,
       irow  type SQLUSMALLINT;
   return (SQLSetPos (hstmt, irow, SQL_POSITION, SQL_LOCK_NO_CHANGE));
 end SQL_POSITION_TO;

 SQL_LOCK_RECORD: Proc (hstmt, irow, fLock)
                  returns (type SQLRETURN optional)
                  options (inline reorder) internal;
   dcl hstmt type SQLHSTMT,
       irow  type SQLUSMALLINT,
       fLock type SQLUSMALLINT;
   return (SQLSetPos (hstmt, irow, SQL_POSITION, fLock));
 end SQL_LOCK_RECORD;

 SQL_REFRESH_RECORD: Proc (hstmt, irow, fLock)
                     returns (type SQLRETURN optional)
                     options (inline reorder) internal;
   dcl hstmt type SQLHSTMT,
       irow  type SQLUSMALLINT,
       fLock type SQLUSMALLINT;
   return (SQLSetPos (hstmt, irow, SQL_REFRESH, fLock));
 end SQL_REFRESH_RECORD;

 SQL_UPDATE_RECORD: Proc (hstmt, irow)
                    returns (type SQLRETURN optional)
                    options (inline reorder) internal;
   dcl hstmt type SQLHSTMT,
       irow  type SQLUSMALLINT;
   return (SQLSetPos (hstmt, irow, SQL_UPDATE, SQL_LOCK_NO_CHANGE));
 end SQL_UPDATE_RECORD;

 SQL_DELETE_RECORD: Proc (hstmt, irow)
                    returns (type SQLRETURN optional)
                    options (inline reorder) internal;
   dcl hstmt type SQLHSTMT,
       irow  type SQLUSMALLINT;
   return (SQLSetPos (hstmt, irow, SQL_DELETE, SQL_LOCK_NO_CHANGE));
 end SQL_DELETE_RECORD;

 SQL_ADD_RECORD: Proc (hstmt, irow)
                 returns (type SQLRETURN optional)
                 options (inline reorder) internal;
   dcl hstmt type SQLHSTMT,
       irow  type SQLUSMALLINT;
   return (SQLSetPos (hstmt, irow, SQL_ADD, SQL_LOCK_NO_CHANGE));
 end SQL_ADD_RECORD;

 /* Column types and scopes in SQLSpecialColumns.  */
 dcl SQL_BEST_ROWID    fixed bin(31) value(1);
 dcl SQL_ROWVER        fixed bin(31) value(2);

 /* Defines for SQLSpecialColumns (returned in the result set) */
 /* SQL_PC_UNKNOWN and SQL_PC_PSEUDO are defined in ODBCSQL.CPY*/
 dcl SQL_PC_NOT_PSEUDO fixed bin(31) value(1);

 /* Defines for SQLStatistics */
 dcl SQL_QUICK         fixed bin(31) value(0);
 dcl SQL_ENSURE        fixed bin(31) value(1);

 /* Defines for SQLStatistics (returned in the result set) */
 /*  SQL_INDEX_CLUSTERED, SQL_INDEX_HASHED, and SQL_INDEX_OTHER are */
 /*  defined in ODBCSQL.CPY */
 dcl SQL_TABLE_STAT    fixed bin(31) value(0);


 /* Defines for SQLTables */
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_ALL_CATALOGS    char value('%');
 dcl SQL_ALL_SCHEMAS     char value('%');
 dcl SQL_ALL_TABLE_TYPES char value('%');
 %end; /* ODBCVER >= '0300'x */

 /* Options for SQLDriverConnect */
 dcl SQL_DRIVER_NOPROMPT          fixed bin(31) value(0);
 dcl SQL_DRIVER_COMPLETE          fixed bin(31) value(1);
 dcl SQL_DRIVER_PROMPT            fixed bin(31) value(2);
 dcl SQL_DRIVER_COMPLETE_REQUIRED fixed bin(31) value(3);

 dcl SQLDriverConnect
     entry (type SQLHDBC,
            type SQLHWND,
            char (*) varz byaddr optional,
            type SQLSMALLINT,
            char (*) varz byaddr optional,
            type SQLSMALLINT,
            type SQLSMALLINT byaddr optional,
            type SQLUSMALLINT)
     returns (byvalue optional type SQLRETURN )
     SQL_API external('SQLDriverConnect');


 /* Level 2 Functions                             */

 /* SQLExtendedFetch "fFetchType" values */
 dcl SQL_FETCH_BOOKMARK fixed bin(31) value(8);

 /* SQLExtendedFetch "rgfRowStatus" element values */
 dcl SQL_ROW_SUCCESS fixed bin(31) value(0);
 dcl SQL_ROW_DELETED fixed bin(31) value(1);
 dcl SQL_ROW_UPDATED fixed bin(31) value(2);
 dcl SQL_ROW_NOROW   fixed bin(31) value(3);
 dcl SQL_ROW_ADDED   fixed bin(31) value(4);
 dcl SQL_ROW_ERROR   fixed bin(31) value(5);
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_ROW_SUCCESS_WITH_INFO fixed bin(31) value(6);
 dcl SQL_ROW_PROCEED fixed bin(31) value(0);
 dcl SQL_ROW_IGNORE fixed bin(31) value(1);
 %end;

 /* value for SQL_DESC_ARRAY_STATUS_PTR */
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_PARAM_SUCCESS           fixed bin(31) value(0);
 dcl SQL_PARAM_SUCCESS_WITH_INFO fixed bin(31) value(6);
 dcl SQL_PARAM_ERROR             fixed bin(31) value(5);
 dcl SQL_PARAM_UNUSED            fixed bin(31) value(7);
 dcl SQL_PARAM_DIAG_UNAVAILABLE  fixed bin(31) value(1);

 dcl SQL_PARAM_PROCEED           fixed bin(31) value(0);
 dcl SQL_PARAM_IGNORE            fixed bin(31) value(1);
 %end; /* ODBCVER >= '0300'x */

 /* Defines for SQLForeignKeys (returned in result set) */
 dcl SQL_CASCADE                 fixed bin(31) value(0);
 dcl SQL_RESTRICT                fixed bin(31) value(1);
 dcl SQL_SET_NULL                fixed bin(31) value(2);
 %if (ODBCVER >= '0250'x) %then %do;
 dcl SQL_NO_ACTION               fixed bin(31) value(3);
 dcl SQL_SET_DEFAULT             fixed bin(31) value(4);
 %end; /* ODBCVER >= '0250'x */
 %if (ODBCVER >=  '0300'x) %then %do;
 dcl SQL_INITIALLY_DEFERRED      fixed bin(31) value(5);
 dcl SQL_INITIALLY_IMMEDIATE     fixed bin(31) value(6);
 %end; /* ODBCVER >= '0300'x */

 /* Defines for SQLBindParameter and */
 /*  SQLProcedureColumns (returned in the result set) */
 dcl SQL_PARAM_TYPE_UNKNOWN      fixed bin(31) value(0);
 dcl SQL_PARAM_INPUT             fixed bin(31) value(1);
 dcl SQL_PARAM_INPUT_OUTPUT      fixed bin(31) value(2);
 dcl SQL_RESULT_COL              fixed bin(31) value(3);
 dcl SQL_PARAM_OUTPUT            fixed bin(31) value(4);
 dcl SQL_RETURN_VALUE            fixed bin(31) value(5);

 /* Defines used by Driver Manager when mapping SQLSetParam to        */
 /* SQLBindParameter                                                  */
 dcl SQL_PARAM_TYPE_DEFAULT      fixed bin(31)
     value(SQL_PARAM_INPUT_OUTPUT);
 dcl SQL_SETPARAM_VALUE_MAX      fixed bin(31) value(-1);

 /* Defines for SQLProcedures (returned in the result set) */
 dcl SQL_PT_UNKNOWN   fixed bin(31) value(0);
 dcl SQL_PT_PROCEDURE fixed bin(31) value(1);
 dcl SQL_PT_FUNCTION  fixed bin(31) value(2);

 %dcl SQL_ODBC_KEYWORDS char ext;
 %SQL_ODBC_KEYWORDS = '''ABSOLUTE,ACTION,ADA,ADD,ALL,ALLOCATE,ALTER,'||
 'AND,ANY,ARE,AS,ASC,ASSERTION,AT,AUTHORIZATION,AVG,BEGIN,BETWEEN,'||
 'BIT,BIT_LENGTH,BOTH,BY,CASCADE,CASCADED,CASE,CAST,CATALOG,CHAR,'||
 'CHAR_LENGTH,CHARACTER,CHARACTER_LENGTH,CHECK,CLOSE,COALESCE,'||
 'COLLATE,COLLATION,COLUMN,COMMIT,CONNECT,CONNECTION,CONSTRAINT,'||
 'CONSTRAINTS,CONTINUE,CONVERT,CORRESPONDING,COUNT,CREATE,CROSS,'||
 'CURRENT,CURRENT_DATE,CURRENT_TIME,CURRENT_TIMESTAMP,CURRENT_USER,'||
 'CURSOR,DATE,DAY,DEALLOCATE,DEC,DECIMAL,DECLARE,DEFAULT,DEFERRABLE,'||
 'DEFERRED,DELETE,DESC,DESCRIBE,DESCRIPTOR,DIAGNOSTICS,DISCONNECT,'||
 'DISTINCT,DOMAIN,DOUBLE,DROP,ELSE,END,END-EXEC,ESCAPE,EXCEPT,'||
 'EXCEPTION,EXEC,EXECUTE,EXISTS,EXTERNAL,EXTRACT,FALSE,FETCH,FIRST,'||
 'FLOAT,FOR,FOREIGN,FORTRAN,FOUND,FROM,FULL,GET,GLOBAL,GO,GOTO,GRANT,'||
 'GROUP,HAVING,HOUR,IDENTITY,IMMEDIATE,IN,INCLUDE,INDEX,INDICATOR,'||
 'INITIALLY,INNER,INPUT,INSENSITIVE,INSERT,INT,INTEGER,INTERSECT,'||
 'INTERVAL,INTO,IS,ISOLATION,JOIN,KEY,LANGUAGE,LAST,LEADING,LEFT,'||
 'LEVEL,LIKE,LOCAL,LOWER,MATCH,MAX,MIN,MINUTE,MODULE,MONTH,NAMES,'||
 'NATIONAL,NATURAL,NCHAR,NEXT,NO,NONE,NOT,NULL,NULLIF,NUMERIC,'||
 'OCTET_LENGTH,OF,ON,ONLY,OPEN,OPTION,OR,ORDER,OUTER,OUTPUT,OVERLAPS,'||
 'PAD,PARTIAL,PASCAL,PLI,POSITION,PRECISION,PREPARE,PRESERVE,PRIMARY,'||
 'PRIOR,PRIVILEGES,PROCEDURE,PUBLIC,READ,REAL,REFERENCES,RELATIVE,'||
 'RESTRICT,REVOKE,RIGHT,ROLLBACK,ROWS,SCHEMA,SCROLL,SECOND,SECTION,'||
 'SELECT,SESSION,SESSION_USER,SET,SIZE,SMALLINT,SOME,SPACE,SQL,SQLCA,'||
 'SQLCODE,SQLERROR,SQLSTATE,SQLWARNING,SUBSTRING,SUM,SYSTEM_USER,'||
 'TABLE,TEMPORARY,THEN,TIME,TIMESTAMP,TIMEZONE_HOUR,TIMEZONE_MINUTE,'||
 'TO,TRAILING,TRANSACTION,TRANSLATE,TRANSLATION,TRIM,TRUE,UNION,'||
 'UNIQUE,UNKNOWN,UPDATE,UPPER,USAGE,USER,USING,VALUE,VALUES,VARCHAR,'||
 'VARYING,VIEW,WHEN,WHENEVER,WHERE,WITH,WORK,WRITE,YEAR,ZONE''';

 dcl SQLBrowseConnect
     entry (type SQLHDBC,
            char (*) varz byaddr,
            type SQLSMALLINT,
            char (*) varz byaddr,
            type SQLSMALLINT,
            type SQLSMALLINT byaddr)
     returns (byvalue optional type SQLRETURN )
     SQL_API external('SQLBrowseConnect');

 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQLBulkOperations
     entry (type SQLHSTMT,
            type SQLSMALLINT)
     returns (byvalue optional type SQLRETURN )
     SQL_API external('SQLBulkOperations');
 %end; /* ODBCVER >= '0300'x */

 dcl SQLColAttributes
     entry (type SQLHSTMT,
            type SQLUSMALLINT,
            type SQLUSMALLINT,
            type SQLPOINTER,
            type SQLSMALLINT,
            type SQLSMALLINT byaddr,
            type SQLINTEGER byaddr)
     returns (byvalue optional type SQLRETURN )
     SQL_API external('SQLColAttributes');

 dcl SQLColumnPrivileges
     entry (type SQLHSTMT,
            char (*) varz byaddr optional,
            type SQLSMALLINT,
            char (*) varz byaddr optional,
            type SQLSMALLINT,
            char (*) varz byaddr,
            type SQLSMALLINT,
            char (*) varz byaddr optional,
            type SQLSMALLINT)
     returns (byvalue optional type SQLRETURN )
     SQL_API external('SQLColumnPrivileges');

 dcl SQLDescribeParam
     entry (type SQLHSTMT,
            type SQLUSMALLINT,
            type SQLSMALLINT byaddr,
            type SQLUINTEGER byaddr,
            type SQLSMALLINT byaddr,
            type SQLSMALLINT byaddr)
     returns (byvalue optional type SQLRETURN )
     SQL_API external('SQLDescribeParam');

 dcl SQLExtendedFetch
     entry (type SQLHSTMT,
            type SQLUSMALLINT,
            type SQLINTEGER,
            type SQLUINTEGER byaddr,
            type SQLUSMALLINT byaddr)
     returns (byvalue optional type SQLRETURN )
     SQL_API external('SQLExtendedFetch');

 dcl SQLForeignKeys
     entry (type SQLHSTMT,
            char (*) varz byaddr optional,
            type SQLSMALLINT,
            char (*) varz byaddr optional,
            type SQLSMALLINT,
            char (*) varz byaddr,
            type SQLSMALLINT,
            char (*) varz byaddr optional,
            type SQLSMALLINT,
            char (*) varz byaddr optional,
            type SQLSMALLINT,
            char (*) varz byaddr,
            type SQLSMALLINT)
     returns (byvalue optional type SQLRETURN )
     SQL_API external('SQLForeignKeys');

 dcl SQLMoreResults
     entry (type SQLHSTMT)
     returns (byvalue optional type SQLRETURN )
     SQL_API external('SQLMoreResults');

 dcl SQLNativeSql
     entry (type SQLHDBC,
            char (*) varz byaddr,
            type SQLINTEGER,
            char (*) varz byaddr,
            type SQLINTEGER,
            type SQLINTEGER byaddr)
     returns (byvalue optional type SQLRETURN )
     SQL_API external('SQLNativeSql');

 dcl SQLNumParams
     entry (type SQLHSTMT,
            type SQLSMALLINT byaddr)
     returns (byvalue optional type SQLRETURN )
     SQL_API external('SQLNumParams');

 dcl SQLParamOptions
     entry (type SQLHSTMT,
            type SQLUINTEGER,
            type SQLUINTEGER byaddr)
     returns (byvalue optional type SQLRETURN )
     SQL_API external('SQLParamOptions');

 dcl SQLPrimaryKeys
     entry (type SQLHSTMT,
            char (*) varz byaddr optional,
            type SQLSMALLINT,
            char (*) varz byaddr optional,
            type SQLSMALLINT,
            char (*) varz byaddr,
            type SQLSMALLINT)
     returns (byvalue optional type SQLRETURN )
     SQL_API external('SQLPrimaryKeys');

 dcl SQLProcedureColumns
     entry (type SQLHSTMT,
            char (*) varz byaddr optional,
            type SQLSMALLINT,
            char (*) varz byaddr optional,
            type SQLSMALLINT,
            char (*) varz byaddr optional,
            type SQLSMALLINT,
            char (*) varz byaddr optional,
            type SQLSMALLINT)
     returns (byvalue optional type SQLRETURN )
     SQL_API external('SQLProcedureColumns');

 dcl SQLProcedures
     entry (type SQLHSTMT,
            char (*) varz byaddr optional,
            type SQLSMALLINT,
            char (*) varz byaddr optional,
            type SQLSMALLINT,
            char (*) varz byaddr optional,
            type SQLSMALLINT)
     returns (byvalue optional type SQLRETURN )
     SQL_API external('SQLProcedures');

 dcl SQLSetPos
     entry (type SQLHSTMT,
            type SQLUSMALLINT,
            type SQLUSMALLINT,
            type SQLUSMALLINT)
     returns (byvalue optional type SQLRETURN )
     SQL_API external('SQLSetPos');

 dcl SQLTablePrivileges
     entry (type SQLHSTMT,
            char (*) varz byaddr optional,
            type SQLSMALLINT,
            char (*) varz byaddr optional,
            type SQLSMALLINT,
            char (*) varz byaddr optional,
            type SQLSMALLINT)
     returns (byvalue optional type SQLRETURN )
     SQL_API external('SQLTablePrivileges');

 dcl SQLDrivers
     entry (type SQLHENV,
            type SQLUSMALLINT,
            char (*) varz byaddr,
            type SQLSMALLINT,
            type SQLSMALLINT byaddr,
            char (*) varz byaddr,
            type SQLSMALLINT,
            type SQLSMALLINT byaddr)
     returns (byvalue optional type SQLRETURN )
     SQL_API external('SQLDrivers');

 dcl SQLBindParameter
     entry (type SQLHSTMT,
            type SQLUSMALLINT,
            type SQLSMALLINT,
            type SQLSMALLINT,
            type SQLSMALLINT,
            type SQLUINTEGER,
            type SQLSMALLINT,
            type SQLPOINTER,
            type SQLINTEGER,
            type SQLINTEGER byaddr optional)
     returns (byvalue optional type SQLRETURN )
     SQL_API external('SQLBindParameter');

 /*---------------------------------------------------------*/
 /* SQLAllocHandleStd is implemented to make SQLAllocHandle */
 /* compatible with X/Open standard.  an application should */
 /* not call SQLAllocHandleStd directly        */
 /*---------------------------------------------------------*/
 %dcl ODBC_STD char ext;
 %if ODBC_STD ^= '' %then %do;
 %dcl SQLAllocHandle char ext;
 %SQLAllocHandle='SQLAllocHandleStd';

 SQLAllocEnv: Proc (henv) returns (type SQLRETURN optional)
              options(inline reorder) internal;
   dcl henv type SQLHENV byaddr;
   return (SQLAllocHandleStd (SQL_HANDLE_ENV, SQL_NULL_HANDLE, henv));
 end SQLAllocEnv;

 /* Internal type subcodes */
 dcl SQL_YEAR              fixed bin(31) value(SQL_CODE_YEAR);
 dcl SQL_MONTH             fixed bin(31) value(SQL_CODE_MONTH);
 dcl SQL_DAY               fixed bin(31) value(SQL_CODE_DAY);
 dcl SQL_HOUR              fixed bin(31) value(SQL_CODE_HOUR);
 dcl SQL_MINUTE            fixed bin(31) value(SQL_CODE_MINUTE);
 dcl SQL_SECOND            fixed bin(31) value(SQL_CODE_SECOND);
 dcl SQL_YEAR_TO_MONTH     fixed bin(31) value(SQL_CODE_YEAR_TO_MONTH);
 dcl SQL_DAY_TO_HOUR       fixed bin(31) value(SQL_CODE_DAY_TO_HOUR);
 dcl SQL_DAY_TO_MINUTE     fixed bin(31) value(SQL_CODE_DAY_TO_MINUTE);
 dcl SQL_DAY_TO_SECOND     fixed bin(31) value(SQL_CODE_DAY_TO_SECOND);
 dcl SQL_HOUR_TO_MINUTE    fixed bin(31) value(SQL_CODE_HOUR_TO_MINUTE);
 dcl SQL_HOUR_TO_SECOND    fixed bin(31) value(SQL_CODE_HOUR_TO_SECOND);
 dcl SQL_MINUTE_TO_SECOND  fixed bin(31)
      value(SQL_CODE_MINUTE_TO_SECOND);
 %end; /* ODBC_STD */

 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQLAllocHandleStd
     entry (type SQLSMALLINT,
            type SQLHANDLE,
            type SQLHANDLE byaddr)
     returns (byvalue optional type SQLRETURN )
     SQL_API external('SQLAllocHandleStd');
 %end;

 /* Deprecated defines from prior versions of ODBC */
 /* Use SQLGetConnectOption/SQL_CURRENT_QUALIFIER */
 dcl SQL_DATABASE_NAME        fixed bin(31) value(16);
 dcl SQL_FD_FETCH_PREV        fixed bin(31) value(SQL_FD_FETCH_PRIOR);
 dcl SQL_FETCH_PREV           fixed bin(31) value(SQL_FETCH_PRIOR);
 dcl SQL_CONCUR_TIMESTAMP     fixed bin(31) value(SQL_CONCUR_ROWVER);
 dcl SQL_SCCO_OPT_TIMESTAMP   fixed bin(31) value(SQL_SCCO_OPT_ROWVER);
 dcl SQL_CC_DELETE            fixed bin(31) value(SQL_CB_DELETE);
 dcl SQL_CR_DELETE            fixed bin(31) value(SQL_CB_DELETE);
 dcl SQL_CC_CLOSE             fixed bin(31) value(SQL_CB_CLOSE);
 dcl SQL_CR_CLOSE             fixed bin(31) value(SQL_CB_CLOSE);
 dcl SQL_CC_PRESERVE          fixed bin(31) value(SQL_CB_PRESERVE);
 dcl SQL_CR_PRESERVE          fixed bin(31) value(SQL_CB_PRESERVE);
 /* SQL_FETCH_RESUME is not supported by 2.0+ drivers  */
 %if (ODBCVER < '0300'x) %then %do;
 dcl SQL_FETCH_RESUME         fixed bin(31) value(7);
 %end;
 /*-SQL_CURSOR_FORWARD_ONLY */
 dcl SQL_SCROLL_FORWARD_ONLY  fixed bin(31) value(0);
 /*-SQL_CURSOR_KEYSET_DRIVEN */
 dcl SQL_SCROLL_KEYSET_DRIVEN fixed bin(31) value(-1);
 /*-SQL_CURSOR_DYNAMIC */
 dcl SQL_SCROLL_DYNAMIC       fixed bin(31) value(-2);
 /*-SQL_CURSOR_STATIC */
 dcl SQL_SCROLL_STATIC        fixed bin(31) value(-3);

 /* Deprecated functions from prior versions of ODBC */
 /* Use SQLSetStmtOptions */
 dcl SQLSetScrollOptions
     entry (type SQLHSTMT,
            type SQLUSMALLINT,
            type SQLINTEGER,
            type SQLUSMALLINT)
     returns (byvalue optional type SQLRETURN )
     SQL_API external('SQLSetScrollOptions');

 /* Tracing section */

 /* Version of trace API */
 dcl TRACE_VERSION fixed bin(31) value(1000);

 /* open a trace log file */
 dcl TraceOpenLogFile
     entry (SQLWCHAR(*) varz byaddr,
            SQLWCHAR(*) varz byaddr,
            type DWORD)
     returns (byvalue optional type RETCODE )
     SQL_API external('TraceOpenLogFile');
 /* Request to close a trace log */
 dcl TraceCloseLogFile
     entry ()
     returns (byvalue optional type RETCODE )
     SQL_API external('TraceCloseLogFile');
 /* Processes trace after FN is called */
 dcl TraceReturn
     entry (type RETCODE,
            type RETCODE)
     SQL_API external('TraceReturn');
 /* Returns trace API version */
 dcl TraceVersion
     entry ()
     returns (byvalue optional type DWORD )
     SQL_API external('TraceVersion');

 /* Functions for Visual Studio Analyzer*/
 /* to turn on/off tracing or VS events, call TraceVSControl by */
 /* setting or clearing the following bits  */
 dcl TRACE_ON          fixed bin (31) value('00000001'xn);
 dcl TRACE_VS_EVENT_ON fixed bin (31) value('00000002'xn);

 dcl TraceVSControl
     entry (type DWORD)
     returns (byvalue optional type RETCODE)
     SQL_API external('TraceVSControl');

 /* Functions for setting the connection pooling failure detection    */
 /* code. The "TryWait" value is the time (in seconds) that the DM    */
 /* will wait between detecting that a connection is dead (using      */
 /* SQL_ATTR_CONNECTION_DEAD) and retrying the connection.  During    */
 /* that interval, connection requests will get "The server appears   */
 /* to be dead" error returns.                                        */


 dcl ODBCSetTryWaitValue
     entry (type DWORD)                       /* In seconds */
     returns (byvalue optional type BOOL)
     SQL_API external('ODBCSetTryWaitValue');


 dcl ODBCGetTryWaitValue
     entry ()
     returns (byvalue optional type DWORD) 	/* In Milliseconds(!) */
     SQL_API external('ODBCGetTryWaitValue');


 /* the flags in ODBC_VS_ARGS */
 dcl ODBC_VS_FLAG_UNICODE_ARG fixed bin (31) value('00000001'xn);
     /* the argument is unicode */
 dcl ODBC_VS_FLAG_UNICODE_COR fixed bin (31) value('00000002'xn);
     /* the correlation is unicode */
 dcl ODBC_VS_FLAG_RETCODE     fixed bin (31) value('00000004'xn);
     /* RetCode field is set */
 dcl ODBC_VS_FLAG_STOP        fixed bin (31) value('00000008'xn);
     /* Stop firing visual studio analyzer events */

 define structure
   1 ODBC_VS_ARGS,
	    2 pguidEvent       pointer,    /* (to) the GUID for event */
	    2 dwFlags          type DWORD, /* flags for the call */
     2 * union,
       3 wszArg         pointer,    /* to WCHAR varz string */
       3 szArg          pointer,    /* to char varz string */
     2 * union,
       3 wszCorrelation pointer,    /* to WCHAR varz string */
       3 szCorrelation  pointer,    /* to char varz string */
     2 RetCode          type RETCODE;
 define alias PODBC_VS_ARGS handle ODBC_VS_ARGS;

 dcl FireVSDebugEvent
     entry (type ODBC_VS_ARGS byaddr)
     SQL_API external('FireVSDebugEvent');

 %include odbcucod;

 %end; /* __SQLEXT */

