 /*****************************************************************/
 /** ODBCSQL.CPY - This is the main include for ODBC functions.   */
 /**             - ODBC V 3.0 Level                               */
 /**                                                              */
 /*****************************************************************/
 /*                                                               */
 /*  Licensed Materials - Property of IBM                         */
 /*  5639-A83, 5639-A24 (C) Copyright IBM Corp. 1998.             */
 /*  All Rights Reserved.                                         */
 /*   (C) Copyright IBM Corp. 1998. All Rights Reserved.          */
 /*   US Government Users Restricted Rights-- Use, duplication or */
 /*   disclosure restricted by GSA ADP Schedule Contract with     */
 /*   IBM Corp.                                                   */
 /*                                                               */
 /* DISCLAIMER OF WARRANTIES                                      */
 /*   The following enclosed code is sample code created by IBM */
 /*   Corporation. This sample code is not part of any standard   */
 /*   IBM product and is provided to you solely for the purpose of*/
 /*   assisting you in the development of your applications.  The */
 /*   code is provided "AS IS", without warranty of any kind.     */
 /*   IBM shall not be liable for any damages arising out of your */
 /*   use of the sample code, even if IBM has been advised of the */
 /*   possibility of such damages.                                */
 /*                                                               */
 /*****************************************************************/
 /*                                                               */
 /* ODBCVER                   ODBC version number ('0300'x).  To  */
 /*                           exclude definitions introduced in   */
 /*                           version 3.0 (or above)              */
 /*                           %ODBCVER = '0250'X; before          */
 /*                           including ODBCSQL.CPY               */
 /*                                                               */
 /*****************************************************************/

 %dcl #_SQL char ext;
 %if #_SQL = '' %then %do;
   %#_SQL = 'Y';

 /* ODBCVER  ODBC version number ('0351'x). To exclude            */
 /*          definitions introduced in version 3.5 (or above)     */
 /*          %ODBCVER = '0300'x before %include'ing odbcsql.cpy   */
 %dcl ODBCVER char ext;
 %if ODBCVER = '' %then %do;
   %ODBCVER = '0351'x;
 %end;

 %dcl #_SQLTYPES char ext;
 %if #_SQLTYPES = '' %then %do;
   %include odbctype;
 %end;

 /* special length/indicator values */
 dcl SQL_NULL_DATA    fixed bin(31) value(-1);
 dcl SQL_DATA_AT_EXEC fixed bin(31) value(-2);

 /* return values from functions */
 dcl SQL_SUCCESS           fixed bin(31) value(0);
 dcl SQL_SUCCESS_WITH_INFO fixed bin(31) value(1);
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_NO_DATA           fixed bin(31) value(100);
 %end;
 dcl SQL_ERROR             fixed bin(31) value(-1);
 dcl SQL_INVALID_HANDLE    fixed bin(31) value(-2);

 dcl SQL_STILL_EXECUTING   fixed bin(31) value(2);
 dcl SQL_NEED_DATA         fixed bin(31) value(99);

 /* test for SQL_SUCCESS or SQL_SUCCESS_WITH_INFO */

 SQL_SUCCEEDED: proc (rc) returns (bit (1) aligned)
                options (inline byvalue) internal;
   dcl rc fixed bin(31);
   dcl inot builtin;

   return (iand (rc, inot (1)) = 0);
 end SQL_SUCCEEDED;

 /* flags for null-terminated string */
 dcl SQL_NTS  fixed bin(15) value(-3);
 dcl SQL_NTSL fixed bin(31) value(-3);

 /* maximum message length */
 dcl SQL_MAX_MESSAGE_LENGTH fixed bin(31) value(512);

 /* date/time length constants */
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_DATE_LEN      fixed bin(31) value(10);
                                  /* add P+1 if precision is nonzero */
 dcl SQL_TIME_LEN      fixed bin(31) value(8);
                                  /* add P+1 if precision is nonzero */
 dcl SQL_TIMESTAMP_LEN fixed bin(31) value(19);
 %end;

 /* handle type identifiers */
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_HANDLE_ENV  fixed bin(31) value(1);
 dcl SQL_HANDLE_DBC  fixed bin(31) value(2);
 dcl SQL_HANDLE_STMT fixed bin(31) value(3);
 dcl SQL_HANDLE_DESC fixed bin(31) value(4);
 %end;

 /* environment attribute */
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_ATTR_OUTPUT_NTS         fixed bin(31) value(10001);
 %end;

 /* connection attributes */
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_ATTR_AUTO_IPD           fixed bin(31) value(10001);
 dcl SQL_ATTR_METADATA_ID        fixed bin(31) value(10014);
 %end; /* ODBCVER >= '0300'x */

 /* statement attributes */
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_ATTR_APP_ROW_DESC       fixed bin(31) value(10010);
 dcl SQL_ATTR_APP_PARAM_DESC     fixed bin(31) value(10011);
 dcl SQL_ATTR_IMP_ROW_DESC       fixed bin(31) value(10012);
 dcl SQL_ATTR_IMP_PARAM_DESC     fixed bin(31) value(10013);
 dcl SQL_ATTR_CURSOR_SCROLLABLE  fixed bin(31) value(-1);
 dcl SQL_ATTR_CURSOR_SENSITIVITY fixed bin(31) value(-2);
 %end;

 /* SQL_ATTR_CURSOR_SCROLLABLE values */
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_NONSCROLLABLE           fixed bin(31) value(0);
 dcl SQL_SCROLLABLE              fixed bin(31) value(1);
 %end; /* ODBCVER >= '0300'x */

 /* identifiers of fields in the SQL descriptor */
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_DESC_COUNT                  fixed bin(31) value(1001);
 dcl SQL_DESC_TYPE                   fixed bin(31) value(1002);
 dcl SQL_DESC_LENGTH                 fixed bin(31) value(1003);
 dcl SQL_DESC_OCTET_LENGTH_PTR       fixed bin(31) value(1004);
 dcl SQL_DESC_PRECISION              fixed bin(31) value(1005);
 dcl SQL_DESC_SCALE                  fixed bin(31) value(1006);
 dcl SQL_DESC_DATETIME_INTERVAL_CODE fixed bin(31) value(1007);
 dcl SQL_DESC_NULLABLE               fixed bin(31) value(1008);
 dcl SQL_DESC_INDICATOR_PTR          fixed bin(31) value(1009);
 dcl SQL_DESC_DATA_PTR               fixed bin(31) value(1010);
 dcl SQL_DESC_NAME                   fixed bin(31) value(1011);
 dcl SQL_DESC_UNNAMED                fixed bin(31) value(1012);
 dcl SQL_DESC_OCTET_LENGTH           fixed bin(31) value(1013);
 dcl SQL_DESC_ALLOC_TYPE             fixed bin(31) value(1099);
 %end;

 /* identifiers of fields in the diagnostics area */
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_DIAG_RETURNCODE            fixed bin(31) value(1);
 dcl SQL_DIAG_NUMBER                fixed bin(31) value(2);
 dcl SQL_DIAG_ROW_COUNT             fixed bin(31) value(3);
 dcl SQL_DIAG_SQLSTATE              fixed bin(31) value(4);
 dcl SQL_DIAG_NATIVE                fixed bin(31) value(5);
 dcl SQL_DIAG_MESSAGE_TEXT          fixed bin(31) value(6);
 dcl SQL_DIAG_DYNAMIC_FUNCTION      fixed bin(31) value(7);
 dcl SQL_DIAG_CLASS_ORIGIN          fixed bin(31) value(8);
 dcl SQL_DIAG_SUBCLASS_ORIGIN       fixed bin(31) value(9);
 dcl SQL_DIAG_CONNECTION_NAME       fixed bin(31) value(10);
 dcl SQL_DIAG_SERVER_NAME           fixed bin(31) value(11);
 dcl SQL_DIAG_DYNAMIC_FUNCTION_CODE fixed bin(31) value(12);
 %end;

 /* dynamic function codes */
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_DIAG_ALTER_TABLE           fixed bin(31) value(4);
 dcl SQL_DIAG_CREATE_INDEX          fixed bin(31) value(-1);
 dcl SQL_DIAG_CREATE_TABLE          fixed bin(31) value(77);
 dcl SQL_DIAG_CREATE_VIEW           fixed bin(31) value(84);
 dcl SQL_DIAG_DELETE_WHERE          fixed bin(31) value(19);
 dcl SQL_DIAG_DROP_INDEX            fixed bin(31) value(-2);
 dcl SQL_DIAG_DROP_TABLE            fixed bin(31) value(32);
 dcl SQL_DIAG_DROP_VIEW             fixed bin(31) value(36);
 dcl SQL_DIAG_DYNAMIC_DELETE_CURSOR fixed bin(31) value(38);
 dcl SQL_DIAG_DYNAMIC_UPDATE_CURSOR fixed bin(31) value(81);
 dcl SQL_DIAG_GRANT                 fixed bin(31) value(48);
 dcl SQL_DIAG_INSERT                fixed bin(31) value(50);
 dcl SQL_DIAG_REVOKE                fixed bin(31) value(59);
 dcl SQL_DIAG_SELECT_CURSOR         fixed bin(31) value(85);
 dcl SQL_DIAG_UNKNOWN_STATEMENT     fixed bin(31) value(0);
 dcl SQL_DIAG_UPDATE_WHERE          fixed bin(31) value(82);
 %end;  /* ODBCVER >= '0300'x */

 /* SQL data type codes */
 dcl SQL_UNKNOWN_TYPE   fixed bin(31) value(0);
 dcl SQL_CHAR           fixed bin(31) value(1);
 dcl SQL_NUMERIC        fixed bin(31) value(2);
 dcl SQL_DECIMAL        fixed bin(31) value(3);
 dcl SQL_INTEGER        fixed bin(31) value(4);
 dcl SQL_SMALLINT       fixed bin(31) value(5);
 dcl SQL_FLOAT          fixed bin(31) value(6);
 dcl SQL_REAL           fixed bin(31) value(7);
 dcl SQL_DOUBLE         fixed bin(31) value(8);
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_DATETIME       fixed bin(31) value(9);
 %end;
 dcl SQL_VARCHAR        fixed bin(31) value(12);

 /* One-parameter shortcuts for date/time data types */
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_TYPE_DATE      fixed bin(31) value(91);
 dcl SQL_TYPE_TIME      fixed bin(31) value(92);
 dcl SQL_TYPE_TIMESTAMP fixed bin(31) value(93);
 %end;

 /* Statement attribute values for cursor sensitivity */
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_UNSPECIFIED fixed bin(31) value(0);
 dcl SQL_INSENSITIVE fixed bin(31) value(1);
 dcl SQL_SENSITIVE   fixed bin(31) value(2);
 %end;

 /* GetTypeInfo() request for all data types */
 dcl SQL_ALL_TYPES fixed bin(31) value(0);

 /* Default conversion code for SQLBindCol(), */
 /* SQLBindParam() and SQLGetData() */
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_DEFAULT fixed bin(31) value(99);
 %end;

 /* SQLGetData() code indicating that the */
 /* application row descriptor specifies the data type   */
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_ARD_TYPE fixed bin(31) value(-99);
 %end;

 /* SQL date/time type subcodes */
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_CODE_DATE      fixed bin(31) value(1);
 dcl SQL_CODE_TIME      fixed bin(31) value(2);
 dcl SQL_CODE_TIMESTAMP fixed bin(31) value(3);
 %end;

 /* CLI option values */
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_FALSE fixed bin(31) value(0);
 dcl SQL_TRUE  fixed bin(31) value(1);
 %end;

 /* values of NULLABLE field in descriptor */
 dcl SQL_NO_NULLS fixed bin(31) value(0);
 dcl SQL_NULLABLE fixed bin(31) value(1);

 /* Value returned by SQLGetTypeInfo() to denote that it is  */
 /* not known whether or not a data type supports null values. */
 dcl SQL_NULLABLE_UNKNOWN fixed bin(31) value(2);

 /* Values returned by SQLGetTypeInfo() to show WHERE clause */
 /* supported  */
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_PRED_NONE  fixed bin(31) value(0);
 dcl SQL_PRED_CHAR  fixed bin(31) value(1);
 dcl SQL_PRED_BASIC fixed bin(31) value(2);
 %end;

 /* values of UNNAMED field in descriptor */
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_NAMED           fixed bin(31) value(0);
 dcl SQL_UNNAMED         fixed bin(31) value(1);
 %end;

 /* values of ALLOC_TYPE field in descriptor */
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_DESC_ALLOC_AUTO fixed bin(31) value(1);
 dcl SQL_DESC_ALLOC_USER fixed bin(31) value(2);
 %end;

 /* FreeStmt() options */
 dcl SQL_CLOSE           fixed bin(31) value(0);
 dcl SQL_DROP            fixed bin(31) value(1);
 dcl SQL_UNBIND          fixed bin(31) value(2);
 dcl SQL_RESET_PARAMS    fixed bin(31) value(3);

 /* Codes used for FetchOrientation in SQLFetchScroll(), */
 /*    and in SQLDataSources()  */
 dcl SQL_FETCH_NEXT      fixed bin(31) value(1);
 dcl SQL_FETCH_FIRST     fixed bin(31) value(2);

 /* Other codes used for FetchOrientation in SQLFetchScroll() */
 dcl SQL_FETCH_LAST      fixed bin(31) value(3);
 dcl SQL_FETCH_PRIOR     fixed bin(31) value(4);
 dcl SQL_FETCH_ABSOLUTE  fixed bin(31) value(5);
 dcl SQL_FETCH_RELATIVE  fixed bin(31) value(6);

 /* SQLEndTran() options */
 dcl SQL_COMMIT          fixed bin(31) value(0);
 dcl SQL_ROLLBACK        fixed bin(31) value(1);

 /* null handles returned by SQLAllocHandle() */
 dcl SQL_NULL_HENV  type SQLHENV  value(sysnull());
 dcl SQL_NULL_HDBC  type SQLHDBC  value(sysnull());
 dcl SQL_NULL_HSTMT type SQLHSTMT value(sysnull());
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_NULL_HDESC type SQLHDESC value(sysnull());
 %end;

 /* null handle used in place of parent handle when allocating HENV */
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_NULL_HANDLE type SQLHANDLE value(sysnull());
 %end;

  /* Values that may appear in the result set of SQLSpecialColumns() */
 dcl SQL_SCOPE_CURROW      fixed bin(31) value(0);
 dcl SQL_SCOPE_TRANSACTION fixed bin(31) value(1);
 dcl SQL_SCOPE_SESSION     fixed bin(31) value(2);

 dcl SQL_PC_UNKNOWN        fixed bin(31) value(0);
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_PC_NON_PSEUDO     fixed bin(31) value(1);
 %end;
 dcl SQL_PC_PSEUDO         fixed bin(31) value(2);

 /* Reserved value for the IdentifierType */
 /* argument of SQLSpecialColumns() */
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_ROW_IDENTIFIER    fixed bin(31) value(1);
 %end;

 /* Reserved values for UNIQUE argument of SQLStatistics() */
 dcl SQL_INDEX_UNIQUE      fixed bin(31) value(0);
 dcl SQL_INDEX_ALL         fixed bin(31) value(1);

 /* Values that may appear in the result set of SQLStatistics() */
 dcl SQL_INDEX_CLUSTERED   fixed bin(31) value(1);
 dcl SQL_INDEX_HASHED      fixed bin(31) value(2);
 dcl SQL_INDEX_OTHER       fixed bin(31) value(3);

 /* SQLGetFunctions() values to identify ODBC APIs */
 dcl SQL_API_SQLALLOCCONNECT     fixed bin(31) value(1);
 dcl SQL_API_SQLALLOCENV         fixed bin(31) value(2);
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_API_SQLALLOCHANDLE      fixed bin(31) value(1001);
 %end;
 dcl SQL_API_SQLALLOCSTMT        fixed bin(31) value(3);
 dcl SQL_API_SQLBINDCOL          fixed bin(31) value(4);
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_API_SQLBINDPARAM        fixed bin(31) value(1002);
 %end;
 dcl SQL_API_SQLCANCEL           fixed bin(31) value(5);
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_API_SQLCLOSECURSOR      fixed bin(31) value(1003);
 dcl SQL_API_SQLCOLATTRIBUTE     fixed bin(31) value(6);
 %end;
 dcl SQL_API_SQLCOLUMNS          fixed bin(31) value(40);
 dcl SQL_API_SQLCONNECT          fixed bin(31) value(7);
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_API_SQLCOPYDESC         fixed bin(31) value(1004);
 %end;
 dcl SQL_API_SQLDATASOURCES      fixed bin(31) value(57);
 dcl SQL_API_SQLDESCRIBECOL      fixed bin(31) value(8);
 dcl SQL_API_SQLDISCONNECT       fixed bin(31) value(9);
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_API_SQLENDTRAN          fixed bin(31) value(1005);
 %end;
 dcl SQL_API_SQLERROR            fixed bin(31) value(10);
 dcl SQL_API_SQLEXECDIRECT       fixed bin(31) value(11);
 dcl SQL_API_SQLEXECUTE          fixed bin(31) value(12);
 dcl SQL_API_SQLFETCH            fixed bin(31) value(13);
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_API_SQLFETCHSCROLL      fixed bin(31) value(1021);
 %end;
 dcl SQL_API_SQLFREECONNECT      fixed bin(31) value(14);
 dcl SQL_API_SQLFREEENV          fixed bin(31) value(15);
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_API_SQLFREEHANDLE       fixed bin(31) value(1006);
 %end;
 dcl SQL_API_SQLFREESTMT         fixed bin(31) value(16);
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_API_SQLGETCONNECTATTR   fixed bin(31) value(1007);
 %end;
 dcl SQL_API_SQLGETCONNECTOPTION fixed bin(31) value(42);
 dcl SQL_API_SQLGETCURSORNAME    fixed bin(31) value(17);
 dcl SQL_API_SQLGETDATA          fixed bin(31) value(43);
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_API_SQLGETDESCFIELD     fixed bin(31) value(1008);
 dcl SQL_API_SQLGETDESCREC       fixed bin(31) value(1009);
 dcl SQL_API_SQLGETDIAGFIELD     fixed bin(31) value(1010);
 dcl SQL_API_SQLGETDIAGREC       fixed bin(31) value(1011);
 dcl SQL_API_SQLGETENVATTR       fixed bin(31) value(1012);
 %end;
 dcl SQL_API_SQLGETFUNCTIONS     fixed bin(31) value(44);
 dcl SQL_API_SQLGETINFO          fixed bin(31) value(45);
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_API_SQLGETSTMTATTR      fixed bin(31) value(1014);
 %end;
 dcl SQL_API_SQLGETSTMTOPTION    fixed bin(31) value(46);
 dcl SQL_API_SQLGETTYPEINFO      fixed bin(31) value(47);
 dcl SQL_API_SQLNUMRESULTCOLS    fixed bin(31) value(18);
 dcl SQL_API_SQLPARAMDATA        fixed bin(31) value(48);
 dcl SQL_API_SQLPREPARE          fixed bin(31) value(19);
 dcl SQL_API_SQLPUTDATA          fixed bin(31) value(49);
 dcl SQL_API_SQLROWCOUNT         fixed bin(31) value(20);
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_API_SQLSETCONNECTATTR   fixed bin(31) value(1016);
 %end;
 dcl SQL_API_SQLSETCONNECTOPTION fixed bin(31) value(50);
 dcl SQL_API_SQLSETCURSORNAME    fixed bin(31) value(21);
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_API_SQLSETDESCFIELD     fixed bin(31) value(1017);
 dcl SQL_API_SQLSETDESCREC       fixed bin(31) value(1018);
 dcl SQL_API_SQLSETENVATTR       fixed bin(31) value(1019);
 %end;
 dcl SQL_API_SQLSETPARAM         fixed bin(31) value(22);
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_API_SQLSETSTMTATTR      fixed bin(31) value(1020);
 %end;
 dcl SQL_API_SQLSETSTMTOPTION    fixed bin(31) value(51);
 dcl SQL_API_SQLSPECIALCOLUMNS   fixed bin(31) value(52);
 dcl SQL_API_SQLSTATISTICS       fixed bin(31) value(53);
 dcl SQL_API_SQLTABLES           fixed bin(31) value(54);
 dcl SQL_API_SQLTRANSACT         fixed bin(31) value(23);

 /* Information requested by SQLGetInfo() */
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_MAX_DRIVER_CONNECTIONS      fixed bin(31) value(0);
 dcl SQL_MAXIMUM_DRIVER_CONNECTIONS  fixed bin(31)
     value(SQL_MAX_DRIVER_CONNECTIONS);
 dcl SQL_MAX_CONCURRENT_ACTIVITIES   fixed bin(31) value(1);
 dcl SQL_MAXIMUM_CONCURRENT_ACTIVITIES fixed bin(31)
     value(SQL_MAX_CONCURRENT_ACTIVITIES);
 %end;
 dcl SQL_DATA_SOURCE_NAME            fixed bin(31) value(2);
 dcl SQL_FETCH_DIRECTION             fixed bin(31) value(8);
 dcl SQL_SERVER_NAME                 fixed bin(31) value(13);
 dcl SQL_SEARCH_PATTERN_ESCAPE       fixed bin(31) value(14);
 dcl SQL_DBMS_NAME                   fixed bin(31) value(17);
 dcl SQL_DBMS_VER                    fixed bin(31) value(18);
 dcl SQL_ACCESSIBLE_TABLES           fixed bin(31) value(19);
 dcl SQL_ACCESSIBLE_PROCEDURES       fixed bin(31) value(20);
 dcl SQL_CURSOR_COMMIT_BEHAVIOR      fixed bin(31) value(23);
 dcl SQL_DATA_SOURCE_READ_ONLY       fixed bin(31) value(25);
 dcl SQL_DEFAULT_TXN_ISOLATION       fixed bin(31) value(26);
 dcl SQL_IDENTIFIER_CASE             fixed bin(31) value(28);
 dcl SQL_IDENTIFIER_QUOTE_CHAR       fixed bin(31) value(29);
 dcl SQL_MAX_COLUMN_NAME_LEN         fixed bin(31) value(30);
 dcl SQL_MAXIMUM_COLUMN_NAME_LENGTH  fixed bin(31)
     value(SQL_MAX_COLUMN_NAME_LEN);
 dcl SQL_MAX_CURSOR_NAME_LEN         fixed bin(31) value(31);
 dcl SQL_MAXIMUM_CURSOR_NAME_LENGTH  fixed bin(31)
     value(SQL_MAX_CURSOR_NAME_LEN);
 dcl SQL_MAX_SCHEMA_NAME_LEN         fixed bin(31) value(32);
 dcl SQL_MAXIMIM_SCHEMA_NAME_LENGTH  fixed bin(31)
     value(SQL_MAX_SCHEMA_NAME_LEN);
 dcl SQL_MAX_CATALOG_NAME_LEN        fixed bin(31) value(34);
 dcl SQL_MAXIMUM_CATALOG_NAME_LENGTH fixed bin(31)
     value(SQL_MAX_CATALOG_NAME_LEN);
 dcl SQL_MAX_TABLE_NAME_LEN          fixed bin(31) value(35);
 dcl SQL_SCROLL_CONCURRENCY          fixed bin(31) value(43);
 dcl SQL_TXN_CAPABLE                 fixed bin(31) value(46);
 dcl SQL_TRANSACTION_CAPABLE         fixed bin(31)
     value(SQL_TXN_CAPABLE);
 dcl SQL_USER_NAME                   fixed bin(31) value(47);
 dcl SQL_TXN_ISOLATION_OPTION        fixed bin(31) value(72);
 dcl SQL_TRANSACTION_ISOLATION_OPTN  fixed bin(31)
     value(SQL_TXN_ISOLATION_OPTION);
 dcl SQL_INTEGRITY                   fixed bin(31) value(73);
 dcl SQL_GETDATA_EXTENSIONS          fixed bin(31) value(81);
 dcl SQL_NULL_COLLATION              fixed bin(31) value(85);
 dcl SQL_ALTER_TABLE                 fixed bin(31) value(86);
 dcl SQL_ORDER_BY_COLUMNS_IN_SELECT  fixed bin(31) value(90);
 dcl SQL_SPECIAL_CHARACTERS          fixed bin(31) value(94);
 dcl SQL_MAX_COLUMNS_IN_GROUP_BY     fixed bin(31) value(97);
 dcl SQL_MAXIMUM_COLUMNS_IN_GROUP_BY fixed bin(31)
     value(SQL_MAX_COLUMNS_IN_GROUP_BY);
 dcl SQL_MAX_COLUMNS_IN_INDEX        fixed bin(31) value(98);
 dcl SQL_MAXIMUM_COLUMNS_IN_INDEX    fixed bin(31)
     value(SQL_MAX_COLUMNS_IN_INDEX);
 dcl SQL_MAX_COLUMNS_IN_ORDER_BY     fixed bin(31) value(99);
 dcl SQL_MAXIMUM_COLUMNS_IN_ORDER_BY fixed bin(31)
     value(SQL_MAX_COLUMNS_IN_ORDER_BY);
 dcl SQL_MAX_COLUMNS_IN_SELECT       fixed bin(31) value(100);
 dcl SQL_MAXIMUM_COLUMNS_IN_SELECT   fixed bin(31)
     value(SQL_MAX_COLUMNS_IN_SELECT);
 dcl SQL_MAX_COLUMNS_IN_TABLE        fixed bin(31) value(101);
 dcl SQL_MAX_INDEX_SIZE              fixed bin(31) value(102);
 dcl SQL_MAXIMIM_INDEX_SIZE          fixed bin(31)
     value(SQL_MAX_INDEX_SIZE);
 dcl SQL_MAX_ROW_SIZE                fixed bin(31) value(104);
 dcl SQL_MAXIMIM_ROW_SIZE            fixed bin(31)
     value(SQL_MAX_ROW_SIZE);
 dcl SQL_MAX_STATEMENT_LEN           fixed bin(31) value(105);
 dcl SQL_MAXIMIM_STATEMENT_LENGTH    fixed bin(31)
     value(SQL_MAX_STATEMENT_LEN);
 dcl SQL_MAX_TABLES_IN_SELECT        fixed bin(31) value(106);
 dcl SQL_MAXIMIM_TABLES_IN_SELECT    fixed bin(31)
     value(SQL_MAX_TABLES_IN_SELECT);
 dcl SQL_MAX_USER_NAME_LEN           fixed bin(31) value(107);
 dcl SQL_MAXIMIM_USER_NAME_LENGTH    fixed bin(31)
     value(SQL_MAX_USER_NAME_LEN);
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_OJ_CAPABILITIES             fixed bin(31) value(115);
 dcl SQL_OUTER_JOIN_CAPABILITIES     fixed bin(31)
     value(SQL_OJ_CAPABILITIES);
 %end; /* ODBCVER >= '0300'x */

 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_XOPEN_CLI_YEAR              fixed bin(31) value(10000);
 dcl SQL_CURSOR_SENSITIVITY          fixed bin(31) value(10001);
 dcl SQL_DESCRIBE_PARAMETER          fixed bin(31) value(10002);
 dcl SQL_CATALOG_NAME                fixed bin(31) value(10003);
 dcl SQL_COLLATION_SEQ               fixed bin(31) value(10004);
 dcl SQL_MAX_IDENTIFIER_LEN          fixed bin(31) value(10005);
 dcl SQL_MAXIMIM_IDENTIFIER_LENGTH   fixed bin(31)
     value(SQL_MAX_IDENTIFIER_LEN);
 %end; /* ODBCVER >= '0300'x */

 /* SQL_ALTER_TABLE bitmasks */
 %if (ODBCVER >= '0200'x) %then %do;
 dcl SQL_AT_ADD_COLUMN      fixed bin(31) value('00000001'xn);
 dcl SQL_AT_DROP_COLUMN     fixed bin(31) value('00000002'xn);
 %end; /* ODBCVER >= '0200'x */

 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_AT_ADD_CONSTRAINT  fixed bin(31) value('00000008'xn);

 /* The following bitmasks are ODBC                                  */
 /*  extensions and defined in odbcext.cpy                           */
 /* dcl SQL_AT_ADD_COLUMN_SINGLE fixed bin(31) value('00000020'xn);  */
 /* dcl SQL_AT_ADD_COLUMN_DEFAULT fixed bin(31) value('00000040'xn); */
 /*dcl SQL_AT_ADD_COLUMN_COLLATION fixed bin(31) value('00000080'xn);*/
 /* dcl SQL_AT_SET_COLUMN_DEFAULT fixed bin(31) value('00000100'xn); */
 /* dcl SQL_AT_DROP_COLUMN_DEFAULT fixed bin(31) value('00000200'xn);*/
 /* dcl SQL_AT_DROP_COLUMN_CASCADE fixed bin(31) value('00000400'xn);*/
 /*dcl SQL_AT_DROP_COLUMN_RESTRICT fixed bin(31) value('00000800'xn);*/
 /*dcl SQL_AT_ADD_TABLE_CONSTRAINT fixed bin(31) value('00001000'xn);*/
 /* dcl SQL_AT_DROP_TBL_CONSTR_CASCADE fixed bin(31)                 */
 /*     value('00002000'xn);                                         */
 /* dcl SQL_AT_DROP_TBL_CONSTR_RESTRICT fixed bin(31)                */
 /*     value('00004000'xn);                                         */
 /* dcl SQL_AT_CONSTR_NAME_DEFINITION fixed bin(31)                  */
 /*     value('00008000'xn);                                         */
 /* dcl SQL_AT_CONSTR_INITIALLY_DEFRD fixed bin(31)                  */
 /*     value('00010000'xn);                                         */
 /* dcl SQL_AT_CONSTR_INITIALLY_IMMED fixed bin(31)                  */
 /*     value('00020000'xn);                                         */
 /*dcl SQL_AT_CONSTRAINT_DEFERRABLE fixed bin(31) value('00040000'xn);*/
 /*dcl SQL_AT_CONSTR_NON_DEFERRABLE fixed bin(31) value('00080000'xn);*/
  %end;  /* ODBCVER >= '0300'x */


 /* SQL_ASYNC_MODE values */
 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQL_AM_NONE           fixed bin(31) value(0);
 dcl SQL_AM_CONNECTION     fixed bin(31) value(1);
 dcl SQL_AM_STATEMENT      fixed bin(31) value(2);
 %end;

 /* SQL_CURSOR_COMMIT_BEHAVIOR values */
 dcl SQL_CB_DELETE         fixed bin(31) value(0);
 dcl SQL_CB_CLOSE          fixed bin(31) value(1);
 dcl SQL_CB_PRESERVE       fixed bin(31) value(2);

 /* SQL_FETCH_DIRECTION bitmasks */
 dcl SQL_FD_FETCH_NEXT     fixed bin(31) value('00000001'xn);
 dcl SQL_FD_FETCH_FIRST    fixed bin(31) value('00000002'xn);
 dcl SQL_FD_FETCH_LAST     fixed bin(31) value('00000004'xn);
 dcl SQL_FD_FETCH_PRIOR    fixed bin(31) value('00000008'xn);
 dcl SQL_FD_FETCH_ABSOLUTE fixed bin(31) value('00000010'xn);
 dcl SQL_FD_FETCH_RELATIVE fixed bin(31) value('00000020'xn);

 /* SQL_GETDATA_EXTENSIONS bitmasks */
 dcl SQL_GD_ANY_COLUMN     fixed bin(31) value('00000001'xn);
 dcl SQL_GD_ANY_ORDER      fixed bin(31) value('00000002'xn);

 /* SQL_IDENTIFIER_CASE values */
 dcl SQL_IC_UPPER          fixed bin(31) value(1);
 dcl SQL_IC_LOWER          fixed bin(31) value(2);
 dcl SQL_IC_SENSITIVE      fixed bin(31) value(3);
 dcl SQL_IC_MIXED          fixed bin(31) value(4);

 /* SQL_OJ_CAPABILITIES bitmasks */
 %if (ODBCVER >= '0201'x) %then %do;
 dcl SQL_OJ_LEFT               fixed bin(31) value('00000001'xn);
 dcl SQL_OJ_RIGHT              fixed bin(31) value('00000002'xn);
 dcl SQL_OJ_FULL               fixed bin(31) value('00000004'xn);
 dcl SQL_OJ_NESTED             fixed bin(31) value('00000008'xn);
 dcl SQL_OJ_NOT_ORDERED        fixed bin(31) value('00000010'xn);
 dcl SQL_OJ_INNER              fixed bin(31) value('00000020'xn);
 dcl SQL_OJ_ALL_COMPARISON_OPS fixed bin(31) value('00000040'xn);
 %end;

 /* SQL_SCROLL_CONCURRENCY bitmasks */
 dcl SQL_SCCO_READ_ONLY        fixed bin(31) value('00000001'xn);
 dcl SQL_SCCO_LOCK             fixed bin(31) value('00000002'xn);
 dcl SQL_SCCO_OPT_ROWVER       fixed bin(31) value('00000004'xn);
 dcl SQL_SCCO_OPT_VALUES       fixed bin(31) value('00000008'xn);

 /* SQL_TXN_CAPABLE values */
 dcl SQL_TC_NONE               fixed bin(31) value(0);
 dcl SQL_TC_DML                fixed bin(31) value(1);
 dcl SQL_TC_ALL                fixed bin(31) value(2);
 dcl SQL_TC_DDL_COMMIT         fixed bin(31) value(3);
 dcl SQL_TC_DDL_IGNORE         fixed bin(31) value(4);

 /* SQL_TXN_ISOLATION_OPTION bitmasks */
 dcl SQL_TXN_READ_UNCOMMITTED        fixed bin(31) value('00000001'xn);
 dcl SQL_TRANSACTION_READ_UNCOMMITTD fixed bin(31)
     value(SQL_TXN_READ_UNCOMMITTED);
 dcl SQL_TXN_READ_COMMITTED          fixed bin(31) value('00000002'xn);
 dcl SQL_TRANSACTION_READ_COMMITTED  fixed bin(31)
     value(SQL_TXN_READ_COMMITTED);
 dcl SQL_TXN_REPEATABLE_READ         fixed bin(31) value('00000004'xn);
 dcl SQL_TRANSACTION_REPEATABLE_READ fixed bin(31)
     value(SQL_TXN_REPEATABLE_READ);
 dcl SQL_TXN_SERIALIZABLE            fixed bin(31) value('00000008'xn);
 dcl SQL_TRANSACTION_SERIALIZABLE    fixed bin(31)
     value(SQL_TXN_SERIALIZABLE);

 /* SQL_NULL_COLLATION values */
 dcl SQL_NC_HIGH fixed bin(31) value(0);
 dcl SQL_NC_LOW  fixed bin(31) value(1);

 dcl SQLAllocConnect
     entry (type SQLHENV,
            type SQLHDBC byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLAllocConnect');

 dcl SQLAllocEnv
     entry (type SQLHENV byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLAllocEnv');

 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQLAllocHandle
     entry (type SQLSMALLINT,
            type SQLHANDLE,
            type SQLHANDLE byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLAllocHandle');
 %end;

 dcl SQLAllocStmt
     entry (type SQLHDBC,
            type SQLHSTMT byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLAllocStmt');

 dcl SQLBindCol
     entry (type SQLHSTMT,
            type SQLUSMALLINT,
            type SQLSMALLINT,
            type SQLPOINTER,
            type SQLINTEGER,
            type SQLINTEGER byaddr optional)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLBindCol');

 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQLBindParam
     entry (type SQLHSTMT,
            type SQLUSMALLINT,
            type SQLSMALLINT,
            type SQLSMALLINT,
            type SQLUINTEGER,
            type SQLSMALLINT,
            type SQLPOINTER,
            type SQLINTEGER byaddr optional)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLBindParam');
 %end;

 dcl SQLCancel
     entry (type SQLHSTMT)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLCancel');

 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQLCloseCursor
     entry (type SQLHSTMT)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLCloseCursor');

 dcl SQLColAttribute
     entry (type SQLHSTMT,
            type SQLUSMALLINT,
            type SQLUSMALLINT,
            type SQLPOINTER,
            type SQLSMALLINT,
            type SQLSMALLINT byaddr,
        type SQLPOINTER)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLColAttribute');
 %end;


 dcl SQLColumns
     entry (type SQLHSTMT,
            char (*) varz byaddr optional,
            type SQLSMALLINT,
            char (*) varz byaddr optional,
            type SQLSMALLINT,
            char (*) varz byaddr optional,
            type SQLSMALLINT,
            char (*) varz byaddr optional,
            type SQLSMALLINT)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLColumns');


 dcl SQLConnect
     entry (type SQLHDBC,
            char (*) varz byaddr optional,
            type SQLSMALLINT,
            char (*) varz byaddr optional,
            type SQLSMALLINT,
            char (*) varz byaddr optional,
            type SQLSMALLINT)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLConnect');

 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQLCopyDesc
     entry (type SQLHDESC,
            type SQLHDESC)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLCopyDesc');
 %end;

 dcl SQLDataSources
     entry (type SQLHENV,
            type SQLUSMALLINT,
            char (*) varz byaddr,
            type SQLSMALLINT,
            type SQLSMALLINT byaddr,
            char (*) varz byaddr,
            type SQLSMALLINT,
            type SQLSMALLINT byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLDataSources');

 dcl SQLDescribeCol
     entry (type SQLHSTMT,
            type SQLUSMALLINT,
            char (*) varz byaddr,
            type SQLSMALLINT,
            type SQLSMALLINT byaddr,
            type SQLSMALLINT byaddr,
            type SQLUINTEGER byaddr,
            type SQLSMALLINT byaddr,
            type SQLSMALLINT byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLDescribeCol');

 dcl SQLDisconnect
     entry (type SQLHDBC)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLDisconnect');

 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQLEndTran
     entry (type SQLSMALLINT,
            type SQLHANDLE,
            type SQLSMALLINT)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLEndTran');
 %end;

 dcl SQLError
     entry (type SQLHENV,
            type SQLHDBC,
            type SQLHSTMT,
            char (*) varz byaddr,
            type SQLINTEGER byaddr,
            char (*) varz byaddr,
            type SQLSMALLINT,
            type SQLSMALLINT byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLError');

 dcl SQLExecDirect
     entry (type SQLHSTMT,
            char (*) varz byaddr,
            type SQLINTEGER)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLExecDirect');

 dcl SQLExecute
     entry (type SQLHSTMT)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLExecute');

 dcl SQLFetch
     entry (type SQLHSTMT)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLFetch');

 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQLFetchScroll
     entry (type SQLHSTMT,
            type SQLSMALLINT,
            type SQLINTEGER)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLFetchScroll');
 %end;

 dcl SQLFreeConnect
     entry (type SQLHDBC)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLFreeConnect');

 dcl SQLFreeEnv
     entry (type SQLHENV)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLFreeEnv');

 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQLFreeHandle
     entry (type SQLSMALLINT,
            type SQLHANDLE)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLFreeHandle');
 %end;

 dcl SQLFreeStmt
     entry (type SQLHSTMT,
            type SQLUSMALLINT)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLFreeStmt');

 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQLGetConnectAttr
     entry (type SQLHDBC,
            type SQLINTEGER,
            type SQLPOINTER,
            type SQLINTEGER,
            type SQLINTEGER byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLGetConnectAttr');
 %end;

 dcl SQLGetConnectOption
     entry (type SQLHDBC,
            type SQLUSMALLINT,
            type SQLPOINTER)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLGetConnectOption');

 dcl SQLGetCursorName
     entry (type SQLHSTMT,
            char (*) varz byaddr,
            type SQLSMALLINT,
            type SQLSMALLINT byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLGetCursorName');

 dcl SQLGetData
     entry (type SQLHSTMT,
            type SQLUSMALLINT,
            type SQLSMALLINT,
            type SQLPOINTER,
            type SQLINTEGER,
            type SQLINTEGER byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLGetData');

 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQLGetDescField
     entry (type SQLHDESC,
            type SQLSMALLINT,
            type SQLSMALLINT,
            type SQLPOINTER,
            type SQLINTEGER,
            type SQLINTEGER byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLGetDescField');

 dcl SQLGetDescRec
     entry (type SQLHDESC,
            type SQLSMALLINT,
            char (*) varz byaddr,
            type SQLSMALLINT,
            type SQLSMALLINT byaddr,
            type SQLSMALLINT byaddr,
            type SQLSMALLINT byaddr,
            type SQLINTEGER byaddr,
            type SQLSMALLINT byaddr,
            type SQLSMALLINT byaddr,
            type SQLSMALLINT byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLGetDescRec');

 dcl SQLGetDiagField
     entry (type SQLSMALLINT,
            type SQLHANDLE,
            type SQLSMALLINT,
            type SQLSMALLINT,
            type SQLPOINTER,
            type SQLSMALLINT,
            type SQLSMALLINT byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLGetDiagField');

 dcl SQLGetDiagRec
     entry (type SQLSMALLINT,
            type SQLHANDLE,
            type SQLSMALLINT,
            char (*) varz byaddr,
            type SQLINTEGER byaddr,
            char (*) varz byaddr,
            type SQLSMALLINT,
            type SQLSMALLINT byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLGetDiagRec');

 dcl SQLGetEnvAttr
     entry (type SQLHENV,
            type SQLINTEGER,
            type SQLPOINTER,
            type SQLINTEGER,
            type SQLINTEGER byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLGetEnvAttr');
 %end; /* ODBCVER >= '0300'x */

 dcl SQLGetFunctions
     entry (type SQLHDBC,
            type SQLUSMALLINT,
            (*) type SQLUSMALLINT byaddr) /* if array, lbound = 0 */
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLGetFunctions');

 dcl SQLGetInfo
     entry (type SQLHDBC,
            type SQLUSMALLINT,
            type SQLPOINTER,
            type SQLSMALLINT,
            type SQLSMALLINT byaddr optional)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLGetInfo');

 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQLGetStmtAttr
     entry (type SQLHSTMT,
            type SQLINTEGER,
            type SQLPOINTER,
            type SQLINTEGER,
            type SQLINTEGER byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLGetStmtAttr');
 %end; /* ODBCVER >= '0300'x */

 dcl SQLGetStmtOption
     entry (type SQLHSTMT,
            type SQLUSMALLINT,
            type SQLPOINTER)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLGetStmtOption');

 dcl SQLGetTypeInfo
     entry (type SQLHSTMT,
            type SQLSMALLINT)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLGetTypeInfo');

 dcl SQLNumResultCols
     entry (type SQLHSTMT,
            type SQLSMALLINT byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLNumResultCols');

 dcl SQLParamData
     entry (type SQLHSTMT,
            type SQLPOINTER byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLParamData');

 dcl SQLPrepare
     entry (type SQLHSTMT,
            char (*) varz byaddr,
            type SQLINTEGER)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLPrepare');

 dcl SQLPutData
     entry (type SQLHSTMT,
            type SQLPOINTER,
            type SQLINTEGER)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLPutData');

 dcl SQLRowCount
     entry (type SQLHSTMT,
            type SQLINTEGER byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLRowCount');

 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQLSetConnectAttr
     entry (type SQLHDBC,
            type SQLINTEGER,
            type SQLPOINTER,
            type SQLINTEGER)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLSetConnectAttr');
 %end; /* ODBCVER >= '0300'x */

 dcl SQLSetConnectOption
     entry (type SQLHDBC,
            type SQLUSMALLINT,
            type SQLUINTEGER)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLSetConnectOption');

 dcl SQLSetCursorName
     entry (type SQLHSTMT,
            char (*) varz byaddr,
            type SQLSMALLINT)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLSetCursorName');

 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQLSetDescField
     entry (type SQLHDESC,
            type SQLSMALLINT,
            type SQLSMALLINT,
            type SQLPOINTER,
            type SQLINTEGER)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLSetDescField');

 dcl SQLSetDescRec
     entry (type SQLHDESC,
            type SQLSMALLINT,
            type SQLSMALLINT,
            type SQLSMALLINT,
            type SQLINTEGER,
            type SQLSMALLINT,
            type SQLSMALLINT,
            type SQLPOINTER,
            type SQLINTEGER byaddr,
            type SQLINTEGER byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLSetDescRed');

 dcl SQLSetEnvAttr
     entry (type SQLHENV,
            type SQLINTEGER,
            type SQLPOINTER,
            type SQLINTEGER)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLSetEnvAttr');
 %end; /* ODBCVER >= '0300'x */

 dcl SQLSetParam
     entry (type SQLHSTMT,
            type SQLUSMALLINT,
            type SQLSMALLINT,
            type SQLSMALLINT,
            type SQLUINTEGER,
            type SQLSMALLINT,
            type SQLPOINTER,
            type SQLINTEGER byaddr)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLSetParam');

 %if (ODBCVER >= '0300'x) %then %do;
 dcl SQLSetStmtAttr
     entry (type SQLHSTMT,
            type SQLINTEGER,
            type SQLPOINTER,
            type SQLINTEGER)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLSetStmtAttr');
 %end;

 dcl SQLSetStmtOption
     entry (type SQLHSTMT,
            type SQLUSMALLINT,
            type SQLUINTEGER)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLSetStmtOption');

 dcl SQLSpecialColumns
     entry (type SQLHSTMT,
            type SQLUSMALLINT,
            char (*) varz byaddr optional,
            type SQLSMALLINT,
            char (*) varz byaddr optional,
            type SQLSMALLINT,
            char (*) varz byaddr,
            type SQLSMALLINT,
            type SQLUSMALLINT,
            type SQLUSMALLINT)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLSpecialColumns');

 dcl SQLStatistics
     entry (type SQLHSTMT,
            char (*) varz byaddr optional,
            type SQLSMALLINT,
            char (*) varz byaddr optional,
            type SQLSMALLINT,
            char (*) varz byaddr,
            type SQLSMALLINT,
            type SQLUSMALLINT,
            type SQLUSMALLINT)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLStatistics');

 dcl SQLTables
     entry (type SQLHSTMT,
            char (*) varz byaddr optional,
            type SQLSMALLINT,
            char (*) varz byaddr optional,
            type SQLSMALLINT,
            char (*) varz byaddr optional,
            type SQLSMALLINT,
            char (*) varz byaddr optional,
            type SQLSMALLINT)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLTables');

 dcl SQLTransact
     entry (type SQLHENV,
            type SQLHDBC,
            type SQLUSMALLINT)
     returns (byvalue optional type SQLRETURN)
     SQL_API external('SQLTransact');


 /* IBM PL/I License Verification Routine */

 dcl ibmODBCLicInfo
     entry (type SQLHDBC)
     returns (fixed bin(15) byvalue)
     SQL_API external('ibmODBCLicInfo');

 %end; /* #ifndef __SQL */
