 /*********************************************************************/
 /*                                                                   */
 /* prsht.cpy - - Interface for the Windows Property Sheet Pages      */
 /*                                                                   */
 /* Version 1.0                                                       */
 /*                                                                   */
 /* Copyright 1991-1998, Microsoft Corp.      All rights reserved.    */
 /*                                                                   */
 /*********************************************************************/

 %dcl #PRSHT_H_ char ext;
 %if #PRSHT_H_ = '' %then %do;
 %#PRSHT_H_ = 'Y';

 %dcl #WIN32       char ext;
 %dcl #WIN32_IE    fixed ext;
 %dcl #WIN32_WINNT fixed ext;

 %if #WIN32_IE = 0 %then %do;
  %#WIN32_IE = 1280;
 %end; %else %do;
 %if (#WIN32_IE < 1024) & (#WIN32_WINNT >= 1280) %then %do;
  %note('Error: #WIN32_IE conflicts with #WIN32_WINNT setting',8);
 %end;
 %end;

 %dcl #WINUSER_ char ext;
 %if #WINUSER_ = '' %then %do;
   %include winuser;
 %end;

 %dcl UNICODE char ext;

 /* Define API decoration for direct importing of DLL references. */
 %dcl WINCOMMCTRLAPI char ext;
 %WINCOMMCTRLAPI = '';

 %dcl #CCSIZEOF_STRUCT char ext;
 %if #CCSIZEOF_STRUCT = '' %then %do;
 %#CCSIZEOF_STRUCT = 'Y';
 %dcl CCSIZEOF_STRUCT entry;
 %CCSIZEOF_STRUCT: proc (structname, member) returns (char);
  dcl (structname, member) char;
   return ('location (bind (: ' || structname || ', sysnull() :) => ' ||
                      member || ') + ' ||
           'stg (bind (: ' || structname || ', sysnull() :) => ' ||
                 member || ')');
 %end CCSIZEOF_STRUCT;
 %end;


 %dcl SNDMSG char ext;
 %if SNDMSG = '' %then %do;
 %SNDMSG = SendMessage;
 %end; /* ifndef SNDMSG */

 dcl MAXPROPPAGES fixed bin(31) value(100);

 define alias HPROPSHEETPAGE pointer; /* opaque structure */

 define alias LPFNPSPCALLBACKA
              entry (type HWND,
                     type UINT,
                     handle PROPSHEETPAGEA) /* forward reference */
              returns (type UINT byvalue optional)
              limited CALLBACK;

 define alias LPFNPSPCALLBACKW
              entry (type HWND,
                     type UINT,
                     handle PROPSHEETPAGEW) /* forward reference */
              returns (type UINT byvalue optional)
              limited CALLBACK;

 %if UNICODE ^= '' %then %do;
   define alias LPFNPSPCALLBACK type LPFNPSPCALLBACKW;
 %end; %else %do;
   define alias LPFNPSPCALLBACK type LPFNPSPCALLBACKA;
 %end;

 dcl PSP_DEFAULT           type DWORD value('00000000'xu);
 dcl PSP_DLGINDIRECT       type DWORD value('00000001'xu);
 dcl PSP_USEHICON          type DWORD value('00000002'xu);
 dcl PSP_USEICONID         type DWORD value('00000004'xu);
 dcl PSP_USETITLE          type DWORD value('00000008'xu);
 dcl PSP_RTLREADING        type DWORD value('00000010'xu);

 dcl PSP_HASHELP           type DWORD value('00000020'xu);
 dcl PSP_USEREFPARENT      type DWORD value('00000040'xu);
 dcl PSP_USECALLBACK       type DWORD value('00000080'xu);
 dcl PSP_PREMATURE         type DWORD value('00000400'xu);


 %if #WIN32_IE >= 1024 %then %do;
 /*----- New flags for wizard97 -------------- */
 dcl PSP_HIDEHEADER        type DWORD value('00000800'xu);
 dcl PSP_USEHEADERTITLE    type DWORD value('00001000'xu);
 dcl PSP_USEHEADERSUBTITLE type DWORD value('00002000'xu);
 /*------------------------------------------- */
 %end;


 dcl PSPCB_RELEASE fixed bin(31) value(1);
 dcl PSPCB_CREATE  fixed bin(31) value(2);

 define structure
   1 PROPSHEETPAGEA unaligned,
     2 dwSize            type DWORD,
     2 dwFlags           type DWORD,
     2 hInstance         type HINSTANCE,
     2 * union,
       3 pszTemplate     type LPCSTR,
       3 pResource       type LPCDLGTEMPLATE,
     2 * union,
       3 hIcon           type HICON,
       3 pszIcon         type LPCSTR,
     2 pszTitle          type LPCSTR,
     2 pfnDlgProc        type DLGPROC,
     2 lParam            type LPARAM,
     2 pfnCallback       type LPFNPSPCALLBACKA,
     2 pcRefParent       pointer
 %if #WIN32_IE >= 1024 %then %do;
   , 2 pszHeaderTitle    type LPCSTR
       /* this is displayed in the header */
   , 2 pszHeaderSubTitle type LPCSTR
 %end;
   ;
 define alias  LPPROPSHEETPAGEA handle PROPSHEETPAGEA;
 define alias LPCPROPSHEETPAGEA handle PROPSHEETPAGEA;
 dcl PROPSHEETPAGEA_V1_SIZE fixed bin(31)
     value (CCSIZEOF_STRUCT (PROPSHEETPAGEA, pcRefParent));

 define structure
   1 PROPSHEETPAGEW unaligned,
     2 dwSize            type DWORD,
     2 dwFlags           type DWORD,
     2 hInstance         type HINSTANCE,
     2 * union,
       3 pszTemplate     type LPCWSTR,
       3 pResource       type LPCDLGTEMPLATE,
     2 * union,
       3 hIcon           type HICON,
       3 pszIcon         type LPCWSTR,
     2 pszTitle          type LPCWSTR,
     2 pfnDlgProc        type DLGPROC,
     2 lParam            type LPARAM,
     2 pfnCallback       type LPFNPSPCALLBACKW,
     2 pcRefParent       pointer
 %if #WIN32_IE >= 1024 %then %do;
   , 2 pszHeaderTitle    type LPCWSTR
       /* this is displayed in the header */
   , 2 pszHeaderSubTitle type LPCWSTR
 %end;
   ;
 define alias  LPPROPSHEETPAGEW handle PROPSHEETPAGEW;
 define alias LPCPROPSHEETPAGEW handle PROPSHEETPAGEW;
 dcl PROPSHEETPAGEW_V1_SIZE fixed bin(31)
     value (CCSIZEOF_STRUCT (PROPSHEETPAGEW, pcRefParent));


 %if UNICODE ^= '' %then %do;
   define alias    PROPSHEETPAGE type    PROPSHEETPAGEW;
   define alias  LPPROPSHEETPAGE type  LPPROPSHEETPAGEW;
   define alias LPCPROPSHEETPAGE type LPCPROPSHEETPAGEW;
 %end; %else %do;
   define alias    PROPSHEETPAGE type    PROPSHEETPAGEA;
   define alias  LPPROPSHEETPAGE type  LPPROPSHEETPAGEA;
   define alias LPCPROPSHEETPAGE type LPCPROPSHEETPAGEA;
 %end;


 dcl PSH_DEFAULT           type DWORD value('00000000'xu);
 dcl PSH_PROPTITLE         type DWORD value('00000001'xu);
 dcl PSH_USEHICON          type DWORD value('00000002'xu);
 dcl PSH_USEICONID         type DWORD value('00000004'xu);
 dcl PSH_PROPSHEETPAGE     type DWORD value('00000008'xu);
 dcl PSH_WIZARDHASFINISH   type DWORD value('00000010'xu);
 dcl PSH_WIZARD            type DWORD value('00000020'xu);
 dcl PSH_USEPSTARTPAGE     type DWORD value('00000040'xu);
 dcl PSH_NOAPPLYNOW        type DWORD value('00000080'xu);
 dcl PSH_USECALLBACK       type DWORD value('00000100'xu);
 dcl PSH_HASHELP           type DWORD value('00000200'xu);
 dcl PSH_MODELESS          type DWORD value('00000400'xu);
 dcl PSH_RTLREADING        type DWORD value('00000800'xu);
 dcl PSH_WIZARDCONTEXTHELP type DWORD value('00001000'xu);


 %if #WIN32_IE >= 1024 %then %do;
 /*----- New flags for wizard97 ----------- */
 dcl PSH_WIZARD97          type DWORD value('00002000'xu);
 /* '00004000'xu was not used by any previous release */
 dcl PSH_WATERMARK         type DWORD value('00008000'xu);
 dcl PSH_USEHBMWATERMARK   type DWORD value('00010000'xu);
     /* user pass in a hbmWatermark instead of pszbmWatermark */
 dcl PSH_USEHPLWATERMARK   type DWORD value('00020000'xu);
 dcl PSH_STRETCHWATERMARK  type DWORD value('00040000'xu);
     /* stretchwatermark also applies for the header */
 dcl PSH_HEADER            type DWORD value('00080000'xu);
 dcl PSH_USEHBMHEADER      type DWORD value('00100000'xu);
 dcl PSH_USEPAGELANG       type DWORD value('00200000'xu);
     /* use frame dialog template matched to page */
 %end;
 %if #WIN32_IE >= 1280 %then %do;
 /* New flags for wizard-lite */
 dcl PSH_WIZARD_LITE       type DWORD value('00400000'xu);
 %end;


 define alias PFNPROPSHEETCALLBACK
              entry (type HWND,
                     type UINT,
                     type LPARAM)
              returns (fixed bin(31) byvalue optional)
              limited CALLBACK;

 define structure
   1 PROPSHEETHEADERA unaligned,
     2 dwSize           type DWORD,
     2 dwFlags          type DWORD,
     2 hwndParent       type HWND,
     2 hInstance        type HINSTANCE,
     2 * union,
       3 hIcon          type HICON,
       3 pszIcon        type LPCSTR,
     2 pszCaption       type LPCSTR,
     2 nPages           type UINT,
     2 * union,
       3 nStartPage     type UINT,
       3 pStartPage     type LPCSTR,
     2 * union,
       3 ppsp           type LPCPROPSHEETPAGEA,
       3 phpage         pointer, /* handle HPROPSHEETPAGE */
     2 pfnCallback      type PFNPROPSHEETCALLBACK
 %if #WIN32_IE >= 1024 %then %do;
   , 2 * union,
       3 hbmWatermark   type HBITMAP,
       3 pszbmWatermark type LPCSTR,
     2 hplWatermark     type HPALETTE,
     2 * union,
       3 hbmHeader      type HBITMAP,
         /* Header bitmap shares the palette with watermark */
       3 pszbmHeader    type LPCSTR
 %end;
   ;
 define alias  LPPROPSHEETHEADERA handle PROPSHEETHEADERA;
 define alias LPCPROPSHEETHEADERA handle PROPSHEETHEADERA;
 dcl PROPSHEETHEADERA_V1_SIZE fixed bin(31)
     value (CCSIZEOF_STRUCT (PROPSHEETHEADERA, pfnCallback));

 define structure
   1 PROPSHEETHEADERW unaligned,
     2 dwSize           type DWORD,
     2 dwFlags          type DWORD,
     2 hwndParent       type HWND,
     2 hInstance        type HINSTANCE,
     2 * union,
       3 hIcon          type HICON,
       3 pszIcon        type LPCWSTR,
     2 pszCaption       type LPCWSTR,
     2 nPages           type UINT,
     2 * union,
       3 nStartPage     type UINT,
       3 pStartPage     type LPCWSTR,
     2 * union,
       3 ppsp           type LPCPROPSHEETPAGEW,
       3 phpage         pointer, /* handle HPROPSHEETPAGE */
     2 pfnCallback      type PFNPROPSHEETCALLBACK
 %if #WIN32_IE >= 1024 %then %do;
   , 2 * union,
       3 hbmWatermark   type HBITMAP,
       3 pszbmWatermark type LPCWSTR,
     2 hplWatermark     type HPALETTE,
     2 * union,
       3 hbmHeader      type HBITMAP,
         /* Header bitmap shares the palette with watermark */
       3 pszbmHeader    type LPCWSTR
 %end;
   ;
 define alias  LPPROPSHEETHEADERW handle PROPSHEETHEADERW;
 define alias LPCPROPSHEETHEADERW handle PROPSHEETHEADERW;
 dcl PROPSHEETHEADERW_V1_SIZE fixed bin(31)
     value (CCSIZEOF_STRUCT (PROPSHEETHEADERW, pfnCallback));

 %if UNICODE ^= '' %then %do;
   define alias    PROPSHEETHEADER type    PROPSHEETHEADERW;
   define alias  LPPROPSHEETHEADER type  LPPROPSHEETHEADERW;
   define alias LPCPROPSHEETHEADER type LPCPROPSHEETHEADERW;
   dcl PROPSHEETHEADER_V1_SIZE fixed bin(31)
       value(PROPSHEETHEADERW_V1_SIZE);
 %end; %else %do;
   define alias    PROPSHEETHEADER type    PROPSHEETHEADERA;
   define alias  LPPROPSHEETHEADER type  LPPROPSHEETHEADERA;
   define alias LPCPROPSHEETHEADER type LPCPROPSHEETHEADERA;
   dcl PROPSHEETHEADER_V1_SIZE fixed bin(31)
       value(PROPSHEETHEADERA_V1_SIZE);
 %end;


 dcl PSCB_INITIALIZED fixed bin(31) value(1);
 dcl PSCB_PRECREATE   fixed bin(31) value(2);

 dcl CreatePropertySheetPageA
     entry (type PROPSHEETPAGEA byaddr nonasgn)
     returns (type HPROPSHEETPAGE byvalue optional)
     WINCOMMCTRLAPI WINAPI ext('CreatePropertySheetPageA');

 dcl CreatePropertySheetPageW
     entry (type PROPSHEETPAGEW byaddr nonasgn)
     returns (type HPROPSHEETPAGE byvalue optional)
     WINCOMMCTRLAPI WINAPI ext('CreatePropertySheetPageW');

 dcl DestroyPropertySheetPage
     entry (type HPROPSHEETPAGE )
     returns (type BOOL byvalue optional)
     WINCOMMCTRLAPI WINAPI ext('DestroyPropertySheetPage');

 dcl PropertySheetA
     entry (type PROPSHEETHEADERA byaddr nonasgn)
     returns (fixed bin(31) byvalue optional)
     WINCOMMCTRLAPI WINAPI ext('PropertySheetA');

 dcl PropertySheetW
     entry (type PROPSHEETHEADERW byaddr nonasgn)
     returns (fixed bin(31) byvalue optional)
     WINCOMMCTRLAPI WINAPI ext('PropertySheetW');


 %dcl CreatePropertySheetPage char ext;
 %dcl PropertySheet char ext;
 %if UNICODE ^= '' %then %do;
   %CreatePropertySheetPage='CreatePropertySheetPageW';
   %PropertySheet='PropertySheetW';
 %end; %else %do;
   %CreatePropertySheetPage='CreatePropertySheetPageA';
   %PropertySheet='PropertySheetA';
 %end;


 define alias LPFNADDPROPSHEETPAGE
              entry (type HPROPSHEETPAGE,
                     type LPARAM)
              returns (type BOOL byvalue optional)
              limited CALLBACK;

 define alias LPFNADDPROPSHEETPAGES
              entry (type LPVOID,
                     type LPFNADDPROPSHEETPAGE,
                     type LPARAM)
              returns (type BOOL byvalue optional)
              limited CALLBACK;

 define structure
   1 PSHNOTIFY unaligned,
     2 hdr    type NMHDR,
     2 lParam type LPARAM;
 define alias LPPSHNOTIFY  handle PSHNOTIFY;

 dcl PSN_FIRST                fixed bin(31) value(0-200);
 dcl PSN_LAST                 fixed bin(31) value(0-299);

 dcl PSN_SETACTIVE            fixed bin(31) value(PSN_FIRST-0);
 dcl PSN_KILLACTIVE           fixed bin(31) value(PSN_FIRST-1);
 /* dcl PSN_VALIDATE          fixed bin(31) value(PSN_FIRST-1) */
 dcl PSN_APPLY                fixed bin(31) value(PSN_FIRST-2);
 dcl PSN_RESET                fixed bin(31) value(PSN_FIRST-3);
 /* dcl PSN_CANCEL            fixed bin(31) value(PSN_FIRST-3) */
 dcl PSN_HELP                 fixed bin(31) value(PSN_FIRST-5);
 dcl PSN_WIZBACK              fixed bin(31) value(PSN_FIRST-6);
 dcl PSN_WIZNEXT              fixed bin(31) value(PSN_FIRST-7);
 dcl PSN_WIZFINISH            fixed bin(31) value(PSN_FIRST-8);
 dcl PSN_QUERYCANCEL          fixed bin(31) value(PSN_FIRST-9);

 %if #WIN32_IE >= 1024 %then %do;
 dcl PSN_GETOBJECT            fixed bin(31) value(PSN_FIRST-10);
 %end; /* 0x0400 */
 %if #WIN32_IE >= 1280 %then %do;
 dcl PSN_TRANSLATEACCELERATOR fixed bin(31) value(PSN_FIRST-12);
 dcl PSN_QUERYINITIALFOCUS    fixed bin(31) value(PSN_FIRST-13);
 %end; /* 0x0500 */

 dcl PSNRET_NOERROR              fixed bin(31) value(0);
 dcl PSNRET_INVALID              fixed bin(31) value(1);
 dcl PSNRET_INVALID_NOCHANGEPAGE fixed bin(31) value(2);
 dcl PSNRET_MESSAGEHANDLED       fixed bin(31) value(3);


 dcl PSM_SETCURSEL   fixed bin(31) value(WM_USER + 101);

 PropSheet_SetCurSel: proc (hDlg, hpage, index)
                      returns (type LRESULT byvalue optional)
                      options(inline reorder) internal;
   dcl hDlg  type HWND byvalue,
       hpage type HPROPSHEETPAGE byvalue,
       index fixed bin (31) byvalue;
   dcl binvalue builtin;
   return (SNDMSG (hDlg, PSM_SETCURSEL, index, binvalue (hpage)));
 end PropSheet_SetCurSel;


 dcl PSM_REMOVEPAGE fixed bin(31) value(WM_USER + 102);

 PropSheet_RemovePage: proc (hDlg, index, hpage)
                       returns (type LRESULT byvalue optional)
                       options(inline reorder) internal;
   dcl hDlg  type HWND byvalue,
       index fixed bin (31) byvalue,
       hpage type HPROPSHEETPAGE byvalue;
   dcl binvalue builtin;
   return (SNDMSG (hDlg, PSM_REMOVEPAGE, index, binvalue (hpage)));
 end PropSheet_RemovePage;


 dcl PSM_ADDPAGE fixed bin(31) value(WM_USER + 103);

 PropSheet_AddPage: proc (hDlg, hpage)
                    returns (type LRESULT byvalue optional)
                    options(inline reorder) internal;
   dcl hDlg  type HWND byvalue,
       hpage type HPROPSHEETPAGE byvalue;
   dcl binvalue builtin;
   return (SNDMSG (hDlg, PSM_ADDPAGE, 0, binvalue (hpage)));
 end PropSheet_AddPage;


 dcl PSM_CHANGED fixed bin(31) value(WM_USER + 104);

 PropSheet_Changed: proc (hDlg, hwnd)
                    returns (type LRESULT byvalue optional)
                    options(inline reorder) internal;
   dcl hDlg type HWND byvalue,
       hwnd type HWND byvalue;
   dcl binvalue builtin;
   return (SNDMSG (hDlg, PSM_CHANGED, binvalue (hwnd), 0));
 end PropSheet_Changed;


 dcl PSM_RESTARTWINDOWS fixed bin(31) value(WM_USER + 105);

 PropSheet_RestartWindows: proc (hDlg)
                           returns (type LRESULT byvalue optional)
                           options(inline reorder) internal;
   dcl hDlg type HWND byvalue;
   return (SNDMSG (hDlg, PSM_RESTARTWINDOWS, 0, 0));
 end PropSheet_RestartWindows;


 dcl PSM_REBOOTSYSTEM fixed bin(31) value(WM_USER + 106);

 PropSheet_RebootSystem: proc (hDlg)
                         returns (type LRESULT byvalue optional)
                         options(inline reorder) internal;
   dcl hDlg type HWND byvalue;
   return (SNDMSG (hDlg, PSM_REBOOTSYSTEM, 0, 0));
 end PropSheet_RebootSystem;


 dcl PSM_CANCELTOCLOSE fixed bin(31) value(WM_USER + 107);

 PropSheet_CancelToClose: proc (hDlg)
                          returns (type BOOL byvalue optional)
                          options(inline reorder) internal;
   dcl hDlg type HWND byvalue;
   return (PostMessage (hDlg, PSM_CANCELTOCLOSE, 0, 0));
 end PropSheet_CancelToClose;


 dcl PSM_QUERYSIBLINGS fixed bin(31) value(WM_USER + 108);

 PropSheet_QuerySiblings: proc (hDlg, wParam, lParam)
                          returns (type LRESULT byvalue optional)
                          options(inline reorder) internal;
   dcl hDlg   type HWND byvalue,
       wParam type WPARAM byvalue,
       lParam type LPARAM byvalue;
   return (SNDMSG (hDlg, PSM_QUERYSIBLINGS, wParam, lParam));
 end PropSheet_QuerySiblings;


 dcl PSM_UNCHANGED fixed bin(31) value(WM_USER + 109);

 PropSheet_UnChanged: proc (hDlg, hwnd)
                      returns (type LRESULT byvalue optional)
                      options(inline reorder) internal;
   dcl hDlg type HWND byvalue,
       hwnd type HWND byvalue;
   dcl binvalue builtin;
   return (SNDMSG (hDlg, PSM_UNCHANGED, binvalue (hwnd), 0));
 end PropSheet_UnChanged;


 dcl PSM_APPLY fixed bin(31) value(WM_USER + 110);

 PropSheet_Apply: proc (hDlg)
                  returns (type LRESULT byvalue optional)
                  options(inline reorder) internal;
   dcl hDlg type HWND byvalue;
   return (SNDMSG (hDlg, PSM_APPLY, 0, 0));
 end PropSheet_Apply;


 dcl PSM_SETTITLEA fixed bin(31) value(WM_USER + 111);
 dcl PSM_SETTITLEW fixed bin(31) value(WM_USER + 120);

 %if UNICODE ^= '' %then %do;
   dcl PSM_SETTITLE fixed bin(31) value(PSM_SETTITLEW);
 %end; %else %do;
   dcl PSM_SETTITLE fixed bin(31) value(PSM_SETTITLEA);
 %end;

 PropSheet_SetTitle: proc (hDlg, wStyle, lpszText)
                     returns (type LRESULT byvalue optional)
                     options(inline reorder) internal;
   dcl hDlg     type HWND byvalue,
       wStyle   type DWORD byvalue,
       lpszText TSTR byaddr nonasgn;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hDlg, PSM_SETTITLE, wStyle,
                   binvalue (addr(lpszText))));
 end PropSheet_SetTitle;


 dcl PSM_SETWIZBUTTONS fixed bin(31) value(WM_USER + 112);

 PropSheet_SetWizButtons: proc (hDlg, dwFlags)
                          returns (type BOOL byvalue optional)
                          options(inline reorder) internal;
   dcl hDlg    type HWND byvalue,
       dwFlags type DWORD byvalue;
   return (PostMessage (hDlg, PSM_SETWIZBUTTONS, 0, dwFlags));
 end PropSheet_SetWizButtons;


 dcl PSWIZB_BACK           type DWORD value('00000001'xu);
 dcl PSWIZB_NEXT           type DWORD value('00000002'xu);
 dcl PSWIZB_FINISH         type DWORD value('00000004'xu);
 dcl PSWIZB_DISABLEDFINISH type DWORD value('00000008'xu);


 dcl PSM_PRESSBUTTON fixed bin(31) value(WM_USER + 113);

 PropSheet_PressButton: proc (hDlg, iButton)
                        returns (type BOOL byvalue optional)
                        options(inline reorder) internal;
   dcl hDlg    type HWND byvalue,
       iButton fixed bin (31) byvalue;
   return (PostMessage (hDlg, PSM_PRESSBUTTON, iButton, 0));
 end PropSheet_PressButton;


 dcl PSBTN_BACK     fixed bin(31) value(0);
 dcl PSBTN_NEXT     fixed bin(31) value(1);
 dcl PSBTN_FINISH   fixed bin(31) value(2);
 dcl PSBTN_OK       fixed bin(31) value(3);
 dcl PSBTN_APPLYNOW fixed bin(31) value(4);
 dcl PSBTN_CANCEL   fixed bin(31) value(5);
 dcl PSBTN_HELP     fixed bin(31) value(6);
 dcl PSBTN_MAX      fixed bin(31) value(6);


 dcl PSM_SETCURSELID fixed bin(31) value(WM_USER + 114);

 PropSheet_SetCurSelByID: proc (hDlg, id)
                          returns (type LRESULT byvalue optional)
                          options(inline reorder) internal;
   dcl hDlg type HWND byvalue,
       id   fixed bin (31) byvalue;
   return (SNDMSG (hDlg, PSM_SETCURSELID, 0, id));
 end PropSheet_SetCurSelByID;


 dcl PSM_SETFINISHTEXTA fixed bin(31) value(WM_USER + 115);
 dcl PSM_SETFINISHTEXTW fixed bin(31) value(WM_USER + 121);

 %if UNICODE ^= '' %then %do;
   dcl PSM_SETFINISHTEXT fixed bin(31) value(PSM_SETFINISHTEXTW);
 %end; %else %do;
   dcl PSM_SETFINISHTEXT fixed bin(31) value(PSM_SETFINISHTEXTA);
 %end;

 PropSheet_SetFinishText: proc (hDlg, lpszText)
                          returns (type LRESULT byvalue optional)
                          options(inline reorder) internal;
   dcl hDlg     type HWND byvalue,
       lpszText TSTR byaddr nonasgn;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hDlg, PSM_SETFINISHTEXT, 0,
                   binvalue (addr(lpszText))));
 end PropSheet_SetFinishText;


 dcl PSM_GETTABCONTROL fixed bin(31) value(WM_USER + 116);

 PropSheet_GetTabControl: proc (hDlg)
                  returns (type HWND byvalue optional)
                  options(inline reorder) internal;
   dcl hDlg type HWND byvalue;
   dcl ptrvalue builtin;
   return (ptrvalue (SNDMSG (hDlg, PSM_GETTABCONTROL, 0, 0)));
 end PropSheet_GetTabControl;


 dcl PSM_ISDIALOGMESSAGE fixed bin(31) value(WM_USER + 117);

 PropSheet_IsDialogMessage: proc (hDlg, pMsg)
                            returns (type BOOL byvalue optional)
                            options(inline reorder) internal;
   dcl hDlg type HWND byvalue,
       pMsg type MSG byaddr;
   dcl (addr, binvalue) builtin;
   return (SNDMSG (hDlg, PSM_ISDIALOGMESSAGE, 0,
                   binvalue (addr (pMsg))));
 end PropSheet_IsDialogMessage;


 dcl PSM_GETCURRENTPAGEHWND fixed bin(31) value(WM_USER + 118);

 PropSheet_GetCurrentPageHwnd: proc (hDlg)
                               returns (type HWND byvalue optional)
                               options(inline reorder) internal;
   dcl hDlg type HWND byvalue;
   dcl ptrvalue builtin;
   return (ptrvalue (SNDMSG (hDlg, PSM_GETCURRENTPAGEHWND, 0, 0)));
 end PropSheet_GetCurrentPageHwnd;


 dcl ID_PSRESTARTWINDOWS fixed bin(31) value('2'xn);
 dcl ID_PSREBOOTSYSTEM   fixed bin(31)
     value(ior (ID_PSRESTARTWINDOWS, '1'xn));


 dcl WIZ_CXDLG      fixed bin(31) value(276);
 dcl WIZ_CYDLG      fixed bin(31) value(140);

 dcl WIZ_CXBMP      fixed bin(31) value(80);

 dcl WIZ_BODYX      fixed bin(31) value(92);
 dcl WIZ_BODYCX     fixed bin(31) value(184);

 dcl PROP_SM_CXDLG  fixed bin(31) value(212);
 dcl PROP_SM_CYDLG  fixed bin(31) value(188);

 dcl PROP_MED_CXDLG fixed bin(31) value(227);
 dcl PROP_MED_CYDLG fixed bin(31) value(215);

 dcl PROP_LG_CXDLG  fixed bin(31) value(252);
 dcl PROP_LG_CYDLG  fixed bin(31) value(218);

 %end; /* #PRSHT_H_ */
