 /* ++ BUILD Version: 0001                                            */
 /*                -- Increment this if a change has global effects   */
 /*                                                                   */
 /* Copyright (c) 1994-1999  Microsoft Corporation                    */
 /*                                                                   */
 /* Module Name:                                                      */
 /*                                                                   */
 /*     psapi.cpy                                                     */
 /*                                                                   */
 /* Abstract:                                                         */
 /*                                                                   */
 /*     Include file for APIs provided by PSAPI.DLL                   */
 /*                                                                   */
 /* Author:                                                           */
 /*                                                                   */
 /*     Richard Shupak   [richards]  06-Jan-1994                      */
 /*                                                                   */
 /* Revision History:                                                 */
 /*                                                                   */
 /* --                                                                */

 %dcl #PSAPI_H_ char ext;
 %if #PSAPI_H_ = '' %then %do;
 %#PSAPI_H_ = 'Y';

 %dcl #WINDEF_ char ext;
 %if #WINDEF_ = '' %then %do;
 %include windef;
 %end;

 %dcl UNICODE char ext;

 dcl EnumProcesses
     entry ((*) type DWORD byaddr,
            type DWORD,
            (*) type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external('EnumProcesses');

 dcl EnumProcessModules
     entry (type HANDLE,
            (*) type HMODULE byaddr,
            type DWORD,
            type DWORD byaddr)
     returns (type BOOL byvalue optional)
     WINAPI external('EnumProcessModules');

 dcl GetModuleBaseNameA
     entry (type HANDLE,
            type HMODULE,
            char (*) varz byaddr,
            type DWORD)
     returns (type DWORD byvalue optional)
     WINAPI external('GetModuleBaseNameA');

 dcl GetModuleBaseNameW
     entry (type HANDLE,
            type HMODULE,
            WCHAR (*) varz byaddr,
            type DWORD)
     returns (type DWORD byvalue optional)
     WINAPI external('GetModuleBaseNameW');

 %dcl GetModuleBaseName char ext;
 %if UNICODE ^= '' %then %do;
   %GetModuleBaseName='GetModuleBaseNameW';
 %end; %else %do;
   %GetModuleBaseName='GetModuleBaseNameA';
 %end; /* !UNICODE */


 dcl GetModuleFileNameExA
     entry (type HANDLE,
            type HMODULE,
            char (*) varz byaddr,
            type DWORD)
     returns (type DWORD byvalue optional)
     WINAPI external('GetModuleFileNameExA');

 dcl GetModuleFileNameExW
     entry (type HANDLE,
            type HMODULE,
            WCHAR (*) varz byaddr,
            type DWORD)
     returns (type DWORD byvalue optional)
     WINAPI external('GetModuleFileNameExW');

 %dcl GetModuleFileNameEx char ext;
 %if UNICODE ^= '' %then %do;
   %GetModuleFileNameEx='GetModuleFileNameExW';
 %end; %else %do;
   %GetModuleFileNameEx='GetModuleFileNameExA';
 %end; /* !UNICODE */


 define structure
   1 MODULEINFO,
     2 lpBaseOfDll type LPVOID,
     2 SizeOfImage type DWORD,
     2 EntryPoint  type LPVOID;
 define alias LPMODULEINFO handle MODULEINFO;


 dcl GetModuleInformation
     entry (type HANDLE,
            type HMODULE,
            type MODULEINFO byaddr,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINAPI external('GetModuleInformation');


 dcl EmptyWorkingSet
     entry (type HANDLE)
     returns (type BOOL byvalue optional)
     WINAPI external('EmptyWorkingSet');


 dcl QueryWorkingSet
     entry (type HANDLE,
            type PVOID,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINAPI external('QueryWorkingSet');

 dcl InitializeProcessForWsWatch
     entry (type HANDLE)
     returns (type BOOL byvalue optional)
     WINAPI external('InitializeProcessForWsWatch');


 define structure
   1 PSAPI_WS_WATCH_INFORMATION,
     2 FaultingPc type LPVOID,
     2 FaultingVa type LPVOID;

 define alias PPSAPI_WS_WATCH_INFORMATION
        handle PSAPI_WS_WATCH_INFORMATION;

 dcl GetWsChanges
     entry (type HANDLE,
            type PSAPI_WS_WATCH_INFORMATION byaddr,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINAPI external('GetWsChanges');

 dcl GetMappedFileNameW
     entry (type HANDLE,
            type LPVOID,
            WCHAR(*) varz byaddr,
            type DWORD)
     returns (type DWORD byvalue optional)
     WINAPI external('GetMappedFileNameW');

 dcl GetMappedFileNameA
     entry (type HANDLE,
            type LPVOID,
            char(*) varz byaddr,
            type DWORD)
     returns (type DWORD byvalue optional)
     WINAPI external('GetMappedFileNameA');

 %dcl GetMappedFileName char ext;
 %if UNICODE ^= '' %then %do;
   %GetMappedFileName='GetMappedFileNameW';
 %end; %else %do;
   %GetMappedFileName='GetMappedFileNameA';
 %end; /* !UNICODE */

 dcl EnumDeviceDrivers
     entry ((*) type LPVOID byaddr,
            type DWORD,
            type LPDWORD)
     returns (type BOOL byvalue optional)
     WINAPI external('EnumDeviceDrivers');


 dcl GetDeviceDriverBaseNameA
     entry (type LPVOID,
            char(*) varz byaddr,
            type DWORD)
     returns (type DWORD byvalue optional)
     WINAPI external('GetDeviceDriverBaseNameA');

 dcl GetDeviceDriverBaseNameW
     entry (type LPVOID,
            WCHAR(*) varz byaddr,
            type DWORD)
     returns (type DWORD byvalue optional)
     WINAPI external('GetDeviceDriverBaseNameW');

 %dcl GetDeviceDriverBaseName char ext;
 %if UNICODE ^= '' %then %do;
   %GetDeviceDriverBaseName='GetDeviceDriverBaseNameW';
 %end; %else %do;
   %GetDeviceDriverBaseName='GetDeviceDriverBaseNameA';
 %end; /* !UNICODE */


 dcl GetDeviceDriverFileNameA
     entry (type LPVOID,
            char(*) varz byaddr,
            type DWORD)
     returns (type DWORD byvalue optional)
     WINAPI external('GetDeviceDriverFileNameA');

 dcl GetDeviceDriverFileNameW
     entry (type LPVOID,
            WCHAR(*) varz byaddr,
            type DWORD)
     returns (type DWORD byvalue optional)
     WINAPI external('GetDeviceDriverFileNameW');

 %dcl GetDeviceDriverFileName char ext;
 %if UNICODE ^= '' %then %do;
   %GetDeviceDriverFileName='GetDeviceDriverFileNameW';
 %end; %else %do;
   %GetDeviceDriverFileName='GetDeviceDriverFileNameA';
 %end; /* !UNICODE */

 /* Structure for GetProcessMemoryInfo() */

 define structure
   1 PROCESS_MEMORY_COUNTERS,
     2 cb                         type DWORD,
     2 PageFaultCount             type DWORD,
     2 PeakWorkingSetSize         type SIZE_T,
     2 WorkingSetSize             type SIZE_T,
     2 QuotaPeakPagedPoolUsage    type SIZE_T,
     2 QuotaPagedPoolUsage        type SIZE_T,
     2 QuotaPeakNonPagedPoolUsage type SIZE_T,
     2 QuotaNonPagedPoolUsage     type SIZE_T,
     2 PagefileUsage              type SIZE_T,
     2 PeakPagefileUsage          type SIZE_T;
 define alias PPROCESS_MEMORY_COUNTERS handle PROCESS_MEMORY_COUNTERS;

 dcl GetProcessMemoryInfo
     entry (type HANDLE,
            type PROCESS_MEMORY_COUNTERS byaddr,
            type DWORD)
     returns (type BOOL byvalue optional)
     WINAPI external('GetProcessMemoryInfo');

 %end;
