 /* ++                                                                */
 /*                                                                   */
 /* Copyright (c) 1992-1998 Microsoft Corporation                     */
 /*                                                                   */
 /* Module Name:                                                      */
 /*                                                                   */
 /*   rpcnsi.cpy                                                      */
 /*                                                                   */
 /* Abstract:                                                         */
 /*                                                                   */
 /*   This file contains the types and function definitions to use    */
 /*   the Name Service Independent APIs.                              */
 /*                                                                   */
 /* --                                                                */

 %dcl #_RPCNSI_H__ char ext;
 %if #_RPCNSI_H__ = '' %then %do;
 %#_RPCNSI_H__ = 'Y';

 %dcl RPC_UNICODE_SUPPORTED char ext;
 %dcl UNICODE char ext;

 define alias RPC_NS_HANDLE pointer;

 dcl RPC_C_NS_SYNTAX_DEFAULT fixed bin(31) value(0);
 dcl RPC_C_NS_SYNTAX_DCE     fixed bin(31) value(3);

 dcl RPC_C_PROFILE_DEFAULT_ELT   fixed bin(31) value(0);
 dcl RPC_C_PROFILE_ALL_ELT       fixed bin(31) value(1);
 dcl RPC_C_PROFILE_ALL_ELTS      fixed bin(31)
     value(RPC_C_PROFILE_ALL_ELT);
 dcl RPC_C_PROFILE_MATCH_BY_IF   fixed bin(31) value(2);
 dcl RPC_C_PROFILE_MATCH_BY_MBR  fixed bin(31) value(3);
 dcl RPC_C_PROFILE_MATCH_BY_BOTH fixed bin(31) value(4);

 dcl RPC_C_NS_DEFAULT_EXP_AGE    fixed bin(31) value(-1);

 /* Server APIs */

 dcl RpcNsBindingExportA
     entry (fixed bin(31),
            char (*) varz byaddr,
            type RPC_IF_HANDLE,
            type RPC_BINDING_VECTOR byaddr,
            type UUID_VECTOR byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsBindingExportA');

 dcl RpcNsBindingUnexportA
     entry (fixed bin(31),
            char (*) varz byaddr,
            type RPC_IF_HANDLE,
            type UUID_VECTOR byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsBindingUnexportA');


 %if RPC_UNICODE_SUPPORTED ^= '' %then %do;

 dcl RpcNsBindingExportW
     entry (fixed bin(31),
            WCHAR (*) varz byaddr,
            type RPC_IF_HANDLE,
            type RPC_BINDING_VECTOR byaddr,
            type UUID_VECTOR byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsBindingExportW');

 dcl RpcNsBindingUnexportW
     entry (fixed bin(31),
            WCHAR (*) varz byaddr,
            type RPC_IF_HANDLE,
            type UUID_VECTOR byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsBindingUnexportW');

 %end;

 /* Server PnP APIs */

 dcl RpcNsBindingExportPnPA
     entry (fixed bin(31),
            char (*) varz byaddr,
            type RPC_IF_HANDLE,
            type UUID_VECTOR byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsBindingExportPnPA');

 dcl RpcNsBindingUnexportPnPA
     entry (fixed bin(31),
            char (*) varz byaddr,
            type RPC_IF_HANDLE,
            type UUID_VECTOR byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsBindingUnexportPnPA');


 %if RPC_UNICODE_SUPPORTED ^= '' %then %do;

 dcl RpcNsBindingExportPnPW
     entry (fixed bin(31),
            WCHAR (*) varz byaddr,
            type RPC_IF_HANDLE,
            type UUID_VECTOR byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsBindingExportPnPW');

 dcl RpcNsBindingUnexportPnPW
     entry (fixed bin(31),
            WCHAR (*) varz byaddr,
            type RPC_IF_HANDLE,
            type UUID_VECTOR byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsBindingUnexportPnPW');

 %end;

 /* Client APIs */

 dcl RpcNsBindingLookupBeginA
     entry (fixed bin(31),
            char (*) varz byaddr,
            type RPC_IF_HANDLE,
            type UUID byaddr,
            fixed bin(31),
            type RPC_NS_HANDLE byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsBindingLookupBeginA');

 %if RPC_UNICODE_SUPPORTED ^= '' %then %do;

 dcl RpcNsBindingLookupBeginW
     entry (fixed bin(31),
            WCHAR (*) varz byaddr,
            type RPC_IF_HANDLE,
            type UUID byaddr,
            fixed bin(31),
            type RPC_NS_HANDLE byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsBindingLookupBeginW');
 %end;

 dcl RpcNsBindingLookupNext
     entry (type RPC_NS_HANDLE,
            type RPC_BINDING_VECTOR byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsBindingLookupNext');

 dcl RpcNsBindingLookupDone
     entry (type RPC_NS_HANDLE byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsBindingLookupDone');

 /* Group APIs */

 dcl RpcNsGroupDeleteA
     entry (fixed bin(31),
            char (*) varz byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsGroupDeleteA');

 dcl RpcNsGroupMbrAddA
     entry (fixed bin(31),
            char (*) varz byaddr,
            fixed bin(31),
            char (*) varz byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsGroupMbrAddA');

 dcl RpcNsGroupMbrRemoveA
     entry (fixed bin(31),
            char (*) varz byaddr,
            fixed bin(31),
            char (*) varz byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsGroupMbrRemoveA');

 dcl RpcNsGroupMbrInqBeginA
     entry (fixed bin(31),
            char (*) varz byaddr,
            fixed bin(31),
            type RPC_NS_HANDLE byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsGroupMbrInqBeginA');

 dcl RpcNsGroupMbrInqNextA
     entry (type RPC_NS_HANDLE,
            pointer byaddr optional) /* to char(*) VARZ */
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsGroupMbrInqNextA');

 %if RPC_UNICODE_SUPPORTED ^= '' %then %do;

 dcl RpcNsGroupDeleteW
     entry (fixed bin(31),
            WCHAR (*) varz byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsGroupDeleteW');

 dcl RpcNsGroupMbrAddW
     entry (fixed bin(31),
            WCHAR (*) varz byaddr,
            fixed bin(31),
            WCHAR (*) varz byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsGroupMbrAddW');

 dcl RpcNsGroupMbrRemoveW
     entry (fixed bin(31),
            WCHAR (*) varz byaddr,
            fixed bin(31),
            WCHAR (*) varz byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsGroupMbrRemoveW');

 dcl RpcNsGroupMbrInqBeginW
     entry (fixed bin(31),
            WCHAR (*) varz byaddr,
            fixed bin(31),
            type RPC_NS_HANDLE byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsGroupMbrInqBeginW');

 dcl RpcNsGroupMbrInqNextW
     entry (type RPC_NS_HANDLE,
            pointer byaddr optional) /* to WCHAR(*) varz */
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsGroupMbrInqNextW');

 %end;

 dcl RpcNsGroupMbrInqDone
     entry (type RPC_NS_HANDLE byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsGroupMbrInqDone');

 /* Profile APIs */

 dcl RpcNsProfileDeleteA
     entry (fixed bin(31),
            char (*) varz byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsProfileDeleteA');

 dcl RpcNsProfileEltAddA
     entry (fixed bin(31),
            char (*) varz byaddr,
            type RPC_IF_ID byaddr optional,
            fixed bin(31),
            char (*) varz byaddr,
            fixed bin(31),
            char (*) varz byaddr optional)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsProfileEltAddA');

 dcl RpcNsProfileEltRemoveA
     entry (fixed bin(31),
            char (*) varz byaddr,
            type RPC_IF_ID byaddr optional,
            fixed bin(31),
            char (*) varz byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsProfileEltRemoveA');

 dcl RpcNsProfileEltInqBeginA
     entry (fixed bin(31),
            char (*) varz byaddr,
            fixed bin(31),
            type RPC_IF_ID byaddr optional,
            fixed bin(31),
            fixed bin(31),
            char (*) varz byaddr optional,
            type RPC_NS_HANDLE byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsProfileEltInqBeginA');

 dcl RpcNsProfileEltInqNextA
     entry (type RPC_NS_HANDLE,
            type RPC_IF_ID byaddr optional,
            pointer byaddr optional, /* to char (*) varz byaddr */
            fixed bin(31) byaddr,
            pointer byaddr optional) /* to char (*) varz byaddr */
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsProfileEltInqNextA');


 %if RPC_UNICODE_SUPPORTED ^= '' %then %do;

 dcl RpcNsProfileDeleteW
     entry (fixed bin(31),
            WCHAR (*) varz byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsProfileDeleteW');

 dcl RpcNsProfileEltAddW
     entry (fixed bin(31),
            WCHAR (*) varz byaddr,
            type RPC_IF_ID byaddr optional,
            fixed bin(31),
            char (*) varz byaddr,
            fixed bin(31),
            char (*) varz byaddr optional)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsProfileEltAddW');

 dcl RpcNsProfileEltRemoveW
     entry (fixed bin(31),
            char (*) varz byaddr,
            type RPC_IF_ID byaddr optional,
            fixed bin(31),
            char (*) varz byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsProfileEltRemoveW');

 dcl RpcNsProfileEltInqBeginW
     entry (fixed bin(31),
            WCHAR (*) varz byaddr,
            fixed bin(31),
            type RPC_IF_ID byaddr optional,
            fixed bin(31),
            fixed bin(31),
            char (*) varz byaddr optional,
            type RPC_NS_HANDLE byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsProfileEltInqBeginW');

 dcl RpcNsProfileEltInqNextW
     entry (type RPC_NS_HANDLE,
            type RPC_IF_ID byaddr,
            pointer byaddr optional, /* to WCHAR (*) varz */
            fixed bin (31) byaddr,
            pointer byaddr optional) /* to WCHAR (*) varz */
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsProfileEltInqNextW');

 %end;

 dcl RpcNsProfileEltInqDone
     entry (type RPC_NS_HANDLE byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsProfileEltInqDone');

 /* Entry object APIs */

 dcl RpcNsEntryObjectInqBeginA
     entry (fixed bin(31),
            char(*) varz byaddr,
            type RPC_NS_HANDLE byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsEntryObjectInqBeginA');


 %if RPC_UNICODE_SUPPORTED ^= '' %then %do;

 dcl RpcNsEntryObjectInqBeginW
     entry (fixed bin(31),
            WCHAR(*) varz byaddr,
            type RPC_NS_HANDLE byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsEntryObjectInqBeginW');

 %end;

 dcl RpcNsEntryObjectInqNext
     entry (type RPC_NS_HANDLE,
            type UUID byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsEntryObjectInqNext');

 dcl RpcNsEntryObjectInqDone
     entry (type RPC_NS_HANDLE byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsEntryObjectInqDone');

 /* Management and MISC APIs */

 dcl RpcNsEntryExpandNameA
     entry (fixed bin(31),
            char (*) varz byaddr,
            pointer byaddr optional) /* to char(*) varz */
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsEntryExpandNameA');

 dcl RpcNsMgmtBindingUnexportA
     entry (fixed bin(31),
            char(*) varz byaddr,
            type RPC_IF_ID byaddr optional,
            fixed bin(31),
            type UUID_VECTOR byaddr optional)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsMgmtBindingUnexportA');

 dcl RpcNsMgmtEntryCreateA
     entry (fixed bin(31),
            char(*) varz byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsMgmtEntryCreateA');

 dcl RpcNsMgmtEntryDeleteA
     entry (fixed bin(31),
            char(*) varz byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsMgmtEntryDeleteA');

 dcl RpcNsMgmtEntryInqIfIdsA
     entry (fixed bin(31),
            char(*) varz byaddr,
            handle RPC_IF_ID_VECTOR byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsMgmtEntryInqIfIdsA');

 dcl RpcNsMgmtHandleSetExpAge
     entry (type RPC_NS_HANDLE,
            fixed bin(31))
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsMgmtHandleSetExpAge');

 dcl RpcNsMgmtInqExpAge
     entry (fixed bin (31) byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsMgmtInqExpAge');

 dcl RpcNsMgmtSetExpAge
     entry (fixed bin(31))
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsMgmtSetExpAge');


 %if RPC_UNICODE_SUPPORTED ^= '' %then %do;

 dcl RpcNsEntryExpandNameW
     entry (fixed bin(31),
            WCHAR(*) varz byaddr,
            pointer byaddr optional) /* to WCHAR(*) varz */
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsEntryExpandNameW');

 dcl RpcNsMgmtBindingUnexportW
     entry (fixed bin(31),
            WCHAR(*) varz byaddr,
            type RPC_IF_ID byaddr optional,
            fixed bin(31),
            type UUID_VECTOR byaddr optional)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsMgmtBindingUnexportW');

 dcl RpcNsMgmtEntryCreateW
     entry (fixed bin(31),
            WCHAR(*) varz byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsMgmtEntryCreateW');

 dcl RpcNsMgmtEntryDeleteW  entry (
              fixed bin(31),
              WCHAR(*) varz byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsMgmtEntryDeleteW');

 dcl RpcNsMgmtEntryInqIfIdsW
     entry (fixed bin(31),
            WCHAR(*) varz byaddr,
            handle RPC_IF_ID_VECTOR byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsMgmtEntryInqIfIdsW');

 %end;

 /* Client API's implemented in wrappers. */

 dcl RpcNsBindingImportBeginA
     entry (fixed bin(31),
            char(*) varz byaddr optional,
            type RPC_IF_HANDLE,
            type UUID byaddr optional,
            type RPC_NS_HANDLE byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsBindingImportBeginA');

 %if RPC_UNICODE_SUPPORTED ^= '' %then %do;

 dcl RpcNsBindingImportBeginW
     entry (fixed bin(31),
            WCHAR(*) varz byaddr optional,
            type RPC_IF_HANDLE,
            type UUID byaddr optional,
            type RPC_NS_HANDLE byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsBindingImportBeginW');

 %end;

 dcl RpcNsBindingImportNext
     entry (type RPC_NS_HANDLE,
            type RPC_BINDING_HANDLE byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsBindingImportNext');

 dcl RpcNsBindingImportDone
     entry (type RPC_NS_HANDLE byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsBindingImportDone');

 dcl RpcNsBindingSelect
     entry (type RPC_BINDING_VECTOR byaddr,
            type RPC_BINDING_HANDLE byaddr)
     returns (type RPC_STATUS byvalue optional)
     RPCNSAPI RPC_ENTRY external('RpcNsBindingSelect');


 %dcl RpcNsBindingLookupBegin  char ext;
 %dcl RpcNsBindingImportBegin  char ext;
 %dcl RpcNsBindingExport       char ext;
 %dcl RpcNsBindingUnexport     char ext;
 %dcl RpcNsGroupDelete         char ext;
 %dcl RpcNsGroupMbrAdd         char ext;
 %dcl RpcNsGroupMbrRemove      char ext;
 %dcl RpcNsGroupMbrInqBegin    char ext;
 %dcl RpcNsGroupMbrInqNext     char ext;
 %dcl RpcNsEntryExpandName     char ext;
 %dcl RpcNsEntryObjectInqBegin char ext;
 %dcl RpcNsMgmtBindingUnexport char ext;
 %dcl RpcNsMgmtEntryCreate     char ext;
 %dcl RpcNsMgmtEntryDelete     char ext;
 %dcl RpcNsMgmtEntryInqIfIds   char ext;
 %dcl RpcNsProfileDelete       char ext;
 %dcl RpcNsProfileEltAdd       char ext;
 %dcl RpcNsProfileEltRemove    char ext;
 %dcl RpcNsProfileEltInqBegin  char ext;
 %dcl RpcNsProfileEltInqNext   char ext;
 %dcl RpcNsBindingExportPnP    char ext;
 %dcl RpcNsBindingUnexportPnP  char ext;

 %if UNICODE ^= '' %then %do;

 %RpcNsBindingLookupBegin  = 'RpcNsBindingLookupBeginW';
 %RpcNsBindingImportBegin  = 'RpcNsBindingImportBeginW';
 %RpcNsBindingExport       = 'RpcNsBindingExportW';
 %RpcNsBindingUnexport     = 'RpcNsBindingUnexportW';
 %RpcNsGroupDelete         = 'RpcNsGroupDeleteW';
 %RpcNsGroupMbrAdd         = 'RpcNsGroupMbrAddW';
 %RpcNsGroupMbrRemove      = 'RpcNsGroupMbrRemoveW';
 %RpcNsGroupMbrInqBegin    = 'RpcNsGroupMbrInqBeginW';
 %RpcNsGroupMbrInqNext     = 'RpcNsGroupMbrInqNextW';
 %RpcNsEntryExpandName     = 'RpcNsEntryExpandNameW';
 %RpcNsEntryObjectInqBegin = 'RpcNsEntryObjectInqBeginW';
 %RpcNsMgmtBindingUnexport = 'RpcNsMgmtBindingUnexportW';
 %RpcNsMgmtEntryCreate     = 'RpcNsMgmtEntryCreateW';
 %RpcNsMgmtEntryDelete     = 'RpcNsMgmtEntryDeleteW';
 %RpcNsMgmtEntryInqIfIds   = 'RpcNsMgmtEntryInqIfIdsW';
 %RpcNsProfileDelete       = 'RpcNsProfileDeleteW';
 %RpcNsProfileEltAdd       = 'RpcNsProfileEltAddW';
 %RpcNsProfileEltRemove    = 'RpcNsProfileEltRemoveW';
 %RpcNsProfileEltInqBegin  = 'RpcNsProfileEltInqBeginW';
 %RpcNsProfileEltInqNext   = 'RpcNsProfileEltInqNextW';
 %RpcNsBindingExportPnP    = 'RpcNsBindingExportPnPW';
 %RpcNsBindingUnexportPnP  = 'RpcNsBindingUnexportPnPW';

 %end; %else %do;

 %RpcNsBindingLookupBegin  = 'RpcNsBindingLookupBeginA';
 %RpcNsBindingImportBegin  = 'RpcNsBindingImportBeginA';
 %RpcNsBindingExport       = 'RpcNsBindingExportA';
 %RpcNsBindingUnexport     = 'RpcNsBindingUnexportA';
 %RpcNsGroupDelete         = 'RpcNsGroupDeleteA';
 %RpcNsGroupMbrAdd         = 'RpcNsGroupMbrAddA';
 %RpcNsGroupMbrRemove      = 'RpcNsGroupMbrRemoveA';
 %RpcNsGroupMbrInqBegin    = 'RpcNsGroupMbrInqBeginA';
 %RpcNsGroupMbrInqNext     = 'RpcNsGroupMbrInqNextA';
 %RpcNsEntryExpandName     = 'RpcNsEntryExpandNameA';
 %RpcNsEntryObjectInqBegin = 'RpcNsEntryObjectInqBeginA';
 %RpcNsMgmtBindingUnexport = 'RpcNsMgmtBindingUnexportA';
 %RpcNsMgmtEntryCreate     = 'RpcNsMgmtEntryCreateA';
 %RpcNsMgmtEntryDelete     = 'RpcNsMgmtEntryDeleteA';
 %RpcNsMgmtEntryInqIfIds   = 'RpcNsMgmtEntryInqIfIdsA';
 %RpcNsProfileDelete       = 'RpcNsProfileDeleteA';
 %RpcNsProfileEltAdd       = 'RpcNsProfileEltAddA';
 %RpcNsProfileEltRemove    = 'RpcNsProfileEltRemoveA';
 %RpcNsProfileEltInqBegin  = 'RpcNsProfileEltInqBeginA';
 %RpcNsProfileEltInqNext   = 'RpcNsProfileEltInqNextA';
 %RpcNsBindingExportPnP    = 'RpcNsBindingExportPnPA';
 %RpcNsBindingUnexportPnP  = 'RpcNsBindingUnexportPnPA';

 %end; /* UNICODE */

 %end; /* __RPCNSI_H__ */
