 /********************************************************************/
 /*                                                                  */
 /*  PL/I Include file: SQLENV.CPY                                   */
 /*                                                                  */
 /* This file is installed in the \IBMPLI\INCLUDE\SDKWIN\ directory.*/
 /*                                                                  */
 /*                                                                  */
 /*  NAME - SQLENV.CPY                                               */
 /*                                                                  */
 /*  DESCRIPTION                                                     */
 /*                                                                  */
 /*    This include file is translated into a PL/I include file,     */
 /*    from the C header files supplied with the                     */
 /*    IBM DATABASE 2 SOFTWARE DEVELOPERS KIT    product.            */
 /*    This include file is intended for use with the                */
 /*    IBM DATABASE 2 SOFTWARE DEVELOPERS KIT   product.             */
 /*                                                                  */
 /*                                                                  */
 /*    (C) Copyright IBM Corp. 1994, 1996. All Rights Reserved.      */
 /*    US Government Users Restricted Rights-- Use, duplication or   */
 /*    disclosure restricted by GSA ADP Schedule Contract with       */
 /*    IBM Corp.                                                     */
 /*  Licensed Materials - Property of IBM                            */
 /*                                                                  */
 /*  Function = Include File defining:                               */
 /*               Environment Commands - Constants                   */
 /*               Environment Commands - Structures                  */
 /*               Environment Commands - Function Prototypes         */
 /*               Environment Commands - Labels for SQLCODES         */
 /*                                                                  */
 /*  Operating System = Windows                                      */
 /*                                                                  */
 /*                                                                  */
 /*  DISCLAIMER OF WARRANTIES                                        */
 /*    The following enclosed code is sample code created by IBM   */
 /*    Corporation. This sample code is not part of any standard     */
 /*    IBM product and is provided to you solely for the purpose of  */
 /*    assisting you in the development of your applications.  The   */
 /*    code is provided "AS IS", without warranty of any kind.       */
 /*    IBM shall not be liable for any damages arising out of your   */
 /*    use of the sample code, even if IBM has been advised of the   */
 /*    possibility of such damages.                                  */
 /*                                                                  */
 /********************************************************************/
 %dcl SQL_H_SQLENV char ext;
 %if SQL_H_SQLENV = '' %then %do;
 %SQL_H_SQLENV = 'Y';

 /* Required Include Files */

 %dcl SQL_H_SQL char ext;
 %if SQL_H_SQL = '' %then %do;
 /* also includes sqlca & sqlsystm */
 %include sql;
 %end;

 %dcl #SQLDASIZE char ext;
 %if #SQLDASIZE = '' %then %do;
 %include sqlda_t;
 %end;

 /* Interface Parameters/Structures/Return Codes */

 /* Parameters for START USING DATABASE          */
 dcl SQL_USE_SHR              char value('S');
                              /* USE = Share                         */
 dcl SQL_USE_EXC              char value('X');
                              /* USE = Exclusive                     */
 dcl SQL_USE_EXC_SN           char value('N');
                              /* USE = Exclusive on Single Node      */

 /* Sizes for entries in sqledinfo, sqleninfo, sqledbstat, */
 /* sqleusrstat, sql_dir_entry, sqle_reg_nwbindery */
 dcl SQL_ALIAS_SZ             fixed bin(31) value(8);
                              /* Alias name                          */
 dcl SQL_USERID_SZ            fixed bin(31) value(30);
                              /* User Id                             */
 dcl SQL_MAX_USERID_SZ        fixed bin(31) value(1024);
                              /* Max User Id Size                    */
 dcl SQL_AUTHID_SZ            fixed bin(31) value(30);
                              /* Auth Id                             */
 dcl SQL_DBNAME_SZ            fixed bin(31) value(8);
                              /* Database name                       */

 dcl SQL_DRIVE_SZ_DB2OS2      fixed bin(31) value(2);
                              /* Drive (Qualified) - OS/2            */
 dcl SQL_DRIVE_SZ_DB2DOS      fixed bin(31) value(2);
                              /* Drive (Qualified) - Windows         */
 dcl SQL_DRIVE_SZ_DB2WINT     fixed bin(31) value(12);
                              /* Drive (Qualified) - NT              */
 dcl SQL_DRIVE_SZ_DB2AIX      fixed bin(31) value(215);
                              /* Path (Qualified) - AIX/UNIX         */
 dcl SQL_DRIVE_SZ             fixed bin(31) value(SQL_DRIVE_SZ_DB2WINT);

 dcl SQL_INAME_SZ             fixed bin(31) value(8);
                              /* Internal db name                    */
 dcl SQL_NNAME_SZ             fixed bin(31) value(8);
                              /* Node name                           */
 dcl SQL_INSTNAME_SZ          fixed bin(31) value(8);
                              /* Instance Name                       */
 dcl SQL_DBTYP_SZ             fixed bin(31) value(20);
                              /* Type of database                    */
 dcl SQL_CMT_SZ               fixed bin(31) value(30);
                              /* Comment                             */
 dcl SQL_LOCLU_SZ             fixed bin(31) value(8);
                              /* Local_lu                            */
 dcl SQL_RMTLU_SZ             fixed bin(31) value(8);
                              /* Partner_lu                          */
 dcl SQL_MODE_SZ              fixed bin(31) value(8);
                              /* Mode                                */
 dcl SQL_TPNAME_SZ            fixed bin(31) value(64);
                              /* length of tpname                    */
 dcl SQL_NRESERVE_SZ          fixed bin(31) value(0);
                              /* Reserved                            */
 dcl SQL_DBSTAT_ALIAS_SZ      fixed bin(31) value(16);
                              /* Alias name                          */
 dcl SQL_DBSTAT_DBNAME_SZ     fixed bin(31) value(16);
                              /* Database name                       */
 dcl SQL_LONG_NAME_SZ         fixed bin(31) value(18);
                              /* Host database name                  */
 dcl SQL_CS_SZ                fixed bin(31) value(256);
                              /* collating sequence                  */
 dcl SQL_PARAMETER_SZ         fixed bin(31) value(512);
                              /* Parameter string                    */
 dcl SQL_NETID_SZ             fixed bin(31) value(8);
                              /* Network ID                          */
 dcl SQL_PATH_SZ              fixed bin(31) value(1024);
                              /* Maximum Path size                   */
 dcl SQL_HOSTNAME_SZ          fixed bin(31) value(255);
                              /* Host Name                           */
 dcl SQL_COMPUTERNAME_SZ      fixed bin(31) value(15);
                              /* Computer Name                       */
 dcl SQL_PROFILE_SZ           fixed bin(31) value(235);
                              /* Profile Name                        */
 dcl SQL_OPTION_SZ            fixed bin(31) value(10);
                              /* Option Name                         */
 dcl SQL_DCEPRIN_SZ           fixed bin(31) value(1024);
                              /* DCE principal name size             */
 dcl SQL_SERVICE_NAME_SZ      fixed bin(31) value(14);
                              /* Service Name                        */
 dcl SQL_TPMON_NAME_SZ        fixed bin(31) value(19);
                              /* TP Monitor Name                     */
 dcl SQL_SYM_DEST_NAME_SZ     fixed bin(31) value(8);
                              /* Symbolic Destination Name           */
 dcl SQL_TMDATABASE_NAME_SZ   fixed bin(31) value(8);
                              /* TM Database Name                    */
 dcl SQL_AR_SZ                fixed bin(31) value(8);
                              /* AR Library Name                     */
 dcl SQL_SYSTEM_NAME_SZ       fixed bin(31) value(21);
                              /* System Name                         */
 dcl SQL_REMOTE_INSTNAME_SZ   fixed bin(31) value(8);
                              /* Remote Instance Name                */
 dcl SQL_IPXADDRESS_SZ        fixed bin(31) value(27);
                              /* IPX address size                    */
 dcl SQL_LANADDRESS_SZ        fixed bin(31) value(12);
                              /* Lan adapter address                 */
 dcl SQL_LDAP_DN_SZ           fixed bin(31) value(1000);
                              /* LDAP Distinguished Name             */
 dcl SQL_LDAP_PSWD_SZ         fixed bin(31) value(256);
                              /* LDAP Password                       */

 dcl SQL_DFTDRDAACT_SZ        fixed bin(31) value(25);
                              /* Default DRDA accounting string.     */
 dcl SQL_DIR_NAME_SZ          fixed bin(31) value(255);
                              /* Dir/Route Path/Obj Name             */
 dcl SQL_CLIENT_COMM_SZ       fixed bin(31) value(31);
                              /* Client Comm. Protocol               */
 dcl SQL_SYSADM_SZ            fixed bin(31) value(16);
                              /* Sysadm Group name                   */
 dcl SQLF_SYS_GROUP_SZ        fixed bin(31) value(8);
                              /* Sysadm, sysctrl, sysmaint size for  */
                              /* validation                          */
 dcl SQL_FILESERVER_SZ        fixed bin(31) value(48);
                              /* Netware fileserver name             */
 dcl SQL_OBJECTNAME_SZ        fixed bin(31) value(48);
                              /* Netware bindery name                */
 dcl SQL_IPXSOCKET_SZ         fixed bin(31) value(4);
                              /* Netware IPX socket                  */
 dcl SQL_NW_UID_SZ            fixed bin(31) value(48);
                              /* Netware userid                      */
 dcl SQL_NW_PSWD_SZ           fixed bin(31) value(128);
                              /* Netware password                    */
 dcl SQL_COLLATE_INFO_SZ      fixed bin(31) value(260);
                              /* Collate info size (256 + 4)         */
 dcl SQL_ACCOUNT_STR_SZ       fixed bin(31) value(199);
                              /* Max accounting string               */
 dcl SQL_DSCVRCOMM_SZ         fixed bin(31) value(35);
                              /* Discover protocols string size      */

 /* After an SQL CONNECT, the 5th token in the SQLCA identifies the  */
 /* DBMS an application has connected to.  The following are values  */
 /* returned from IBM DBMS. */
 dcl SQL_DBMS_ES10_OS2        char value("QOS/2 DBM");
 dcl SQL_DBMS_DB2_OS2         char value("QDB2/2");
 dcl SQL_DBMS_DB2_NT          char value("QDB2/NT");
 dcl SQL_DBMS_DB2_NT64        char value("QDB2/NT64");
 dcl SQL_DBMS_DB2_95          char value("QDB2/Windows 95");
 dcl SQL_DBMS_DB2_AIX         char value("QDB2/6000");
 dcl SQL_DBMS_DB2_AIX64       char value("QDB2/AIX64");
 dcl SQL_DBMS_DB2_AIX_PE      char value("QDB2/6000 PE");
 dcl SQL_DBMS_DB2_HPUX        char value("QDB2/HPUX");
 dcl SQL_DBMS_DB2_HPUX64      char value("QDB2/HP64");
 dcl SQL_DBMS_DB2_SUN         char value("QDB2/SUN");
 dcl SQL_DBMS_DB2_SUN64       char value("QDB2/SUN64");
 dcl SQL_DBMS_DB2_SNI         char value("QDB2/SNI");
 dcl SQL_DBMS_DB2_SCO         char value("QDB2/SCO");
 dcl SQL_DBMS_DB2_SGI         char value("QDB2/SGI");
 dcl SQL_DBMS_DB2_LINUXPPC    char value("QDB2/LINUXPPC");
 dcl SQL_DBMS_DB2_LINUX390    char value("QDB2/LINUX390");
 dcl SQL_DBMS_DB2_LINUX       char value("QDB2/LINUX");
 dcl SQL_DBMS_DB2_DYNIX       char value("QDB2/PTX");
 dcl SQL_DBMS_DB2_MVS         char value("QDB2");
 dcl SQL_DBMS_OS400           char value("QAS");
 dcl SQL_DBMS_SQLDS_VM        char value("QSQLDS/VM");
 dcl SQL_DBMS_SQLDS_VSE       char value("QSQLDS/VSE");
 dcl SQL_DBMS_LU62_SPM        char value("QLU62SPM");

 /* Parameters for Entry Type in sqledinfo */
 dcl SQL_LDAP                 char value('4');
                              /* Database is LDAP                    */
 dcl SQL_DCE                  char value('3');
                              /* Database is DCE                     */
 dcl SQL_HOME                 char value('2');
                              /* Database is Home                    */
 dcl SQL_REMOTE               char value('1');
                              /* Database is Remote                  */
 dcl SQL_INDIRECT             char value('0');
                              /* Database is Indirect                */

 /* Parameters for adapter number in sqlectnd */
 dcl SQL_ADAPTER_0            fixed bin(15) value(0);
                              /* Adapter number 0                    */
 dcl SQL_ADAPTER_1            fixed bin(15) value(1);
                              /* Adapter number 1                    */
 dcl SQL_ADAPTER_MIN          fixed bin(15) value(0);
                              /* Minimum adapter number              */
 dcl SQL_ADAPTER_MAX          fixed bin(15) value(15);
                              /* Maximum adapter number              */

 /* Definitions of constants used for Structure IDs */
 dcl SQL_DCS_STR_ID           fixed bin(16) value('100'xn);
                              /* DCS directory entry id              */
 dcl SQL_NODE_STR_ID          fixed bin(16) value('100'xn);
                              /* Catalog node struct id              */

 /* Parameters for protocol types in sqlectnd       */
 dcl SQL_PROTOCOL_APPC        char value('00'x);
                              /* APPC                                */
 dcl SQL_PROTOCOL_NETB        char value('01'x);
                              /* NETBIOS                             */
 dcl SQL_PROTOCOL_APPN        char value('02'x);
                              /* APPN                                */
 dcl SQL_PROTOCOL_TCPIP       char value('03'x);
                              /* TCPIP                               */
 dcl SQL_PROTOCOL_CPIC        char value('04'x);
                              /* APPC using CPIC                     */
 dcl SQL_PROTOCOL_IPXSPX      char value('05'x);
                              /* IPX/SPX                             */
 dcl SQL_PROTOCOL_LOCAL       char value('06'x);
                              /* Local IPC                           */
 dcl SQL_PROTOCOL_NPIPE       char value('07'x);
                              /* Named Pipe                          */
 dcl SQL_PROTOCOL_SOCKS       char value('08'x);
                              /* TCPIP using SOCKS                   */

 /* Security Type for APPC using CPIC */
 dcl SQL_CPIC_SECURITY_NONE        fixed bin(16) unsigned value(0);
                                   /* None                           */
 dcl SQL_CPIC_SECURITY_SAME        fixed bin(16) unsigned value(1);
                                   /* Same                           */
 dcl SQL_CPIC_SECURITY_PROGRAM     fixed bin(16) unsigned value(2);
                                   /* Program                        */

 /* Security Type for TCPIP */
 dcl SQL_TCPIP_SECURITY_NONE       fixed bin(16) unsigned value(0);
                                   /* None                           */
 dcl SQL_TCPIP_SECURITY_SOCKS      fixed bin(16) unsigned value(1);
                                   /* TCPIP SOCKS Support            */

 /* Authentication Types              */
 dcl SQL_AUTHENTICATION_SERVER     fixed bin(16) unsigned value(0);
                                   /* Authenticate on Server         */
 dcl SQL_AUTHENTICATION_CLIENT     fixed bin(16) unsigned value(1);
                                   /* Authenticate on Client         */
 dcl SQL_AUTHENTICATION_DCS        fixed bin(16) unsigned value(2);
                                   /* Authenticate via DDCS          */
 dcl SQL_AUTHENTICATION_DCE        fixed bin(16) unsigned value(3);
                                   /* Authenticate via DCE           */
 dcl SQL_AUTHENTICATION_SVR_ENCRYPT fixed bin(16) unsigned value(4);
                                   /* Auth at Server with encrypt    */
 dcl SQL_AUTHENTICATION_DCS_ENCRYPT fixed bin(16) unsigned value(5);
                                   /* Auth via DDCS with encrypt     */
 dcl SQL_AUTHENTICATION_DCE_SVR_ENC fixed bin(16) unsigned value(6);
                                   /* Auth via DCE or Server with    */
                                   /* Encrypt (Valid only at server) */
 dcl SQL_AUTHENTICATION_KERBEROS    fixed bin(16) unsigned value(7);
                                   /* Auth via Kerberos              */
 dcl SQL_AUTHENTICATION_KRB_SVR_ENC fixed bin(16) unsigned value(8);
                                   /* Auth via Kerberos or Server    */
                                   /* with Envrypt (Valid only at    */
                                   /* the server                     */
 dcl SQL_AUTHENTICATION_NOT_SPEC   fixed bin(16) unsigned value(255);
                                   /* Authentication Not Specified   */

 /* Parameters for Create Database API Collating Sequences */
 dcl SQL_CS_SYSTEM            fixed bin(31) value(0);
                              /* Coll. Seq. from System              */
 dcl SQL_CS_USER              fixed bin(31) value(-1);
                              /* Coll. Seq. from User                */
 dcl SQL_CS_NONE              fixed bin(31) value(-2);
                              /* Coll. Seq. (None)                   */
 dcl SQL_CS_COMPATIBILITY     fixed bin(31) value(-4);
                              /* Coll. Seq. from pre-v5              */
 dcl SQL_CS_SYSTEM_NLSCHAR    fixed bin(31) value(-8);
                              /* SYSTEM table + NLS function         */
 dcl SQL_CS_USER_NLSCHAR      fixed bin(31) value(-9);
                              /* USER table + NLS function           */
 dcl SQL_CS_IDENTITY_16BIT    fixed bin(31) value(-10);
                              /* UTF-8S collation                    */

 /* Defines for Start Database Manager OPTION parameter and          */
 /* Stop Database Manager OPTION and CALLERAC parameters             */
 dcl SQLE_NONE                fixed bin(32) unsigned value(0);
 dcl SQLE_FORCE               fixed bin(32) unsigned value(1);
 dcl SQLE_DROP                fixed bin(32) unsigned value(2);
 dcl SQLE_CONTINUE            fixed bin(32) unsigned value(3);
 dcl SQLE_TERMINATE           fixed bin(32) unsigned value(4);
 dcl SQLE_ADDNODE             fixed bin(32) unsigned value(5);
 dcl SQLE_RESTART             fixed bin(32) unsigned value(6);
 dcl SQLE_STANDALONE          fixed bin(32) unsigned value(7);

 /* Defines for Start Database Manager & Add Node Tablespace type    */
 dcl SQLE_TABLESPACES_NONE         fixed bin(32) unsigned value(0);
                              /* No Temp Tablespaces                 */
 dcl SQLE_TABLESPACES_LIKE_NODE    fixed bin(32) unsigned value(1);
                              /* Temp Tablespaces like Specified     */
                              /* Node                                */
 dcl SQLE_TABLESPACES_LIKE_CATALOG fixed bin(32) unsigned value(2);
                              /* Temp Tablespaces like Catalog       */
                              /* Node                                */

 /* Parameters for Drop Node Action                                  */
 dcl SQL_DROPNODE_VERIFY      fixed bin(16) unsigned value(1);
                              /* Verify                              */

 /* Parameters for indicating the stored procedure invocation was    */
 /* via the CALL statement */
 dcl SQL_CALLPROC             char value("$SQL$CAL");

 /* Default values for Segmented Tables parameters */
 dcl SQL_DEF_NUMSEGS          fixed bin(31) value(1);
                              /* Default number of segments-nonOS2   */
 dcl SQL_DEF_SEGPAGES         fixed bin(31) value(76800);
                              /* OBSOLETE: Default max pages per     */
                              /* seg                                 */
 dcl SQL_DEF_EXTSIZE          fixed bin(31) value(32);
                              /* default extent size                 */

 /* DUOW Connection Setting types used by sqleqryc() and             */
 /* sqlesetc().Associated values are in sql.cpy, used in common with */
 /* the precompiler. */
 dcl SQL_CONNECT_TYPE         fixed bin(16) unsigned value(1);
                              /* Connect type                        */
 dcl SQL_RULES                fixed bin(16) unsigned value(2);
                              /* Rules for changing connections      */
 dcl SQL_DISCONNECT           fixed bin(16) unsigned value(3);
                              /* Disconnect type at syncpoint        */
 dcl SQL_SYNCPOINT            fixed bin(16) unsigned value(4);
                              /* Syncpoint type                      */
 dcl SQL_MAX_NETBIOS_CONNECTIONS fixed bin(16) unsigned value(5);
                              /* Maximum concurrent connections      */
 dcl SQL_DEFERRED_PREPARE     fixed bin(16) unsigned value(6);
                              /* Maximum concurrent connections      */
 dcl SQL_CONNECT_NODE         fixed bin(16) unsigned value(7);
                              /* Node to connect to                  */
 dcl SQL_ATTACH_NODE          fixed bin(16) unsigned value(8);
                              /* Node to attach to                   */

 /* SET CLIENT INFORMATION types used by sqleseti() and sqleqryi().  */
 dcl SQLE_CLIENT_INFO_USERID     fixed bin(31) value(1);
                              /* Client user name                    */
 dcl SQLE_CLIENT_INFO_WRKSTNNAME fixed bin(31) value(2);
                              /* Client workstation name             */
 dcl SQLE_CLIENT_INFO_APPLNAME   fixed bin(31) value(3);
                              /* Client application name             */
 dcl SQLE_CLIENT_INFO_ACCTSTR    fixed bin(31) value(4);
                              /* Client accounting string            */

 /* SET CLIENT INFORMATION types maximum information lengths         */
 dcl SQLE_CLIENT_USERID_MAX_LEN     fixed bin(31) value(255);
                              /* Maximum client user information     */
                              /* length                              */
 dcl SQLE_CLIENT_WRKSTNNAME_MAX_LEN fixed bin(31) value(255);
                              /* Maximum client workstation          */
                              /* information length                  */
 dcl SQLE_CLIENT_APPLNAME_MAX_LEN   fixed bin(31) value(255);
                              /* Maximum client application          */
                              /* information length                  */
 dcl SQLE_CLIENT_ACCTSTR_MAX_LEN    fixed bin(31) value(200);
                              /* Maximum client accounting           */
                              /* information length                  */

 dcl SQL_PARM_UNCHANGE       char value('U');

 /* A structure to identify an SQL statement.  The eyecatcher  */
 /* $SQL$CALL identifies this as an EXEC SQL CALL statement.*/
 define structure
   1 SQLSTMTID,
     2 sqlcstid   char(8),                  /* eye catcher           */
     2 sqluser    char(8),                  /* creator id            */
     2 pkgname    char(8),                  /* package name          */
     2 contoken   char(8),                  /* consistency token     */
     2 sectnum    fixed bin(15),            /* reserved              */
     2 wchar_info char(1),                  /* reserved              */
     2 fCacheRows char(1),                  /* reserved              */
     2 buffer     char(38) ;                /* reserved              */


 /********************************************************************/
 /** Database Description Block structure                            */
 /********************************************************************/
 /* TableSpace types                                                 */
 dcl SQL_TBS_TYP_SMS          char value('S');
 dcl SQL_TBS_TYP_DMS          char value('D');

 /* TableSpace container types                                       */
 dcl SQL_TBSC_TYP_PATH        char value('P');
                              /* path (directory)  SMS only          */
 dcl SQL_TBSC_TYP_DEV         char value('D');
                              /* device (raw disk) DMS only          */
 dcl SQL_TBSC_TYP_FILE        char value('F');
                              /* file (cooked file) DMS only         */

 dcl SQLE_DBDESC_2            char value("SQLDBD02");
                              /* version 2 database descriptor       */
 dcl SQLE_DBTSDESC_1          char value("SQLTS001");
                              /* version 2 tableSpace descriptor     */

 /* Initial TableSpace names */
 dcl SQLCATTS_NAME            char value("SYSCATSPACE");
                              /* system catalogs                     */
 dcl SQLUSRTS_NAME            char value("USERSPACE1");
                              /* user tables                         */
 dcl SQLTMPTS_NAME            char value("TEMPSPACE1");
                               /* temp tables                        */

 /* tableSpace container descriptor */
 define structure
   1 SQLETSCDESC,
     2 sqlctype char(1),                    /* container type        */
     2 pad1     char(3),                    /* reserved              */
     2 sqlcsize fixed bin(31),              /* container size (4K    */
                                            /* pages)                */
     2 sqlclen  fixed bin(15),              /* length of container   */
                                            /* name                  */
     2 sqlcontr char(SQLB_MAX_CONTAIN_NAME_SZ - 1) varz,
                                            /* container name        */
                                            /* (includes 1 byte for  */
                                            /* C NULL terminator)    */
     2 pad2     char(2) ;                   /* 2 bytes padding       */
                                            /* before next container */

 /* tableSpace descriptor */
 define structure
   1 SQLETSDESC,
     2 sqltsdid char(8),                    /* eyecatcher            */
                                            /* descriptor version    */
     2 sqlextnt fixed bin(31),              /* extent size (in 4K    */
                                            /* pages)                */
     2 sqlprftc fixed bin(31),              /* prefetch size (4K     */
                                            /* pages)                */
     2 sqlpovhd float bin(53),              /* i/o overhead          */
     2 sqltrfrt float bin(53),              /* i/o transfer rate     */
     2 sqltstyp char(1),                    /* tableSpace type       */
     2 pad1     char(1),                    /* reserved              */
     2 sqlccnt  fixed bin(15),              /* container count       */
     2 containr (1) type SQLETSCDESC;       /* array of container    */
                                            /* specs           REFER */

 %SQLETSDESC_SIZE: proc (containerCount) returns (char);
   dcl containerCount char;
   return ('(size (: SQLETSDESC :) + ' ||
            '((' || containerCount || ') - 1) ' ||
            '* size (: SQLETSCDESC :) )');
 %end SQLETSDESC_SIZE;
 %activate SQLETSDESC_SIZE;

 define structure
   1 sqledbdesc,
     2 sqldbdid char(8),                    /* eye catcher           */
     2 sqldbccp fixed bin(31),              /* comment code page     */
     2 sqldbcss fixed bin(31),              /* Source of collating   */
                                            /* seq                   */
     2 sqldbudc char(SQL_CS_SZ),            /* user-defined          */
                                            /* collating seq         */
     2 sqldbcmt char(SQL_CMT_SZ) varz,      /* comment               */
     2 pad      char(1),                    /* reserved              */
     2 sqldbsgp fixed bin(32) unsigned,     /* obsolete: use         */
                                            /* sqltsext              */
     2 sqldbnsg fixed bin(15),              /* number of segments    */
     2 pad2     char(2),                    /* reserved              */
     2 sqltsext fixed bin(31),              /* default extent size   */
     2 sqlcatts handle SQLETSDESC,
     2 sqlusrts handle SQLETSDESC,
     2 sqltmpts handle SQLETSDESC;

 /* Database Directory Scan data structure */
 define structure
   1 sqledinfo,
     2 alias          char(SQL_ALIAS_SZ),   /* Alias name            */
     2 dbname         char(SQL_DBNAME_SZ),  /* Database name         */
     2 drive          char(SQL_DRIVE_SZ),   /* Drive/Path            */
     2 intname        char(SQL_INAME_SZ),   /* Database subdirectory */
     2 nodename       char(SQL_NNAME_SZ),   /* Node name             */
     2 dbtype         char(SQL_DBTYP_SZ),   /* Release information   */
     2 comment        char(SQL_CMT_SZ),     /* Comment               */
     2 com_codepage   fixed bin(15),        /* Code page of comment  */
     2 type           char(1),              /* Entry type - defines  */
                                            /* above                 */
                                            /* Authentication type   */
     2 authentication fixed bin(16) unsigned,/* Global databasename  */
     2 glbdbname      char(SQL_DIR_NAME_SZ),
     2 dceprincipal   char(SQL_DCEPRIN_SZ), /* dce principal bin     */
                                            /* string                */
     2 cat_nodenum    fixed bin(15),        /* Catalog node number   */
     2 nodenum        fixed bin(15);        /* Node number           */


 /* Node Directory Scan data structure */
 define structure
   1 sqleninfo,
     2 nodename      char(SQL_NNAME_SZ),    /* Node name             */
     2 local_lu      char(SQL_LOCLU_SZ),    /* Local_lu_name         */
     2 partner_lu    char(SQL_RMTLU_SZ),    /* Partner_lu_name       */
     2 mode          char(SQL_MODE_SZ),     /* Mode                  */
     2 comment       char(SQL_CMT_SZ),      /* Comment               */
     2 com_codepage  fixed bin(16) unsigned,/* Comment code page     */
     2 adapter       fixed bin(16) unsigned,/* NetBIOS Adapter #     */
     2 networkid     char(SQL_NETID_SZ),    /* APPN Network ID       */
     2 protocol      char(1),               /* Protocol type         */
     2 sym_dest_name char(SQL_SYM_DEST_NAME_SZ),/* CPIC Sym.         */
                                            /* Dest. Name            */
     2 security_type fixed bin(16) unsigned,/* CPIC Security Type    */
     2 hostname      char(SQL_HOSTNAME_SZ), /* TCP/IP Host name      */
     2 service_name  char(SQL_SERVICE_NAME_SZ),/* TCP/IP Service     */
                                             /* name                 */
     2 fileserver    char(SQL_FILESERVER_SZ),/* IPX/SPX fileserver   */
                                             /* name                 */
     2 objectname    char(SQL_OBJECTNAME_SZ),/* IPX/SPX objectname   */
     2 instance_name char(SQL_INSTNAME_SZ),  /* LOCAL Instance       */
                                             /* name                 */
     2 computername  char(SQL_COMPUTERNAME_SZ),/* Computer name      */
     2 system_name   char(SQL_SYSTEM_NAME_SZ), /* System name        */
     2 remote_instname char(SQL_REMOTE_INSTNAME_SZ), /* Remote       */
                                             /* instance name        */
     2 catalog_node_type char(1),            /* Catalog node type    */
     2 os_type       fixed bin(16) unsigned, /* OS type              */
     2 chgpwd_lu     char(SQL_RMTLU_SZ),     /* Change_password_lu   */
                                             /* name                 */
     2 transpn       char(SQL_TPNAME_SZ),    /* TRANSaction_Program  */
                                             /* Name                 */
     2 lanaddr       char(SQL_LANADDRESS_SZ);/* LAN_Adapter_Address  */


 /* General Catalog Node structures and defines */

 define structure
   1 sqle_node_struct,
     2 struct_id  fixed bin(16) unsigned,   /* Structure Identifier  */
     2 codepage   fixed bin(16) unsigned,   /* Codepage for comment  */
     2 comment    char(SQL_CMT_SZ) varz,    /* Comment               */
     2 nodename   char(SQL_NNAME_SZ) varz,  /* Node name             */
     2 protocol   char(1);                  /* Protocol Type         */

 define structure
   1 sqle_node_appc,                        /* For APPC protocol     */
     2 local_lu   char(SQL_LOCLU_SZ) varz,  /* Local_lu name         */
                                            /* Alias Partner_lu      */
     2 partner_lu char(SQL_RMTLU_SZ) varz,  /* name                  */
     2 mode       char(SQL_MODE_SZ) varz;   /* Mode                  */

 define structure
   1 sqle_node_netb,                        /* For NetBIOS Protocol  */
     2 adapter      fixed bin(16) unsigned, /* Adapter Number        */
                                            /* Remote Workstation    */
     2 remote_nname char(SQL_RMTLU_SZ) varz;/* name                  */

 define structure
   1 sqle_node_appn,                        /* For APPN protocol     */
     2 networkid  char(SQL_NETID_SZ) varz,  /* Network ID            */
     2 remote_lu  char(SQL_RMTLU_SZ) varz,  /* Remoter lu name       */
     2 local_lu   char(SQL_LOCLU_SZ) varz,  /* Local_lu name         */
     2 mode       char(SQL_MODE_SZ) varz,   /* Mode                  */
     2 chgpwd_lu  char(SQL_RMTLU_SZ) varz,  /* Change password lu    */
                                            /* name                  */
     2 transpn    char(SQL_TPNAME_SZ) varz, /* Transaction Program   */
                                            /* Name                  */
     2 lanaddr    char(SQL_LANADDRESS_SZ) varz, /* LAN Adapter       */
                                            /* Address               */
     2 security_type fixed bin(16) unsigned;/* Security Type         */

 define structure
   1 sqle_node_tcpip,                      /* For TCPIP protocol     */
     2 hostname     char(SQL_HOSTNAME_SZ) varz,     /* Host name     */
     2 service_name char(SQL_SERVICE_NAME_SZ) varz; /* ServiceName   */


 define structure
   1 sqle_node_npipe,                       /* For NPIPE protocol    */
     2 computername  char(SQL_COMPUTERNAME_SZ) varz,/* Computer name */
     2 instance_name char(SQL_INSTNAME_SZ) varz;    /* Instance Name */

 define structure
    1 sqle_node_local,                      /* For LOCAL protocol    */
      2 instance_name char(SQL_INSTNAME_SZ) varz;   /* Instance Name */

 define structure
    1 sqle_node_cpic,                /* For APPC using CPIC protocol */
      2 sym_dest_name char(SQL_SYM_DEST_NAME_SZ) varz,/* Sym Dest    */
                                                    /* name          */
      2 security_type fixed bin(16) unsigned;       /* Security Type */

 define structure
    1 sqle_node_ipxspx,                     /* For IPX/SPX protocol  */
      2 fileserver char(SQL_FILESERVER_SZ) varz,   /* Fileservername */
      2 objectname char(SQL_OBJECTNAME_SZ) varz;   /* Object name    */


 /* Values for sqlefrce */
 dcl SQL_ASYNCH               fixed bin(16) unsigned value(0);
                              /* Force Mode (Asynchronous)           */
 dcl SQL_ALL_USERS            fixed bin(31) value(-1);
                              /* Force Count (All Users)             */

 /* Values for priority type in sqlesapr */
 dcl SQL_ABSOLUTE_PRIORITY    fixed bin(16) unsigned value(1);
                              /* Absolute (i.e. fixed) Priority      */
 dcl SQL_DELTA_PRIORITY       fixed bin(16) unsigned value(0);
                              /* Delta (i.e. nice) Priority          */

 dcl SQL_PRODNAME_SZ          fixed bin(31) value(30);
                              /* Product name                        */

 define structure
   1 sql_dir_entry,           /* DDCS Directory Entry Data Structure */
     2 struct_id fixed bin(16) unsigned,   /* Structure Identifier   */
     2 release   fixed bin(16) unsigned,   /* Release level of entry */
     2 codepage  fixed bin(16) unsigned,   /* Codepage of comment    */
     2 comment   char(SQL_CMT_SZ) varz,    /* Directory entry comment*/
     2 ldb       char(SQL_DBNAME_SZ) varz, /* Local DB name          */
     2 tdb       char(SQL_LONG_NAME_SZ) varz, /* Target (host)       */
                                           /* DB name                */
     2 ar        char(SQL_AR_SZ) varz,     /* AR library name        */
     2 parm      char(SQL_PARAMETER_SZ) varz; /* Parameter string    */


 /********************************************************************/
 /** Database Codepage and Country code info structures              */
 /********************************************************************/

 define structure
   1 sqledbcinfo,
     2 sqldbcp      char(SQL_CODESET_LEN) varz,/* database codeset   */
     2 sqldbcc      char(SQL_LOCALE_LEN) varz; /* database territory */


 /********************************************************************/
 /** V2 Database Codepage and Country code info structure            */
 /********************************************************************/

 define structure
   1 sqledbcountryinfo,
     2 sqldbcodeset char(SQL_CODESET_LEN) varz,
     2 sqldblocale  char(SQL_LOCALE_LEN) varz; /* database territory */


 define structure
    1 sqle_conn_setting,       /* Connection setting structure for   */
                               /* use with distributed unit of work  */
      2 type  fixed bin(16) unsigned,   /* Connection setting type   */
      2 value fixed bin(16) unsigned;   /* Connection setting value  */

 define structure
   1 sqle_client_info,         /* SET CLIENT Information structure   */
                               /* for use with sqleseti and sqleqryi */
     2 type   fixed bin(16) unsigned, /* information setting type    */
     2 length fixed bin(16) unsigned, /* information setting length  */
     2 pValue pointer;                /* information setting value   */

 /********************************************************************/
 /** Register/Deregister constants and data structures               */
 /********************************************************************/

 /* Defines for LOCATION TO REGISTER parameter                       */
 dcl SQL_NWBINDERY    fixed bin(16) unsigned value(0);

 /* Register/deregister info. for NW bindery data structure          */
 define structure
   1 sqle_reg_nwbindery,
     2 uid            char(SQL_NW_UID_SZ) varz,
     2 reserved_len_1 fixed bin(16) unsigned,
     2 pswd           char(SQL_NW_PSWD_SZ) varz,
     2 reserved_len_2 fixed bin(16) unsigned;


 /********************************************************************/
 /* Start/Stop Database Manager constants and data structures        */
 /********************************************************************/
 /* V5 Start Options structure Eye Catcher value */
 dcl SQLE_STARTOPTID_V51    char value("SQLOPT01");

 /* V5 Start Database Manager structure */
 define structure
   1 sqle_start_options,
     2 sqloptid   char(8),                  /* Structure Eye Catcher  */
     2 isprofile  fixed bin(32) unsigned,   /* Profile specified?     */
     2 profile    char(SQL_PROFILE_SZ) varz,/* Profile                */
     2 isnodenum  fixed bin(32) unsigned,   /* Node number specified? */
     2 nodenum    type SQL_PDB_NODE_TYPE,   /* Node number            */
     2 option     fixed bin(32) unsigned,   /* Start option           */
     2 ishostname fixed bin(32) unsigned,   /* Hostname specified?    */
     2 hostname   char(SQL_HOSTNAME_SZ) varz,/* Hostname              */
     2 isport     fixed bin(32) unsigned,   /* Port specified?        */
     2 port       type SQL_PDB_PORT_TYPE,   /* Port                   */
     2 isnetname  fixed bin(32) unsigned,   /* Netname specified?     */
     2 netname    char(SQL_HOSTNAME_SZ) varz,/* Netname               */
     2 tblspace_type fixed bin(32) unsigned, /* Addnode tbspace type  */
     2 tblspace_node type SQL_PDB_NODE_TYPE, /* Addnode tbspace node  */
     2 iscomputer fixed bin(32) unsigned,  /* Computername specified? */
     2 computer   char(SQL_COMPUTERNAME_SZ) varz,
     2 pUserName  pointer,                 /* Logon Account user name */
     2 pPassword  pointer;                 /* Logon Account password  */


 /* V5 Stop Database Manager structure */
 define structure
   1 sqledbstopopt,
     2 isprofile  fixed bin(32) unsigned,   /* Profile specified?     */
     2 profile    char(SQL_PROFILE_SZ) varz,/* Profile                */
     2 isnodenum  fixed bin(32) unsigned,   /* Node number specified? */
     2 nodenum    type SQL_PDB_NODE_TYPE,   /* Node number            */
     2 option     fixed bin(32) unsigned,   /* Option                 */
     2 callerac   fixed bin(32) unsigned;   /* Caller action          */


 /*********************************************************************/
 /** Add Node data structures                                         */
 /*********************************************************************/

 /* V5 Add Node Option structure Eye Catcher value */
 dcl SQLE_ADDOPTID_V51 char value("SQLADD01");

 /* Add Node structure                             */
 define structure
   1 sqle_addn_options,
     2 sqladdid      char(8),               /* Structure Eye Catcher  */
     2 tblspace_type fixed bin(32) unsigned,/* Temp Tablespace Type   */
     2 tblspace_node type SQL_PDB_NODE_TYPE;/* Temp Tablespace Node   */


 %dcl SQLZ_STACK char ext;
 %if SQLZ_STACK ^= '' %then %do;
 dcl SQLENOP fixed bin(31) value(0);
 %end; %else %do;

 /********************************************************************/
 /** Database Environment Commands -- Function Prototypes            */
 /********************************************************************/

 %dcl SQL_REL_10 char ext;
 %if SQL_REL_10 ^= '' %then %do;
 sqledrpd: proc (dbn, pw, ca)
           returns (type SQL_API_RC byvalue optional)
           options (inline) internal;
   dcl dbn char (*) varz byaddr,
       pw  char (*) varz byaddr optional,
       ca  pointer byvalue; /* to SQLCA */
   return (sqledrpd_api (dbn, pw, ca));
 end sqledrpd;
 %end;  %else %do;
 sqledrpd: proc (dbn, ca)
           returns (type SQL_API_RC byvalue optional)
           options (inline) internal;
   dcl dbn char (*) varz byaddr,
       ca  pointer byvalue; /* to SQLCA */
   return (sqledrpd_api (dbn, *, ca));
 end sqledrpd;
 %end;

 /* Whereas C needs macros, PL/I just needs preprocessor vars */
 %dcl sqlectdd char;   %sqlectdd = 'sqlectdd_api';
 %dcl sqlecadb char;   %sqlecadb = 'sqlecadb_api';
 %dcl sqlectnd char;   %sqlectnd = 'sqlectnd_api';
 %dcl sqledbcr char;   %sqledbcr = 'sqledbcr_api';
 %dcl sqledcgd char;   %sqledcgd = 'sqledcgd_api';
 %dcl sqledcls char;   %sqledcls = 'sqledcls_api';
 %dcl sqledgne char;   %sqledgne = 'sqledgne_api';
 %dcl sqledosd char;   %sqledosd = 'sqledosd_api';
 %dcl sqlefrce char;   %sqlefrce = 'sqlefrce_api';
 %dcl sqlegdad char;   %sqlegdad = 'sqlegdad_api';
 %dcl sqlegdcl char;   %sqlegdcl = 'sqlegdcl_api';
 %dcl sqlegdel char;   %sqlegdel = 'sqlegdel_api';
 %dcl sqlegdge char;   %sqlegdge = 'sqlegdge_api';
 %dcl sqlegdgt char;   %sqlegdgt = 'sqlegdgt_api';
 %dcl sqlegdsc char;   %sqlegdsc = 'sqlegdsc_api';
 %dcl sqlegins char;   %sqlegins = 'sqlegins_api';
 %dcl sqlesdeg char;   %sqlesdeg = 'sqlesdeg_api';

 %dcl sqleregs char;   %sqleregs = 'sqleregs_api';
 %dcl sqledreg char;   %sqledreg = 'sqledreg_api';
 %dcl sqleintr char;   %sqleintr = 'sqleintr_api';
 %dcl sqleisig char;   %sqleisig = 'sqleisig_api';
 %dcl sqlefmem char;   %sqlefmem = 'sqlefmem_api';
 %dcl sqlemgdb char;   %sqlemgdb = 'sqlemgdb_api';
 %dcl sqle_activate_db   char;
                       %sqle_activate_db   = 'sqle_activate_db_api';
 %dcl sqle_deactivate_db char;
                       %sqle_deactivate_db = 'sqle_deactivate_db_api';
 %dcl sqlencls char;   %sqlencls = 'sqlencls_api';
 %dcl sqlengne char;   %sqlengne = 'sqlengne_api';
 %dcl sqlenops char;   %sqlenops = 'sqlenops_api';
 %dcl sqleproc char;   %sqleproc = 'sqleproc_api';
 %dcl sqlepstr char;   %sqlepstr = 'sqlepstr_api';
 %dcl sqlepstp char;   %sqlepstp = 'sqlepstp_api';
 %dcl sqlepstart char; %sqlepstart = 'sqlepstart_api';
 %dcl sqlerstd char;   %sqlerstd = 'sqlerstd_api';
 %dcl sqlesapr char;   %sqlesapr = 'sqlesapr_api';
 %dcl sqlestar char;   %sqlestar = 'sqlestar_api';
 %dcl sqlestop char;   %sqlestop = 'sqlestop_api';
 %dcl sqleuncd char;   %sqleuncd = 'sqleuncd_api';
 %dcl sqleuncn char;   %sqleuncn = 'sqleuncn_api';
 %dcl sqlesetc char;   %sqlesetc = 'sqlesetc_api';
 %dcl sqleqryc char;   %sqleqryc = 'sqleqryc_api';
 %dcl sqleseti char;   %sqleseti = 'sqleseti_api';
 %dcl sqleqryi char;   %sqleqryi = 'sqleqryi_api';
 %dcl sqleatcp char;   %sqleatcp = 'sqleatcp_api';
 %dcl sqleatin char;   %sqleatin = 'sqleatin_api';
 %dcl sqledtin char;   %sqledtin = 'sqledtin_api';
 %dcl sqlecrea char;   %sqlecrea = 'sqlecrea_api';
 %dcl sqlesact char;   %sqlesact = 'sqlesact_api';
 %dcl sqleaddn char;   %sqleaddn = 'sqleaddn_api';
 %dcl sqlecran char;   %sqlecran = 'sqlecran_api';
 %dcl sqledpan char;   %sqledpan = 'sqledpan_api';
 %dcl sqledrpn char;   %sqledrpn = 'sqledrpn_api';
 %end; /* SQLZ_STACK = '' */


 dcl sqlectdd_api                         /* Catalog Database        */
     entry (char(*) varz byaddr,          /* database                */
            char(*) varz byaddr,          /* alias                   */
            char(1),                      /* type                    */
            char(*) varz byaddr optional, /* node name               */
            char(*) varz byaddr optional, /* drive/path              */
            char(*) varz byaddr optional, /* comment                 */
            fixed bin(16) unsigned,       /* authentication          */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlectdd_api');

 dcl sqlecadb_api                         /* Catalog Database        */
     entry (char(*) varz byaddr,          /* database                */
            char(*) varz byaddr,          /* alias                   */
            char(1),                      /* type                    */
            char(*) varz byaddr optional, /* node name               */
            char(*) varz byaddr optional, /* drive/path              */
            char(*) varz byaddr optional, /* comment                 */
            fixed bin(16) unsigned,       /* authentication          */
            char(*) varz byaddr optional, /* DCE principal name if   */
                                          /* auth=DCE                */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlecadb_api');

 dcl sqlectnd_api                         /* Catalog Node            */
     entry (type sqle_node_struct byaddr, /* node structure ptr      */
            pointer,                      /* protocol structure ptr  */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlectnd_api');

 dcl sqledcgd_api                         /* Change Database Comment */
     entry (char(*) varz byaddr,          /* database alias          */
            char(*) varz byaddr optional, /* drive/path              */
            char(*) varz byaddr optional, /* comment                 */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqledcgd_api');

 dcl sqledcls_api                         /* Close Directory Scan    */
     entry (fixed bin(16) unsigned,       /* handle                  */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqledcls_api');

 dcl sqledgne_api                         /* Get Next Directory Entry*/
     entry (fixed bin(16) unsigned,       /* handle                  */
            handle sqledinfo byaddr,      /* buffer                  */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqledgne_api');

 dcl sqledosd_api                         /* Open Directory Scan     */
     entry (char(*) varz byaddr optional, /* drive/path              */
            fixed bin(16) unsigned byaddr,/* handle                  */
            fixed bin(16) unsigned byaddr,/* count                   */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqledosd_api');

 dcl sqledrpd_api                         /* Drop Database           */
     entry (char (*) varz byaddr,         /* database alias          */
            char (*) varz byaddr optional,/* reserved                */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqledrpd_api');

 dcl sqlesdeg_api                         /* Set intra query         */
                                          /* parallelism degree      */
     entry (fixed bin(31),                /* no. of agents to update */
            (*) fixed bin(32) unsigned byaddr optional,
                                          /* array of agent ids      */
            fixed bin(31),                /* degree of parallelism   */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlesdeg_api');

 dcl sqlefrce_api                         /* Force Users             */
     entry (fixed bin(31),                /* number of users to force*/
            (*) fixed bin(32) unsigned byaddr optional,
                                          /* array of agent ids      */
            fixed bin(16) unsigned,       /* mode of operation       */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlefrce_api');

 dcl sqlegdad_api                         /* Catalog DCS Database    */
      entry (type sql_dir_entry byaddr,   /* ptr to entry structure  */
             pointer)                     /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlegdad_api');

 dcl sqlegdcl_api                         /* Close DCS Directory Scan*/
     entry (pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlegdcl_api');

 dcl sqlegdel_api                         /* Uncatalog DCS Database  */
     entry (type sql_dir_entry byaddr,    /* ptr to entry structure  */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlegdel_api');

 dcl sqlegdge_api                         /* Get DCS Directory Entry */
                                          /* For Database            */
     entry (type sql_dir_entry byaddr,    /* ptr to entry structure  */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlegdge_api');

 dcl sqlegdgt_api                       /* Get DCS Directory Entries */
     entry (fixed bin(16) unsigned byaddr,/* ptr to count variable   */
            (*) type sql_dir_entry byaddr,/* ptr to entry structure  */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlegdgt_api');

 dcl sqlegdsc_api                         /* Open DCS Directory Scan */
     entry (fixed bin(16) unsigned byaddr,/* ptr to count variable   */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlegdsc_api');

 dcl sqlegins_api                         /* Get Instance            */
     entry (char(*) varz byaddr,          /* ptr to instance name    */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlegins_api');

 dcl sqleintr_api                         /* Interrupt               */
     entry ()
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqleintr_api');

 dcl sqleisig_api                         /* Install Signal Handler  */
     entry (pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqleisig_api');

 dcl sqlefmem_api                         /* Free Memory             */
     entry (pointer,                      /* SQLCA                   */
            pointer)                      /* buffer pointer          */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlefmem_api');

 dcl sqlemgdb_api                         /* Migrate Database        */
     entry (char(*) varz byaddr,          /* database alias          */
            char(*) varz byaddr optional, /* user name               */
            char(*) varz byaddr optional, /* password                */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlemgdb_api');

 dcl sqle_activate_db_api                 /* Activate Database       */
     entry (char(*) varz byaddr,          /* database alias          */
            char(*) varz byaddr optional, /* user name               */
            char(*) varz byaddr optional, /* password                */
            pointer,                      /* reserved for future use */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqle_activate_db_api');

 dcl sqle_deactivate_db_api               /* Deactivate Database     */
     entry (char(*) varz byaddr,          /* database alias          */
            char(*) varz byaddr optional, /* user name               */
            char(*) varz byaddr optional, /* password                */
            pointer,                      /* reserved for future use */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqle_deactivate_db_api');

 dcl sqlencls_api                       /* Close Node Directory Scan */
     entry (fixed bin(16) unsigned,       /* handle                  */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlencls_api');

 dcl sqlengne_api                         /* Get Next Node Directory */
                                          /* Entry                   */
     entry (fixed bin(16) unsigned,       /* handle                  */
            handle sqleninfo byaddr,      /* buffer                  */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlengne_api');

 dcl sqlenops_api                         /* Open Node Directory Scan*/
     entry (fixed bin(16) unsigned byaddr,/* handle                  */
            fixed bin(16) unsigned byaddr,/* count                   */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlenops_api');

 dcl sqleproc_api                         /* Database Application    */
                                          /* Remote Interface        */
     entry (char(*) varz byaddr,          /* Path of program to run  */
            handle sqlchar,               /* variable length area ptr*/
            pointer,                      /* input SQLDA             */
            pointer,                      /* output SQLDA            */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqleproc_api');

 dcl sqlerstd_api                         /* Restart Database        */
     entry (char(*) varz byaddr,          /* database alias          */
            char(*) varz byaddr optional, /* user name               */
            char(*) varz byaddr optional, /* password                */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlerstd_api');

 dcl sqlepstart_api                     /* V5 Start Database Manager */
     entry (type sqle_start_options byaddr, /* start options         */
            pointer)                        /* SQLCA                 */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlepstart_api');

 dcl sqlepstp_api                         /* V5 Stop Database Manager*/
     entry (type sqledbstopopt byaddr,    /* STOP OPTIONS            */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlepstp_api');

 dcl sqleuncd_api                         /* Uncatalog Database      */
     entry (char(*) varz byaddr,          /* database alias          */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqleuncd_api');

 dcl sqleuncn_api                         /* Uncatalog Node          */
     entry (char(*) varz byaddr,          /* node name               */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqleuncn_api');

 dcl sqlesetc_api                         /* Set Client              */
     entry ((*) type sqle_conn_setting byaddr, /* conn setting array */
            fixed bin(16) unsigned,       /* number of settings      */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlesetc_api');

 dcl sqleqryc_api                         /* Query Client            */
     entry ((*) type sqle_conn_setting byaddr, /* conn setting array */
            fixed bin(16) unsigned,       /* number of settings      */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqleqryc_api');

 dcl sqleseti_api                         /* Set Client Information  */
     entry (fixed bin(16) unsigned,       /* database alias length   */
            char(*) varz byaddr optional, /* database alias          */
            fixed bin(16) unsigned,       /* number of types to set  */
            (*) type sqle_client_info byaddr, /* information to set  */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqleseti_api');

 dcl sqleqryi_api                         /* Query Client Information*/
     entry (fixed bin(16) unsigned,       /* database alias length   */
            char(*) varz byaddr optional, /* database alias          */
            fixed bin(16) unsigned,       /* number of types to set  */
            (*) type sqle_client_info byaddr,/* information to query */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqleqryi_api');

 dcl sqlecrea_api                         /* Create Database         */
     entry (char(*) varz byaddr,          /* database                */
            char(*) varz byaddr,          /* local alias             */
            char(*) varz byaddr optional, /* drive/path              */
            type sqledbdesc byaddr,      /* database descriptor block*/
            type sqledbcountryinfo byaddr,/* db locale and codeset   */
            char(1),                      /* reserved                */
            pointer,                      /* reserved                */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlecrea_api');

 dcl sqleatcp_api                         /* Attach                  */
     entry (char (*) varz byaddr optional,/* node name               */
            char (*) varz byaddr optional,/* user name               */
            char (*) varz byaddr optional,/* password                */
            char (*) varz byaddr optional,/* new password            */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqleatcp_api');

 dcl sqleatin_api                         /* Attach                  */
     entry (char (*) varz byaddr optional,/* node name               */
            char (*) varz byaddr optional,/* user name               */
            char (*) varz byaddr optional,/* password                */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqleatin_api');

 dcl sqledtin_api                         /* Detach                  */
     entry (pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqledtin_api');

 dcl sqlesact_api                         /* Set Accounting String   */
     entry (char (*) varz byaddr,         /* accounting string       */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlesact_api');

 dcl sqleregs_api                         /* Register DB2 Server     */
     entry (fixed bin(16) unsigned,       /* location at which to reg*/
            pointer,                      /* register info.          */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqleregs_api');

 dcl sqledreg_api                         /* Deregister DB2 Server   */
     entry (fixed bin(16) unsigned,     /* location at which to dereg*/
            pointer,                      /* deregister info.        */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqledreg_api');

 dcl sqleaddn_api                         /* Add Node                */
     entry (pointer,                      /* add node options        */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqleaddn_api');

 dcl sqlecran_api                         /* Create Database at Node */
     entry (char(*) varz byaddr,          /* database name           */
            pointer,                      /* reserved                */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlecran_api');

 dcl sqledpan_api                         /* Drop Database at Node   */
     entry (char(*) varz byaddr,          /* database alias          */
            pointer,                      /* reserved                */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqledpan_api');

 dcl sqledrpn_api                         /* Drop Node Verify        */
     entry (fixed bin(16) unsigned,       /* Action                  */
            pointer,                      /* reserved                */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqledrpn_api');

 dcl sqlesapr_api                         /* Set Application Priority*/
     entry (fixed bin(32) unsigned,   /* agentid of application coord*/
            fixed bin(31),                /* priority level          */
            fixed bin(16) unsigned,       /* priority type           */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlesapr_api');


 /* GENERIC INTERFACES          */

 dcl sqlgdcgd                             /* Change Database Comment */
     entry (fixed bin(16) unsigned,       /* comment length          */
            fixed bin(16) unsigned,       /* drive/path length       */
            fixed bin(16) unsigned,       /* database length         */
            pointer,                      /* SQLCA                   */
            char(*) varz byaddr optional, /* comment                 */
            char(*) varz byaddr optional, /* drive/path              */
            char(*) varz byaddr)          /* database                */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlgdcgd');

 dcl sqlgdcls                             /* Close Directory Scan    */
     entry (fixed bin(16) unsigned,       /* handle                  */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlgdcls');

 dcl sqlgdgne                             /* Get Next Database       */
                                          /* Directory Entry         */
     entry (fixed bin(16) unsigned,       /* handle                  */
            handle sqledinfo byaddr,      /* buffer                  */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlgdgne');

 dcl sqlgdrpd                             /* Drop Database           */
     entry (fixed bin(16) unsigned,       /* reserved                */
            fixed bin(16) unsigned,       /* database alias length   */
            pointer,                      /* SQLCA                   */
            pointer,                      /* reserved                */
            char(*) varz byaddr)          /* database alias          */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlgdrpd');

 dcl sqlgdosd                             /* Open Directory Scan     */
     entry (fixed bin(16) unsigned,       /* drive/path length       */
            pointer,                      /* SQLCA                   */
            fixed bin(16) unsigned byaddr,/* count                   */
            fixed bin(16) unsigned byaddr,/* handle                  */
            char(*) varz byaddr optional) /* drive/path              */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlgdosd');

 dcl sqlgsdeg                             /* Set parallelism degree  */
     entry (pointer,                      /* SQLCA                   */
            fixed bin (31),               /* mode of operation       */
            (*) fixed bin(32) unsigned byaddr optional,
                                          /* array of agent ids      */
            fixed bin (31))               /* num of users to force   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlgsdeg');

 dcl sqlgfrce                             /* Force Users             */
     entry (pointer,                      /* SQLCA                   */
            fixed bin(16) unsigned,       /* mode of operation       */
            (*) fixed bin(32) unsigned byaddr optional,
                                          /* array of agent ids      */
            fixed bin(31))                /* num of users to force   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlgfrce');

 dcl sqlggdad                             /* Catalog DCS Database    */
     entry (pointer,                      /* SQLCA                   */
            type sql_dir_entry byaddr)    /* directory entry         */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlggdad');


 dcl sqlggdcl                             /* Close DCS Directory Scan*/
     entry (pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlggdcl');

 dcl sqlggdel                             /* Uncatalog DCS Database  */
     entry (pointer,                      /* SQLCA                   */
            type sql_dir_entry byaddr)    /* directory entry         */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlggdel');

 dcl sqlggdge                             /* Get DCS Directory Entry */
                                          /* For Database            */
     entry (pointer,                      /* SQLCA                   */
            type sql_dir_entry byaddr)    /* directory entry         */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlggdge');

 dcl sqlggdgt                           /* Get DCS Directory Entries */
     entry (pointer,                      /* SQLCA                   */
            fixed bin(16) unsigned,       /* count variable          */
            type sql_dir_entry byaddr)    /* entry structure         */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlggdgt');

 dcl sqlggdsc                             /* Open DCS Directory Scan */
     entry (pointer,                      /* SQLCA                   */
            fixed bin(16) unsigned)       /* count variable          */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlggdsc');

 dcl sqlggins                             /* Get Instance            */
     entry (pointer,                      /* SQLCA                   */
            char(*) varz byaddr)          /* pointer to instance name*/
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlggins');

 dcl sqlgctdd                             /* Catalog Database        */
     entry (fixed bin(16) unsigned,       /* comment length          */
            fixed bin(16) unsigned,       /* drive/path length       */
            fixed bin(16) unsigned,       /* node name length        */
            fixed bin(16) unsigned,       /* alias length            */
            fixed bin(16) unsigned,       /* database length         */
            pointer,                      /* SQLCA                   */
            fixed bin(16) unsigned,       /* authentication          */
            char(*) varz byaddr optional, /* comment                 */
            char(*) varz byaddr optional, /* drive/path              */
            char(*) varz byaddr optional, /* node name               */
            char (1),                     /* type                    */
            char(*) varz byaddr,          /* alias                   */
            char(*) varz byaddr)          /* database                */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlgctdd');

 dcl sqlgcadb                             /* Catalog Database        */
     entry (fixed bin(16) unsigned,       /* DCE principal length    */
            fixed bin(16) unsigned,       /* comment length          */
            fixed bin(16) unsigned,       /* drive/path length       */
            fixed bin(16) unsigned,       /* node name length        */
            fixed bin(16) unsigned,       /* alias length            */
            fixed bin(16) unsigned,       /* database length         */
            pointer,                      /* SQLCA                   */
            char(*) varz byaddr optional, /* DCE Principal Name      */
            fixed bin(16) unsigned,       /* authentication          */
            char(*) varz byaddr optional, /* comment                 */
            char(*) varz byaddr optional, /* drive/path              */
            char(*) varz byaddr optional, /* node name               */
            char (1),                     /* type                    */
            char(*) varz byaddr,          /* alias                   */
            char(*) varz byaddr)          /* database                */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlgcadb');

 dcl sqlgctnd                             /* Catalog Node            */
     entry (pointer,                      /* SQLCA                   */
            type sqle_node_struct byaddr, /* node structure          */
            pointer)                      /* Protocol Structure      */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlgctnd');

 dcl sqlgintr                             /* Interrupt               */
     entry ()
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlgintr');

 dcl sqlgisig                             /* Install Signal Handler  */
     entry (pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlgisig');

 dcl sqlgmgdb                             /* Migrate Database        */
     entry (fixed bin(16) unsigned,       /* password length         */
            fixed bin(16) unsigned,       /* user name length        */
            fixed bin(16) unsigned,       /* database alias length   */
            pointer,                      /* SQLCA                   */
            char(*) varz byaddr optional, /* password                */
            char(*) varz byaddr optional, /* user name               */
            char(*) varz byaddr)          /* database alias          */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlgmgdb');

 dcl sqlg_activate_db                     /* Activate Database       */
     entry (fixed bin(16) unsigned,       /* database alias length   */
            fixed bin(16) unsigned,       /* user name length        */
            fixed bin(16) unsigned,       /* password length         */
            char(*) varz byaddr,          /* database alias          */
            char(*) varz byaddr optional, /* user name               */
            char(*) varz byaddr optional, /* password                */
            pointer,                      /* reserved                */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlg_activate_db');

 dcl sqlg_deactivate_db                   /* Deactivate Database     */
     entry (fixed bin(16) unsigned,       /* database alias length   */
            fixed bin(16) unsigned,       /* user name length        */
            fixed bin(16) unsigned,       /* password length         */
            char(*) varz byaddr,          /* database alias          */
            char(*) varz byaddr optional, /* user name               */
            char(*) varz byaddr optional, /* password                */
            pointer,                      /* reserved                */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlg_deactivate_db');

 dcl sqlgncls                           /* Close Node Directory Scan */
     entry (fixed bin(16) unsigned,       /* handle                  */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlgncls');

 dcl sqlgngne                             /* Get Next Node Directory */
                                          /* Entry                   */
     entry (fixed bin(16) unsigned,       /* handle                  */
            handle sqleninfo byaddr,      /* buffer                  */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlgngne');

 dcl sqlgnops                             /* Open Node Directory Scan*/
     entry (fixed bin(16) unsigned byaddr,/* handle                  */
            fixed bin(16) unsigned byaddr,/* count                   */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlgnops');

 dcl sqlgproc                             /* Database Application    */
                                          /* Remote Interface        */
     entry (fixed bin(16) unsigned,       /* program name length     */
            pointer,                      /* SQLCA                   */
            char(*) varz byaddr,          /* Path of program to run  */
            pointer,                      /* input SQLDA             */
            pointer,                      /* output SQLDA            */
            handle sqlchar)               /* variable length area ptr*/
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlgproc');

 dcl sqlgrstd                             /* Restart Database        */
     entry (fixed bin(16) unsigned,       /* password length         */
            fixed bin(16) unsigned,       /* user name length        */
            fixed bin(16) unsigned,       /* database alias length   */
            pointer,                      /* SQLCA                   */
            char(*) varz byaddr optional, /* password                */
            char(*) varz byaddr optional, /* user name               */
            char(*) varz byaddr)          /* database alias          */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlgrstd');

 dcl sqlgsetc                             /* Set Client              */
     entry ((*) type sqle_conn_setting byaddr, /* conn setting array */
            fixed bin(16) unsigned,       /* number of settings      */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlgsetc');

 dcl sqlgqryc                             /* Query Client            */
     entry ((*) type sqle_conn_setting byaddr, /* conn setting array */
            fixed bin(16) unsigned,       /* number of settings      */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlgqryc');

 dcl sqlgcrea                             /* Create Database         */
     entry (fixed bin(16) unsigned,       /* drive/path length       */
            fixed bin(16) unsigned,       /* local alias length      */
            fixed bin(16) unsigned,       /* database length         */
            pointer,                      /* SQLCA                   */
            pointer,                      /* reserved                */
            fixed bin(16) unsigned,       /* reserved                */
            type sqledbcountryinfo byaddr,/* db locale and codeset   */
            type sqledbdesc byaddr,       /* db description block    */
            char(*) varz byaddr optional, /* drive/path              */
            char(*) varz byaddr optional, /* local alias             */
            char(*) varz byaddr)          /* database                */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlgcrea');

 dcl sqlgatin                             /* Attach                  */
     entry (fixed bin(16) unsigned,       /* password length         */
            fixed bin(16) unsigned,       /* user name length        */
            fixed bin(16) unsigned,       /* node name length        */
            pointer,                      /* SQLCA                   */
            char(*) varz byaddr optional, /* password                */
            char(*) varz byaddr optional, /* user name               */
            char(*) varz byaddr optional) /* node name               */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlgatin');

 dcl sqlgdtin                             /* Detach                  */
     entry (pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlgdtin');

 dcl sqlgpstart                         /* V5 Start Database Manager */
     entry (type sqle_start_options byaddr, /* start options         */
            pointer)                        /* SQLCA                 */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlepstart');

 dcl sqlgpstp                             /* V5 Stop Database Manager*/
     entry (type sqledbstopopt byaddr,    /* STOP OPTIONS            */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlgpstp');

 dcl sqlguncd                             /* Uncatalog Database      */
     entry (fixed bin(16) unsigned,       /* database alias length   */
            pointer,                      /* SQLCA                   */
            char(*) varz byaddr)          /* database alias          */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlguncd');

 dcl sqlguncn                             /* Uncatalog Node          */
     entry (fixed bin(16) unsigned,       /* node name length        */
            pointer,                      /* SQLCA                   */
            char(*) varz byaddr)          /* node name               */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlguncn');

 dcl sqlgsact                             /* Set Accounting String   */
     entry (fixed bin(16) unsigned,       /* accounting string length*/
            char(*) varz byaddr,          /* accounting string       */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlgsact');

 dcl sqlgregs                             /* Register DB2 Server     */
     entry (fixed bin(16) unsigned,       /* location at which to reg*/
            pointer,                      /* register info.          */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlgregs');

 dcl sqlgdreg                             /* Deregister DB2 Server   */
     entry (fixed bin(16) unsigned,     /* location at which to dereg*/
            pointer,                      /* deregister info.        */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlgdreg');

 dcl sqlgfmem                             /* Free Memory             */
     entry (pointer,                      /* SQLCA                   */
            pointer)                      /* buffer pointer          */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlgfmem');

 dcl sqlgaddn                             /* Add Node                */
     entry (fixed bin(16) unsigned,       /* options length          */
            pointer,                      /* SQLCA                   */
            pointer)                      /* add node options        */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlgaddn');

 dcl sqlgcran                             /* Create Database at Node */
     entry (fixed bin(16) unsigned,       /* reserved length         */
            fixed bin(16) unsigned,       /* database name length    */
            pointer,                      /* SQLCA                   */
            pointer,                      /* reserved                */
            char(*) varz byaddr)          /* database name           */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlgcran');

 dcl sqlgdpan                             /* Drop Database at Node   */
     entry (fixed bin(16) unsigned,       /* reserved length         */
            fixed bin(16) unsigned,       /* database alias length   */
            pointer,                      /* SQLCA                   */
            pointer,                      /* reserved                */
            char(*) varz byaddr)          /* database alias          */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlgdpan');

 dcl sqlgdrpn
     entry (fixed bin(16) unsigned,       /* reserved length         */
            pointer,                      /* SQLCA                   */
            pointer,                      /* reserved                */
            fixed bin(16) unsigned)          /* Action               */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlgdrpn');

 /* SQL Return Codes in SQLCODE for Environment Commands */

 %dcl #SQL_RC_OK char ext;
 %if #SQL_RC_OK = '' %then %do;
 %#SQL_RC_OK = 'Y';
 dcl SQL_RC_OK fixed bin (31) value(0);  /* everything is OK         */
 %end;

 %dcl #SQL_RC_INVALID_SQLCA char ext;
 %if #SQL_RC_INVALID_SQLCA = '' %then %do;
 %#SQL_RC_INVALID_SQLCA = 'Y';
 dcl SQL_RC_INVALID_SQLCA fixed bin (31) value (-1); /* invalid sqlca */
 %end;

 dcl SQLE_RC_STILL_EXECUTING        fixed bin(31) value(16);
                                    /* Request is still executing    */
 dcl SQLE_RC_INLUW                  fixed bin(31) value(-752);
                                    /* Connect to other DB not       */
                                    /* allowed                       */
 dcl SQLE_RC_W863                   fixed bin(31) value(863);
                                    /* Only SBCS data allowed        */

 dcl SQLE_RC_E953                   fixed bin(31) value(-953);
                                    /* Agent heap too small          */
 dcl SQLE_RC_E957                   fixed bin(31) value(-957);
                                    /* Requestor comm heap too       */
                                    /* small                         */
 dcl SQLE_RC_E959                   fixed bin(31) value(-959);
                                    /* Server comm heap too small    */
 dcl SQLE_RC_E961                   fixed bin(31) value(-961);
                                    /* Rqstr remote svcs heap too    */
                                    /* small                         */
 dcl SQLE_RC_E962                   fixed bin(31) value(-962);
                                    /* Svr remote svcs heap too      */
                                    /* small                         */

 dcl SQLE_RC_NO_APP_CTRL_SEG        fixed bin(31) value(-987);
                                    /* Application control shared    */
                                    /* memory set cannot be          */
                                    /* allocated                     */
 dcl SQLE_RC_INVNEWLOGP             fixed bin(31) value(993);
                                    /* New log path is invalid       */
 dcl SQLE_RC_INVLOGP                fixed bin(31) value(995);
                                    /* Current log path is invalid   */

 dcl SQLE_RC_INVALIAS               fixed bin(31) value(-1000);
                                    /* Invalid alias                 */
 dcl SQLE_RC_INVDBNAME              fixed bin(31) value(-1001);
                                    /* Invalid database name         */
 dcl SQLE_RC_INVDRIVE               fixed bin(31) value(-1002);
                                    /* Invalid drive                 */

 dcl SQLE_RC_INVPSW_DB2OS2          fixed bin(31) value(-1003);
                                    /* Invalid password - OS/2       */
 dcl SQLE_RC_INVPSW_DB2NT           fixed bin(31) value(-1003);
                                    /* Invalid password - NT         */
 dcl SQLE_RC_INVPSW_DB2DOS          fixed bin(31) value(-1003);
                                    /* Invalid password - DOS        */
 dcl SQLE_RC_INVPSW_DB2WIN          fixed bin(31) value(-1003);
                                    /* Invalid password - Windows    */
 dcl SQLE_RC_INVPSW_DB2MAC          fixed bin(31) value(-1003);
                                    /* Invalid password - Mac        */
 dcl SQLE_RC_INVPSW_DB2AIX          fixed bin(31) value(-10002);
                                    /* Invalid password - AIX        */
 dcl SQLE_RC_INVPSW                 fixed bin(31)
                                    value(SQLE_RC_INVPSW_DB2NT);

 dcl SQLE_RC_INSSTOR                fixed bin(31) value(-1004);
                                    /* Insuf storage on file system  */
 dcl SQLE_RC_DUPALIAS               fixed bin(31) value(-1005);
                                    /* Duplicate alias               */
 dcl SQLE_RC_WRONGCODEPG            fixed bin(31) value(-1006);
                                    /* Appl code page does not       */
                                    /* match db                      */
 dcl SQLE_RC_INV_NEWPSW             fixed bin(31) value(-1008);
                                    /* Invalid new password          */
 dcl SQLE_RC_INVREMOTE              fixed bin(31) value(-1009);
                                    /* Invalid remote command        */

 dcl SQLE_RC_INVTYPE                fixed bin(31) value(-1010);
                                    /* Invalid type                  */
 dcl SQLE_RC_NODRIVE                fixed bin(31) value(-1011);
                                    /* No drive for indirect entry   */
 dcl SQLE_RC_NONODE                 fixed bin(31) value(-1012);
                                    /* No nodename for remote entry  */
 dcl SQLE_RC_NODB                   fixed bin(31) value(-1013);
                                    /* Alias or database name not    */
                                    /* found                         */
 dcl SQLE_RC_NOMORE                 fixed bin(31) value(1014);
                                    /* No more entries               */
 dcl SQLE_RC_DB_RESTART             fixed bin(31) value(-1015);
                                    /* Database needs restart        */
 dcl SQLE_RC_INVLLU                 fixed bin(31) value(-1016);
                                    /* Invalid local_lu alias        */
 dcl SQLE_RC_INVMODE                fixed bin(31) value(-1017);
                                    /* Invalid mode                  */
 dcl SQLE_RC_DUPNODE                fixed bin(31) value(-1018);
                                    /* Duplicate node name           */
 dcl SQLE_RC_INVNODE                fixed bin(31) value(-1019);
                                    /* Invalid node name             */

 dcl SQLE_RC_MAXNODE                fixed bin(31) value(-1020);
                                    /* Node could not be cataloged   */
 dcl SQLE_RC_NOTNODE                fixed bin(31) value(-1021);
                                    /* Nodename not found            */

 dcl SQLE_RC_INSSYS_DB2OS2          fixed bin(31) value(-1022);
                                    /* Insuf system resources - OS2  */
 dcl SQLE_RC_INSSYS_DB2NT           fixed bin(31) value(-1022);
                                    /* Insuf system resources - NT   */
 dcl SQLE_RC_INSSYS_DB2DOS          fixed bin(31) value(-1022);
                                    /* Insuf system resources - DOS  */
 dcl SQLE_RC_INSSYS_DB2WIN          fixed bin(31) value(-1022);
                                    /* Insuf system resources -      */
                                    /* Windows                       */
 dcl SQLE_RC_INSSYS_DB2MAC          fixed bin(31) value(-1022);
                                    /* Insuf system resources -      */
                                    /* Macintosh                     */
 dcl SQLE_RC_INSSYS_DB2AIX          fixed bin(31) value(-10003);
                                    /* Insuf system resources - AIX  */
 dcl SQLE_RC_INSSYS                 fixed bin(31)
                                    value(SQLE_RC_INSSYS_DB2NT);

 dcl SQLE_RC_NOCONV                 fixed bin(31) value(-1023);
                                    /* Communication conversation    */
                                    /* failed                        */
 dcl SQLE_RC_NOSUDB                 fixed bin(31) value(-1024);
                                    /* No database connection        */
                                    /* exists                        */
 dcl SQLE_RC_DBACT                  fixed bin(31) value(-1025);
                                    /* Databases are active          */
 dcl SQLE_RC_INVSTRT                fixed bin(31) value(-1026);
                                    /* Database manager already      */
                                    /* started                       */
 dcl SQLE_RC_NONODEDIR              fixed bin(31) value(-1027);
                                    /* Node directory not found      */
 dcl SQLE_RC_INVRLU                 fixed bin(31) value(-1029);
                                    /* Partner lu not specified      */

 dcl SQLE_RC_MAXDB                  fixed bin(31) value(-1030);
                                    /* Database directory is full    */
 dcl SQLE_RC_NODBDIR                fixed bin(31) value(-1031);
                                    /* Database directory not found  */
 dcl SQLE_RC_NOSTARTG               fixed bin(31) value(-1032);
                                    /* Database manager not started  */
 dcl SQLE_RC_DIRBUSY                fixed bin(31) value(-1033);
                                    /* Database directory being      */
                                    /* updated                       */
 dcl SQLE_RC_DBBAD                  fixed bin(31) value(-1034);
                                    /* Database is damaged           */
 dcl SQLE_RC_DB_INUSE               fixed bin(31) value(-1035);
                                    /* Database already in use       */
 dcl SQLE_RC_FILEDB                 fixed bin(31) value(-1036);
                                    /* Database file error           */
 dcl SQLE_RC_NODE_DIR_EMPTY         fixed bin(31) value(1037);
                                    /* No entry in Node directory    */
 dcl SQLE_RC_FILENODE               fixed bin(31) value(-1038);
                                    /* Node directory file error     */

 dcl SQLE_RC_FILEDIR_DB2OS2         fixed bin(31) value(-1039);
                                    /* Directory file error - OS/2   */
 dcl SQLE_RC_FILEDIR_DB2NT          fixed bin(31) value(-1039);
                                    /* Directory file error - NT     */
 dcl SQLE_RC_FILEDIR_DB2DOS         fixed bin(31) value(-1039);
                                    /* Directory file error - DOS    */
 dcl SQLE_RC_FILEDIR_DB2WIN         fixed bin(31) value(-1039);
                                    /* Directory file error -        */
                                    /* Windows                       */
 dcl SQLE_RC_FILEDIR_DB2MAC         fixed bin(31) value(-1039);
                                    /* Directory file error - Mac    */
 dcl SQLE_RC_FILEDIR_DB2AIX         fixed bin(31) value(-10004);
                                    /* Directory file error - AIX    */
 dcl SQLE_RC_FILEDIR                fixed bin(31)
                                    value(SQLE_RC_FILEDIR_DB2NT);

 dcl SQLE_RC_MAXAPPLS               fixed bin(31) value(-1040);
                                    /* Max number of applications    */
                                    /* reached                       */
 dcl SQLE_RC_MAXDBS                 fixed bin(31) value(-1041);
                                    /* Max number of databases       */
                                    /* started                       */
 dcl SQLE_RC_SYSERR                 fixed bin(31) value(-1042);
                                    /* System error                  */
 dcl SQLE_RC_CATBOOT                fixed bin(31) value(-1043);
                                    /* Catalog bootstrap failure     */
 dcl SQLE_RC_INTRRPT                fixed bin(31) value(-1044);
                                    /* Request interrupted by        */
                                    /* ctrl+break                    */
 dcl SQLE_RC_INVINDIR               fixed bin(31) value(-1045);
                                    /* Invalid level of indirection  */
 dcl SQLE_RC_INVAUTHID              fixed bin(31) value(-1046);
                                    /* Invalid userid                */
 dcl SQLE_RC_APCONN                 fixed bin(31) value(-1047);
                                    /* Appl already connect to       */
                                    /* another db                    */

 dcl SQLE_RC_USEINVALID_DB2OS2      fixed bin(31) value(-1048);
                                    /* Invalid use specified - OS/2  */
 dcl SQLE_RC_USEINVALID_DB2NT       fixed bin(31) value(-1048);
                                    /* Invalid use specified - NT    */
 dcl SQLE_RC_USEINVALID_DB2DOS      fixed bin(31) value(-1048);
                                    /* Invalid use specified - DOS   */
 dcl SQLE_RC_USEINVALID_DB2WIN      fixed bin(31) value(-1048);
                                    /* Invalid use specified -       */
                                    /* Windows                       */
 dcl SQLE_RC_USEINVALID_DB2MAC      fixed bin(31) value(-1048);
                                    /* Invalid use specified -       */
                                    /* MacOS                         */
 dcl SQLE_RC_USEINVALID_DB2AIX      fixed bin(31) value(-10005);
                                    /* Invalid use specified - AIX   */
 dcl SQLE_RC_USEINVALID             fixed bin(31)
                                    value(SQLE_RC_USEINVALID_DB2NT);

 dcl SQLE_RC_APPSERR                fixed bin(31) value(-900);
                                    /* Appl state in error           */

 dcl SQLE_RC_UNCHOME                fixed bin(31) value(-1050);
                                    /* Cannot uncatalog 'Home'       */
                                    /* database                      */
 dcl SQLE_RC_NODIRDRV               fixed bin(31) value(-1051);
                                    /* Db direct. drive does not     */
                                    /* exist                         */
 dcl SQLE_RC_NODBDRV                fixed bin(31) value(-1052);
                                    /* Database drive does not       */
                                    /* exist                         */
 dcl SQLE_RC_INTBUSY                fixed bin(31) value(-1053);
                                    /* Interrupt already in          */
                                    /* progress                      */
 dcl SQLE_RC_COMMINP                fixed bin(31) value(-1054);
                                    /* Commit in progress - no       */
                                    /* int's                         */
 dcl SQLE_RC_ROLLINP                fixed bin(31) value(-1055);
                                    /* Rollback in progress - no     */
                                    /* int's                         */
 dcl SQLE_RC_NOINTER                fixed bin(31) value(-1360);
                                    /* Cannot be interrupted - no    */
                                    /* int's                         */
 dcl SQLE_RC_TIMEOUT                fixed bin(31) value(1361);
                                    /* Windows Client Execution      */
                                    /* Timeout                       */
 dcl SQLE_RC_MAXSCAN                fixed bin(31) value(-1056);
                                    /* Maximum allowable scans       */
                                    /* exceeded                      */
 dcl SQLE_RC_NODENTRY               fixed bin(31) value(1057);
                                    /* No entries in directory       */
 dcl SQLE_RC_INVHAND                fixed bin(31) value(-1058);
                                    /* Invalid input handle          */
 dcl SQLE_RC_NOSCAN                 fixed bin(31) value(-1059);
                                    /* Open scan not issued          */

 dcl SQLE_RC_NOCONNECT              fixed bin(31) value(-1060);
                                    /* User lacks connect privilege  */
 dcl SQLE_RC_RESTART_WITH_INDOUBTS  fixed bin(31) value(1061);
                                    /* RESTART was successful, but   */
                                    /* indoubt transactions exist    */
 dcl SQLE_RC_BADPATH                fixed bin(31) value(-1062);
                                    /* Database path not found       */
 dcl SQLE_RC_START_OK               fixed bin(31) value(-1063);
                                    /* Database manager started OK   */
 dcl SQLE_RC_STOP_OK                fixed bin(31) value(-1064);
                                    /* Database manager stopped OK   */
 dcl SQLE_RC_DB_BADBINDS            fixed bin(31) value(1065);
                                    /* N utilities not bound         */

 dcl SQLE_RC_NOMSG_DB2OS2           fixed bin(31) value(-1068);
                                    /* Message file not found - OS2  */
 dcl SQLE_RC_NOMSG_DB2NT            fixed bin(31) value(-1068);
                                    /* Message file not found - NT   */
 dcl SQLE_RC_NOMSG_DB2DOS           fixed bin(31) value(-1068);
                                    /* Message file not found - DOS  */
 dcl SQLE_RC_NOMSG_DB2WIN           fixed bin(31) value(-1068);
                                    /* Message file not found -      */
                                    /* Windows                       */
 dcl SQLE_RC_NOMSG_DB2MAC           fixed bin(31) value(-1068);
                                    /* Message file not found -      */
                                    /* MacOS                         */
 dcl SQLE_RC_NOMSG_DB2AIX           fixed bin(31) value(-10007);
                                    /* Message file not found - AIX  */
 dcl SQLE_RC_NOMSG                  fixed bin(31)
                                    value(SQLE_RC_NOMSG_DB2NT);

 dcl SQLE_RC_INVDROP                fixed bin(31) value(-1069);
                                    /* DB invalid type for Drop      */

 dcl SQLE_RC_INVDBNAME_PTR          fixed bin(31) value(-1070);
                                    /* Invalid Database Name         */
                                    /* pointer                       */
 dcl SQLE_RC_INVALIAS_PTR           fixed bin(31) value(-1071);
                                    /* Invalid Alias pointer         */
 dcl SQLE_RC_RESOURCE_ERROR         fixed bin(31) value(-1072);
                                    /* Resources in inconsistent     */
                                    /* state                         */
 dcl SQLE_RC_BAD_ND_REL             fixed bin(31) value(-1073);
                                    /* Invalid Node Directory        */
                                    /* release                       */
 dcl SQLE_RC_INVPSW_PTR             fixed bin(31) value(-1074);
                                    /* Invalid Password pointer      */
 dcl SQLE_RC_INVCOMM_PTR            fixed bin(31) value(-1075);
                                    /* Invalid Comment pointer       */
 dcl SQLE_RC_INVCNT_PTR             fixed bin(31) value(-1076);
                                    /* Invalid Count pointer         */
 dcl SQLE_RC_INVHAND_PTR            fixed bin(31) value(-1077);
                                    /* Invalid Handle pointer        */
 dcl SQLE_RC_INVBUFF_PTR            fixed bin(31) value(-1078);
                                    /* Invalid Buffer pointer        */
 dcl SQLE_RC_INVNODE_PTR            fixed bin(31) value(-1079);
                                    /* Invalid Buffer pointer        */
 dcl SQLE_RC_INVUSERID_PTR          fixed bin(31) value(-1150);
                                    /* Invalid Userid pointer        */
 dcl SQLE_RC_INVPARM_PTR            fixed bin(31) value(-1151);
                                    /* Invalid Parms pointer         */

 dcl SQLE_RC_INVLLU_PTR             fixed bin(31) value(-1080);
                                    /* Invalid Local Lu pointer      */
 dcl SQLE_RC_INVRLU_PTR             fixed bin(31) value(-1081);
                                    /* Invalid Remote Lu pointer     */
 dcl SQLE_RC_INVMODE_PTR            fixed bin(31) value(-1082);
                                    /* Invalid Mode pointer          */
 dcl SQLE_RC_BAD_DBDB               fixed bin(31) value(-1083);
                                    /* Bad Database Description      */
                                    /* Block                         */
 dcl SQLE_RC_KSEGSFAIL              fixed bin(31) value(-1084);
                                    /* Cannot Allocate Kernel        */
                                    /* Segments                      */
 dcl SQLE_RC_APPHEAPFAIL            fixed bin(31) value(-1085);
                                    /* Cannot Allocate Application   */
                                    /* heap                          */
 dcl SQLE_RC_OS2ERROR               fixed bin(31) value(-1086);
                                    /* Unexpected OS/2 error         */
 dcl SQLE_RC_BIND_LIST              fixed bin(31) value(1087);
                                    /* Bind list could not be        */
                                    /* opened                        */
 dcl SQLE_RC_BIND_ERROR             fixed bin(31) value(1088);
                                    /* Error occurred during bind    */
 dcl SQLE_RC_BIND_INTRRPT           fixed bin(31) value(1089);
                                    /* Binding was interrupted       */

 dcl SQLE_RC_BAD_APP_REL            fixed bin(31) value(-1090);
                                    /* Release number of appl is     */
                                    /* invalid                       */
 dcl SQLE_RC_BAD_DB_REL             fixed bin(31) value(-1091);
                                    /* Release number of database    */
                                    /* bad                           */

 dcl SQLE_RC_INSAUTH                fixed bin(31) value(-1092);
                                    /* Authorization error           */
 dcl SQLE_RC_NOLOGON                fixed bin(31) value(-1093);
                                    /* User not logged on            */
 dcl SQLE_RC_NDBUSY                 fixed bin(31) value(-1094);
                                    /* Node directory being updated  */
 dcl SQLE_RC_MAX_NDSCAN             fixed bin(31) value(-1095);
                                    /* Max node scans open           */
 dcl SQLE_RC_REQTYPE                fixed bin(31) value(-1096);
                                    /* Invalid type for requester    */
                                    /* node                          */
 dcl SQLE_RC_NODERR                 fixed bin(31) value(-1097);
                                    /* Node not found for remote db  */
 dcl SQLE_RC_APCONN_SAME            fixed bin(31) value(-1098);
                                    /* Appl is already connected to  */
                                    /* db                            */

 dcl SQLE_RC_WRPROT_ERR_DB2OS2      fixed bin(31) value(-1099);
                                    /* Write protect error on        */
                                    /* diskette                      */
 dcl SQLE_RC_WRPROT_ERR_DB2NT       fixed bin(31) value(-1099);
                                    /* Write protect error on        */
                                    /* diskette                      */
 dcl SQLE_RC_WRPROT_ERR_DB2DOS      fixed bin(31) value(-1099);
                                    /* Write protect error on        */
                                    /* diskette                      */
 dcl SQLE_RC_WRPROT_ERR_DB2WIN      fixed bin(31) value(-1099);
                                    /* Write protect error on        */
                                    /* diskette                      */
 dcl SQLE_RC_WRPROT_ERR_DB2MAC      fixed bin(31) value(-1099);
                                    /* Write protect error on        */
                                    /* diskette                      */
 dcl SQLE_RC_WRPROT_ERR_DB2AIX      fixed bin(31) value(-10021);
                                    /* Write protect error on        */
                                    /* filesystem                    */
 dcl SQLE_RC_WRPROT_ERR             fixed bin(31)
                                    value(SQLE_RC_WRPROT_ERR_DB2NT);

 dcl SQLE_RC_NODE_WARN              fixed bin(31) value(1100);
                                    /* Node not cataloged for        */
                                    /* database                      */
 dcl SQLE_RC_REMCONN_ERR            fixed bin(31) value(-1101);
                                    /* Remote communications error   */
 dcl SQLE_RC_MIG_NODB               fixed bin(31) value(-1102);
                                    /* No database name provided in  */
                                    /* call                          */
 dcl SQLE_RC_MIG_OK                 fixed bin(31) value(1103);
                                    /* Migration was successful      */
 dcl SQLE_RC_INVPROG_PTR            fixed bin(31) value(-1104);
                                    /* Invalid program name pointer  */

 dcl SQLE_RC_INV_SPDB_DB2OS2        fixed bin(31) value(-1105);
                                    /* Invalid disconnect from       */
                                    /* database                      */
 dcl SQLE_RC_INV_SPDB_DB2NT         fixed bin(31) value(-1105);
                                    /* Invalid disconnect from       */
                                    /* database                      */
 dcl SQLE_RC_INV_SPDB_DB2DOS        fixed bin(31) value(-1105);
                                    /* Invalid disconnect from       */
                                    /* database                      */
 dcl SQLE_RC_INV_SPDB_DB2WIN        fixed bin(31) value(-1105);
                                    /* Invalid disconnect from       */
                                    /* database                      */
 dcl SQLE_RC_INV_SPDB_DB2MAC        fixed bin(31) value(-1105);
                                    /* Invalid disconnect from       */
                                    /* database                      */
 dcl SQLE_RC_INV_SPDB_DB2AIX        fixed bin(31) value(-10017);
                                    /* Invalid disconnect from       */
                                    /* database                      */
 dcl SQLE_RC_INV_SPDB               fixed bin(31)
                                    value(SQLE_RC_INV_SPDB_DB2NT);

 dcl SQLE_RC_INVALID_PROC_DB2OS2    fixed bin(31) value(-1106);
                                    /* Function could not be         */
                                    /* executed                      */
 dcl SQLE_RC_INVALID_PROC_DB2NT     fixed bin(31) value(-1106);
                                    /* Function could not be         */
                                    /* executed                      */
 dcl SQLE_RC_INVALID_PROC_DB2DOS    fixed bin(31) value(-1106);
                                    /* Function could not be         */
                                    /* executed                      */
 dcl SQLE_RC_INVALID_PROC_DB2WIN    fixed bin(31) value(-1106);
                                    /* Function could not be         */
                                    /* executed                      */
 dcl SQLE_RC_INVALID_PROC_DB2MAC    fixed bin(31) value(-1106);
                                    /* Function could not be         */
                                    /* executed                      */
 dcl SQLE_RC_INVALID_PROC_DB2AIX    fixed bin(31) value(-10010);
                                    /* Function could not be         */
                                    /* executed                      */
 dcl SQLE_RC_INVALID_PROC           fixed bin(31)
                                    value(SQLE_RC_INVALID_PROC_DB2NT);

 dcl SQLE_RC_INTRP_PROC_DB2OS2      fixed bin(31) value(-1107);
                                    /* Program interrupted - OS/2    */
 dcl SQLE_RC_INTRP_PROC_DB2NT       fixed bin(31) value(-1107);
                                    /* Program interrupted - NT      */
 dcl SQLE_RC_INTRP_PROC_DB2DOS      fixed bin(31) value(-1107);
                                    /* Program interrupted - DOS     */
 dcl SQLE_RC_INTRP_PROC_DB2WIN      fixed bin(31) value(-1107);
                                    /* Program interrupted -         */
                                    /* Windows                       */
 dcl SQLE_RC_INTRP_PROC_DB2MAC      fixed bin(31) value(-1107);
                                    /* Program interrupted - MacOS   */
 dcl SQLE_RC_INTRP_PROC_DB2AIX      fixed bin(31) value(-10011);
                                    /* Program interrupted - AIX     */
 dcl SQLE_RC_INTRP_PROC             fixed bin(31)
                                    value(SQLE_RC_INVALID_PROC_DB2NT);

 dcl SQLE_RC_SYSERR_PROC_DB2OS2     fixed bin(31) value(-1108);
                                    /* System error on library load  */
 dcl SQLE_RC_SYSERR_PROC_DB2NT      fixed bin(31) value(-1108);
                                    /* System error on library load  */
 dcl SQLE_RC_SYSERR_PROC_DB2DOS     fixed bin(31) value(-1108);
                                    /* System error on library load  */
 dcl SQLE_RC_SYSERR_PROC_DB2WIN     fixed bin(31) value(-1108);
                                    /* System error on library load  */
 dcl SQLE_RC_SYSERR_PROC_DB2MAC     fixed bin(31) value(-1108);
                                    /* System error on library load  */
 dcl SQLE_RC_SYSERR_PROC_DB2AIX     fixed bin(31) value(-10012);
                                    /* System error on library load  */
 dcl SQLE_RC_SYSERR_PROC            fixed bin(31)
                                    value(SQLE_RC_SYSERR_PROC_DB2NT);

 dcl SQLE_RC_NOFILE_PROC_DB2OS2     fixed bin(31) value(-1109);
                                    /* Library could not be loaded   */
 dcl SQLE_RC_NOFILE_PROC_DB2NT      fixed bin(31) value(-1109);
                                    /* Library could not be loaded   */
 dcl SQLE_RC_NOFILE_PROC_DB2DOS     fixed bin(31) value(-1109);
                                    /* Library could not be loaded   */
 dcl SQLE_RC_NOFILE_PROC_DB2WIN     fixed bin(31) value(-1109);
                                    /* Library could not be loaded   */
 dcl SQLE_RC_NOFILE_PROC_DB2MAC     fixed bin(31) value(-1109);
                                    /* Library could not be loaded   */
 dcl SQLE_RC_NOFILE_PROC_DB2AIX     fixed bin(31) value(-10013);
                                    /* Library could not be loaded   */
 dcl SQLE_RC_NOFILE_PROC            fixed bin(31)
                                    value(SQLE_RC_NOFILE_PROC_DB2NT);

 dcl SQLE_RC_ERROR_PROC             fixed bin(31) value(-1110);
                                    /* Program error                 */

 dcl SQLE_RC_BADPGN_PROC_DB2OS2     fixed bin(31) value(-1111);
                                    /* Invalid DARI prog name        */
                                    /* format                        */
 dcl SQLE_RC_BADPGN_PROC_DB2NT      fixed bin(31) value(-1111);
                                    /* Invalid DARI prog name        */
                                    /* format                        */
 dcl SQLE_RC_BADPGN_PROC_DB2DOS     fixed bin(31) value(-1111);
                                    /* Invalid DARI prog name        */
                                    /* format                        */
 dcl SQLE_RC_BADPGN_PROC_DB2WIN     fixed bin(31) value(-1111);
                                    /* Invalid DARI prog name        */
                                    /* format                        */
 dcl SQLE_RC_BADPGN_PROC_DB2MAC     fixed bin(31) value(-1111);
                                    /* Invalid DARI prog name        */
                                    /* format                        */
 dcl SQLE_RC_BADPGN_PROC_DB2AIX     fixed bin(31) value(-10014);
                                    /* Invalid DARI prog name        */
                                    /* format                        */
 dcl SQLE_RC_BADPGN_PROC            fixed bin(31)
                                    value(SQLE_RC_BADPGN_PROC_DB2NT);

 dcl SQLE_RC_INSMEM_PROC_DB2OS2     fixed bin(31) value(-1112);
                                    /* Insuf memory to load lib      */
 dcl SQLE_RC_INSMEM_PROC_DB2NT      fixed bin(31) value(-1112);
                                    /* Insuf memory to load lib      */
 dcl SQLE_RC_INSMEM_PROC_DB2DOS     fixed bin(31) value(-1112);
                                    /* Insuf memory to load lib      */
 dcl SQLE_RC_INSMEM_PROC_DB2WIN     fixed bin(31) value(-1112);
                                    /* Insuf memory to load lib      */
 dcl SQLE_RC_INSMEM_PROC_DB2MAC     fixed bin(31) value(-1112);
                                    /* Insuf memory to load lib      */
 dcl SQLE_RC_INSMEM_PROC_DB2AIX     fixed bin(31) value(-10015);
                                    /* Insuf memory to load lib      */
 dcl SQLE_RC_INSMEM_PROC            fixed bin(31)
                                    value(SQLE_RC_INSMEM_PROC_DB2NT);

 dcl SQLE_RC_SQLDA_DATATYPE         fixed bin(31) value(-1113);
                                    /* Data type in output SQLDA     */
                                    /* changed                       */
 dcl SQLE_RC_SQLDA_LENGTH           fixed bin(31) value(-1114);
                                    /* Data length in output SQLDA   */
                                    /* changed                       */
 dcl SQLE_RC_SQLDA_VARS             fixed bin(31) value(-1115);
                                    /* Num of sqlvars changed in     */
                                    /* SQLDA                         */
 dcl SQLE_RC_BKP_PEND               fixed bin(31) value(-1116);
                                    /* Backup pending                */
 dcl SQLE_RC_ROLLFWD_PEND           fixed bin(31) value(-1117);
                                    /* Roll forward pending          */
 dcl SQLE_RC_BKP_INPROG             fixed bin(31) value(-1118);
                                    /* Need to rerun the Backup      */
                                    /* process                       */
 dcl SQLE_RC_RST_INPROG             fixed bin(31) value(-1119);
                                    /* Need to rerun the Restore     */
                                    /* process                       */
 dcl SQLE_RC_BR_INPROG              fixed bin(31) value(-1120);
                                    /* Need to rerun either Backup   */
                                    /* or Restore process            */

 dcl SQLE_RC_INVNODESTR_PTR         fixed bin(31) value(-1121);
                                    /* Invalid Node structure        */
                                    /* pointer                       */
 dcl SQLE_RC_INVPROTOCOL_PTR        fixed bin(31) value(-1122);
                                    /* Invalid Protocol structure    */
                                    /* pointer                       */
 dcl SQLE_RC_INVPROTOCOL            fixed bin(31) value(-1123);
                                    /* Invalid protocol type         */
 dcl SQLE_RC_INVRNNAME              fixed bin(31) value(-1124);
                                    /* Invalid remote workstation    */
                                    /* name                          */
 dcl SQLE_RC_INVADAPTER             fixed bin(31) value(-1125);
                                    /* Invalid adapter number        */
 dcl SQLE_RC_INVNETID               fixed bin(31) value(-1126);
                                    /* Invalid network id            */
 dcl SQLE_RC_INVPLU                 fixed bin(31) value(-1127);
                                    /* Invalid real partner LU name  */

 dcl SQLE_RC_DARI_INSSYS            fixed bin(31) value(-1129);
                                    /* Insuf system resources for    */
                                    /* DARI                          */
 dcl SQLE_RC_DARI_MAXDARI           fixed bin(31) value(-1130);
                                    /* Max DARI process limit        */
                                    /* reached                       */
 dcl SQLE_RC_DARI_ABEND             fixed bin(31) value(-1131);
                                    /* DARI process abnormally       */
                                    /* terminated                    */
 dcl SQLE_RC_DARI_INV_RQST          fixed bin(31) value(-1132);
                                    /* Invalid DB2 request in DARI   */
 dcl SQLE_RC_DARI_VAR_POINTER_CHG   fixed bin(31) value(-1133);
                                    /* SQLVAR's sqldata or sqlind    */
                                    /* ptrs were altered             */
 dcl SQLE_RC_DARI_RQST_AUTH_ERR     fixed bin(31) value(-1134);
                                    /* DB2 request is not allowed    */
                                    /* when DB auth is client        */
 dcl SQLE_RC_BAD_NUMSEGS            fixed bin(31) value(-1135);
                                    /* Invalid numsegs on create db  */
 dcl SQLE_RC_BAD_EXTSIZE            fixed bin(31) value(-1136);
                                    /* Invalid extSize on create db  */
 dcl SQLE_RC_MOUNTED_SEGS           fixed bin(31) value(-1137);
                                    /* Mounted Segment Directories   */
                                    /* on a drop database request    */

 dcl SQLE_RC_INVOS_OBJ              fixed bin(31) value(-1200);
                                    /* Invalid object specified      */
 dcl SQLE_RC_INVOS_STAT             fixed bin(31) value(-1201);
                                    /* Invalid status specified      */
 dcl SQLE_RC_INVOS_NOSTAT           fixed bin(31) value(-1202);
                                    /* Status has not been           */
                                    /* collected                     */
 dcl SQLE_RC_INVOS_NOUSER           fixed bin(31) value(-1203);
                                    /* No users connected to         */
                                    /* database                      */
 dcl SQLE_RC_UNSUPP_CODEPG          fixed bin(31) value(-1204);
                                    /* Active codepage is not        */
                                    /* supported                     */

 dcl SQLE_RC_INV_CNTRYINFO_DB2OS2   fixed bin(31) value(-1205);
                                    /* Invalid country information   */
 dcl SQLE_RC_INV_CNTRYINFO_DB2NT    fixed bin(31) value(-1205);
                                    /* Invalid country information   */
 dcl SQLE_RC_INV_CNTRYINFO_DB2DOS   fixed bin(31) value(-1205);
                                    /* Invalid country information   */
 dcl SQLE_RC_INV_CNTRYINFO_DB2WIN   fixed bin(31) value(-1205);
                                    /* Invalid country information   */
 dcl SQLE_RC_INV_CNTRYINFO_DB2MAC   fixed bin(31) value(-1205);
                                    /* Invalid country information   */
 dcl SQLE_RC_INV_CNTRYINFO_DB2AIX   fixed bin(31) value(-10009);
                                    /* Invalid country information   */
 dcl SQLE_RC_INV_CNTRYINFO          fixed bin(31)
                                    value(SQLE_RC_INV_CNTRYINFO_DB2NT);

 dcl SQLE_RC_INV_COMPUTERNAME       fixed bin(31) value(-1211);
                                    /* Invalid Computer Name         */
 dcl SQLE_RC_INV_INSTANCENAME       fixed bin(31) value(-1212);
                                    /* Invalid Instance Name         */

 dcl SQLE_RC_INVCHGPWDLU            fixed bin(31) value(-1213);
                                    /* Invalid Change Password LU    */
 dcl SQLE_RC_INVTPNAME              fixed bin(31) value(-1214);
                                    /* Invalid Transaction Pgm Name  */
 dcl SQLE_RC_INVLANADDRESS          fixed bin(31) value(-1215);
                                    /* Invalid LAN Adapter Addr      */
 dcl SQLE_RC_NO_SHRD_SEG            fixed bin(31) value(-1220);
                                    /* DB2 Shared Memory Set alloc   */
                                    /* failed                        */
 dcl SQLE_RC_NO_ASL_HEAP            fixed bin(31) value(-1221);
                                    /* ASL heap cannot be allocated  */
 dcl SQLE_RC_ASL_TOO_SMALL          fixed bin(31) value(-1222);
                                    /* ASL heap is too small         */
 dcl SQLE_RC_NO_AGENT_AVAIL         fixed bin(31) value(-1223);
                                    /* No more agents available      */
 dcl SQLE_RC_AGENT_GONE             fixed bin(31) value(-1224);
                                    /* DB2 agent not active          */
 dcl SQLE_RC_PROC_LIMIT             fixed bin(31) value(-1225);
                                    /* Op. Sys. couldn't spawn a     */
                                    /* process                       */
 dcl SQLE_RC_MAXCOORDS              fixed bin(31) value(-1226);
                                    /* Max number of coords reached  */
 dcl SQLE_RC_DROPDB_WARN            fixed bin(31) value(1228);
                                    /* Drop database warning         */

 dcl SQLE_RC_AGENT_NOT_FORCED       fixed bin(31) value(1230);
                                    /* At least one agent not        */
                                    /* forced                        */
 dcl SQLE_RC_INVCOUNT               fixed bin(31) value(-1231);
                                    /* Invalid Force Users count     */
 dcl SQLE_RC_INVFRCE_MODE           fixed bin(31) value(-1232);
                                    /* Invalid Force Users mode      */

 dcl SQLE_RC_INV_TBS_DESC           fixed bin(31) value(-1241);
                                    /* Invalid TableSpace            */
                                    /* descriptor                    */

 dcl SQLE_RC_NO_SETCONNOPT          fixed bin(31) value(-1246);
                                    /* Cannot set connection         */
                                    /* options - existing            */
                                    /* connections                   */

 dcl SQLE_RC_NOUEXIT                fixed bin(31) value(-1267);
                                    /* db2uexit file not found       */

 dcl SQLC_RC_NPIPE_BROKEN           fixed bin(31) value(-1281);
 dcl SQLC_RC_NPIPE_BUSY             fixed bin(31) value(-1282);
 dcl SQLC_RC_NPIPE_PIPE_INUSE       fixed bin(31) value(-1283);
 dcl SQLC_RC_NPIPE_PIPE_NOT_FOUND   fixed bin(31) value(-1284);
 dcl SQLC_RC_NPIPE_INVALID_NAME     fixed bin(31) value(-1285);
 dcl SQLC_RC_NPIPE_NO_RESOURCE      fixed bin(31) value(-1286);
 dcl SQLC_RC_NPIPE_INST_NOT_FOUND   fixed bin(31) value(-1287);

 dcl SQLE_RC_DS_FAILED              fixed bin(31) value(-1291);
                                    /* Directory Services failed     */
 dcl SQLE_RC_DS_BAD_GLB_NAME        fixed bin(31) value(-1292);
                                    /* Bad global name               */
 dcl SQLE_RC_DS_BAD_GLB_DIR_ENTRY   fixed bin(31) value(-1293);
                                    /* Bad global directory entry    */
 dcl SQLE_RC_DS_BAD_DIR_PATH_NAME   fixed bin(31) value(-1294);
                                    /* Bad DIR_PATH_NAME             */
 dcl SQLE_RC_DS_BAD_ROUTE_NAME      fixed bin(31) value(-1295);
                                    /* Bad ROUTE_OBJ_NAME            */
 dcl SQLE_RC_DS_UNSUPPORTED_CMD     fixed bin(31) value(-1297);
                                    /* Command not supported         */

 dcl SQLE_RC_DCE_INVPN              fixed bin(31) value(-1300);
                                    /* Invalid DCE principal name    */
 dcl SQLE_RC_DCE_ERR_KEYTAB         fixed bin(31) value(-1301);
                                    /* Error DCE keytab file         */
 dcl SQLE_RC_DCE_ERR_MAPPING        fixed bin(31) value(-1302);
                                    /* DCE principal and DB2 authid  */
                                    /* mapping error                 */
 dcl SQLE_RC_SECD_ERR_RESTART       fixed bin(31) value(-1303);
                                    /* Security daemon could not be  */
                                    /* restarted                     */
 dcl SQLE_RC_INVSTCP                fixed bin(31) value(-1304);
                                    /* Invalid security type for     */
                                    /* TCPIP protocol                */
 dcl SQLE_RC_DCE_ERR                fixed bin(31) value(-1305);
                                    /* DCE internal error            */
 dcl SQLE_RC_DCE_INV_PRINC          fixed bin(31) value(-1309);
                                    /* DCE invalid server principal  */
                                    /* name                          */

 dcl SQLE_RC_FILEDCS                fixed bin(31) value(-1310);
                                    /* DCS Directory file access     */
                                    /* error                         */
 dcl SQLE_RC_DCSDIR_NF              fixed bin(31) value(-1311);
                                    /* DCS Directory not found       */
 dcl SQLE_RC_NO_ENTRY               fixed bin(31) value(1312);
                                    /* DCS Directory is empty        */
 dcl SQLE_RC_MAX_ENTRY              fixed bin(31) value(-1313);
                                    /* DCS Directory is full         */
 dcl SQLE_RC_INVENTRY_PTR           fixed bin(31) value(-1314);
                                    /* Entry parameter pointer       */
                                    /* invalid                       */
 dcl SQLE_RC_INVLDB                 fixed bin(31) value(-1315);
                                    /* Local DB name has invalid     */
                                    /* chars                         */
 dcl SQLE_RC_LDB_NF                 fixed bin(31) value(-1316);
                                    /* DCS Directory entry not       */
                                    /* found                         */
 dcl SQLE_RC_DUPLDB                 fixed bin(31) value(-1317);
                                    /* DCS Directory duplicate       */
                                    /* entry                         */
 dcl SQLE_RC_INVLENGTH              fixed bin(31) value(-1318);
                                    /* Invalid element length        */
 dcl SQLE_RC_ENTRYNOT_COL           fixed bin(31) value(-1319);
                                    /* Entries have not been         */
                                    /* collected                     */

 dcl SQLE_RC_GDBUSY                 fixed bin(31) value(-1320);
                                    /* Cannot access DCS Dir at      */
                                    /* this time                     */
 dcl SQLE_RC_INVSTRUCT_ID           fixed bin(31) value(-1321);
                                    /* Invalid structure ID          */
 dcl SQLE_RC_AUD_WRITE_ERR          fixed bin(31) value(-1322);
                                    /* Error writing to audit log    */
 dcl SQLE_RC_AUD_CFG_FILE_ERR       fixed bin(31) value(-1323);
                                    /* Error accessing db2audit.cfg  */
 dcl SQLE_RC_DRDANSP                fixed bin(31) value(-1325);
                                    /* Remote function not           */
                                    /* supported                     */
 dcl SQLE_RC_ACCD                   fixed bin(31) value(-1326);
                                    /* File or directory access      */
                                    /* denied                        */
 dcl SQLE_RC_IMPLCONN_INVDB         fixed bin(31) value(-1327);
                                    /* Implicit connect - invalid    */
                                    /* dbname                        */
 dcl SQLE_RC_IMPLCONN_NODB          fixed bin(31) value(-1328);
                                    /* Implicit connect - alias not  */
                                    /* found                         */
 dcl SQLE_RC_PATH_TOO_LONG          fixed bin(31) value(-1329);
                                    /* Input path too long           */

 dcl SQLE_RC_INVSDNAME              fixed bin(31) value(-1330);
                                    /* Invalid symbolic destination  */
                                    /* name                          */
 dcl SQLE_RC_INVSTYPE               fixed bin(31) value(-1331);
                                    /* Invalid CPIC security type    */
 dcl SQLE_RC_INV_HOSTNAME           fixed bin(31) value(-1332);
                                    /* Invalid Host Name             */
 dcl SQLE_RC_INV_SERNAME            fixed bin(31) value(-1333);
                                    /* Invalid Service Name          */

 dcl SQLE_RC_DOUBLE_REMOTE          fixed bin(31) value(-1334);
                                    /* Double-hops not allowed       */
 dcl SQLE_RC_INVAR                  fixed bin(31) value(-1335);
                                    /* AR name has invalid chars     */

 dcl SQLE_RC_UNKNOWN_FILESERVER     fixed bin(31) value(-1340);
                                    /* File server is unknown        */
 dcl SQLE_RC_INV_FSERVER            fixed bin(31) value(-1342);
                                    /* Invalid File Server           */
 dcl SQLE_RC_INV_OBJNAME            fixed bin(31) value(-1343);
                                    /* Invalid Object Name           */

 dcl SQLE_RC_BR_ACTIVE              fixed bin(31) value(-1350);
                                    /* Backup or Restore is active   */

 dcl SQLE_RC_INV_INSTANCE           fixed bin(31) value(-1390);
                                    /* Invalid Instance Name         */
 dcl SQLE_RC_INSTANCE_USING         fixed bin(31) value(-1391);
                                    /* Another Instance is using     */
                                    /* the DB                        */
 dcl SQLE_RC_INV_DB2PATH            fixed bin(31) value(-1393);
                                    /* Invalid DB2 Path Name         */

 dcl SQLE_RC_BAD_AUTH               fixed bin(31) value(-1400);
                                    /* Unsupported authentication    */
                                    /* type                          */
 dcl SQLE_RC_DIFF_AUTH              fixed bin(31) value(-1401);
                                    /* Authentication types do not   */
                                    /* match                         */
 dcl SQLE_RC_AUTH_ERR               fixed bin(31) value(-1402);
                                    /* Authentication failed due to  */
                                    /* unexpected error              */
 dcl SQLE_RC_AUTH_FAILURE           fixed bin(31) value(-1403);
                                    /* Invalid user name and/or      */
                                    /* password                      */
 dcl SQLE_RC_PASSWORD_EXPIRED       fixed bin(31) value(-1404);
                                    /* Password has expired          */
 dcl SQLE_RC_PASSWORD_WITHOUT_USERID  fixed bin(31) value(-1425);
                                    /* Password without userid       */
 dcl SQLE_RC_DB2INSTDFT_ERROR       fixed bin(31) value(-1426);
                                    /* Error getting DB2INSTDFT      */
 dcl SQLE_RC_NOT_INSTANCE_ATTACHED  fixed bin(31) value(-1427);
                                    /* No current attachment         */
 dcl SQLE_RC_WRONG_ATTACH           fixed bin(31) value(-1428);
                                    /* Attached to wrong instance    */
 dcl SQLE_RC_RELPATH_NOT_ALLOWED    fixed bin(31) value(-1431);
                                    /* Relative path not allowed     */
 dcl SQLE_RC_WRONG_CONNECT          fixed bin(31) value(-1433);
                                    /* Connected to wrong database   */

 dcl SQLE_RC_CTX_INUSE              fixed bin(31) value(-1440);
                                    /* App Ctx in use                */
 dcl SQLE_RC_CTX_INV_PARM           fixed bin(31) value(-1441);
                                    /* Ctx parm invalid              */
 dcl SQLE_RC_CTX_NOTINUSE           fixed bin(31) value(-1442);
                                    /* App Ctx not in use            */
 dcl SQLE_RC_CTX_USING              fixed bin(31) value(-1443);
                                    /* Already using Ctx             */
 dcl SQLE_RC_CTX_NO_CTX             fixed bin(31) value(-1445);
                                    /* Thread does not have context  */

 dcl SQLE_RC_INVREGINFO_PTR         fixed bin(31) value(-1450);
                                    /* Invalid registration info.    */
                                    /* ptr.                          */
 dcl SQLE_RC_REG_INVNODE            fixed bin(31) value(-1451);
                                    /* Reg. issued from invalid      */
                                    /* node                          */
 dcl SQLE_RC_INVREGLOC              fixed bin(31) value(-1452);
                                    /* Invalid registration          */
                                    /* location                      */
 dcl SQLE_RC_INVCFG_FSNAME          fixed bin(31) value(-1453);
                                    /* Invalid file server in DBM    */
                                    /* cfg.                          */
 dcl SQLE_RC_INVCFG_OBJNAME         fixed bin(31) value(-1454);
                                    /* Invalid object name in DBM    */
                                    /* cfg.                          */
 dcl SQLE_RC_INVCFG_IPXSOCKET       fixed bin(31) value(-1455);
                                    /* Invalid IPX socket in DBM     */
                                    /* cfg.                          */
 dcl SQLE_RC_DUPLICATE_OBJNAME      fixed bin(31) value(-1456);
                                    /* Object name already exists    */
 dcl SQLE_RC_NWDS_CONNEXISTS        fixed bin(31) value(-1457);
                                    /* NWDS connection exists,       */
                                    /* cannot log into NW            */
                                    /* fileserver                    */
 dcl SQLE_RC_REG_NOT_NEEDED         fixed bin(31) value(-1458);
                                    /* DB2 server reg./dereg. not    */
                                    /* needed                        */

 dcl SQLE_RC_INVSTYPE_TCP           fixed bin(31) value(-1461);
                                    /* Invalid TCPIP Security        */

 dcl SQLE_RC_ONE_BUFFERPOOL         fixed bin(31) value(1478);
                                    /* Database is started but only  */
                                    /* one bufferpool is started     */

 dcl SQLE_RC_SECD_FAILURE           fixed bin(31) value(-1525);
                                    /* An error occured when         */
                                    /* starting the DB2 security     */
                                    /* daemon                        */

 dcl SQLE_RC_VI_ERROR               fixed bin(31) value(-1526);
                                    /* FCM startup error when using  */
                                    /* VI                            */

 dcl SQLE_RC_UNSUPP_FUNCTION        fixed bin(31) value(-1650);
                                    /* Function is no longer         */
                                    /* supported                     */

 dcl SQLE_RC_INV_SERVERLVL          fixed bin(31) value(-1651);
                                    /* Invalid server level for      */
                                    /* request                       */
 dcl SQLE_RC_FILEIO_ERR             fixed bin(31) value(-1652);
                                    /* File I/O error                */
 dcl SQLE_RC_INV_PROFILE_PATH       fixed bin(31) value(-1653);
                                    /* Invalid profile path          */
 dcl SQLE_RC_INSTPATH_ERR           fixed bin(31) value(-1654);
                                    /* Instance path error           */

 dcl SQLE_RC_GENERATOR_FAILED       fixed bin(31) value(-1660);
                                    /* Generator failed              */

 dcl SQLE_RC_DSCVR_DISABLED         fixed bin(31) value(-1670);
                                    /* Discover is disabled in DBM   */
                                    /* CFG                           */
 dcl SQLE_RC_SEARCH_DSCVR_FAILED    fixed bin(31) value(-1671);
                                    /* Search discovery failed       */
 dcl SQLE_RC_INV_DSCVR_ADDRLST      fixed bin(31) value(-1673);
                                    /* Invalid discover address      */
                                    /* list                          */
 dcl SQLE_RC_INV_DSCVR_ADDR         fixed bin(31) value(-1674);
                                    /* Invalid discover address      */
 dcl SQLE_RC_INV_ADMINSERVER        fixed bin(31) value(-1675);
                                    /* Invalid admin. server         */

 dcl SQLE_RC_INV_SCHEMA             fixed bin(31) value(-1700);
                                    /* Invalid Schema name found     */
 dcl SQLE_RC_DB_NOT_MIGR            fixed bin(31) value(-1701);
                                    /* DB cannot be migrated         */
 dcl SQLE_RC_CRT_EVENT_FAIL         fixed bin(31) value(-1703);
                                    /* Fail to create db2event dir   */
 dcl SQLE_RC_DB_MIG_FAIL            fixed bin(31) value(-1704);
                                    /* DB migration failed           */
 dcl SQLE_RC_UPDATE_DIR_FAIL        fixed bin(31) value(1705);
                                    /* Fail to update directory      */
                                    /* entry                         */

 dcl SQLE_RC_INV_REQINFO_PTR        fixed bin(31) value(-1800);
                                    /* Invalid Request Info pointer  */
 dcl SQLE_RC_INV_REQUEST_TYPE       fixed bin(31) value(-1801);
                                    /* Invalid Request Type          */
 dcl SQLE_RC_NO_NODE_ENTRY          fixed bin(31) value(-1802);
                                    /* No entry belongs to Request   */
                                    /* Type                          */
 dcl SQLE_RC_NODE_EXIST             fixed bin(31) value(-1803);
                                    /* Node already exists in node   */
                                    /* directory                     */

 dcl SQLE_RC_DB_ACTIVATED           fixed bin(31) value(1490);
                                    /* DB is already activated       */
 dcl SQLE_RC_DB_NOT_STOPPED         fixed bin(31) value(-1491);
                                    /* DB is still active            */
 dcl SQLE_RC_DB_NOT_ACTIVATED       fixed bin(31) value(-1492);
                                    /* DB is not active              */
 dcl SQLE_RC_APP_IS_CONNECTED       fixed bin(31) value(-1493);
                                    /* Application is connected to   */
                                    /* a database                    */
 dcl SQLE_RC_ACT_DB_CONNECTED       fixed bin(31) value(1494);
                                    /* There is already DB           */
                                    /* connection                    */
 dcl SQLE_RC_DEACT_DB_CONNECTED     fixed bin(31) value(1495);
                                    /* There is still DB connection  */
 dcl SQLE_RC_DEACT_DB_NOT_ACTIVATED fixed bin(31) value(1496);
                                    /* DB is not activated           */
 dcl SQLE_RC_ACTDEACT_ERROR         fixed bin(31) value(1497);
                                    /* Error occurs on some nodes    */
 dcl SQLE_RC_INVALID_PARM           fixed bin(31) value(-2032);
                                    /* Invalid parameter             */

 dcl SQLE_RC_E4411                  fixed bin(31) value(-4411);
                                    /* Error not Admin Server        */
 dcl SQLE_RC_NOADMSTART             fixed bin(31) value(-4414);
                                    /* Admin Server not started      */

 dcl SQLE_RC_COMM_FAILED            fixed bin(31) value(5043);
                                    /* Communications support        */
                                    /* failed                        */

 dcl SQLE_RC_NO_VENDOR_CFG          fixed bin(31) value(-5500);
                                    /* Vendor cfg file not found     */
 dcl SQLE_RC_BAD_VENDOR_CFG         fixed bin(31) value(-5501);
                                    /* Vendor cfg file invalid       */

 dcl SQLE_RC_SDIRERR                fixed bin(31) value(-6022);
                                    /* System database directory is  */
                                    /* not shared by all PDB nodes   */
 dcl SQLE_RC_PATH_NOT_QUAL          fixed bin(31) value(-6027);
                                    /* The path specified for the    */
                                    /* database directory is not     */
                                    /* valid                         */
 dcl SQLE_RC_LOCALDB_NOT_FOUND      fixed bin(31) value(-6028);
                                    /* Database is not found in      */
                                    /* local database directory      */
 dcl SQLE_RC_INV_PARM               fixed bin(31) value(-6030);
                                    /* Invalid parameter for start   */
                                    /* stop                          */
 dcl SQLE_RC_ERR_DB2NODES_CFG       fixed bin(31) value(-6031);
                                    /* Error in db2nodes.cfg file    */
 dcl SQLE_RC_STARTED_PARTIALLY      fixed bin(31) value(6032);
                                    /* Some nodes have not been      */
                                    /* started properly              */
 dcl SQLE_RC_STOPPED_PARTIALLY      fixed bin(31) value(6033);
                                    /* Some nodes have not been      */
                                    /* stopped properly              */
 dcl SQLE_RC_NODE_NOT_INUSE         fixed bin(31) value(6034);
                                    /* The node is not in used by    */
                                    /* any database                  */
 dcl SQLE_RC_NODE_INUSE             fixed bin(31) value(6035);
                                    /* The node is used by a         */
                                    /* database                      */
 dcl SQLE_RC_START_STOP_IN_PROG     fixed bin(31) value(-6036);
                                    /* Start/stop command in         */
                                    /* progress                      */
 dcl SQLE_RC_NODE_TIMEOUT           fixed bin(31) value(-6037);
                                    /* Timeout reached for start     */
                                    /* stop                          */
 dcl SQLE_RC_INVDROP_ACTION         fixed bin(31) value(-6046);
                                    /* Invalid action for DROP NODE  */
 dcl SQLE_RC_COMM_ERR               fixed bin(31) value(-6048);
                                    /* Communication error in start  */
                                    /* stop                          */
 dcl SQLE_RC_NODE_NEED_STOP         fixed bin(31) value(-6072);
                                    /* Need to stop the node before  */
                                    /* starting the node with the    */
                                    /* restart option                */
 dcl SQLE_RC_ADD_NODE_FAIL          fixed bin(31) value(-6073);
                                    /* Add Node failed               */
 dcl SQLE_RC_ADD_NODE_CRDP          fixed bin(31) value(-6074);
                                    /* Add Node failed because       */
                                    /* Create/Drop Db in progress    */
 dcl SQLE_RC_ADD_NODE_OK            fixed bin(31) value(6075);
                                    /* Add Node operation            */
                                    /* successful                    */
 dcl SQLE_RC_DROP_PROMPT            fixed bin(31) value(6076);
                                    /* Prompt for db2stop DROP       */
                                    /* NODENUM                       */
 dcl SQLE_RC_DROP_OK                fixed bin(31) value(6077);
                                    /* Drop node OK. Files still     */
                                    /* exist                         */
 dcl SQLE_RC_DROP_FAILED            fixed bin(31) value(-6078);
                                    /* Drop node failed              */
 dcl SQLE_RC_DROP_CANCEL            fixed bin(31) value(6079);
                                    /* Drop node cancelled           */
                                    /* successfully                  */
 dcl SQLE_RC_ADD_NODE_NODB          fixed bin(31) value(6080);
                                    /* Add Node succeeded but no     */
                                    /* databases created on the      */
                                    /* node                          */
 dcl SQLE_RC_FORCE_TIMEOUT_ERR      fixed bin(31) value(-6081);
                                    /* Timeout reached in stop       */
                                    /* FORCE                         */

 dcl SQLE_RC_DB2_SERVER_LICENSE     fixed bin(31) value(-8000);
                                    /* No DB2/6000 license           */
 dcl SQLE_RC_DB2_LICENSE            fixed bin(31) value(-8001);
                                    /* Out of DB2 client licenses    */
 dcl SQLE_RC_DDCS_LICENSE           fixed bin(31) value(-8002);
                                    /* Out of DDCS clients           */
 dcl SQLE_RC_NO_FED_CFG             fixed bin(31) value(-5180);
                                    /* Federated cfg file not found  */
 dcl SQLE_RC_BAD_FED_CFG            fixed bin(31) value(-5181);
                                    /* Federated cfg file invalid    */

 /********************************************************************/
 /*                                                                  */
 /* The following functions and symbols are obsolete and may not be  */
 /* supported in future releases. The obsolete functions are provided*/
 /* for backward compatibility and exported from DB2API.LIB. All     */
 /* applications should be migrated to use new APIs.                 */
 /* Note: Some of the function parameters may be NO-OP.              */
 /*       Some structures are larger (eg. SQLEDINFO) in V2.          */
 /*                                                                  */
 /********************************************************************/

 dcl SQLE_RC_BAD_SEGPAGES           fixed bin(31) value(-1136);
                                    /* Invalid numsegs on create db  */

 dcl SQLE_RC_CS_LICENSE             fixed bin(31) value(-8003);
                                    /* No CS/6000 license            */
 dcl SQLE_RC_SNA_LICENSE            fixed bin(31) value(-8004);
                                    /* No SNA/6000 license           */

                                    /* Authentication Undefined      */
 dcl SQL_AUTHENTICATION_UNDEF       fixed bin(16) unsigned value(255);

 dcl sqledbcr_api                         /* CREATE DATABASE         */
     entry (char(*) varz byaddr,          /* database                */
            char(*) varz byaddr,          /* drive/path              */
            type sqledbdesc byaddr,       /* db description block    */
            fixed bin(16) unsigned,       /* authentication          */
            type sqledbcinfo byaddr,      /* database country info   */
            pointer)                      /* SQLCA                   */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqledbcr_api');


 dcl sqlgdbcr                             /* CREATE DATABASE         */
     entry (fixed bin(16) unsigned,       /* length drive/path       */
            fixed bin(16) unsigned,       /* length database         */
            pointer,                      /* SQLCA                   */
            type sqledbcinfo byaddr,      /* database country info   */
            fixed bin(16) unsigned,       /* authentication          */
            type sqledbdesc byaddr,       /* db descriptor block     */
            char(*) varz byaddr,          /* drive/path              */
            char(*) varz byaddr)          /* database                */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlgdbcr');

 dcl sqlestar_api                         /* Start Database Manager  */
     entry ()
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlestar_api');

 /* PE V1.2 Start Database Manager structure */
 define structure
   1 sqledbstrtopt,
     2 isprofile  fixed bin(32) unsigned,     /* Profile specified? */
     2 profile    char(SQL_PROFILE_SZ) varz,  /* Profile */
     2 isnodenum  fixed bin(32) unsigned,   /* Node number specified? */
     2 nodenum    type SQL_PDB_NODE_TYPE,     /* Node number */
     2 iscommand  fixed bin(32) unsigned,     /* Command specified? */
     2 scommand   char(SQL_OPTION_SZ) varz,   /* Command */
     2 ishostname fixed bin(32) unsigned,     /* Hostname specified? */
     2 hostname   char(SQL_HOSTNAME_SZ) varz, /* Hostname */
     2 isport     fixed bin(32) unsigned,     /* Port specified? */
     2 port       type SQL_PDB_PORT_TYPE,     /* Port */
     2 isnetname  fixed bin(32) unsigned,     /* Netname specified? */
     2 netname    char(SQL_HOSTNAME_SZ) varz; /* Netname */

 dcl sqlepstr_api                   /* PE V1.2 Start Database        */
                                    /* Manager                       */
     entry (type sqledbstrtopt byaddr,/* START OPTIONS                */
            pointer)                /* SQLCA                         */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlepstr_api');

 dcl sqlgstar                       /* Start Database Manager        */
     entry ()
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlgstar');

 dcl sqlgpstr                       /* PE V1.2 Start Database        */
                                    /* Manager                       */
     entry (type sqledbstrtopt byaddr,/* START OPTIONS                */
            pointer)                /* SQLCA                         */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlgpstr');


 dcl sqlestop_api                   /* Stop Database Manager         */
     entry (pointer)                /* SQLCA                         */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlestop_api');


 dcl sqlgstdm                       /* Stop Database Manager         */
     entry (pointer )               /* SQLCA                         */
     returns (byvalue optional type SQL_API_RC)
     SQL_API_FN external('sqlgstdm');

 /********************************************************************/
 /*                                                                  */
 /* End of obsolete functions and symbols                            */
 /*                                                                  */
 /********************************************************************/

 %end; /* SQL_H_SQLENV */
