 /* WINCPIC contains the PL/I language declarations for the          */
 /* parameter values and entry points of the CPI Communications      */
 /* Protocol Boundary Interface services.                            */
   %DCL CM_ENTRY CHAR;
   %CM_ENTRY = 'OPTIONS (BYADDR NODESCRIPTOR LINKAGE (STDCALL))';

   /******************************************************************/
   /* Call ID Values                                                 */
   /******************************************************************/
   DECLARE
     ( cm_cmacci                        VALUE (1),
       cm_cmaccp                        VALUE (2),
       cm_cmallc                        VALUE (3),
       cm_cmcanc                        VALUE (4),
       cm_cmcfm                         VALUE (5),
       cm_cmcfmd                        VALUE (6),
       cm_cmcnvi                        VALUE (7),
       cm_cmcnvo                        VALUE (8),
       cm_cmdeal                        VALUE (9),
       cm_cmdfde                        VALUE (10),
       cm_cmeacn                        VALUE (11),
       cm_cmeaeq                        VALUE (12),
       cm_cmeapt                        VALUE (13),
       cm_cmecs                         VALUE (14),
       cm_cmect                         VALUE (15),
       cm_cmectx                        VALUE (16),
       cm_cmeid                         VALUE (17),
       cm_cmembs                        VALUE (18),
       cm_cmemn                         VALUE (19),
       cm_cmepid                        VALUE (20),
       cm_cmepln                        VALUE (21),
       cm_cmesi                         VALUE (22),
       cm_cmesl                         VALUE (23),
       cm_cmesrm                        VALUE (24),
       cm_cmesui                        VALUE (25),
       cm_cmetc                         VALUE (26),
       cm_cmetpn                        VALUE (27),
       cm_cmflus                        VALUE (28),
       cm_cmincl                        VALUE (29),
       cm_cminic                        VALUE (30),
       cm_cminit                        VALUE (31),
       cm_cmprep                        VALUE (32),
       cm_cmptr                         VALUE (33),
       cm_cmrcv                         VALUE (34),
       cm_cmrcvx                        VALUE (35),
       cm_cmrltp                        VALUE (36),
       cm_cmrts                         VALUE (37),
       cm_cmsac                         VALUE (38),
       cm_cmsacn                        VALUE (39),
       cm_cmsaeq                        VALUE (40),
       cm_cmsapt                        VALUE (41),
       cm_cmsbt                         VALUE (42),
       cm_cmscsp                        VALUE (43),
       cm_cmscst                        VALUE (44),
       cm_cmscsu                        VALUE (45),
       cm_cmsct                         VALUE (46),
       cm_cmscu                         VALUE (47),
       cm_cmsdt                         VALUE (48),
       cm_cmsed                         VALUE (49),
       cm_cmsend                        VALUE (50),
       cm_cmserr                        VALUE (51),
       cm_cmsf                          VALUE (52),
       cm_cmsid                         VALUE (53),
       cm_cmsld                         VALUE (54),
       cm_cmsltp                        VALUE (55),
       cm_cmsmn                         VALUE (56),
       cm_cmsndx                        VALUE (57),
       cm_cmspdp                        VALUE (58),
       cm_cmspid                        VALUE (59),
       cm_cmspln                        VALUE (60),
       cm_cmspm                         VALUE (61),
       cm_cmsptr                        VALUE (62),
       cm_cmsqcf                        VALUE (63),
       cm_cmsqpm                        VALUE (64),
       cm_cmsrc                         VALUE (65),
       cm_cmsrt                         VALUE (66),
       cm_cmssl                         VALUE (67),
       cm_cmssrm                        VALUE (68),
       cm_cmsst                         VALUE (69),
       cm_cmstc                         VALUE (70),
       cm_cmstpn                        VALUE (71),
       cm_cmtrts                        VALUE (72),
       cm_cmwait                        VALUE (73),
       cm_cmwcmp                        VALUE (74),
       cm_cmsjt                         VALUE (75),
       cm_cmemid                        VALUE (76),
       cm_cmsmid                        VALUE (77),
       cm_cmsndm                        VALUE (78),
       cm_cmrcvm                        VALUE (79)
     ) FIXED BINARY (31);

   /******************************************************************/
   /* AE Qual or AP Title Format Values, used for                    */
   /* AE Qualifier Format and AP Title Format parameters             */
   /******************************************************************/
   DECLARE
     ( CM_DN                            VALUE(0),
       CM_OID                           VALUE(1),
       CM_INT_DIGITS                    VALUE(2))
                                        FIXED BINARY(31);
   /******************************************************************/
   /*  Allocate Confirm Values                                       */
   /******************************************************************/
   DECLARE
     ( CM_ALLOCATE_NO_CONFIRM           VALUE(0),
       CM_ALLOCATE_CONFIRM              VALUE(1))
                                        FIXED BINARY(31);
   /******************************************************************/
   /*  Begin Transaction Values                                      */
   /******************************************************************/
   DECLARE
     ( CM_BEGIN_IMPLICIT                VALUE(0),
       CM_BEGIN_EXPLICIT                VALUE(1))
                                        FIXED BINARY(31);
   /******************************************************************/
   /*  Confirmation Urgency Values                                   */
   /******************************************************************/
   DECLARE
     ( CM_CONFIRMATION_NOT_URGENT       VALUE(0),
       CM_CONFIRMATION_URGENT           VALUE(1))
                                        FIXED BINARY(31);
   /******************************************************************/
   /*  Control Information Received, Request to Send Received Values */
   /*  Control Information Received is a superset of the old         */
   /*  Request to Send Received parameter.                           */
   /******************************************************************/
   DECLARE
     ( CM_NO_CONTROL_INFO_RECEIVED      VALUE(0),
       CM_REQ_TO_SEND_NOT_RECEIVED      VALUE(0),
       CM_REQ_TO_SEND_RECEIVED          VALUE(1),
       CM_ALLOCATE_CONFIRMED            VALUE(2),
       CM_ALLOCATE_CONFIRMED_WITH_DATA  VALUE(3),
       CM_ALLOCATE_REJECTED_WITH_DATA   VALUE(4),
       CM_EXPEDITED_DATA_AVAILABLE      VALUE(5),
       CM_RTS_RCVD_AND_EXP_DATA_AVAIL   VALUE(6))
                                        FIXED BINARY(31);
   /******************************************************************/
   /*  Conversation Queue Values                                     */
   /******************************************************************/
   DECLARE
     ( CM_INITIALIZATION_QUEUE          VALUE(0),
       CM_SEND_QUEUE                    VALUE(1),
       CM_RECEIVE_QUEUE                 VALUE(2),
       CM_SEND_RECEIVE_QUEUE            VALUE(3),
       CM_EXPEDITED_SEND_QUEUE          VALUE(4),
       CM_EXPEDITED_RECEIVE_QUEUE       VALUE(5))
                                        FIXED BINARY(31);
   /******************************************************************/
   /* Conversation State Values                                      */
   /******************************************************************/
   DECLARE
     ( cm_initialize_state              VALUE(2),
       cm_send_state                    VALUE(3),
       cm_receive_state                 VALUE(4),
       cm_send_pending_state            VALUE(5),
       cm_confirm_state                 VALUE(6),
       cm_confirm_send_state            VALUE(7),
       cm_confirm_deallocate_state      VALUE(8),
       cm_defer_receive_state           VALUE(9),
       cm_defer_deallocate_state        VALUE(10),
       cm_sync_point_state              VALUE(11),
       cm_sync_point_send_state         VALUE(12),
       cm_sync_point_deallocate_state   VALUE(13),
       cm_initialize_incoming_state     VALUE(14),
       cm_send_only_state               VALUE(15),
       cm_receive_only_state            VALUE(16),
       cm_send_receive_state            VALUE(17),
       cm_prepared_state                VALUE(18))
                                        FIXED BINARY(31);
   /******************************************************************/
   /* Conversation Type Values                                       */
   /******************************************************************/
   DECLARE
     ( cm_basic_conversation            VALUE(0),
       cm_mapped_conversation           VALUE(1))
                                        FIXED BINARY(31);
   /******************************************************************/
   /* Data Received Values                                           */
   /******************************************************************/
   DECLARE
     ( cm_no_data_received              VALUE(0),
       cm_data_received                 VALUE(1),
       cm_complete_data_received        VALUE(2),
       cm_incomplete_data_received      VALUE(3))
                                        FIXED BINARY(31);
   /******************************************************************/
   /* Deallocate Type Values                                         */
   /******************************************************************/
   DECLARE
     ( cm_deallocate_sync_level         VALUE(0),
       cm_deallocate_flush              VALUE(1),
       cm_deallocate_confirm            VALUE(2),
       cm_deallocate_abend              VALUE(3))
                                        FIXED BINARY(31);
   /******************************************************************/
   /*  Directory Encoding Values                                     */
   /******************************************************************/
   DECLARE
     ( CM_DEFAULT_ENCODING              VALUE(0),
       CM_UNICODE_ENCODING              VALUE(1))
                                        FIXED BINARY(31);
   /******************************************************************/
   /*  Directory Syntax Values                                       */
   /******************************************************************/
   DECLARE
     ( CM_DEFAULT_SYNTAX                VALUE(0),
       CM_DCE_SYNTAX                    VALUE(1),
       CM_XDS_SYNTAX                    VALUE(2),
       CM_NDS_SYNTAX                    VALUE(3))
                                        FIXED BINARY(31);
   /******************************************************************/
   /* Error Direction Values                                         */
   /******************************************************************/
   DECLARE
     ( cm_receive_error                 VALUE(0),
       cm_send_error                    VALUE(1))
                                        FIXED BINARY(31);
   /******************************************************************/
   /* Fill Values                                                    */
   /******************************************************************/
   DECLARE
     ( cm_fill_ll                       VALUE(0),
       cm_fill_buffer                   VALUE(1))
                                        FIXED BINARY(31);
   /******************************************************************/
   /*  Join Transaction Values                                       */
   /******************************************************************/
   DECLARE
     ( CM_JOIN_IMPLICIT                 VALUE(0),
       CM_JOIN_EXPLICIT                 VALUE(1))
                                        FIXED BINARY(31);
   /******************************************************************/
   /*  Partner ID Scope Values                                       */
   /******************************************************************/
   DECLARE
     ( CM_EXPLICIT                      VALUE(0),
       CM_REFERENCE                     VALUE(1))
                                        FIXED BINARY(31);
   /******************************************************************/
   /*  Partner ID Type Values                                        */
   /******************************************************************/
   DECLARE
     ( CM_DISTINGUISHED_NAME            VALUE(0),
       CM_LOCAL_DISTINGUISHED_NAME      VALUE(1),
       CM_PROGRAM_FUNCTION_ID           VALUE(2),
       CM_OSI_TPSU_TITLE_OID            VALUE(3),
       CM_PROGRAM_BINDING               VALUE(4))
                                        FIXED BINARY(31);
   /******************************************************************/
   /*  Prepare Data Permitted Values                                 */
   /******************************************************************/
   DECLARE
     ( CM_PREPARE_DATA_NOT_PERMITTED    VALUE(0),
       CM_PREPARE_DATA_PERMITTED        VALUE(1))
                                        FIXED BINARY(31);
   /******************************************************************/
   /* Prepare to Receive Type Values                                 */
   /******************************************************************/
   DECLARE
     ( cm_prep_to_receive_sync_level    VALUE(0),
       cm_prep_to_receive_flush         VALUE(1),
       cm_prep_to_receive_confirm       VALUE(2))
                                        FIXED BINARY(31);
   /******************************************************************/
   /*  Processing Mode Values                                        */
   /******************************************************************/
   DECLARE
     ( CM_BLOCKING                      VALUE(0),
       CM_NON_BLOCKING                  VALUE(1))
                                        FIXED BINARY(31);
   /******************************************************************/
   /* Receive Type Values                                            */
   /******************************************************************/
   DECLARE
     ( cm_receive_and_wait              VALUE(0),
       cm_receive_immediate             VALUE(1))
                                        FIXED BINARY(31);
   /******************************************************************/
   /* Return Code Values                                             */
   /******************************************************************/
   DECLARE
     ( cm_ok                            VALUE(0),
       cm_allocate_failure_no_retry     VALUE(1),
       cm_allocate_failure_retry        VALUE(2),
       cm_conversation_type_mismatch    VALUE(3),
       cm_pip_not_specified_correctly   VALUE(5),
       cm_security_not_valid            VALUE(6),
       cm_sync_lvl_not_supported_lu     VALUE(7),
       cm_sync_lvl_not_supported_pgm    VALUE(8),
       cm_tpn_not_recognized            VALUE(9),
       cm_tp_not_available_no_retry     VALUE(10),
       cm_tp_not_available_retry        VALUE(11),
       cm_deallocated_abend             VALUE(17),
       cm_deallocated_normal            VALUE(18),
       cm_parameter_error               VALUE(19),
       cm_product_specific_error        VALUE(20),
       cm_program_error_no_trunc        VALUE(21),
       cm_program_error_purging         VALUE(22),
       cm_program_error_trunc           VALUE(23),
       cm_program_parameter_check       VALUE(24),
       cm_program_state_check           VALUE(25),
       cm_resource_failure_no_retry     VALUE(26),
       cm_resource_failure_retry        VALUE(27),
       cm_unsuccessful                  VALUE(28),
       cm_deallocated_abend_svc         VALUE(30),
       cm_deallocated_abend_timer       VALUE(31),
       cm_svc_error_no_trunc            VALUE(32),
       cm_svc_error_purging             VALUE(33),
       cm_svc_error_trunc               VALUE(34),
       cm_operation_incomplete          VALUE(35),
       cm_system_event                  VALUE(36),
       cm_operation_not_accepted        VALUE(37),
       cm_conversation_ending           VALUE(38),
       cm_send_rcv_mode_not_supported   VALUE(39),
       cm_buffer_too_small              VALUE(40),
       cm_exp_data_not_supported        VALUE(41),
       cm_dealloc_confirm_reject        VALUE(42),
       cm_allocation_error              VALUE(43),
       cm_retry_limit_exceeded          VALUE(44),
       cm_no_secondary_information      VALUE(45),
       cm_security_not_supported        VALUE(46),
       cm_security_mutual_failed        VALUE(47),
       cm_call_not_supported            VALUE(48),
       cm_parm_value_not_supported      VALUE(49),
       cm_unknown_map_name_requested    VALUE(50),
       cm_unknown_map_name_received     VALUE(51),
       cm_map_routine_error             VALUE(52),
       cm_conversation_cancelled        VALUE(53),
       cm_take_backout                  VALUE(100),
       cm_deallocated_abend_bo          VALUE(130),
       cm_deallocated_abend_svc_bo      VALUE(131),
       cm_deallocated_abend_timer_bo    VALUE(132),
       cm_resource_fail_no_retry_bo     VALUE(133),
       cm_resource_failure_retry_bo     VALUE(134),
       cm_deallocated_normal_bo         VALUE(135),
       cm_conv_dealloc_after_syncpt     VALUE(136),
       cm_include_partner_reject_bo     VALUE(137))
                                        FIXED BINARY(31);
 /********************************************************************/
 /* Windows CPI-C Extension Return Codes.                            */
 /********************************************************************/
 DECLARE
   ( WCPICALREADY                       VALUE('0000F000'XN),
                              /* An async call is already outstanding*/
     WCPICINVALID                       VALUE('0000F001'XN),
                              /* Async Task Id is invalid            */
     WCPICCANCEL                        VALUE('0000F002'XN),
                              /* Blocking call was cancelled         */
     WCPICSYSNOTREADY                   VALUE('0000F003'XN),
                              /* Underlying subsystem not started    */
     WCPICVERNOTSUPPORTED               VALUE('0000F004'XN))
                              /* Application version not supported   */
                                        FIXED BINARY(31);
   /******************************************************************/
   /* Return Control Values                                          */
   /******************************************************************/
   DECLARE
     ( cm_when_session_allocated        VALUE(0),
       cm_immediate                     VALUE(1),
       cm_when_conwinner_allocated      VALUE(2),
       cm_when_session_free             VALUE(3))
                                        FIXED BINARY(31);
   /******************************************************************/
   /*  Send Receive Mode Values                                      */
   /******************************************************************/
   DECLARE
     ( CM_HALF_DUPLEX                   VALUE(0),
       CM_FULL_DUPLEX                   VALUE(1))
                                        FIXED BINARY(31);
   /******************************************************************/
   /* Send Type Values                                               */
   /******************************************************************/
   DECLARE
     ( cm_buffer_data                   VALUE(0),
       cm_send_and_flush                VALUE(1),
       cm_send_and_confirm              VALUE(2),
       cm_send_and_prep_to_receive      VALUE(3),
       cm_send_and_deallocate           VALUE(4))
                                        FIXED BINARY(31);
   /******************************************************************/
   /* Status Received Values                                         */
   /******************************************************************/
   DECLARE
     ( cm_no_status_received            VALUE(0),
       cm_send_received                 VALUE(1),
       cm_confirm_received              VALUE(2),
       cm_confirm_send_received         VALUE(3),
       cm_confirm_dealloc_received      VALUE(4),
       cm_take_commit                   VALUE(5),
       cm_take_commit_send              VALUE(6),
       cm_take_commit_deallocate        VALUE(7),
       cm_take_commit_data_ok           VALUE(8),
       cm_take_commit_send_data_ok      VALUE(9),
       cm_take_commit_dealloc_data_ok   VALUE(10),
       cm_prepare_ok                    VALUE(11),
       cm_join_transaction              VALUE(12))
                                        FIXED BINARY(31);
   /******************************************************************/
   /* Sync Level Values                                              */
   /******************************************************************/
   DECLARE
     (
 %dcl #CM_NONE char ext;
 %if #CM_NONE = '' %then %do;
 %#CM_NONE = 'Y';
 /* Potential name clash with WinGDI, but both have same value */
       cm_none                          VALUE(0),
 %end;
       cm_confirm                       VALUE(1),
       cm_sync_point                    VALUE(2),
       cm_sync_point_no_confirm         VALUE(3))
                                        FIXED BINARY(31);
   /******************************************************************/
   /* Conversation Security Type Values                              */
   /******************************************************************/
   DECLARE
     ( CM_SECURITY_NONE                 VALUE(0),
       CM_SECURITY_SAME                 VALUE(1),
       CM_SECURITY_PROGRAM              VALUE(2),
       CM_SECURITY_DISTRIBUTED          VALUE(3),
       CM_SECURITY_MUTUAL               VALUE(4),
       CM_SECURITY_PROGRAM_STRONG       VALUE(5))
                                        FIXED BINARY(31);
   /******************************************************************/
   /* Transaction Control Values                                      */
   /******************************************************************/
   DECLARE
     ( CM_CHAINED_TRANSACTIONS          VALUE(0),
       CM_UNCHAINED_TRANSACTIONS        VALUE(1))
                                        FIXED BINARY(31);

   /******************************************************************/
   /* SAA CPI Communications Accept Conversation Verb                */
   /******************************************************************/
   DECLARE
     CMACCP ENTRY
       ( CHAR(8),                   /* Out - Conversation ID         */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmaccp') CM_ENTRY;
   /******************************************************************/
   /* CPI Communications Accept Incoming Call                        */
   /******************************************************************/
   DECLARE
     CMACCI ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmacci') CM_ENTRY;
   /******************************************************************/
   /* SAA CPI Communications Allocate Verb                           */
   /******************************************************************/
   DECLARE
     CMALLC ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmallc') CM_ENTRY;
   /******************************************************************/
   /* CPI Communications Cancel Call                                 */
   /******************************************************************/
   DECLARE
     CMCANC ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmcanc') CM_ENTRY;
   /******************************************************************/
   /* SAA CPI Communications Confirm Verb                            */
   /******************************************************************/
   DECLARE
     CMCFM ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31),          /* Out - Req to send Received    */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmcfm') CM_ENTRY;
   /******************************************************************/
   /* SAA CPI Communications Confirmed Verb                          */
   /******************************************************************/
   DECLARE
     CMCFMD ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmcfmd') CM_ENTRY;
   /******************************************************************/
   /* CPI Communications Convert Incoming Call                       */
   /******************************************************************/
   DECLARE
     CMCNVI ENTRY
       ( CHAR(*),                   /* In/Out - Buffer               */
         FIXED BINARY(31),          /* In  - Buffer Length           */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmcnvi') CM_ENTRY;
   /******************************************************************/
   /* CPI Communications Convert Outgoing Call                       */
   /******************************************************************/
   DECLARE
     CMCNVO ENTRY
       ( CHAR(*),                   /* In/Out - Buffer               */
         FIXED BINARY(31),          /* In  - Buffer Length           */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmcnvo') CM_ENTRY;
   /******************************************************************/
   /* SAA CPI Communications Deallocate Verb                         */
   /******************************************************************/
   DECLARE
     CMDEAL ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmdeal') CM_ENTRY;
   /******************************************************************/
   /* CPI Communications Deferred Deallocate Call                    */
   /******************************************************************/
   DECLARE
     CMDFDE ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmdfde') CM_ENTRY;
   /******************************************************************/
   /* CPI Communications Extract AE Qualifier Call                   */
   /******************************************************************/
   DECLARE
     CMEAEQ ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         CHAR(32),                  /* Out - AE Qualifier            */
         FIXED BINARY(31),          /* Out - AE Qualifier Length     */
         FIXED BINARY(31),          /* Out - AE Qualifier Format     */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmeaeq') CM_ENTRY;
   /******************************************************************/
   /* CPI Communications Extract AP Title Call                       */
   /******************************************************************/
   DECLARE
     CMEAPT ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         CHAR(32),                  /* Out - AP Title                */
         FIXED BINARY(31),          /* Out - AP Title Length         */
         FIXED BINARY(31),          /* Out - AP Title Format         */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmeapt') CM_ENTRY;
   /******************************************************************/
   /* CPI Communications Extract Application Context Call            */
   /******************************************************************/
   DECLARE
     CMEACN ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         CHAR(32),                  /* Out - Application Context     */
         FIXED BINARY(31),          /* Out - Application Context Leng*/
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmeacn') CM_ENTRY;
   /******************************************************************/
   /* SAA CPI Communications Extract_Conversation_State Verb         */
   /******************************************************************/
   DECLARE
     CMECS ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31),          /* Out - Conversation State      */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmecs') CM_ENTRY;

   /******************************************************************/
   /* CPI Communications Extract Conversation Security Type          */
   /******************************************************************/
   DECLARE
     CMECST ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31),          /* Out - Conversation Security   */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmecst') CM_ENTRY;

   /******************************************************************/
   /* CPI Communications Extract Conversation Context                */
   /******************************************************************/
   DECLARE
     CMECTX ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         CHAR(32),                  /* Out - Context                 */
         FIXED BINARY(31),          /* Out - Context Length          */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmectx') CM_ENTRY;
   /******************************************************************/
   /* CPI Communications Extract Initialization Data Call            */
   /******************************************************************/
   DECLARE
     CMEID ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         CHAR(*),                   /* Out - Initialization Data     */
         FIXED BINARY(31),          /* In  - Requested Length        */
         FIXED BINARY(31),          /* Out - Initialization Data Leng*/
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmeid') CM_ENTRY;
   /******************************************************************/
   /* SAA CPI Communications Extract_Conversation_Type Verb          */
   /******************************************************************/
   DECLARE
     CMECT ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31),          /* Out - Conversation Type       */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmect') CM_ENTRY;
   /******************************************************************/
   /* SAA CPI Communications Extract_Mode_Name Verb                  */
   /******************************************************************/
   DECLARE
     CMEMN ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         CHAR(8),                   /* Out - Mode Name               */
         FIXED BINARY(31),          /* Out - Mode Name Length        */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmemn') CM_ENTRY;
   /******************************************************************/
   /* CPI Communications Extract Maximum Buffer Size                 */
   /******************************************************************/
   DECLARE
     CMEMBS ENTRY
       ( FIXED BINARY(31),          /* Out - Maximum Buffer Size     */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmembs') CM_ENTRY;
   /******************************************************************/
   /* CPI Communications Extract Mapped Initialization Data Call     */
   /******************************************************************/
   DECLARE
     CMEMID ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         CHAR(*),                   /* Out - Local Map Name          */
         FIXED BINARY(31),          /* Out - Map Name Length         */
         CHAR(*),                   /* Out - Initialization Data     */
         FIXED BINARY(31),          /* In  - Requested Length        */
         FIXED BINARY(31),          /* Out - Initialization Data Leng*/
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmemid') CM_ENTRY;
   /******************************************************************/
   /* CPI Communications Extract Partner ID Call                     */
   /******************************************************************/
   DECLARE
     CMEPID ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31),          /* Out - Partner ID Type         */
         CHAR(*),                   /* Out - Partner ID              */
         FIXED BINARY(31),          /* In  - Requested Length        */
         FIXED BINARY(31),          /* Out - Partner ID Length       */
         FIXED BINARY(31),          /* Out - Partner ID Scope        */
         FIXED BINARY(31),          /* Out - Directory Syntax        */
         FIXED BINARY(31),          /* Out - Directory Encoding      */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmepid') CM_ENTRY;
   /******************************************************************/
   /* SAA CPI Communications Extract_Partner_LU_Name Verb            */
   /******************************************************************/
   DECLARE
     CMEPLN ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         CHAR(17),                  /* Out - Partner LU name         */
         FIXED BINARY(31),          /* Out - Partner LU name length  */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmepln') CM_ENTRY;
   /******************************************************************/
   /* CPI Communications Extract Secondary Information Call          */
   /******************************************************************/
   DECLARE
     CMESI ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31),          /* Out - Call ID                 */
         CHAR(*),                   /* Out - Buffer                  */
         FIXED BINARY(31),          /* In  - Requested Length        */
         FIXED BINARY(31),          /* Out - Data Received           */
         FIXED BINARY(31),          /* Out - Received Length         */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmesi') CM_ENTRY;
   /******************************************************************/
   /* SAA CPI Communications Extract_Sync_Level Verb                 */
   /******************************************************************/
   DECLARE
     CMESL ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31),          /* Out - Sync Level              */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmesl') CM_ENTRY;
   /******************************************************************/
   /* CPI Communications Extract_Send_Receive_Mode Call              */
   /******************************************************************/
   DECLARE
     CMESRM ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31),          /* Out - Send Receive Mode       */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmesrm') CM_ENTRY;
   /******************************************************************/
   /*  SAA CPI Communications Extract Conversation Security User ID  */
   /******************************************************************/
   DECLARE
     CMESUI ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         CHAR(10),                  /* Out - Security User ID        */
         FIXED BINARY(31),          /* Out - Security User ID Length */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmesui') CM_ENTRY;
   /******************************************************************/
   /* CPI Communications Extract TP Name Call                        */
   /******************************************************************/
   DECLARE
     CMETPN ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         CHAR(64),                  /* Out - TP Name                 */
         FIXED BINARY(31),          /* Out - TP Name Length          */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmetpn') CM_ENTRY;
   /******************************************************************/
   /* CPI Communications Extract Transaction Control Call            */
   /******************************************************************/
   DECLARE
     CMETC ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31),          /* Out - Transaction Control     */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmetc') CM_ENTRY;
   /******************************************************************/
   /* SAA CPI Communications Flush Verb                              */
   /******************************************************************/
   DECLARE
     CMFLUS ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmflus') CM_ENTRY;
   /******************************************************************/
   /* CPI Communications Include Partner In Transaction Call         */
   /******************************************************************/
   DECLARE
     CMINCL ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmincl') CM_ENTRY;
   /******************************************************************/
   /* CPI Communications Initialize For Incoming Call                */
   /******************************************************************/
   DECLARE
     CMINIC ENTRY
       ( CHAR(8),                   /* Out - Conversation ID         */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cminic') CM_ENTRY;
   /******************************************************************/
   /* SAA CPI Communications Initialize Conversation Verb            */
   /******************************************************************/
   DECLARE
     CMINIT ENTRY
       ( CHAR(8),                   /* Out - Conversation ID         */
         CHAR(8),                   /* In  - Symbolic Dest Name      */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cminit') CM_ENTRY;
   /******************************************************************/
   /* CPI Communications Prepare Call                                */
   /******************************************************************/
   DECLARE
     CMPREP ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmprep') CM_ENTRY;
   /******************************************************************/
   /* SAA CPI Communications Prepare to Receive Verb                 */
   /******************************************************************/
   DECLARE
     CMPTR ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmptr') CM_ENTRY;
   /******************************************************************/
   /* SAA CPI Communications Receive Verb                            */
   /******************************************************************/
   DECLARE
     CMRCV ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         CHAR(*),                   /* Out - Buffer                  */
         FIXED BINARY(31),          /* In  - Requested Length        */
         FIXED BINARY(31),          /* Out - Data Received           */
         FIXED BINARY(31),          /* Out - Received Length         */
         FIXED BINARY(31),          /* Out - Status Received         */
         FIXED BINARY(31),          /* Out - Request To Send Received*/
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmrcv') CM_ENTRY;
   /******************************************************************/
   /* CPI Communications Receive Mapped Call                         */
   /******************************************************************/
   DECLARE
     CMRCVM ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         CHAR(*),                   /* Out - Local Map Name          */
         FIXED BINARY(31),          /* Out - Map Name Length         */
         CHAR(*),                   /* Out - Buffer                  */
         FIXED BINARY(31),          /* In  - Requested Length        */
         FIXED BINARY(31),          /* Out - Data Received           */
         FIXED BINARY(31),          /* Out - Status Received         */
         FIXED BINARY(31),          /* Out - Control Info Received   */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmrcvm') CM_ENTRY;
   /******************************************************************/
   /* CPI Communications Receive Expedited Data Call                 */
   /******************************************************************/
   DECLARE
     CMRCVX ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         CHAR(*),                   /* Out - Buffer                  */
         FIXED BINARY(31),          /* In  - Requested Length        */
         FIXED BINARY(31),          /* Out - Received Length         */
         FIXED BINARY(31),          /* In  - Expedited Receive Type  */
         FIXED BINARY(31),          /* Out - Control Information Rcvd*/
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmrcvx') CM_ENTRY;
   /******************************************************************/
   /* CPI Communications Release Local TP Name                       */
   /******************************************************************/
   DECLARE
     CMRLTP ENTRY
       ( CHAR(64),                  /* In  - TP Name                 */
         FIXED BINARY(31),          /* In  - TP Name Length          */
         FIXED BINARY(31) )         /* In  - Return Code             */
       EXTERNAL ('cmrltp') CM_ENTRY;
   /******************************************************************/
   /* SAA CPI Communications Request to Send Verb                    */
   /******************************************************************/
   DECLARE
     CMRTS ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmrts') CM_ENTRY;
   /******************************************************************/
   /* SAA CPI Communications Send Data Verb                          */
   /******************************************************************/
   DECLARE
     CMSEND ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         CHAR(*),                   /* In  - Buffer                  */
         FIXED BINARY(31),          /* In  - Send Length             */
         FIXED BINARY(31),          /* Out - Request To Send Received*/
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmsend') CM_ENTRY;
   /******************************************************************/
   /* SAA CPI Communications Send Error Verb                         */
   /******************************************************************/
   DECLARE
     CMSERR ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31),          /* Out - Request To Send Received*/
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmserr') CM_ENTRY;
   /******************************************************************/
   /* CPI Communications Send Mapped Data Call                       */
   /******************************************************************/
   DECLARE
     CMSNDM ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         CHAR(64),                  /* In  - Local Map Name          */
         FIXED BINARY(31),          /* In  - Map Name Length         */
         CHAR(*),                   /* In  - Buffer                  */
         FIXED BINARY(31),          /* In  - Send Length             */
         FIXED BINARY(31),          /* Out - Control Info Received   */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmsndm') CM_ENTRY;
   /******************************************************************/
   /* CPI Communications Send Expedited Data Call                    */
   /******************************************************************/
   DECLARE
     CMSNDX ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         CHAR(*),                   /* In  - Buffer                  */
         FIXED BINARY(31),          /* In  - Send Length             */
         FIXED BINARY(31),          /* Out - Control Information Rcvd*/
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmsndx') CM_ENTRY;
   /******************************************************************/
   /* CPI Communications Set AE Qualifier Call                       */
   /******************************************************************/
   DECLARE
     CMSAEQ ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         CHAR(*),                   /* In  - AE Qualifier            */
         FIXED BINARY(31),          /* In  - AE Qualifier Length     */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmsaeq') CM_ENTRY;
   /******************************************************************/
   /* CPI Communications Set Allocate Confirm Call                   */
   /******************************************************************/
   DECLARE
     CMSAC ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31),          /* In  - Allocate Confirm        */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmsac') CM_ENTRY;
   /******************************************************************/
   /* CPI Communications Set AP Title Call                           */
   /******************************************************************/
   DECLARE
     CMSAPT ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         CHAR(*),                   /* In  - AP Title                */
         FIXED BINARY(31),          /* In  - AP Title Length         */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmsapt') CM_ENTRY;
   /******************************************************************/
   /* CPI Communications Set Application Context Name Call           */
   /******************************************************************/
   DECLARE
     CMSACN ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         CHAR(*),                   /* In  - Application Context Name*/
         FIXED BINARY(31),          /* In  - Application Context Leng*/
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmsacn') CM_ENTRY;
   /******************************************************************/
   /* CPI Communications Set Begin Transaction Call                  */
   /******************************************************************/
   DECLARE
     CMSBT ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31),          /* In  - Begin Transaction       */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmsbt') CM_ENTRY;
   /******************************************************************/
   /* SAA CPI Communications Set Conversation Security Password       */
   /******************************************************************/
   DECLARE
     CMSCSP ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         CHAR(10),                  /* In  - Security password       */
         FIXED BINARY(31),          /* In  - Security password length*/
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmscsp') CM_ENTRY;
   /******************************************************************/
   /* SAA CPI Communications Set Conversation Security Type          */
   /******************************************************************/
   DECLARE
     CMSCST ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31),          /* In  - Conv. security type     */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmscst') CM_ENTRY;
   /******************************************************************/
   /* SAA CPI Communications Extract Conversation Security User ID   */
   /******************************************************************/
   DECLARE
     CMSCSU ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         CHAR(10),                  /* In  - Security User ID        */
         FIXED BINARY(31),          /* In  - Security User ID Length */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmscsu') CM_ENTRY;
   /******************************************************************/
   /* SAA CPI Communications Set Conversation Type Verb              */
   /******************************************************************/
   DECLARE
     CMSCT ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31),          /* In  - Conversation Type       */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmsct') CM_ENTRY;
   /******************************************************************/
   /* CPI Communications Set Confirmation Urgency Call               */
   /******************************************************************/
   DECLARE
     CMSCU ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31),          /* In  - Confirmation Urgency    */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmscu') CM_ENTRY;
   /******************************************************************/
   /* SAA CPI Communications Set Deallocate Type Verb                */
   /******************************************************************/
   DECLARE
     CMSDT ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31),          /* In  - Deallocate Type         */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmsdt') CM_ENTRY;
   /******************************************************************/
   /* SAA CPI Communications Set Error Direction Verb                */
   /******************************************************************/
   DECLARE
     CMSED ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31),          /* In  - Error Direction         */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmsed') CM_ENTRY;
   /******************************************************************/
   /* SAA CPI Communications Set Fill Verb                           */
   /******************************************************************/
   DECLARE
     CMSF ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31),          /* In  - Fill                    */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmsf') CM_ENTRY;
   /******************************************************************/
   /* CPI Communications Set Initialization Data Call                */
   /******************************************************************/
   DECLARE
     CMSID ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         CHAR(*),                   /* In  - Initialization Data     */
         FIXED BINARY(31),          /* In  - Initialization Data Leng*/
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmsid') CM_ENTRY;
   /******************************************************************/
   /* CPI Communications Set Join Transaction Call                   */
   /******************************************************************/
   DECLARE
     CMSJT ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31),          /* In  - Join Transaction        */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmsjt') CM_ENTRY;
   /******************************************************************/
   /* SAA CPI Communications Set Log Data Verb                       */
   /******************************************************************/
   DECLARE
     CMSLD ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         CHAR(*),                   /* In  - Log Data                */
         FIXED BINARY(31),          /* In  - Log Data Length         */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmsld') CM_ENTRY;
   /******************************************************************/
   /* CPI Communications Set Mapped Initialization Data Call         */
   /******************************************************************/
   DECLARE
     CMSMID ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         CHAR(64),                  /* In  - Local Map Name          */
         FIXED BINARY(31),          /* In  - Map Name Length         */
         CHAR(*),                   /* In  - Initialization Data     */
         FIXED BINARY(31),          /* In  - Initialization Data Len */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmsmid') CM_ENTRY;
   /******************************************************************/
   /* SAA CPI Communications Set Mode Name Verb                      */
   /******************************************************************/
   DECLARE
     CMSMN ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         CHAR(8),                   /* In  - Mode Name               */
         FIXED BINARY(31),          /* In  - Mode Name Length        */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmsmn') CM_ENTRY;
   /******************************************************************/
   /* CPI Communications Set Partner ID Call                         */
   /******************************************************************/
   DECLARE
     CMSPID ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31),          /* In  - Partner ID Type         */
         CHAR(*),                   /* In  - Partner ID              */
         FIXED BINARY(31),          /* In  - Partner ID Length       */
         FIXED BINARY(31),          /* In  - Partner ID Scope        */
         FIXED BINARY(31),          /* In  - Directory Syntax        */
         FIXED BINARY(31),          /* In  - Directory Encoding      */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmspid') CM_ENTRY;
   /******************************************************************/
   /* SAA CPI Communications Set Partner LU Name Verb                */
   /******************************************************************/
   DECLARE
     CMSPLN ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         CHAR(17),                  /* In  - Partner LU Name         */
         FIXED BINARY(31),          /* In  - Partner LU Name Length  */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmspln') CM_ENTRY;
   /******************************************************************/
   /* CPI Communications Set Prepare Data Permitted Call             */
   /******************************************************************/
   DECLARE
     CMSPDP ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31),          /* In  - Prepare Data Permitted  */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmspdp') CM_ENTRY;
   /******************************************************************/
   /* SAA CPI Communications Set Prepare To Receive Type Verb        */
   /******************************************************************/
   DECLARE
     CMSPTR ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31),          /* In  - Prepare To Receive Type */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmsptr') CM_ENTRY;
   /******************************************************************/
   /* CPI Communications Set Processing Mode Call                    */
   /******************************************************************/
   DECLARE
     CMSPM ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31),          /* In  - Processing Mode         */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmspm') CM_ENTRY;
   /******************************************************************/
   /* CPI Communications Set Queue Processing Mode Call              */
   /******************************************************************/
   DECLARE
     CMSQPM ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31),          /* In  - Conversation Queue      */
         FIXED BINARY(31),          /* In  - Queue Processing Mode   */
         CHAR(8),                   /* In  - User Field              */
         FIXED BINARY(31),          /* Out - OOID                    */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmsqpm') CM_ENTRY;
   /******************************************************************/
   /* SAA CPI Communications Set Receive Type Verb                   */
   /******************************************************************/
   DECLARE
     CMSRT ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31),          /* In  - Receive Type            */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmsrt') CM_ENTRY;
   /******************************************************************/
   /* SAA CPI Communications Set Return Control Verb                 */
   /******************************************************************/
   DECLARE
     CMSRC ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31),          /* In  - Return Control          */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmsrc') CM_ENTRY;
   /******************************************************************/
   /* CPI Communications Set Send Receive Mode Call                  */
   /******************************************************************/
   DECLARE
     CMSSRM ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31),          /* In  - Send Receive Mode       */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmssrm') CM_ENTRY;
   /******************************************************************/
   /* SAA CPI Communications Set Send Type Verb                      */
   /******************************************************************/
   DECLARE
     CMSST ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31),          /* In  - Send Type               */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmsst') CM_ENTRY;
   /******************************************************************/
   /* SAA CPI Communications Set Sync Level Verb                     */
   /******************************************************************/
   DECLARE
     CMSSL ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31),          /* In  - Sync Level              */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmssl') CM_ENTRY;
   /******************************************************************/
   /* SAA CPI Communications Set TP Name Verb                        */
   /******************************************************************/
   DECLARE
     CMSTPN ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         CHAR(64),                  /* In  - TP Name                 */
         FIXED BINARY(31),          /* In  - TP Name Length          */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmstpn') CM_ENTRY;
   /******************************************************************/
   /* CPI Communications Set Transaction Control Call                */
   /******************************************************************/
   DECLARE
     CMSTC ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31),          /* In  - Transaction Control     */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmstc') CM_ENTRY;
   /******************************************************************/
   /* CPI Communications Specify Local TP Name                       */
   /******************************************************************/
   DECLARE
     CMSLTP ENTRY
       ( CHAR(64),                  /* In  - TP Name                 */
         FIXED BINARY(31),          /* In  - TP Name Length          */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmsltp') CM_ENTRY;
   /******************************************************************/
   /* SAA CPI Communications Test Request To Send Received Verb      */
   /******************************************************************/
   DECLARE
     CMTRTS ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31),          /* Out - Request To Send Received*/
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmtrts') CM_ENTRY;
   /******************************************************************/
   /* CPI Communications Wait For Conversation Call                  */
   /******************************************************************/
   DECLARE
     CMWAIT ENTRY
       ( CHAR(8),                   /* Out - Conversation ID         */
         FIXED BINARY(31),          /* Out - Conversation Return Code*/
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('cmwait') CM_ENTRY;
   /******************************************************************/
   /* CPI Communications Wait For Completion Call                    */
   /******************************************************************/
   DECLARE
     CMWCMP ENTRY
       ( CHAR(*),                /* In  - OOID List                  */
         FIXED BINARY(31),       /* In  - OOID List Count            */
         FIXED BINARY(31),       /* In  - Timeout                    */
         CHAR(*),                /* Out - Completed OP Index List    */
         FIXED BINARY(31),       /* Out - Completed OP Count         */
         CHAR(*),                /* Out - User Field List            */
         FIXED BINARY(31) )      /* Out - Return Code                */
       EXTERNAL ('cmwcmp') CM_ENTRY;

   /*************************************/
   /* Windows specific extension calls: */
   /*************************************/

   DECLARE
     ( xc_security_none                 VALUE(0),
       xc_security_same                 VALUE(1),
       xc_security_program              VALUE(2))
                                        FIXED BINARY(31);
   /******************************************************************/
   /* TP Name Type                                                   */
   /******************************************************************/
   DECLARE
     ( xc_application_tp                VALUE(0),
       xc_sna_service_tp                VALUE(1))
                                        FIXED BINARY(31);
   /******************************************************************/
   /* End TP Type                                                    */
   /******************************************************************/
   DECLARE
     ( xc_soft                          VALUE(0),
       xc_hard                          VALUE(1))
                                        FIXED BINARY(31);

   /******************************************************************/
   /* Windows Extension Call Extract Conversation Security Type      */
   /******************************************************************/
   DECLARE
     XCECST ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31),          /* Out - Conv. security type     */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('xcecst') CM_ENTRY;
   /******************************************************************/
   /* Windows Extension Call Extract Conversation Security User ID   */
   /******************************************************************/
   DECLARE
     XCECSU ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         CHAR(10),                  /* Out - Security User ID        */
         FIXED BINARY(31),          /* Out - Security User ID Length */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('xcecsu') CM_ENTRY;
   /******************************************************************/
   /* Windows Extension Call Initialize Conversation for TP          */
   /******************************************************************/
   DECLARE
     XCINCT ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         CHAR(8),                   /* In  - Symbolic dest name      */
         CHAR(12),                  /* In  - CPIC TP ID              */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('xcinct') CM_ENTRY;
   /******************************************************************/
   /* Windows Extension Call Set Conversation Security Password      */
   /******************************************************************/
   DECLARE
     XCSCSP ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         CHAR(8),                   /* In  - Security password       */
         FIXED BINARY(31),          /* In  - Security password length*/
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('xcscsp') CM_ENTRY;
   /******************************************************************/
   /* Windows Extension Call Set Conversation Security Type          */
   /******************************************************************/
   DECLARE
     XCSCST ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         FIXED BINARY(31),          /* In  - Conv. security type     */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('xcscst') CM_ENTRY;
   /******************************************************************/
   /* Windows Extension Call Extract Conversation Security User ID   */
   /******************************************************************/
   DECLARE
     XCSCSU ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         CHAR(10),                  /* In  - Security User ID        */
         FIXED BINARY(31),          /* In  - Security User ID Length */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('xcscsu') CM_ENTRY;

   /******************************************************************/
   /* Windows Extension Call End TP                                  */
   /******************************************************************/
   DECLARE
     XCENDT ENTRY
       ( CHAR(12),                  /* In  - CPIC TP ID              */
         FIXED BINARY(31),          /* In  - Resource release type   */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('xcendt') CM_ENTRY;
   /******************************************************************/
   /* Windows Extension Call Extract TP ID                           */
   /******************************************************************/
   DECLARE
     XCETI  ENTRY
       ( CHAR(8),                   /* In  - Conversation ID         */
         CHAR(12),                  /* Out - CPIC TP ID              */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('xceti') CM_ENTRY;
   /******************************************************************/
   /* Windows Extension Call Start TP                                */
   /******************************************************************/
   DECLARE
     XCSTP  ENTRY
       ( CHAR(8),                   /* In  - Local LU alias          */
         FIXED BINARY(31),          /* In  - Local LU alias length   */
         CHAR(64),                  /* In  - TP Name                 */
         FIXED BINARY(31),          /* In  - TP Name Length          */
         FIXED BINARY(31),          /* In  - TP Type                 */
         CHAR(12),                  /* Out - CPIC TP ID              */
         FIXED BINARY(31) )         /* Out - Return Code             */
       EXTERNAL ('xcstp') CM_ENTRY;

   /******************************************************************/
   /* Windows CPI-C Initialization and Termination Calls             */
   /******************************************************************/
   DECLARE WCPICDESCRIPTION_LEN FIXED BIN (15) VALUE (127);

   DEFINE STRUCTURE
     1 WCPICDATA,
       3 wVersion      fixed bin (16) unsigned,            /* WORD   */
       3 SzDescription char (WCPICDESCRIPTION_LEN) varz;
   DEFINE ALIAS  PWCPICDATA HANDLE WCPICDATA;
   DEFINE ALIAS LPWCPICDATA HANDLE WCPICDATA;

   DECLARE
     WinCPICStartup ENTRY
       (fixed bin (16) unsigned,                           /* WORD   */
        TYPE WCPICDATA byaddr)
       options (byvalue nodescriptor linkage (stdcall))    /* WINAPI */
       external ('WinCPICStartup');
   DECLARE
     WinCPICCleanup ENTRY ()
       returns (fixed bin (31) optional)                   /* BOOL   */
       options (byvalue nodescriptor linkage (stdcall))    /* WINAPI */
       external ('WinCPICCleanup');

   /******************************************************************/
   /* Windows Specify Windows Handle (non-blocking notification)     */
   /******************************************************************/
   DECLARE
     xchwnd ENTRY
       ( ptr byvalue,                                       /* HWND   */
         fixed bin (31))
       returns (fixed bin (31) optional)                    /* BOOL   */
       EXTERNAL ('xchwnd') CM_ENTRY;

