 /*  WS2TCPIP.H - WinSock2 Extension for TCP/IP protocols       */
 /*                                                             */
 /*  This file contains TCP/IP specific information for use     */
 /*  by WinSock2 compatible applications.                       */
 /*                                                             */
 /*  To provide the backward compatibility, all the TCP/IP      */
 /*  specific definitions that were included in the WINSOCK.CPY */
 /*  file are now included in WINSOCK2.CPY file. WS2TCPIP.CPY   */
 /*  file includes only the definitions  introduced in the      */
 /*  WinSock 2 Protocol-Specific Annex document.                */
 /*                                                             */
 /*  Rev 0.2 Aug 10, 1995                                       */
 /*                                                             */

 %dcl #WS2TCPIP_H_ char ext;
 %if #WS2TCPIP_H_ = '' %then %do;
   %#WS2TCPIP_H_ = 'Y';

 /* Structure to keep interface specific information */

 define structure 
   1 INTERFACE_INFO,
     2 iiFlags            type u_long,   /* Interface flags   */
     2 iiAddress          type sockaddr, /* Interface address */
     2 iiBroadcastAddress type sockaddr, /* Broadcast address */
     2 iiNetmask          type sockaddr; /* Network mask      */
 define alias LPINTERFACE_INFO handle INTERFACE_INFO;

 /* Possible flags for the  iiFlags - bitmask  */

 dcl ( IFF_UP           value('00000001'xn) /* Interface is up        */
     , IFF_BROADCAST    value('00000002'xn) /* Broadcast is supported */
     , IFF_LOOPBACK     value('00000004'xn) /* this is loopback       */
     , IFF_POINTTOPOINT value('00000008'xn) /* this is point-to-point */
     , IFF_MULTICAST    value('00000010'xn) /* multicast is supported */
     ) fixed bin (31);

 /* Argument structure for IP_ADD_MEMBERSHIP and IP_DROP_MEMBERSHIP */
 define structure 
   1 ip_mreq,
     2 imr_multiaddr type in_addr, /* IP multicast address of group */
     2 imr_interface type in_addr; /* local IP address of interface */


 /* TCP/IP specific Ioctl codes */
 dcl SIO_GET_INTERFACE_LIST fixed bin (31)  /* <TBD> */

     value (#IOR ('t', 127, u_long));

 /* Option to use with [gs]etsockopt at the IPPROTO_IP level */

 dcl ( IP_OPTIONS         value( 1) /* set/get IP options             */
     , IP_HDRINCL         value( 2) /* header is included with data   */
     , IP_TOS             value( 3) /* IP type of service and preced  */
     , IP_TTL             value( 4) /* IP time to live                */
     , IP_MULTICAST_IF    value( 9) /* set/get IP multicast i/f       */
     , IP_MULTICAST_TTL   value(10) /* set/get IP multicast ttl       */
     , IP_MULTICAST_LOOP  value(11) /*set/get IP multicast loopback   */
     , IP_ADD_MEMBERSHIP  value(12) /* add an IP group membership     */
     , IP_DROP_MEMBERSHIP value(13) /* drop an IP group membership    */
     , IP_DONTFRAGMENT    value(14) /* don't fragment IP datagrams    */
     ) fixed bin (31);
 /* Option to use with [gs]etsockopt at the IPPROTO_UDP level */
 dcl UDP_NOCHECKSUM       fixed bin(31) value(1);

 /* Option to use with [gs]etsockopt at the IPPROTO_TCP level */
 dcl TCP_EXPEDITED_1122   fixed bin(31) value('0002'xn);

 %end; /* _WS2TCPIP_H_ */
