 /* $XConsortium: Xlib.h,v 11.221 93/07/02 14:13:28 gildea Exp $      */
 /* Copyright 1985, 1986, 1987, 1991 by the Massachusetts Institute   */
 /* of Technology                                                     */
 /*                                                                   */
 /* Permission to use, copy, modify, and distribute this software and */
 /* its documentation for any purpose and without fee is hereby       */
 /* granted, provided that the above copyright notice appear in all   */
 /* copies and that both that copyright notice and this permission    */
 /* notice appear in supporting documentation, and that the name of   */
 /* M.I.T. not be used in advertising or publicity pertaining to      */
 /* distribution of the software without specific, written prior      */
 /* permission. M.I.T. makes no representations about the suitability */
 /* of this software for any purpose. It is provided "as is" without  */
 /* express or implied warranty.                                      */
 /*                                                                   */
 /* X Window System is a Trademark of MIT.                            */


 /* Xlib.cpy - Header definition and support file for the PL/I        */
 /* subroutine interface library (Xlib) to the X Window System        */
 /* Protocol (V11). Structures and symbols starting with "_" are      */
 /* private to the library.                                           */

 %dcl #XLIB_H_ char ext;
 %if #XLIB_H_ = '' %then %do;
 %#XLIB_H_ = 'Y';

 dcl XlibSpecificationRelease fixed bin(31) value(5);

 %include "X11\X.cpy";

 %dcl #WCHAR_DEFINED char ext;
 %if #WCHAR_DEFINED = '' %then %do;
 %#WCHAR_DEFINED = 'Y';
 /* replace this with #include or typedef appropriate for your system */
 define alias wchar_t unsigned fixed bin(16); /* DONE, for Windows NT */
 %end;

 define alias XPointer  pointer;
 define alias Status    fixed bin(31);

 dcl QueuedAlready      fixed bin(31) value(0);
 dcl QueuedAfterReading fixed bin(31) value(1);
 dcl QueuedAfterFlush   fixed bin(31) value(2);

 %ConnectionNumber: proc (dpy) returns (char);
   dcl dpy char;
   return ('((' || dpy || ') => fd)');
 %end ConnectionNumber;
 %dcl ConnectionNumber entry;

 %RootWindow: proc (dpy, scr) returns (char);
   dcl (dpy, scr) char;
   return ('((' || dpy || ') => screens (' || scr || ').root)');
 %end RootWindow;
 %dcl RootWindow entry;

 %DefaultScreen: proc (dpy) returns (char);
   dcl dpy char;
   return ('((' || dpy || ') => default_screen)');
 %end DefaultScreen;
 %dcl DefaultScreen entry;

 %DefaultRootWindow: proc (dpy) returns (char);
   dcl dpy char;
   return ('((' || dpy || ') => screens (( ' || dpy ||
                          ') => default_screen).root)');
 %end DefaultRootWindow;
 %dcl DefaultRootWindow entry;

 %DefaultVisual: proc (dpy, scr) returns (char);
   dcl (dpy, scr) char;
   return ('((' || dpy || ') => screens (' || scr || ').root_visual)');
 %end DefaultVisual;
 %dcl DefaultVisual entry;

 %DefaultGC: proc (dpy, scr) returns (char);
   dcl (dpy, scr) char;
   return ('((' || dpy || ') => screens (' || scr || ').default_gc)');
 %end DefaultGC;
 %dcl DefaultGC entry;

 %BlackPixel: proc (dpy, scr) returns (char);
   dcl (dpy, scr) char;
   return ('((' || dpy || ') => screens (' || scr || ').black_pixel)');
 %end BlackPixel;
 %dcl BlackPixel entry;

 %WhitePixel: proc (dpy, scr) returns (char);
   dcl (dpy, scr) char;
   return ('((' || dpy || ') => screens (' || scr || ').white_pixel)');
 %end WhitePixel;
 %dcl WhitePixel entry;

 dcl AllPlanes fixed bin (31) value (inot (0));

 %QLength: proc (dpy) returns (char);
   dcl dpy char;
   return ('((' || dpy || ') => qlen)');
 %end QLength;
 %dcl QLength entry;

 %DisplayWidth: proc (dpy, scr) returns (char);
   dcl (dpy, scr) char;
   return ('((' || dpy || ') => screens (' || scr || ').width)');
 %end DisplayWidth;
 %dcl DisplayWidth entry;

 %DisplayHeight: proc (dpy, scr) returns (char);
   dcl (dpy, scr) char;
   return ('((' || dpy || ') => screens (' || scr || ').height)');
 %end DisplayHeight;
 %dcl DisplayHeight entry;

 %DisplayWidthMM: proc (dpy, scr) returns (char);
   dcl (dpy, scr) char;
   return ('((' || dpy || ') => screens (' || scr || ').mwidth)');
 %end DisplayWidthMM;
 %dcl DisplayWidthMM entry;

 %DisplayHeightMM: proc (dpy, scr) returns (char);
   dcl (dpy, scr) char;
   return ('((' || dpy || ') => screens (' || scr || ').mheight)');
 %end DisplayHeightMM;
 %dcl DisplayHeightMM entry;


 %DisplayPlanes: proc (dpy, scr) returns (char);
   dcl (dpy, scr) char;
   return ('((' || dpy || ') => screens (' || scr || ').root_depth)');
 %end DisplayPlanes;
 %dcl DisplayPlanes entry;

 %DisplayCells: proc (dpy, scr) returns (char);
   dcl (dpy, scr) char;
   return ('(DefaultVisual((' || dpy || '), ' ||
                          '(' || scr || ')) => map_entries)');
 %end DisplayCells;
 %dcl DisplayCells entry;

 %ScreenCount: proc (dpy) returns (char);
   dcl dpy char;
   return ('((' || dpy || ') => nscreens)');
 %end ScreenCount;
 %dcl ScreenCount entry;

 %ServerVendor: proc (dpy) returns (char);
   dcl dpy char;
   return ('((' || dpy || ') => vendor)');
 %end ServerVendor;
 %dcl ServerVendor entry;

 %ProtocolVersion: proc (dpy) returns (char);
   dcl dpy char;
   return ('((' || dpy || ') => proto_major_version)');
 %end ProtocolVersion;
 %dcl ProtocolVersion entry;

 %ProtocolRevision: proc (dpy) returns (char);
   dcl dpy char;
   return ('((' || dpy || ') => proto_minor_version)');
 %end ProtocolRevision;
 %dcl ProtocolRevision entry;

 %VendorRelease: proc (dpy) returns (char);
   dcl dpy char;
   return ('((' || dpy || ') => release)');
 %end VendorRelease;
 %dcl VendorRelease entry;

 %DisplayString: proc (dpy) returns (char);
   dcl dpy char;
   return ('((' || dpy || ') => display_name -> $tcl_string_overlay)');
 %end DisplayString;
 %dcl DisplayString entry;

 %DefaultDepth: proc (dpy, scr) returns (char);
   dcl (dpy, scr) char;
   return ('((' || dpy || ') => screens (' || scr || ').root_depth)');
 %end DefaultDepth;
 %dcl DefaultDepth entry;

 %DefaultColormap: proc (dpy, scr) returns (char);
   dcl (dpy, scr) char;
   return ('((' || dpy || ') => screens (' || scr || ').cmap)');
 %end DefaultColormap;
 %dcl DefaultColormap entry;

 %BitmapUnit: proc (dpy) returns (char);
   dcl dpy char;
   return ('((' || dpy || ') => bitmap_unit)');
 %end BitmapUnit;
 %dcl BitmapUnit entry;

 %BitmapBitOrder: proc (dpy) returns (char);
   dcl dpy char;
   return ('((' || dpy || ') => bitmap_bit_order)');
 %end BitmapBitOrder;
 %dcl BitmapBitOrder entry;

 %BitmapPad: proc (dpy) returns (char);
   dcl dpy char;
   return ('((' || dpy || ') => bitmap_pad)');
 %end BitmapPad;
 %dcl BitmapPad entry;

 %ImageByteOrder: proc (dpy) returns (char);
   dcl dpy char;
   return ('((' || dpy || ') => byte_order)');
 %end ImageByteOrder;
 %dcl ImageByteOrder entry;

 %NextRequest: proc (dpy) returns (char);
   dcl dpy char;
   return ('((' || dpy || ') => request + 1)');
 %end NextRequest;
 %dcl NextRequest entry;

 %LastKnownRequestProcessed: proc (dpy) returns (char);
   dcl dpy char;
   return ('((' || dpy || ') => request)');
 %end LastKnownRequestProcessed;
 %dcl LastKnownRequestProcessed entry;

 /* macros for screen oriented applications (toolkit) */

 %ScreenOfDisplay: proc (dpy, scr) returns (char);
   dcl (dpy, scr) char;
   return ('handle ((' || dpy || ') => screens (' || scr || '))');
 %end ScreenOfDisplay;
 %dcl ScreenOfDisplay entry;

 %DefaultScreenOfDisplay: proc (dpy) returns (char);
   dcl dpy char;
   return ('handle ((' || dpy || ') => screens (( ' || dpy ||
                                 ') => default_screen))');
 %end DefaultScreenOfDisplay;
 %dcl DefaultScreenOfDisplay entry;

 %DisplayOfScreen: proc (s) returns (char);
   dcl s char;
   return ('((' || s || ') => display)');
 %end DisplayOfScreen;
 %dcl DisplayOfScreen entry;

 %RootWindowOfScreen: proc (s) returns (char);
   dcl s char;
   return ('((' || s || ') => root)');
 %end RootWindowOfScreen;
 %dcl RootWindowOfScreen entry;

 %BlackPixelOfScreen: proc (s) returns (char);
   dcl s char;
   return ('((' || s || ') => black_pixel)');
 %end BlackPixelOfScreen;
 %dcl BlackPixelOfScreen entry;

 %WhitePixelOfScreen: proc (s) returns (char);
   dcl s char;
   return ('((' || s || ') => white_pixel)');
 %end WhitePixelOfScreen;
 %dcl WhitePixelOfScreen entry;

 %DefaultColormapOfScreen: proc (s) returns (char);
   dcl s char;
   return ('((' || s || ') => cmap)');
 %end DefaultColormapOfScreen;
 %dcl DefaultColormapOfScreen entry;

 %DefaultDepthOfScreen: proc (s) returns (char);
   dcl s char;
   return ('((' || s || ') => root_depth)');
 %end DefaultDepthOfScreen;
 %dcl DefaultDepthOfScreen entry;

 %DefaultGCOfScreen: proc (s) returns (char);
   dcl s char;
   return ('((' || s || ') => default_gc)');
 %end DefaultGCOfScreen;
 %dcl DefaultGCOfScreen entry;

 %DefaultVisualOfScreen: proc (s) returns (char);
   dcl s char;
   return ('((' || s || ') => root_visual)');
 %end DefaultVisualOfScreen;
 %dcl DefaultVisualOfScreen entry;

 %WidthOfScreen: proc (s) returns (char);
   dcl s char;
   return ('((' || s || ') => width)');
 %end WidthOfScreen;
 %dcl WidthOfScreen entry;

 %HeightOfScreen: proc (s) returns (char);
   dcl s char;
   return ('((' || s || ') => height)');
 %end HeightOfScreen;
 %dcl HeightOfScreen entry;

 %WidthMMOfScreen: proc (s) returns (char);
   dcl s char;
   return ('((' || s || ') => mwidth)');
 %end WidthMMOfScreen;
 %dcl WidthMMOfScreen entry;

 %HeightMMOfScreen: proc (s) returns (char);
   dcl s char;
   return ('((' || s || ') => mheight)');
 %end HeightMMOfScreen;
 %dcl HeightMMOfScreen entry;

 %PlanesOfScreen: proc (s) returns (char);
   dcl s char;
   return ('((' || s || ') => root_depth)');
 %end PlanesOfScreen;
 %dcl PlanesOfScreen entry;

 %CellsOfScreen: proc (s) returns (char);
   dcl s char;
   return ('(DefaultVisualOfScreen (' || s || ') => map_entries)');
 %end CellsOfScreen;
 %dcl CellsOfScreen entry;

 %MinCmapsOfScreen: proc (s) returns (char);
   dcl s char;
   return ('((' || s || ') => min_maps)');
 %end MinCmapsOfScreen;
 %dcl MinCmapsOfScreen entry;

 %MaxCmapsOfScreen: proc (s) returns (char);
   dcl s char;
   return ('((' || s || ') => max_maps)');
 %end MaxCmapsOfScreen;
 %dcl MaxCmapsOfScreen entry;

 /* Note: DoesXXX macros return int, might need to compare against 0 */

 %DoesSaveUnders: proc (s) returns (char);
   dcl s char;
   return ('((' || s || ') => save_unders)');
 %end DoesSaveUnders;
 %dcl DoesSaveUnders entry;

 %DoesBackingStore: proc (s) returns (char);
   dcl s char;
   return ('((' || s || ') => backing_store)');
 %end DoesBackingStore;
 %dcl DoesBackingStore entry;

 %EventMaskOfScreen: proc (s) returns (char);
   dcl s char;
   return ('((' || s || ') => root_input_mask)');
 %end EventMaskOfScreen;
 %dcl EventMaskOfScreen entry;


 /* Extensions need a way to hang private data on some structures. */
 define structure
   1 XExtData,
    2 number fixed bin(31),
             /* number returned by XRegisterExtension */
    2 next   handle XExtData,
             /* next item on list of data for structure */
    2 free_private entry limited
                   returns (fixed bin (31) optional byvalue)
                   options (byvalue nodescriptor linkage(cdecl)),
             /* called to free private storage */
    2 private_data type XPointer;/* data private to this extension. */

 /* This file contains structures used by the extension mechanism. */
 define structure
   1 XExtCodes,   /* public to extension, cannot be changed */
    2 extension    fixed bin(31), /* extension number */
    2 major_opcode fixed bin(31),
                   /* major op-code assigned by server */
    2 first_event  fixed bin(31),
                   /* first event number for the extension */
    2 first_error  fixed bin(31);
                   /* first error number for the extension */


 /* Data structure for retrieving info about pixmap formats. */

 define structure
   1 XPixmapFormatValues,
    2 depth          fixed bin(31),
    2 bits_per_pixel fixed bin(31),
    2 scanline_pad   fixed bin(31);


 /* Data structure for setting graphics context. */
 define structure
   1 XGCValues,
    2 function    fixed bin(31), /* logical operation */
    2 plane_mask  fixed bin(32) unsigned, /* plane mask */
    2 foreground  fixed bin(32) unsigned, /* foreground pixel */
    2 background  fixed bin(32) unsigned, /* background pixel */
    2 line_width  fixed bin(31), /* line width */
    2 line_style  fixed bin(31),
                 /* LineSolid, LineOnOffDash, LineDoubleDash */
    2 cap_style   fixed bin(31),
                 /* CapNotLast, CapButt, CapRound, CapProjecting */
    2 join_style  fixed bin(31), /* JoinMiter, JoinRound, JoinBevel */
    2 fill_style  fixed bin(31),
            /* FillSolid, FillTiled, FillStippled, FillOpaqueStippled */
    2 fill_rule   fixed bin(31), /* EvenOddRule, WindingRule */
    2 arc_mode    fixed bin(31), /* ArcChord, ArcPieSlice */
    2 tile        type Pixmap,  /* tile pixmap for tiling operations */
    2 stipple     type Pixmap,  /* stipple 1 plane pixmap for stipping*/
    2 ts_x_origin fixed bin(31),/* offset for tile or stipple */
    2 ts_y_origin fixed bin(31),/*   operations               */
    2 font        type Font, /* default text font for text operations */
    2 subwindow_mode fixed bin(31),/* ClipByChildren, IncludeInferiors*/
    2 graphics_exposures fixed bin (31),
                 /* boolean, should exposures be generated */
    2 clip_x_origin fixed bin(31),/* origin for clipping */
    2 clip_y_origin fixed bin(31),
    2 clip_mask   type Pixmap,
                 /* bitmap clipping; other calls for rects */
    2 dash_offset fixed bin(31),/* patterned/dashed line information */
    2 dashes      char;


 /* Graphics context.  The contents of this structure are             */
 /* implementation dependent.  A GC should be treated as opaque by    */
 /* application code.                                                 */

 define alias GC handle XGCValues;

 /* Visual structure, contains information about colormapping  */
 /* possible.                                                  */
 define structure
   1 Visual,
    2 ext_data handle XExtData, /* hook for extension to hang data */
    2 visualid type VisualID,   /* visual id of this visual */
    2 c_class fixed bin(31),/* C++ class of screen (monochrome, etc.) */
    2 red_mask     fixed bin(32) unsigned, /* mask values */
    2 green_mask   fixed bin(32) unsigned,
    2 blue_mask    fixed bin(32) unsigned,
    2 bits_per_rgb fixed bin(31),
                   /* log base 2 of distinct color values */
    2 map_entries  fixed bin(31); /* color map entries */

 /* Depth structure; contains information for each possible depth. */
 define structure
   1 Depth,
    2 depth    fixed bin(31),/* this depth (Z) of the depth */
    2 nvisuals fixed bin(31),/* number of Visual types at this depth */
    2 visuals  pointer;      /* list of visuals possible at this depth*/


 /* Information about the screen.  The contents of this structure are */
 /* implementation dependent.  A Screen should be treated as opaque   */
 /* by application code.                                              */
 define structure
   1 Screen,
    2 ext_data handle XExtData,/* hook for extension to hang data */
    2 display  handle _XDisplay,/* back pointer to display structure */
    2 root     type Window,/* Root window id. */
    2 width    fixed bin(31),/* width and height of screen */
    2 height   fixed bin(31),/* width and height of screen */
    2 mwidth   fixed bin(31),/* width and                          */
    2 mheight  fixed bin(31),/*           height of in millimeters */
    2 ndepths  fixed bin(31),/* number of depths possible */
    2 depths   handle Depth,/* list of allowable depths on the screen */
    2 root_depth  fixed bin(31),/* bits per pixel */
    2 root_visual handle Visual,/* root visual */
    2 default_gc  type GC,/* GC for the root root visual */
    2 cmap        type XColormap,/* default color map */
    2 white_pixel fixed bin(32) unsigned, /* White and                */
    2 black_pixel fixed bin(32) unsigned, /*       Black pixel values */
    2 max_maps    fixed bin(31), /* max and                */
    2 min_maps    fixed bin(31), /*         min color maps */
    2 backing_store fixed bin(31),/* Never, WhenMapped, Always */
    2 save_unders   fixed bin (31),
    2 root_input_mask fixed bin(31);/* initial root input mask */


 /* Format structure; describes ZFormat data the screen will */
 /* understand.                                              */
 define structure
   1 ScreenFormat,
    2 ext_data     handle XExtData,/* hook for extension to hang data */
    2 depth          fixed bin(31),/* depth of this image format */
    2 bits_per_pixel fixed bin(31),/* bits/pixel at this depth */
    2 scanline_pad   fixed bin(31);
                     /* scanline must padded to this multiple */


 /* Data structure for setting window attributes. */
 define structure
   1 XSetWindowAttributes,
    2 background_pixmap type Pixmap,
                     /* background or None or ParentRelative */
    2 background_pixel fixed bin(32) unsigned,/* background pixel */
    2 border_pixmap  type Pixmap,  /* border of the window */
    2 border_pixel   fixed bin(32) unsigned,/* border pixel value */
    2 bit_gravity    fixed bin(31),/* one of bit gravity values */
    2 win_gravity    fixed bin(31),/* one of the window gravity values*/
    2 backing_store  fixed bin(31),/* NotUseful, WhenMapped, Always */
    2 backing_planes fixed bin(32) unsigned,
                     /* planes to be preseved if possible */
    2 backing_pixel  fixed bin(32) unsigned,
                     /* value to use in restoring planes*/
    2 save_under     fixed bin(31),
                     /* should bits under be saved? (popups) */
    2 event_mask     fixed bin(31),
                     /* set of events that should be saved */
    2 do_not_propagate_mask fixed bin(31),
                     /* set of events that should not propagate */
    2 override_redirect fixed bin (31),
                     /* boolean value for override-redirect */
    2 colormap       type XColormap,
                     /* color map to be associated with window */
    2 cursor         type Cursor;/* cursor to be displayed (or None) */

 define structure
   1 XWindowAttributes,
    2 x            fixed bin(31),/* location of window */
    2 y            fixed bin(31),/* location of window */
    2 width        fixed bin(31),/* width and height of window */
    2 height       fixed bin(31),/* width and height of window */
    2 border_width fixed bin(31),/* border width of window */
    2 depth        fixed bin(31),/* depth of window */
    2 visual       handle Visual,/* the associated visual structure */
    2 root         type Window,  /* root of screen containing window */
    2 c_class      fixed bin(31),/* C++ InputOutput, InputOnly*/
    2 bit_gravity  fixed bin(31),/* one of bit gravity values */
    2 win_gravity  fixed bin(31),/* one of the window gravity values */
    2 backing_store fixed bin(31),/* NotUseful, WhenMapped, Always */
    2 backing_planes fixed bin(32) unsigned,
                   /* planes to be preserved if possible */
    2 backing_pixel fixed bin(32) unsigned,
                   /* value to be used when restoring planes */
    2 save_under   fixed bin (31),
                   /* boolean, should bits under be saved? */
    2 colormap     type XColormap,
                   /* color map to be associated with window */
    2 map_installed fixed bin (31),
                   /* boolean, is color map currently installed */
    2 map_state    fixed bin(31),
                   /* IsUnmapped, IsUnviewable, IsViewable */
    2 all_event_masks fixed bin(31),
                   /* set of events all people have interest in*/
    2 your_event_mask fixed bin(31),/* my event mask */
    2 do_not_propagate_mask fixed bin(31),
                   /* set of events that should not propagate */
    2 override_redirect fixed bin (31),
                   /* boolean value for override-redirect  */
    2 screen pointer;/* back pointer to correct screen */


 /* Data structure for host setting, getting routines. */

 define structure
   1 XHostAddress,
    2 family  fixed bin(31),/* for example FamilyInternet */
    2 length  fixed bin(31),/* length of address, in bytes */
    2 address pointer;/* to char (*) varz, where to find the bytes */


 /* Data structure for "image" data, used by image manipulation */
 /* routines.                                                   */

 define structure
   1 XImage,
    2 width   fixed bin(31),/* size of image */
    2 height  fixed bin(31),/* size of image */
    2 xoffset fixed bin(31),/* number of pixels offset in X direction */
    2 format  fixed bin(31),/* XYBitmap, XYPixmap, ZPixmap */
    2 data    pointer,/* pointer to image data */
    2 byte_order  fixed bin(31),/* data byte order, LSBFirst, MSBFirst*/
    2 bitmap_unit fixed bin(31),/* quant. of scanline 8, 16, 32 */
    2 bitmap_bit_order fixed bin(31),/* LSBFirst, MSBFirst */
    2 bitmap_pad fixed bin(31),/* 8, 16, 32 either XY or ZPixmap */
    2 depth      fixed bin(31),/* depth of image */
    2 bytes_per_line fixed bin(31),/* accelarator to next line */
    2 bits_per_pixel fixed bin(31),/* bits per pixel (ZPixmap) */
    2 red_mask   fixed bin(32) unsigned,/* bits in z arrangment */
    2 green_mask fixed bin(32) unsigned,
    2 blue_mask  fixed bin(32) unsigned,
    2 obdata type XPointer,/* hook for the object routines to hang on */
    2 funcs,/* image manipulation routines */
      3 create_image  entry ()
                      returns (handle XImage byvalue) limited
                      options (byvalue nodescriptor linkage(cdecl)),
      3 destroy_image entry (handle XImage) limited
                      returns (fixed bin (31) byvalue optional) limited
                      options (byvalue nodescriptor linkage(cdecl)),
      3 get_pixel     entry (handle XImage,
                             fixed bin (31),
                             fixed bin (31))
                      limited
                      returns (fixed bin (32) unsigned byvalue optional)
                      options (byvalue nodescriptor linkage(cdecl)),
      3 put_pixel     entry (handle XImage,
                             fixed bin (31),
                             fixed bin (31),
                             fixed bin (31))
                      returns (fixed bin (31) byvalue optional) limited
                      options (byvalue nodescriptor linkage(cdecl)),
      3 sub_image     entry (handle XImage,
                             fixed bin (31),
                             fixed bin (31),
                             fixed bin (32) unsigned,
                             fixed bin (32) unsigned)
                      returns (handle XImage byvalue optional) limited
                      options (byvalue nodescriptor linkage(cdecl)),
      3 add_pixel     entry (handle XImage,
                             fixed bin (31))
                      returns (fixed bin (31) byvalue optional) limited
                      options (byvalue nodescriptor linkage(cdecl));

 /* Data structure for XReconfigureWindow */

 define structure
   1 XWindowChanges,
    2 x            fixed bin(31),
    2 y            fixed bin(31),
    2 width        fixed bin(31),
    2 height       fixed bin(31),
    2 border_width fixed bin(31),
    2 sibling      type Window,
    2 stack_mode   fixed bin(31);

 /* Data structure used by color operations */
 define structure
   1 XColor,
    2 pixel fixed bin(32) unsigned,
    2 red   unsigned fixed bin(16),
    2 green unsigned fixed bin(16),
    2 blue  unsigned fixed bin(16),
    2 flags char,/* do_red, do_green, do_blue */
    2 pad   char;


 /* Data structures for graphics operations. On most machines, these  */
 /* are congruent with the wire protocol structures, so reformatting  */
 /* the data can be avoided on these architectures.                   */

 define structure
   1 XSegment,
    2 (x1, y1, x2, y2) fixed bin(15);

 define structure
   1 XPoint,
    2 (x, y) fixed bin(15);

 define structure
   1 XRectangle,
    2 (x, y) fixed bin(15),
    2 (width, height) unsigned fixed bin(16) ;

 define structure
   1 XArc,
    2 (x, y) fixed bin(15),
    2 (width, height) unsigned fixed bin(16) ,
    2 (angle1, angle2) fixed bin(15);


 /* Data structure for XChangeKeyboardControl */

 define structure
   1 XKeyboardControl,
    2 key_click_percent fixed bin(31),
    2 bell_percent      fixed bin(31),
    2 bell_pitch        fixed bin(31),
    2 bell_duration     fixed bin(31),
    2 led               fixed bin(31),
    2 led_mode          fixed bin(31),
    2 key               fixed bin(31),
    2 auto_repeat_mode  fixed bin(31); /* On, Off, Default */

 /* Data structure for XGetKeyboardControl */

 define structure
   1 XKeyboardState,
    2 key_click_percent  fixed bin(31),
    2 bell_percent       fixed bin(31),
    2 bell_pitch         fixed bin(32) unsigned,
    2 bell_duration      fixed bin(32) unsigned,
    2 led_mask           fixed bin(31),
    2 global_auto_repeat fixed bin(31),
    2 auto_repeats       char(32-1) varyingz;

 /* Data structure for XGetMotionEvents.  */

 define structure
   1 XTimeCoord,
    2 time   type Time,
    2 (x, y) fixed bin(15);

 /* Data structure for X{Set,Get}ModifierMapping */

 define structure
   1 XModifierKeymap,
    2 max_keypermod fixed bin(31),
                    /* The server's max # of keys per modifier */
    2 modifiermap   pointer;             /* to array of KeyCode */
                    /* An 8 by max_keypermod array of modifiers */


 /* Display datatype maintaining display specific data.          */
 /* The contents of this structure are implementation dependent. */
 /* A Display should be treated as opaque by application code.   */

 define structure
   1 _XDisplay,
    2 ext_data     handle XExtData,/* hook for extension to hang data */
    2 free_funcs   pointer,/* internal free functions */
    2 fd           fixed bin(31),/* Network socket. */
    2 conn_checker fixed bin(31),/* ugly thing used by _XEventsQueued */
    2 proto_major_version fixed bin(31),
              /* maj. version of server's X protocol */
    2 proto_minor_version fixed bin(31),
              /* minor version of servers X protocol */
    2 vendor pointer,/* to char(*) varz, vendor of the server hardware*/
    2 resource_base  type XID,/* resource ID base */
    2 resource_mask  type XID,/* resource ID mask bits */
    2 resource_id    type XID,/* allocator current ID */
    2 resource_shift fixed bin(31),/* allocator shift to correct bits */
    2 resource_alloc entry returns (type XID) /* allocator function */
                  limited options (nodescriptor linkage(cdecl) byvalue),
    2 byte_order  fixed bin(31),
             /* screen byte order, LSBFirst, MSBFirst */
    2 bitmap_unit fixed bin(31),/* padding and data requirements */
    2 bitmap_pad  fixed bin(31),/* padding requirements on bitmaps */
    2 bitmap_bit_order fixed bin(31),
             /* LeastSignificant or MostSignificant */
    2 nformats    fixed bin(31),/* number of pixmap formats in list*/
    2 pixmap_format  handle ScreenFormat,/* pixmap format list */
    2 vnumber     fixed bin(31),/* Xlib's X protocol version number. */
    2 release     fixed bin(31),/* release of the server */
    2 head        pointer,/* Input event queue. */
    2 tail        pointer,/* Input event queue. */
    2 qlen        fixed bin(31),/* Length of input event queue */
    2 request     fixed bin(32) unsigned,
                          /* sequence number of last request. */
    2 last_req    pointer,/* beginning of last request, or dummy */
    2 buffer      pointer,/* Output buffer starting address. */
    2 bufptr      pointer,/* Output buffer index pointer. */
    2 bufmax      pointer,/* Output buffer maximum+1 address. */
    2 max_request_size fixed bin(32) unsigned,
             /* maximum number 32 bit words in request*/
    2 db          pointer,
    2 synchandler entry returns (fixed bin (31))
                  limited options (nodescriptor linkage(cdecl) byvalue),
             /* Synchronization handler */
    2 display_name pointer, /* to char (*) varz */
             /* "host:display" string used on this connect */
    2 default_screen fixed bin(31),/* default screen for operations */
    2 nscreens      fixed bin(31),/* number of screens on this server*/
    2 screens       handle Screen,/* pointer to list of screens */
    2 motion_buffer fixed bin(32) unsigned,/* size of motion buffer */
    2 flags         fixed bin(32) unsigned,
                                  /* internal connection flags */
    2 min_keycode   fixed bin(31),/* minimum defined keycode */
    2 max_keycode   fixed bin(31),/* maximum defined keycode */
    2 keysyms       pointer,/* This server's keysyms */
    2 modifiermap   handle XModifierKeymap,
             /* This server's modifier keymap */
    2 keysyms_per_keycode fixed bin(31),/* number of rows */
    2 xdefaults      pointer,/* contents of defaults from server */
    2 scratch_buffer pointer,/* place to hang scratch buffer */
    2 scratch_length fixed bin(32) unsigned,
                             /* length of scratch buffer */
    2 ext_number  fixed bin(31),/* extension number on this display */
    2 ext_procs   pointer,  /* extensions initialized on this display */
    /* the following can be fixed size, as the protocol defines how   */
    /* much address space is available. While this could be done      */
    /* using the extension vector, there may be MANY events processed,*/
    /* so a search through the extensionlist to find the right        */
    /* procedure for each event might be expensive if many extensions */
    /* are being used.                                                */
    2 event_vec (128) entry returns (fixed bin (31))
                 limited options (nodescriptor linkage(cdecl) byvalue),
            /* vector for wire to event */
    2 wire_vec (128) entry returns (type Status)
                 limited options (nodescriptor linkage(cdecl) byvalue),
            /* vector for event to wire */
    2 lock_meaning type KeySym,/* for XLookupString */
    2 lock         pointer,/* multi-thread state, display lock */
    2 async_handlers pointer,/* for internal async */
    2 bigreq_size  fixed bin(32) unsigned,/* max size of big requests */
    2 lock_fns     pointer,/* pointers to threads functions */
 /* things above this line should not move, for binary compatibility */
    2 key_bindings pointer,/* for XLookupString */
    2 cursor_font  type Font,/* for XCreateFontCursor */
    2 atoms        pointer,/* for XInternAtom */
    2 mode_switch  fixed bin(32) unsigned,/* keyboard group modifiers */
    2 context_db   pointer,/* context database */
    2 error_vec    pointer, /* vector for wire to error (to funcs) */
    2 cms,  /* Xcms information */
      3 defaultCCCs type XPointer,
            /* pointer to an array of default XcmsCCC */
      3 clientCmaps type XPointer,
            /* pointer to linked list of XcmsCmapRec */
      3 perVisualIntensityMaps type XPointer,
            /* linked list of XcmsIntensityMap */
    2 im_filters   pointer,
    2 qfree        pointer,/* unallocated event queue elements */
    2 next_event_serial_num fixed bin(32) unsigned,
            /* inserted into next queue elt */
    2 savedsynchandlerentry returns (fixed bin (31))
                limited options (nodescriptor linkage(cdecl) byvalue);
            /* user synchandler when Xlib usurps */

 define alias Display type _XDisplay;

 dcl XMaxTransChars fixed bin(31) value(4);

 /* Definitions of specific events.  */
 define structure
   1 XKeyEvent,
    2 type   fixed bin(31),/* of event */
    2 serial fixed bin(32) unsigned,
                           /* # of last request processed by server */
    2 send_event fixed bin (31),
            /* true if this came from a SendEvent request */
    2 display handle Display,/* Display the event was read from */
    2 window type Window,/* "event" window it is reported relative to */
    2 root   type Window,/* root window that the event occured on*/
    2 subwindow   type Window,/* child window */
    2 time   type Time,/* milliseconds */
    2 (x, y) fixed bin(31),/* pointer x, y coordinates in event window*/
    2 (x_root, y_root) fixed bin(31),/* coordinates relative to root */
    2 state  fixed bin(32) unsigned,/* key or button mask */
    2 keycode     fixed bin(32) unsigned,/* detail */
    2 same_screen fixed bin (31),/* same screen flag */
    2 trans_chars char(XMaxTransChars-1) varyingz,
            /* translated characters */
    2 nchars fixed bin(31);

 define alias XKeyPressedEvent  type XKeyEvent;
 define alias XKeyReleasedEvent type XKeyEvent;

 define structure
   1 XButtonEvent,
    2 type   fixed bin(31),/* of event */
    2 serial fixed bin(32) unsigned,
                           /* # of last request processed by server */
    2 send_event fixed bin (31),
            /* true if this came from a SendEvent request */
    2 display handle Display,/* Display the event was read from */
    2 window type Window,/* "event" window it is reported relative to */
    2 root   type Window,/* root window that the event occured on*/
    2 subwindow   type Window,/* child window */
    2 time   type Time,/* milliseconds */
    2 (x, y) fixed bin(31),/* pointer x, y coordinates in event window*/
    2 (x_root, y_root) fixed bin(31),/* coordinates relative to root */
    2 state       fixed bin(32) unsigned,/* key or button mask */
    2 button      fixed bin(32) unsigned,/* detail */
    2 same_screen fixed bin (31);/* same screen flag */

 define alias XButtonPressedEvent  type XButtonEvent;
 define alias XButtonReleasedEvent type XButtonEvent;

 define structure
   1 XMotionEvent,
    2 type   fixed bin(31),/* of event */
    2 serial fixed bin(32) unsigned,
                           /* # of last request processed by server */
    2 send_event fixed bin (31),
            /* true if this came from a SendEvent request */
    2 display handle Display,/* Display the event was read from */
    2 window type Window,/* "event" window it is reported relative to */
    2 root   type Window,/* root window that the event occured on*/
    2 subwindow   type Window,/* child window */
    2 time   type Time,/* milliseconds */
    2 (x, y) fixed bin(31),/* pointer x, y coordinates in event window*/
    2 (x_root, y_root) fixed bin(31),/* coordinates relative to root */
    2 state       fixed bin(32) unsigned,/* key or button mask */
    2 is_hint     char,/* detail */
    2 same_screen fixed bin (31);/* same screen flag */

 define alias XPointerMovedEvent type XMotionEvent;

 define structure
   1 XCrossingEvent,
    2 type   fixed bin (31),/* of event */
    2 serial fixed bin (32) unsigned,
                           /* # of last request processed by server */
    2 send_event fixed bin (31),
            /* true if this came from a SendEvent request */
    2 display handle Display,/* Display the event was read from */
    2 window type Window,/* "event" window it is reported relative to */
    2 root   type Window,/* root window that the event occured on*/
    2 subwindow   type Window,/* child window */
    2 time   type Time,/* milliseconds */
    2 (x, y) fixed bin(31),/* pointer x, y coordinates in event window*/
    2 (x_root, y_root) fixed bin(31),/* coordinates relative to root */
    2 mode   fixed bin(31),/* NotifyNormal, NotifyGrab, NotifyUngrab */
    2 detail fixed bin(31),
            /* NotifyAncestor, NotifyVirtual, NotifyInferior, */
            /* NotifyNonlinear,NotifyNonlinearVirtual         */
    2 same_screen fixed bin (31),/* same screen flag */
    2 focus  fixed bin (31),/* boolean focus */
    2 state  fixed bin (32) unsigned;/* key or button mask */

 define alias XEnterWindowEvent type XCrossingEvent;
 define alias XLeaveWindowEvent type XCrossingEvent;

 define structure
   1 XFocusChangeEvent,
    2 type   fixed bin(31),/* of event */
    2 serial fixed bin(32) unsigned,
                           /* # of last request processed by server */
    2 send_event fixed bin (31),
            /* true if this came from a SendEvent request */
    2 display handle Display,/* Display the event was read from */
    2 window type Window,/* "event" window it is reported relative to */
    2 mode   fixed bin(31),/* NotifyNormal, NotifyGrab, NotifyUngrab */
    2 detail fixed bin(31);
            /* NotifyAncestor, NotifyVirtual, NotifyInferior,         */
            /* NotifyNonlinear,NotifyNonlinearVirtual, NotifyPointer, */
            /* NotifyPointerRoot, NotifyDetailNone                    */

 define alias XFocusInEvent  type XFocusChangeEvent;
 define alias XFocusOutEvent type XFocusChangeEvent;

 /* generated on EnterWindow and FocusIn  when KeyMapState selected */
 define structure
   1 XKeymapEvent,
    2 type   fixed bin(31),/* of event */
    2 serial fixed bin(32) unsigned,
             /* # of last request processed by server */
    2 send_event fixed bin (31),
            /* true if this came from a SendEvent request */
    2 display handle Display,/* Display the event was read from */
    2 window type Window,/* "event" window it is reported relative to */
    2 key_vector char(32-1) varyingz;

 define structure
   1 XExposeEvent,
    2 type   fixed bin(31),/* of event */
    2 serial fixed bin(32) unsigned,
                           /* # of last request processed by server */
    2 send_event fixed bin (31),
            /* true if this came from a SendEvent request */
    2 display handle Display,/* Display the event was read from */
    2 window type Window,/* "event" window it is reported relative to */
    2 (x, y) fixed bin(31),
    2 (width, height) fixed bin(31),
    2 count  fixed bin(31);/* if non-zero, at least this many more */


 define structure
   1 XGraphicsExposeEvent,
    2 type   fixed bin(31),/* of event */
    2 serial fixed bin(32) unsigned,
                           /* # of last request processed by server */
    2 send_event fixed bin (31),
            /* true if this came from a SendEvent request */
    2 display handle Display,/* Display the event was read from */
    2 drawable type Drawable,
    2 (x, y) fixed bin(31),
    2 (width, height) fixed bin(31),
    2 count  fixed bin(31),/* if non-zero, at least this many more */
    2 major_code fixed bin(31),/* core is CopyArea or CopyPlane */
    2 minor_code fixed bin(31);/* not defined in the core */

 define structure
   1 XNoExposeEvent,
    2 type   fixed bin(31),/* of event */
    2 serial fixed bin(32) unsigned,
             /* # of last request processed by server */
    2 send_event fixed bin (31),
            /* true if this came from a SendEvent request */
    2 display handle Display,/* Display the event was read from */
    2 drawable type Drawable,
    2 major_code fixed bin(31),/* core is CopyArea or CopyPlane */
    2 minor_code fixed bin(31);/* not defined in the core */

 define structure
   1 XVisibilityEvent,
    2 type   fixed bin(31),/* of event */
    2 serial fixed bin(32) unsigned,
                           /* # of last request processed by server */
    2 send_event fixed bin (31),
            /* true if this came from a SendEvent request */
    2 display handle Display,/* Display the event was read from */
    2 window type Window,/* "event" window it is reported relative to */
    2 state fixed bin(31);/* Visibility state */

 define structure
   1 XCreateWindowEvent,
    2 type   fixed bin(31),/* of event */
    2 serial fixed bin(32) unsigned,
                           /* # of last request processed by server */
    2 send_event fixed bin (31),
            /* true if this came from a SendEvent request */
    2 display handle Display,/* Display the event was read from */
    2 parent type Window,/* parent of the window */
    2 window type Window,/* window id of window created */
    2 (x, y) fixed bin(31),/* window location */
    2 (width, height) fixed bin(31),/* size of window */
    2 border_width fixed bin(31),/* border width */
    2 override_redirect fixed bin (31);
            /* creation should be overridden */

 define structure
   1 XDestroyWindowEvent,
    2 type   fixed bin(31),/* of event */
    2 serial fixed bin(32) unsigned,
                           /* # of last request processed by server */
    2 send_event fixed bin (31),
            /* true if this came from a SendEvent request */
    2 display handle Display,/* Display the event was read from */
    2 event   type Window,
    2 window  type Window;

 define structure
   1 XUnmapEvent,
    2 type   fixed bin(31),/* of event */
    2 serial fixed bin(32) unsigned,
                           /* # of last request processed by server */
    2 send_event fixed bin (31),
            /* true if this came from a SendEvent request */
    2 display handle Display,/* Display the event was read from */
    2 event   type Window,
    2 window  type Window,
    2 from_configure fixed bin (31);

 define structure
   1 XMapEvent,
    2 type   fixed bin(31),/* of event */
    2 serial fixed bin(32) unsigned,
                           /* # of last request processed by server */
    2 send_event fixed bin (31),
            /* true if this came from a SendEvent request */
    2 display handle Display,/* Display the event was read from */
    2 event   type Window,
    2 window  type Window,
    2 override_redirect fixed bin (31);/* boolean, is override set... */

 define structure
   1 XMapRequestEvent,
    2 type   fixed bin(31),/* of event */
    2 serial fixed bin(32) unsigned,
                           /* # of last request processed by server */
    2 send_event fixed bin (31),
            /* true if this came from a SendEvent request */
    2 display handle Display,/* Display the event was read from */
    2 parent  type Window,
    2 window  type Window;

 define structure
   1 XReparentEvent,
    2 type   fixed bin(31),/* of event */
    2 serial fixed bin(32) unsigned,
                           /* # of last request processed by server */
    2 send_event fixed bin (31),
            /* true if this came from a SendEvent request */
    2 display handle Display,/* Display the event was read from */
    2 event   type Window,
    2 window  type Window,
    2 parent  type Window,
    2 (x, y) fixed bin(31),
    2 override_redirect fixed bin (31);

 define structure
   1 XConfigureEvent,
    2 type   fixed bin(31),/* of event */
    2 serial fixed bin(32) unsigned,
                           /* # of last request processed by server */
    2 send_event fixed bin (31),
            /* true if this came from a SendEvent request */
    2 display handle Display,/* Display the event was read from */
    2 event   type Window,
    2 window  type Window,
    2 (x, y)  fixed bin(31),
    2 (width, height) fixed bin(31),
    2 border_width fixed bin(31),
    2 above   type Window,
    2 override_redirect fixed bin (31);

 define structure
   1 XGravityEvent,
    2 type   fixed bin(31),/* of event */
    2 serial fixed bin(32) unsigned,
                           /* # of last request processed by server */
    2 send_event fixed bin (31),
            /* true if this came from a SendEvent request */
    2 display handle Display,/* Display the event was read from */
    2 event   type Window,
    2 window  type Window,
    2 (x, y)  fixed bin(31);

 define structure
   1 XResizeRequestEvent,
    2 type   fixed bin(31),/* of event */
    2 serial fixed bin(32) unsigned,
                           /* # of last request processed by server */
    2 send_event fixed bin (31),
            /* true if this came from a SendEvent request */
    2 display handle Display,/* Display the event was read from */
    2 window  type Window,
    2 (width, height) fixed bin(31);

 define structure
   1 XConfigureRequestEvent,
    2 type   fixed bin(31),/* of event */
    2 serial fixed bin(32) unsigned,
                           /* # of last request processed by server */
    2 send_event fixed bin (31),
            /* true if this came from a SendEvent request */
    2 display handle Display,/* Display the event was read from */
    2 parent  type Window,
    2 window  type Window,
    2 (x, y)  fixed bin(31),
    2 (width, height) fixed bin(31),
    2 border_width fixed bin(31),
    2 above   type Window,
    2 detail  fixed bin(31),/* Above, Below, TopIf, BottomIf, Opposite*/
    2 value_mask fixed bin(32) unsigned;

 define structure
   1 XCirculateEvent,
    2 type   fixed bin(31),/* of event */
    2 serial fixed bin(32) unsigned,
                           /* # of last request processed by server */
    2 send_event fixed bin (31),
            /* true if this came from a SendEvent request */
    2 display handle Display,/* Display the event was read from */
    2 event   type Window,
    2 window  type Window,
    2 place   fixed bin(31);/* PlaceOnTop, PlaceOnBottom */

 define structure
   1 XCirculateRequestEvent,
    2 type   fixed bin(31),/* of event */
    2 serial fixed bin(32) unsigned,
                           /* # of last request processed by server */
    2 send_event fixed bin (31),
            /* true if this came from a SendEvent request */
    2 display handle Display,/* Display the event was read from */
    2 parent  type Window,
    2 window  type Window,
    2 place   fixed bin(31);/* PlaceOnTop, PlaceOnBottom */

 define structure
   1 XPropertyEvent,
    2 type   fixed bin(31),/* of event */
    2 serial fixed bin(32) unsigned,
                           /* # of last request processed by server */
    2 send_event fixed bin (31),
            /* true if this came from a SendEvent request */
    2 display handle Display,/* Display the event was read from */
    2 window type Window,
    2 atom   type XAtom,
    2 time   type Time,
    2 state  fixed bin(31);/* NewValue, Deleted */

 define structure
   1 XSelectionClearEvent,
    2 type   fixed bin(31),/* of event */
    2 serial fixed bin(32) unsigned,
                           /* # of last request processed by server */
    2 send_event fixed bin (31),
            /* true if this came from a SendEvent request */
    2 display handle Display,/* Display the event was read from */
    2 window  type Window,
    2 selection type XAtom,
    2 time    type Time;

 define structure
   1 XSelectionRequestEvent,
    2 type   fixed bin(31),/* of event */
    2 serial fixed bin(32) unsigned,
                           /* # of last request processed by server */
    2 send_event fixed bin (31),
            /* true if this came from a SendEvent request */
    2 display handle Display,/* Display the event was read from */
    2 owner     type Window,
    2 requestor type Window,
    2 selection type XAtom,
    2 target    type XAtom,
    2 property  type XAtom,
    2 time      type Time;

 define structure
   1 XSelectionEvent,
    2 type   fixed bin(31),/* of event */
    2 serial fixed bin(32) unsigned,
                           /* # of last request processed by server */
    2 send_event fixed bin (31),
            /* true if this came from a SendEvent request */
    2 display handle Display,/* Display the event was read from */
    2 requestor type Window,
    2 selection type XAtom,
    2 target    type XAtom,
    2 property  type XAtom,/* ATOM or None */
    2 time      type Time;

 define structure
   1 XColormapEvent,
    2 type   fixed bin(31),/* of event */
    2 serial fixed bin(32) unsigned,
                           /* # of last request processed by server */
    2 send_event fixed bin (31),
            /* true if this came from a SendEvent request */
    2 display handle Display,/* Display the event was read from */
    2 window   type Window,
    2 colormap type XColormap,/* COLORMAP or None */
    2 c_new    fixed bin(31),/* C++ */
    2 state    fixed bin(31);/* ColormapInstalled, ColormapUninstalled*/

 define structure
   1 XClientMessageEvent,
    2 type   fixed bin(31),/* of event */
    2 serial fixed bin(32) unsigned,
                           /* # of last request processed by server */
    2 send_event fixed bin (31),
            /* true if this came from a SendEvent request */
    2 display handle Display,/* Display the event was read from */
    2 window type Window,
    2 message_type type XAtom,
    2 format fixed bin(31),
    2 data union,
      3 b char(20-1) varyingz,
      3 s (10) fixed bin(15),
      3 l (5)  fixed bin(31);

 define structure
   1 XMappingEvent,
    2 type   fixed bin(31),/* of event */
    2 serial fixed bin(32) unsigned,
                           /* # of last request processed by server */
    2 send_event fixed bin (31),
            /* true if this came from a SendEvent request */
    2 display handle Display,/* Display the event was read from */
    2 window  type Window,/* unused */
    2 request fixed bin(31),
           /* one of MappingModifier, MappingKeyboard, MappingPointer */
    2 first_keycode fixed bin(31),/* first keycode */
    2 count fixed bin(31);/* defines range of change w. first_keycode*/

 define structure
   1 XErrorEvent,
    2 type    fixed bin(31),
    2 display handle Display,/* Display the event was read from */
    2 resourceid type XID,/* resource id */
    2 serial  fixed bin(32) unsigned,
                          /* serial number of failed request */
    2 error_code   fixed bin (8) unsigned,
           /* error code of failed request */
    2 request_code fixed bin (8) unsigned,
           /* Major op-code of failed request */
    2 minor_code   fixed bin (8) unsigned;
           /* Minor op-code of failed request */

 define structure
   1 XAnyEvent,
    2 type   fixed bin(31),/* of event */
    2 serial fixed bin(32) unsigned,
                           /* # of last request processed by server */
    2 send_event fixed bin (31),
            /* true if this came from a SendEvent request */
    2 display handle Display,/* Display the event was read from */
    2 window  type Window;
            /* window on which event was requested in event mask */

 /* this union is defined so Xlib can always use the same sized */
 /* event structure internally, to avoid memory fragmentation.  */
 define structure
 1 _XEvent union,
    2 type fixed bin(31),/* must not be changed; first element */
    2 xany              type XAnyEvent,
    2 xkey              type XKeyEvent,
    2 xbutton           type XButtonEvent,
    2 xmotion           type XMotionEvent,
    2 xcrossing         type XCrossingEvent,
    2 xfocus            type XFocusChangeEvent,
    2 xexpose           type XExposeEvent,
    2 xgraphicsexpose   type XGraphicsExposeEvent,
    2 xnoexpose         type XNoExposeEvent,
    2 xvisibility       type XVisibilityEvent,
    2 xcreatewindow     type XCreateWindowEvent,
    2 xdestroywindow    type XDestroyWindowEvent,
    2 xunmap            type XUnmapEvent,
    2 xmap              type XMapEvent,
    2 xmaprequest       type XMapRequestEvent,
    2 xreparent         type XReparentEvent,
    2 xconfigure        type XConfigureEvent,
    2 xgravity          type XGravityEvent,
    2 xresizerequest    type XResizeRequestEvent,
    2 xconfigurerequest type XConfigureRequestEvent,
    2 xcirculate        type XCirculateEvent,
    2 xcirculaterequest type XCirculateRequestEvent,
    2 xproperty         type XPropertyEvent,
    2 xselectionclear   type XSelectionClearEvent,
    2 xselectionrequest type XSelectionRequestEvent,
    2 xselection        type XSelectionEvent,
    2 xcolormap         type XColormapEvent,
    2 xclient           type XClientMessageEvent,
    2 xmapping          type XMappingEvent,
    2 xerror            type XErrorEvent,
    2 xkeymap           type XKeymapEvent,
    2 pad (24) fixed bin(31);

 define alias XEvent type _XEvent;

 %XAllocID: proc (dpy) returns (char);
   dcl dpy char;
   return ('(' || dpy || ') => resource_alloc (' || dpy || ')');
 %end XAllocID;
 %dcl XAllocID entry;


 /* per character font metric information. */
 define structure
   1 XCharStruct,
    2 lbearing fixed bin(15),/* origin to left edge of raster */
    2 rbearing fixed bin(15),/* origin to right edge of raster */
    2 width    fixed bin(15),/* advance to next char's origin */
    2 ascent   fixed bin(15),/* baseline to top edge of raster */
    2 descent  fixed bin(15),/* baseline to bottom edge of raster */
    2 attributes unsigned fixed bin(16);
                 /* per char flags (not predefined) */


 /* To allow arbitrary information with fonts, there are additional   */
 /* properties returned.                                              */
 define structure
   1 XFontProp,
    2 name   type XAtom,
    2 card32 fixed bin(32) unsigned;

 define structure
   1 XFontStruct,
    2 ext_data  handle XExtData,/* hook for extension to hang data */
    2 fid       type Font,/* Font id for this font */
    2 direction fixed bin(32) unsigned,
                /* hint about direction the font is painted */
    2 min_char_or_byte2 fixed bin(32) unsigned,/* first character */
    2 max_char_or_byte2 fixed bin(32) unsigned,/* last character */
    2 min_byte1         fixed bin(32) unsigned,/*first row that exists*/
    2 max_byte1         fixed bin(32) unsigned,/* last row that exists*/
    2 all_chars_exist   fixed bin(31),
               /* flag if all characters have non-zero size*/
    2 default_char      fixed bin(32) unsigned,
               /* char to print for undefined character */
    2 n_properties fixed bin(31), /* how many properties there are */
    2 properties   handle XFontProp,
               /* pointer to array of additional properties*/
    2 min_bounds   type XCharStruct, /* minimum and maximum bounds */
    2 max_bounds   type XCharStruct, /* over all existing char*/
    2 per_char handle XCharStruct,
               /* first_char to last_char information */
    2 ascent  fixed bin(31),/* log. extent above baseline for spacing */
    2 descent fixed bin(31);/* log. descent below baseline for spacing*/


 /* PolyText routines take these as arguments. */
 define structure
   1 XTextItem,
    2 chars  pointer,/* pointer to char (*) varz string */
    2 nchars fixed bin(31),/* number of characters */
    2 delta  fixed bin(31),/* delta between strings */
    2 font   type Font;/* font to print it in, None don't change */

 define structure
   1 XChar2b,   /* normal 16 bit characters are two bytes */
    2 byte1  fixed bin(8) unsigned,
    2 byte2  fixed bin(8) unsigned;

 define structure
   1 XTextItem16,
    2 chars  handle XChar2b,/* two byte characters */
    2 nchars fixed bin(31), /* number of characters */
    2 delta  fixed bin(31), /* delta between strings */
    2 font   type Font;     /* font to print it in, None don't change */

 define structure
   1 XEDataObject union,
     2 display       handle Display,
     2 gc            type   GC,
     2 visual        handle Visual,
     2 screen        handle Screen,
     2 pixmap_format handle ScreenFormat,
     2 font          handle XFontStruct;

 define structure
   1 XFontSetExtents,
    2 max_ink_extent     type XRectangle,
    2 max_logical_extent type XRectangle;

 define alias XFontSet pointer;

 define structure
   1 XmbTextItem,
    2 chars    pointer, /* to char (*) varz */
    2 nchars   fixed bin(31),
    2 delta    fixed bin(31),
    2 font_set type XFontSet;


 define structure
   1 XwcTextItem,
    2 chars    pointer  /* to (*) type wchar_t */,
    2 nchars   fixed bin(31),
    2 delta    fixed bin(31),
    2 font_set type XFontSet;

 define alias XIMProc
              entry  ()
              limited options (byvalue nodescriptor linkage(cdecl));

 define alias XIM pointer;
 define alias XIC pointer;

 define alias XIMStyle fixed bin(32) unsigned;

 define structure
   1 XIMStyles,
    2 count_styles     unsigned fixed bin(16) ,
    2 supported_styles pointer;


 dcl XIMPreeditArea      fixed bin(31) value('0001'xn);
 dcl XIMPreeditCallbacks fixed bin(31) value('0002'xn);
 dcl XIMPreeditPosition  fixed bin(31) value('0004'xn);
 dcl XIMPreeditNothing   fixed bin(31) value('0008'xn);
 dcl XIMPreeditNone      fixed bin(31) value('0010'xn);
 dcl XIMStatusArea       fixed bin(31) value('0100'xn);
 dcl XIMStatusCallbacks  fixed bin(31) value('0200'xn);
 dcl XIMStatusNothing    fixed bin(31) value('0400'xn);
 dcl XIMStatusNone       fixed bin(31) value('0800'xn);

 dcl XNVaNestedList         char value('XNVaNestedList');
 dcl XNClientWindow         char value('clientWindow');
 dcl XNInputStyle           char value('inputStyle');
 dcl XNFocusWindow          char value('focusWindow');
 dcl XNResourceName         char value('resourceName');
 dcl XNResourceClass        char value('resourceClass');
 dcl XNGeometryCallback     char value('geometryCallback');
 dcl XNFilterEvents         char value('filterEvents');
 dcl XNPreeditStartCallback char value('preeditStartCallback');
 dcl XNPreeditDoneCallback  char value('preeditDoneCallback');
 dcl XNPreeditDrawCallback  char value('preeditDrawCallback');
 dcl XNPreeditCaretCallback char value('preeditCaretCallback');
 dcl XNPreeditAttributes    char value('preeditAttributes');
 dcl XNStatusStartCallback  char value('statusStartCallback');
 dcl XNStatusDoneCallback   char value('statusDoneCallback');
 dcl XNStatusDrawCallback   char value('statusDrawCallback');
 dcl XNStatusAttributes     char value('statusAttributes');
 dcl XNArea                 char value('area');
 dcl XNAreaNeeded           char value('areaNeeded');
 dcl XNSpotLocation         char value('spotLocation');
 dcl XNColormap             char value('colorMap');
 dcl XNStdColormap          char value('stdColorMap');
 dcl XNForeground           char value('foreground');
 dcl XNBackground           char value('background');
 dcl XNBackgroundPixmap     char value('backgroundPixmap');
 dcl XNFontSet              char value('fontSet');
 dcl XNLineSpace            char value('lineSpace');
 dcl XNCursor               char value('cursor');

 dcl XBufferOverflow fixed bin(31) value(-1);
 dcl XLookupNone     fixed bin(31) value(1);
 dcl XLookupChars    fixed bin(31) value(2);
 dcl XLookupKeySym$  fixed bin(31) value(3); /* XLookupKeysym */
 dcl XLookupBoth     fixed bin(31) value(4);

 define alias XVaNestedList pointer;

 define structure
   1 XIMCallback,
    2 client_data  type XPointer,
    2 callbackproc type XIMProc; /* was callback */

 define alias XIMFeedback fixed bin(32) unsigned;

 dcl XIMReverse   fixed bin(31) value(1);
 dcl XIMUnderline fixed bin(31) value(raise2(1,1));
 dcl XIMHighlight fixed bin(31) value(raise2(1,2));
 dcl XIMPrimary   fixed bin(31) value(raise2(1,5));
 dcl XIMSecondary fixed bin(31) value(raise2(1,6));
 dcl XIMTertiary  fixed bin(31) value(raise2(1,7));

 define structure
   1 XIMText,
    2 length   unsigned fixed bin(16) ,
    2 feedback pointer,
    2 encoding_is_wchar fixed bin (31),
    2 string   union,
      3 multi_byte pointer,
      3 wide_char  pointer;

 define structure
   1 XIMPreeditDrawCallbackStruct,
    2 caret      fixed bin(31),/* Cursor offset within pre-edit string*/
    2 chg_first  fixed bin(31),/* Starting change position */
    2 chg_length fixed bin(31),
            /* Length of the change in character count */
    2 text handle XIMText;


 define ordinal XIMCaretDirection
       ( XIMForwardChar,
         XIMBackwardChar,
         XIMForwardWord,
         XIMBackwardWord,
         XIMCaretUp,
         XIMCaretDown,
         XIMNextLine,
         XIMPreviousLine,
         XIMLineStart,
         XIMLineEnd,
         XIMAbsolutePosition,
         XIMDontChange
      )  prec(31);

 define ordinal XIMCaretStyle
       ( XIMIsInvisible, /* Disable caret feedback */
         XIMIsPrimary,   /* UI defined caret feedback */
         XIMIsSecondary  /* UI defined caret feedback */
      )  prec(31);

 define structure
   1 XIMPreeditCaretCallbackStruct,    /* UI defined caret feedback */
    2 position  fixed bin(31),/* Caret offset within pre-edit string */
    2 direction type XIMCaretDirection,/* Caret moves direction */
    2 style     type XIMCaretStyle;    /* Feedback of the caret */


 define ordinal XIMStatusDataType
       ( XIMTextType,
         XIMBitmapType
      )  prec(31);

 define structure
   1 XIMStatusDrawCallbackStruct,
    2 type type XIMStatusDataType,
    2 data union,
      3 text   handle XIMText,
      3 bitmap type Pixmap;


 dcl XLoadQueryFont
     entry (handle Display                  /* display */,
            char (*) varz nonasgn byaddr)   /* name */
     returns (handle XFontStruct byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XLoadQueryFont');

 dcl XQueryFont
     entry (handle Display                  /* display */,
            type XID)                       /* font_ID */
     returns (handle XFontStruct byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XQueryFont');


 dcl XGetMotionEvents
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            type Time                       /* start */,
            type Time                       /* stop */,
            fixed bin(31) byaddr)           /* nevents_return */
     returns (handle XTimeCoord byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XGetMotionEvents');

 dcl XDeleteModifiermapEntry
     entry (handle XModifierKeymap          /* modmap */,
            type KeyCode                    /* keycode_entry */,
            fixed bin(31))                  /* modifier */
     returns (handle XModifierKeymap byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XDeleteModifiermapEntry');

 dcl XGetModifierMapping
     entry (handle Display)                 /* display */
     returns (handle XModifierKeymap byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XGetModifierMapping');

 dcl XInsertModifiermapEntry
     entry (handle XModifierKeymap          /* modmap */,
            type KeyCode                    /* keycode_entry */,
            fixed bin(31))                  /* modifier */
     returns (handle XModifierKeymap byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XInsertModifiermapEntry');

 dcl XNewModifiermap
     entry (fixed bin(31))                  /* max_keys_per_mod */
     returns (handle XModifierKeymap byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XNewModifiermap');

 dcl XCreateImage
     entry (handle Display                  /* display */,
            handle Visual                   /* visual */,
            fixed bin(32) unsigned          /* depth */,
            fixed bin(31)                   /* format */,
            fixed bin(31)                   /* offset */,
            pointer                         /* data */,
            fixed bin(32) unsigned          /* width */,
            fixed bin(32) unsigned          /* height */,
            fixed bin(31)                   /* bitmap_pad */,
            fixed bin(31))                  /* bytes_per_line */
     returns (handle XImage byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XCreateImage');

 dcl XGetImage
     entry (handle Display                  /* display */,
            type Drawable                   /* d */,
            fixed bin(31)                   /* x */,
            fixed bin(31)                   /* y */,
            fixed bin(32) unsigned          /* width */,
            fixed bin(32) unsigned          /* height */,
            fixed bin(32) unsigned          /* plane_mask */,
            fixed bin(31))                  /* format */
     returns (handle XImage byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XGetImage');

 dcl XGetSubImage
     entry (handle Display                  /* display */,
            type Drawable                   /* d */,
            fixed bin(31)                   /* x */,
            fixed bin(31)                   /* y */,
            fixed bin(32) unsigned          /* width */,
            fixed bin(32) unsigned          /* height */,
            fixed bin(32) unsigned          /* plane_mask */,
            fixed bin(31)                   /* format */,
            handle XImage                   /* dest_image */,
            fixed bin(31)                   /* dest_x */,
            fixed bin(31))                  /* dest_y */
     returns (handle XImage byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XGetSubImage');

 /* X function declarations. */
 dcl XOpenDisplay
     entry (char (*) varz nonasgn byaddr)   /* display_name */
     returns (handle Display byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XOpenDisplay');

 dcl XrmInitialize
     entry ()
     options (byvalue nodescriptor linkage(cdecl))
     external('XrmInitialize');

 dcl XFetchBytes
     entry (handle Display                  /* display */,
            fixed bin(31) byaddr)           /* nbytes_return */
     returns (pointer byvalue)              /* to bytes */
     options (byvalue nodescriptor linkage(cdecl))
     external('XFetchBytes');

 dcl XFetchBuffer
     entry (handle Display                  /* display */,
            fixed bin(31) byaddr            /* nbytes_return */,
            fixed bin(31))                  /* buffer */
     returns (pointer byvalue)              /* to buffer */
     options (byvalue nodescriptor linkage(cdecl))
     external('XFetchBuffer');

 dcl XGetAtomName
     entry (handle Display                  /* display */,
            type XAtom)                     /* atom */
     returns (pointer byvalue)              /* to char (*) varz */
     options (byvalue nodescriptor linkage(cdecl))
     external('XGetAtomName');

 dcl XGetDefault
     entry (handle Display                  /* display */,
            char (*) varz nonasgn byaddr    /* program */,
            char (*) varz nonasgn byaddr)   /* option */
     returns (pointer byvalue)              /* to char (*) varz */
     options (byvalue nodescriptor linkage(cdecl))
     external('XGetDefault');

 dcl XDisplayName
     entry (char (*) varz nonasgn byaddr)   /* string */
     returns (pointer byvalue)              /* to char (*) varz */
     options (byvalue nodescriptor linkage(cdecl))
     external('XDisplayName');

 dcl XKeysymToString
     entry (type KeySym)                    /* keysym */
     returns (pointer byvalue)              /* to char (*) varz */
     options (byvalue nodescriptor linkage(cdecl))
     external('XKeysymToString');

 dcl XSynchronize
     entry (handle Display                  /* display */,
            fixed bin(31))                  /* onoff   */
     returns (entry (handle Display) limited
              returns (fixed bin(31) optional byvalue)
              options (byvalue nodescriptor linkage(cdecl)))
     options (byvalue nodescriptor linkage(cdecl))
     external ('XSynchronize');

 dcl XSetAfterFunction
     entry (handle Display                  /* display */,
            entry (handle Display)          /* procedure */
            returns (fixed bin(31) optional byvalue) limited
            options (byvalue nodescriptor linkage(cdecl)))
     returns (entry (handle Display) limited
              returns (fixed bin(31) optional byvalue)
              options (byvalue nodescriptor linkage(cdecl)))
     options (byvalue nodescriptor linkage(cdecl))
     external ('XSetAfterFunction');

 dcl XInternAtom
     entry (handle Display                  /* display */,
            char (*) varz nonasgn byaddr    /* atom_name */,
            fixed bin(31))                  /* only_if_exists */
     returns (byvalue optional type XAtom)
     options (byvalue nodescriptor linkage(cdecl))
     external('XInternAtom');

 dcl XCopyColormapAndFree
     entry (handle Display                  /* display */,
            type XColormap)                 /* colormap */
     returns (byvalue optional type XColormap)
     options (byvalue nodescriptor linkage(cdecl))
     external('XCopyColormapAndFree');

 dcl XCreateColormap
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            handle Visual                   /* visual */,
            fixed bin(31))                  /* alloc */
     returns (byvalue optional type XColormap)
     options (byvalue nodescriptor linkage(cdecl))
     external('XCreateColormap');

 dcl XCreatePixmapCursor
     entry (handle Display                  /* display */,
            type Pixmap                     /* source */,
            type Pixmap                     /* mask */,
            type XColor byaddr              /* foreground_color */,
            type XColor byaddr              /* background_color */,
            fixed bin(32) unsigned          /* x */,
            fixed bin(32) unsigned)         /* y */
     returns (byvalue optional type Cursor)
     options (byvalue nodescriptor linkage(cdecl))
     external('XCreatePixmapCursor');

 dcl XCreateGlyphCursor
     entry (handle Display                  /* display */,
            type Font                       /* source_font */,
            type Font                       /* mask_font */,
            fixed bin(32) unsigned          /* source_char */,
            fixed bin(32) unsigned          /* mask_char */,
            type XColor byaddr              /* foreground_color */,
            type XColor byaddr)             /* background_color */
     returns (byvalue optional type Cursor)
     options (byvalue nodescriptor linkage(cdecl))
     external('XCreateGlyphCursor');

 dcl XCreateFontCursor
     entry (handle Display                  /* display */,
            fixed bin(31))                  /* shape */
     returns (byvalue optional type Cursor)
     options (byvalue nodescriptor linkage(cdecl))
     external('XCreateFontCursor');

 dcl XLoadFont
     entry (handle Display                  /* display */,
            char (*) varz nonasgn byaddr)   /* name */
     returns (byvalue optional type Font)
     options (byvalue nodescriptor linkage(cdecl))
     external('XLoadFont');

 dcl XCreateGC
     entry (handle Display                  /* display */,
            type Drawable                   /* d */,
            fixed bin(32) unsigned          /* valuemask */,
            type XGCValues byaddr)          /* values */
     returns (byvalue optional type GC)
     options (byvalue nodescriptor linkage(cdecl))
     external('XCreateGC');

 dcl XGContextFromGC
     entry (type GC)                        /* gc */
     returns (byvalue optional type GContext)
     options (byvalue nodescriptor linkage(cdecl))
     external('XGContextFromGC');

 dcl XFlushGC
     entry (handle Display                  /* display */,
            type GC)                        /* gc */
     options (byvalue nodescriptor linkage(cdecl))
     external('XFlushGC');

 dcl XCreatePixmap
     entry (handle Display                  /* display */,
            type Drawable                   /* d */,
            fixed bin(32) unsigned          /* width */,
            fixed bin(32) unsigned          /* height */,
            fixed bin(31))                  /* depth */
     returns (byvalue optional type Pixmap)
     options (byvalue nodescriptor linkage(cdecl))
     external('XCreatePixmap');

 dcl XCreateBitmapFromData
     entry (handle Display                  /* display */,
            type Drawable                   /* d */,
            char (*) varz nonasgn byaddr    /* data */,
            fixed bin(32) unsigned          /* width */,
            fixed bin(32) unsigned)         /* height */
     returns (byvalue optional type Pixmap)
     options (byvalue nodescriptor linkage(cdecl))
     external('XCreateBitmapFromData');

 dcl XCreatePixmapFromBitmapData
     entry (handle Display                  /* display */,
            type Drawable                   /* d */,
            pointer                         /* data */,
            fixed bin(32) unsigned          /* width */,
            fixed bin(32) unsigned          /* height */,
            fixed bin(31)                   /* fg */,
            fixed bin(31)                   /* bg */,
            fixed bin(31))                  /* depth */
     returns (byvalue optional type Pixmap)
     options (byvalue nodescriptor linkage(cdecl))
     external('XCreatePixmapFromBitmapData');

 dcl XCreateSimpleWindow
     entry (handle Display                  /* display */,
            type Window                     /* parent */,
            fixed bin(31)                   /* x */,
            fixed bin(31)                   /* y */,
            fixed bin(32) unsigned          /* width */,
            fixed bin(32) unsigned          /* height */,
            fixed bin(31)                   /* border_width */,
            fixed bin(31)                   /* border */,
            fixed bin(31))                  /* background */
     returns (byvalue optional type Window)
     options (byvalue nodescriptor linkage(cdecl))
     external('XCreateSimpleWindow');

 dcl XGetSelectionOwner
     entry (handle Display                  /* display */,
            type XAtom)                     /* selection */
     returns (byvalue optional type Window)
     options (byvalue nodescriptor linkage(cdecl))
     external('XGetSelectionOwner');

 dcl XCreateWindow
     entry (handle Display                  /* display */,
            type Window                     /* parent */,
            fixed bin(31)                   /* x */,
            fixed bin(31)                   /* y */,
            fixed bin(32) unsigned          /* width */,
            fixed bin(32) unsigned          /* height */,
            fixed bin(31)                   /* border_width */,
            fixed bin(31)                   /* depth */,
            fixed bin(31)                   /* class */,
            handle Visual                   /* visual */,
            fixed bin(32) unsigned          /* valuemask */,
            type XSetWindowAttributes byaddr) /* attributes */
     returns (byvalue optional type Window)
     options (byvalue nodescriptor linkage(cdecl))
     external('XCreateWindow');

 dcl XListInstalledColormaps
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            fixed bin(31) byaddr)          /* num_return */
     returns (pointer byvalue)       /* to XColormap */
     options (byvalue nodescriptor linkage(cdecl))
     external('XListInstalledColormaps');

 dcl XListFonts
     entry (handle Display                  /* display */,
            char (*) varz nonasgn byaddr    /* pattern */,
            fixed bin(31)                   /* maxnames */,
            fixed bin(31) byaddr)           /* actual_count_return */
     returns (pointer byvalue) /* to array of ptrs to char (*) varz*/
     options (byvalue nodescriptor linkage(cdecl))
     external('XListFonts');

 dcl XListFontsWithInfo
     entry (handle Display                  /* display */,
            char (*) varz nonasgn byaddr    /* pattern */,
            fixed bin(31)                   /* maxnames */,
            fixed bin(31) byaddr            /* count_return */,
            handle XFontStruct)             /* info_return */
     returns (pointer byvalue)/* to array of ptrs to char (*) varz*/
     options (byvalue nodescriptor linkage(cdecl))
     external('XListFontsWithInfo');

 dcl XGetFontPath
     entry (handle Display                  /* display */,
            fixed bin(31) byaddr)           /* npaths_return */
     returns (pointer byvalue) /* to array of ptrs to char (*) varz*/
     options (byvalue nodescriptor linkage(cdecl))
     external('XGetFontPath');

 dcl XListExtensions
     entry (handle Display                  /* display */,
            fixed bin(31) byaddr)           /* nextensions_return */
     returns (pointer byvalue) /* to array of ptrs to char (*) varz*/
     options (byvalue nodescriptor linkage(cdecl))
     external('XListExtensions');

 dcl XListProperties
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            fixed bin(31) byaddr)           /* num_prop_return */
     returns (pointer byvalue)              /* addr (atom) */
     options (byvalue nodescriptor linkage(cdecl))
     external('XListProperties');

 dcl XListHosts
     entry (handle Display                  /* display */,
            fixed bin(31) byaddr            /* nhosts_return */,
            fixed bin(31) byaddr)           /* state_return */
     returns (handle XHostAddress byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XListHosts');

 dcl XKeycodeToKeysym
     entry (handle Display                  /* display */,
            type KeyCode                    /* keycode */,
            fixed bin(31))                  /* index */
     returns (byvalue optional type KeySym)
     options (byvalue nodescriptor linkage(cdecl))
     external('XKeycodeToKeysym');

 dcl XLookupKeysym
     entry (handle XKeyEvent                /* key_event */,
            fixed bin(31))                  /* index */
     returns (byvalue optional type KeySym)
     options (byvalue nodescriptor linkage(cdecl))
     external('XLookupKeysym');

 dcl XGetKeyboardMapping
     entry (handle Display                  /* display */,
            type KeyCode                    /* first_keycode */,
            fixed bin(31)                   /* keycode_count */,
            fixed bin(31) byaddr)       /* keysyms_per_keycode_return */
     returns (pointer byvalue)              /* to KeySym */
     options (byvalue nodescriptor linkage(cdecl))
     external('XGetKeyboardMapping');

 dcl XStringToKeysym
     entry (
        char (*) varz byaddr)           /* string */
     returns (byvalue optional type KeySym)
     options (byvalue nodescriptor linkage(cdecl))
     external('XStringToKeysym');

 dcl XMaxRequestSize
     entry (handle Display)                 /* display */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XMaxRequestSize');

 dcl XExtendedMaxRequestSize
     entry (handle Display)                 /* display */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XExtendedMaxRequestSize');

 dcl XResourceManagerString
     entry (handle Display)                 /* display */
     returns (pointer byvalue)       /* to char (*) varz */
     options (byvalue nodescriptor linkage(cdecl))
     external('XResourceManagerString');

 dcl XScreenResourceString
     entry (handle Screen)                  /* screen */
     returns (pointer byvalue)       /* to char (*) varz */
     options (byvalue nodescriptor linkage(cdecl))
     external('XScreenResourceString');

 dcl XDisplayMotionBufferSize
     entry (handle Display)                 /* display */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XDisplayMotionBufferSize');

 dcl XVisualIDFromVisual
     entry (handle Visual)                  /* visual */
     returns (byvalue optional type VisualID)
     options (byvalue nodescriptor linkage(cdecl))
     external('XVisualIDFromVisual');

 /* routines for dealing with extensions */

 dcl XInitExtension
     entry (handle Display                  /* display */,
            char (*) varz nonasgn byaddr)   /* name */
     returns (handle XExtCodes byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XInitExtension');

 dcl XAddExtension
     entry (handle Display)                 /* display */
     returns (handle XExtCodes byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XAddExtension');

 dcl XFindOnExtensionList
     entry (handle XExtData                 /* structure */,
            fixed bin(31))                  /* number */
     returns (handle XExtCodes byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XFindOnExtensionList');

 dcl XEHeadOfExtensionList
     entry (type XEDataObject)              /* object */
     returns (handle XExtCodes byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XEHeadOfExtensionList');

 /* these are routines for which there are also macros */
 dcl XRootWindow
     entry (handle Display                  /* display */,
            fixed bin(31))                  /* screen_number */
     returns (byvalue optional type Window)
     options (byvalue nodescriptor linkage(cdecl))
     external('XRootWindow');

 dcl XDefaultRootWindow
     entry (handle Display)                 /* display */
     returns (byvalue optional type Window)
     options (byvalue nodescriptor linkage(cdecl))
     external('XDefaultRootWindow');

 dcl XRootWindowOfScreen
     entry (handle Screen)                  /* screen */
     returns (byvalue optional type Window)
     options (byvalue nodescriptor linkage(cdecl))
     external('XRootWindowOfScreen');

 dcl XDefaultVisual
     entry (handle Display                  /* display */,
            fixed bin(31))                  /* screen_number */
     returns (handle Visual byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XDefaultVisual');

 dcl XDefaultVisualOfScreen
     entry (handle Screen)                  /* screen */
     returns (handle Visual byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XDefaultVisualOfScreen');

 dcl XDefaultGC
     entry (handle Display                  /* display */,
            fixed bin(31))                  /* screen_number */
     returns (byvalue optional type GC)
     options (byvalue nodescriptor linkage(cdecl))
     external('XDefaultGC');

 dcl XDefaultGCOfScreen
     entry (handle Screen)                  /* screen */
     returns (byvalue optional type GC)
     options (byvalue nodescriptor linkage(cdecl))
     external('XDefaultGCOfScreen');

 dcl XBlackPixel
     entry (handle Display                  /* display */,
            fixed bin(31))                  /* screen_number */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XBlackPixel');

 dcl XWhitePixel
     entry (handle Display                  /* display */,
            fixed bin(31))                  /* screen_number */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XWhitePixel');

 dcl XAllPlanes
     entry ()
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XAllPlanes');

 dcl XBlackPixelOfScreen
     entry (handle Screen)                  /* screen */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XBlackPixelOfScreen');

 dcl XWhitePixelOfScreen
     entry (handle Screen)                  /* screen */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XWhitePixelOfScreen');

 dcl XNextRequest
     entry (handle Display)                 /* display */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XNextRequest');

 dcl XLastKnownRequestProcessed
     entry (handle Display)                 /* display */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XLastKnownRequestProcessed');

 dcl XServerVendor
     entry (handle Display)                 /* display */
     returns (pointer byvalue)       /* to char (*) varz */
     options (byvalue nodescriptor linkage(cdecl))
     external('XServerVendor');

 dcl XDisplayString
     entry (handle Display)                 /* display */
     returns (pointer byvalue)       /* to char (*) varz */
     options (byvalue nodescriptor linkage(cdecl))
     external('XDisplayString');

 dcl XDefaultColormap
     entry (handle Display                  /* display */,
            fixed bin(31))                  /* screen_number */
     returns (byvalue optional type XColormap)
     options (byvalue nodescriptor linkage(cdecl))
     external('XDefaultColormap');

 dcl XDefaultColormapOfScreen
     entry (handle Screen)                  /* screen */
     returns (byvalue optional type XColormap)
     options (byvalue nodescriptor linkage(cdecl))
     external('XDefaultColormapOfScreen');

 dcl XDisplayOfScreen
     entry (handle Screen)                  /* screen */
     returns (handle Display byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XDisplayOfScreen');

 dcl XScreenOfDisplay
     entry (handle Display                  /* display */,
            fixed bin(31))                  /* screen_number */
     returns (handle Screen byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XScreenOfDisplay');

 dcl XDefaultScreenOfDisplay
     entry (handle Display)                 /* display */
     returns (handle Screen byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XDefaultScreenOfDisplay');

 dcl XEventMaskOfScreen
     entry (handle Screen)                  /* screen */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XEventMaskOfScreen');

 dcl XScreenNumberOfScreen
     entry (handle Screen)                  /* screen */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XScreenNumberOfScreen');

 /* WARNING, this type not in Xlib spec */
 define alias XErrorHandler
        entry (handle Display               /* display */,
               handle XErrorEvent)          /* error_event */
     returns (fixed bin(31) byvalue)
     limited options (byvalue nodescriptor linkage(cdecl));

 dcl XSetErrorHandler
     entry (type XErrorHandler)             /* handler */
     returns (byvalue optional type XErrorHandler)
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetErrorHandler');


 /* WARNING, this type not in Xlib spec */
 define alias XIOErrorHandler
        entry (handle Display)              /* display */
     returns (fixed bin(31) byvalue)
     limited options (byvalue nodescriptor linkage(cdecl)) ;

 dcl XSetIOErrorHandler
     entry (type XIOErrorHandler)           /* handler */
     returns (byvalue optional type XIOErrorHandler)
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetIOErrorHandler');


 dcl XListPixmapFormats
     entry (handle Display                  /* display */,
            fixed bin(31) byaddr)           /* count_return */
     returns (handle XPixmapFormatValues byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XListPixmapFormats');

 dcl XListDepths
     entry (handle Display                  /* display */,
            fixed bin(31)                   /* screen_number */,
            fixed bin(31) byaddr)           /* count_return */
     returns (pointer byvalue)              /* to (*) fixed bin(31) */
     options (byvalue nodescriptor linkage(cdecl))
     external('XListDepths');

 /* ICCCM routines for things that don't require special include */
 /* files, other declarations are given in Xutil.h               */

 dcl XReconfigureWMWindow
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            fixed bin(31)                   /* screen_number */,
            fixed bin(31)                   /* mask */,
            handle XWindowChanges)          /* changes */
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XReconfigureWMWindow');

 dcl XGetWMProtocols
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            type XAtom byaddr               /* protocols_return */,
            fixed bin(31) byaddr)           /* count_return */
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XGetWMProtocols');

 dcl XSetWMProtocols
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            type XAtom byaddr               /* protocols */,
            fixed bin(31))                  /* count */
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetWMProtocols');

 dcl XIconifyWindow
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            fixed bin(31))                  /* screen_number */
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XIconifyWindow');

 dcl XWithdrawWindow
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            fixed bin(31))                  /* screen_number */
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XWithdrawWindow');

 dcl XGetCommand
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            pointer byaddr                  /* argv_return */,
            fixed bin(31) byaddr)           /* argc_return */
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XGetCommand');

 dcl XGetWMColormapWindows
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            type Window byaddr              /* windows_return */,
            fixed bin(31) byaddr)           /* count_return */
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XGetWMColormapWindows');

 dcl XSetWMColormapWindows
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            type Window byaddr              /* colormap_windows */,
            fixed bin(31))                  /* count */
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetWMColormapWindows');

 dcl XFreeStringList
     entry ((*) pointer byaddr)             /* list */
     options (byvalue nodescriptor linkage(cdecl))
     external('XFreeStringList');

 dcl XSetTransientForHint
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            type Window)                    /* prop_window */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetTransientForHint');

 /* The following are given in alphabetical order */

 dcl XActivateScreenSaver
     entry (handle Display)                 /* display */
     options (byvalue nodescriptor linkage(cdecl))
     external('XActivateScreenSaver');

 dcl XAddHost
     entry (handle Display                  /* display */,
            type XHostAddress byaddr)       /* host */
     options (byvalue nodescriptor linkage(cdecl))
     external('XAddHost');

 dcl XAddHosts
     entry (handle Display                  /* display */,
            type XHostAddress byaddr        /* hosts */,
            fixed bin(31))                  /* num_hosts */
     options (byvalue nodescriptor linkage(cdecl))
     external('XAddHosts');

 dcl XAddToExtensionList
     entry (handle XExtData                 /* structure */,
            handle XExtData)                /* ext_data */
     options (byvalue nodescriptor linkage(cdecl))
     external('XAddToExtensionList');

 dcl XAddToSaveSet
     entry (handle Display                  /* display */,
            type Window)                    /* w */
     options (byvalue nodescriptor linkage(cdecl))
     external('XAddToSaveSet');

 dcl XAllocColor
     entry (handle Display                  /* display */,
            type XColormap                  /* colormap */,
            type XColor byaddr)             /* screen_in_out */
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XAllocColor');

 dcl XAllocColorCells
     entry (handle Display                  /* display */,
            type XColormap                  /* colormap */,
            fixed bin(31)                   /* contig */,
            fixed bin(32) unsigned byaddr   /* plane_masks_return */,
            fixed bin(31)                   /* nplanes */,
            fixed bin(31) byaddr            /* pixels_return */,
            fixed bin(31))                  /* npixels */
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XAllocColorCells');

 dcl XAllocColorPlanes
     entry (handle Display                  /* display */,
            type XColormap                  /* colormap */,
            fixed bin(31)                   /* contig */,
            fixed bin(31) byaddr            /* pixels_return */,
            fixed bin(31)                   /* ncolors */,
            fixed bin(31)                   /* nreds */,
            fixed bin(31)                   /* ngreens */,
            fixed bin(31)                   /* nblues */,
            fixed bin(31) byaddr            /* rmask_return */,
            fixed bin(31) byaddr            /* gmask_return */,
            fixed bin(31) byaddr)           /* bmask_return */
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XAllocColorPlanes');

 dcl XAllocNamedColor
     entry (handle Display                  /* display */,
            type XColormap                  /* colormap */,
            char (*) varz nonasgn byaddr    /* color_name */,
            type XColor byaddr              /* screen_def_return */,
            type XColor byaddr)             /* exact_def_return */
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XAllocNamedColor');

 dcl XAllowEvents
     entry (handle Display                  /* display */,
            fixed bin(31)                   /* event_mode */,
            type Time)                      /* time */
     options (byvalue nodescriptor linkage(cdecl))
     external('XAllowEvents');

 dcl XAutoRepeatOff
     entry (handle Display)                 /* display */
     options (byvalue nodescriptor linkage(cdecl))
     external('XAutoRepeatOff');

 dcl XAutoRepeatOn
     entry (handle Display)                 /* display */
     options (byvalue nodescriptor linkage(cdecl))
     external('XAutoRepeatOn');

 dcl XBell
     entry (handle Display                  /* display */,
            fixed bin(31))                  /* percent */
     options (byvalue nodescriptor linkage(cdecl))
     external('XBell');

 dcl XBitmapBitOrder
     entry (handle Display)                 /* display */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XBitmapBitOrder');

 dcl XBitmapPad
     entry (handle Display)                 /* display */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XBitmapPad');

 dcl XBitmapUnit
     entry (handle Display)                 /* display */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XBitmapUnit');

 dcl XCellsOfScreen
     entry (handle Screen)                  /* screen */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XCellsOfScreen');

 dcl XChangeActivePointerGrab
     entry (handle Display                  /* display */,
            fixed bin(31)                   /* event_mask */,
            type Cursor                     /* cursor */,
            type Time)                      /* time */
     options (byvalue nodescriptor linkage(cdecl))
     external('XChangeActivePointerGrab');

 dcl XChangeGC
     entry (handle Display                  /* display */,
            type GC                         /* gc */,
            fixed bin(32) unsigned          /* valuemask */,
            type XGCValues byaddr)          /* values */
     options (byvalue nodescriptor linkage(cdecl))
     external('XChangeGC');

 dcl XChangeKeyboardControl entry (
            handle Display                  /* display */,
            fixed bin(32) unsigned          /* value_mask */,
            handle XKeyboardControl)        /* values */
     options (byvalue nodescriptor linkage(cdecl))
     external('XChangeKeyboardControl');

 dcl XChangeKeyboardMapping
     entry (handle Display                  /* display */,
            fixed bin(31)                   /* first_keycode */,
            fixed bin(31)                   /* keysyms_per_keycode */,
            type KeySym byaddr              /* keysyms */,
            fixed bin(31))                  /* num_codes */
     options (byvalue nodescriptor linkage(cdecl))
     external('XChangeKeyboardMapping');

 dcl XChangePointerControl
     entry (handle Display                  /* display */,
            fixed bin(31)                   /* do_accel */,
            fixed bin(31)                   /* do_threshold */,
            fixed bin(31)                   /* accel_numerator */,
            fixed bin(31)                   /* accel_denominator */,
            fixed bin(31))                  /* threshold */
     options (byvalue nodescriptor linkage(cdecl))
     external('XChangePointerControl');

 dcl XChangeProperty
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            type XAtom                      /* property */,
            type XAtom                      /* type */,
            fixed bin(31)                   /* format */,
            fixed bin(31)                   /* mode */,
            pointer                         /* data */,
            fixed bin(31))                  /* nelements */
     options (byvalue nodescriptor linkage(cdecl))
     external('XChangeProperty');

 dcl XChangeSaveSet
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            fixed bin(31))                  /* change_mode */
     options (byvalue nodescriptor linkage(cdecl))
     external('XChangeSaveSet');

 dcl XChangeWindowAttributes
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            fixed bin(32) unsigned          /* valuemask */,
            type XSetWindowAttributes byaddr) /* attributes */
     options (byvalue nodescriptor linkage(cdecl))
     external('XChangeWindowAttributes');

 dcl XCheckIfEvent
     entry (handle Display                  /* display */,
            handle XEvent                   /* event_return */,
            entry (                         /* predicate */
                   handle Display           /* display */,
                   handle XEvent            /* event */,
                   type XPointer)           /* arg */
                  returns (fixed bin(31) byvalue optional)
                  options (byvalue nodescriptor linkage(cdecl)) limited,
            type XPointer)                  /* arg */
     returns (byvalue optional fixed bin(31))
     options (byvalue nodescriptor linkage(cdecl))
     external('XCheckIfEvent');

 dcl XCheckMaskEvent
     entry (handle Display                  /* display */,
            fixed bin(31)                   /* event_mask */,
            handle Xevent)                  /* event_return */
     returns (byvalue optional fixed bin(31))
     options (byvalue nodescriptor linkage(cdecl))
     external('XCheckMaskEvent');

 dcl XCheckTypedEvent
     entry (handle Display                  /* display */,
            fixed bin(31)                   /* event_type */,
            handle Xevent)                  /* event_return */
     returns (byvalue optional fixed bin(31))
     options (byvalue nodescriptor linkage(cdecl))
     external('XCheckTypedEvent');

 dcl XCheckTypedWindowEvent
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            fixed bin(31)                   /* event_type */,
            handle Xevent)                  /* event_return */
     returns (byvalue optional fixed bin(31))
     options (byvalue nodescriptor linkage(cdecl))
     external('XCheckTypedWindowEvent');

 dcl XCheckWindowEvent
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            fixed bin(31)                   /* event_mask */,
            handle Xevent)                  /* event_return */
     returns (byvalue optional fixed bin(31))
     options (byvalue nodescriptor linkage(cdecl))
     external('XCheckWindowEvent');

 dcl XCirculateSubwindows
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            fixed bin(31))                  /* direction */
     options (byvalue nodescriptor linkage(cdecl))
     external('XCirculateSubwindows');

 dcl XCirculateSubwindowsDown
     entry (handle Display                  /* display */,
            type Window)                    /* w */
     options (byvalue nodescriptor linkage(cdecl))
     external('XCirculateSubwindowsDown');

 dcl XCirculateSubwindowsUp
     entry (handle Display                  /* display */,
            type Window)                    /* w */
     options (byvalue nodescriptor linkage(cdecl))
     external('XCirculateSubwindowsUp');

 dcl XClearArea
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            fixed bin(31)                   /* x */,
            fixed bin(31)                   /* y */,
            fixed bin(32) unsigned          /* width */,
            fixed bin(32) unsigned          /* height */,
            fixed bin(31))                  /* exposures */
     options (byvalue nodescriptor linkage(cdecl))
     external('XClearArea');

 dcl XClearWindow
     entry (handle Display                  /* display */,
            type Window)                    /* w */
     options (byvalue nodescriptor linkage(cdecl))
     external('XClearWindow');

 dcl XCloseDisplay
     entry (handle Display)                 /* display */
     options (byvalue nodescriptor linkage(cdecl))
     external('XCloseDisplay');

 dcl XConfigureWindow
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            fixed bin(32) unsigned          /* value_mask */,
            handle XWindowChanges)          /* values */
     options (byvalue nodescriptor linkage(cdecl))
     external('XConfigureWindow');

 dcl XConnectionNumber
     entry (handle Display)                 /* display */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XConnectionNumber');

 dcl XConvertSelection
     entry (handle Display                  /* display */,
            type XAtom                      /* selection */,
            type XAtom                      /* target */,
            type XAtom                      /* property */,
            type Window                     /* requestor */,
            type Time)                      /* time */
     options (byvalue nodescriptor linkage(cdecl))
     external('XConvertSelection');

 dcl XCopyArea
     entry (handle Display                  /* display */,
            type Drawable                   /* src */,
            type Drawable                   /* dest */,
            type GC                         /* gc */,
            fixed bin(31)                   /* src_x */,
            fixed bin(31)                   /* src_y */,
            fixed bin(32) unsigned          /* width */,
            fixed bin(32) unsigned          /* height */,
            fixed bin(31)                   /* dest_x */,
            fixed bin(31))                  /* dest_y */
     options (byvalue nodescriptor linkage(cdecl))
     external('XCopyArea');

 dcl XCopyGC
     entry (handle Display                  /* display */,
            type GC                         /* src */,
            fixed bin(32) unsigned          /* valuemask */,
            type GC)                        /* dest */
     options (byvalue nodescriptor linkage(cdecl))
     external('XCopyGC');

 dcl XCopyPlane
     entry (handle Display                  /* display */,
            type Drawable                   /* src */,
            type Drawable                   /* dest */,
            type GC                         /* gc */,
            fixed bin(31)                   /* src_x */,
            fixed bin(31)                   /* src_y */,
            fixed bin(32) unsigned          /* width */,
            fixed bin(32) unsigned          /* height */,
            fixed bin(31)                   /* dest_x */,
            fixed bin(31)                   /* dest_y */,
            fixed bin(32) unsigned)         /* plane */
     options (byvalue nodescriptor linkage(cdecl))
     external('XCopyPlane');

 dcl XDefaultDepth
     entry (handle Display                  /* display */,
            fixed bin(31))                  /* screen_number */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XDefaultDepth');

 dcl XDefaultDepthOfScreen
     entry (handle Screen)                  /* screen */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XDefaultDepthOfScreen');

 dcl XDefaultScreen
     entry (handle Display)                 /* display */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XDefaultScreen');

 dcl XDefineCursor
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            type Cursor)                    /* cursor */
     options (byvalue nodescriptor linkage(cdecl))
     external('XDefineCursor');

 dcl XDeleteProperty
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            type XAtom)                     /* property */
     options (byvalue nodescriptor linkage(cdecl))
     external('XDeleteProperty');

 dcl XDestroyWindow
     entry (handle Display                  /* display */,
            type Window)                    /* w */
     options (byvalue nodescriptor linkage(cdecl))
     external('XDestroyWindow');

 dcl XDestroySubwindows
     entry (handle Display                  /* display */,
            type Window)                    /* w */
     options (byvalue nodescriptor linkage(cdecl))
     external('XDestroySubwindows');

 dcl XDoesBackingStore
     entry (handle Screen)                  /* screen */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XDoesBackingStore');

 dcl XDoesSaveUnders
     entry (handle Screen)                  /* screen */
     returns (byvalue optional fixed bin(31))
     options (byvalue nodescriptor linkage(cdecl))
     external('XDoesSaveUnders');

 dcl XDisableAccessControl
     entry (handle Display)                 /* display */
     options (byvalue nodescriptor linkage(cdecl))
     external('XDisableAccessControl');

 dcl XDisplayCells
     entry (handle Display                  /* display */,
            fixed bin(31))                  /* screen_number */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XDisplayCells');

 dcl XDisplayHeight
     entry (handle Display                  /* display */,
            fixed bin(31))                  /* screen_number */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XDisplayHeight');

 dcl XDisplayHeightMM
     entry (handle Display                  /* display */,
            fixed bin(31))                  /* screen_number */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XDisplayHeightMM');

 dcl XDisplayKeycodes
     entry (handle Display                  /* display */,
            fixed bin(31) byaddr            /* min_keycodes_return */,
            fixed bin(31) byaddr)           /* max_keycodes_return */
     options (byvalue nodescriptor linkage(cdecl))
     external('XDisplayKeycodes');

 dcl XDisplayPlanes
     entry (handle Display                  /* display */,
            fixed bin(31))                  /* screen_number */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XDisplayPlanes');

 dcl XDisplayWidth
     entry (handle Display                  /* display */,
            fixed bin(31))                  /* screen_number */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XDisplayWidth');

 dcl XDisplayWidthMM
     entry (handle Display                  /* display */,
            fixed bin(31))                  /* screen_number */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XDisplayWidthMM');

 dcl XDrawArc
     entry (handle Display                  /* display */,
            type Drawable                   /* d */,
            type GC                         /* gc */,
            fixed bin(31)                   /* x */,
            fixed bin(31)                   /* y */,
            fixed bin(32) unsigned          /* width */,
            fixed bin(32) unsigned          /* height */,
            fixed bin(31)                   /* angle1 */,
            fixed bin(31))                  /* angle2 */
     options (byvalue nodescriptor linkage(cdecl))
     external('XDrawArc');

 dcl XDrawArcs
     entry (handle Display                  /* display */,
            type Drawable                   /* d */,
            type GC                         /* gc */,
            (*) type XArc byaddr            /* arcs */,
            fixed bin(31))                  /* narcs */
     options (byvalue nodescriptor linkage(cdecl))
     external('XDrawArcs');

 dcl XDrawImageString
     entry (handle Display                  /* display */,
            type Drawable                   /* d */,
            type GC                         /* gc */,
            fixed bin(31)                   /* x */,
            fixed bin(31)                   /* y */,
            char (*) varz nonasgn byaddr    /* string */,
            fixed bin(31))                  /* length */
     options (byvalue nodescriptor linkage(cdecl))
     external('XDrawImageString');

 dcl XDrawImageString16
     entry (handle Display                  /* display */,
            type Drawable                   /* d */,
            type GC                         /* gc */,
            fixed bin(31)                   /* x */,
            fixed bin(31)                   /* y */,
            handle XChar2b                  /* string */,
            fixed bin(31))                  /* length */
     options (byvalue nodescriptor linkage(cdecl))
     external('XDrawImageString16');

 dcl XDrawLine
     entry (handle Display                  /* display */,
            type Drawable                   /* d */,
            type GC                         /* gc */,
            fixed bin(31)                   /* x1 */,
            fixed bin(31)                   /* y1 */,
            fixed bin(31)                   /* x2 */,
            fixed bin(31))                  /* y2 */
     options (byvalue nodescriptor linkage(cdecl))
     external('XDrawLine');

 dcl XDrawLines
     entry (handle Display                  /* display */,
            type Drawable                   /* d */,
            type GC                         /* gc */,
            (*) type XPoint byaddr          /* points */,
            fixed bin(31)                   /* npoints */,
            fixed bin(31))                  /* mode */
     options (byvalue nodescriptor linkage(cdecl))
     external('XDrawLines');

 dcl XDrawPoint
     entry (handle Display                  /* display */,
            type Drawable                   /* d */,
            type GC                         /* gc */,
            fixed bin(31)                   /* x */,
            fixed bin(31))                  /* y */
     options (byvalue nodescriptor linkage(cdecl))
     external('XDrawPoint');

 dcl XDrawPoints
     entry (handle Display                  /* display */,
            type Drawable                   /* d */,
            type GC                         /* gc */,
            (*) type XPoint byaddr          /* points */,
            fixed bin(31)                   /* npoints */,
            fixed bin(31))                  /* mode */
     options (byvalue nodescriptor linkage(cdecl))
     external('XDrawPoints');

 dcl XDrawRectangle
     entry (handle Display                  /* display */,
            type Drawable                   /* d */,
            type GC                         /* gc */,
            fixed bin(31)                   /* x */,
            fixed bin(31)                   /* y */,
            fixed bin(32) unsigned          /* width */,
            fixed bin(32) unsigned)         /* height */
     options (byvalue nodescriptor linkage(cdecl))
     external('XDrawRectangle');

 dcl XDrawRectangles
     entry (handle Display                  /* display */,
            type Drawable                   /* d */,
            type GC                         /* gc */,
            (*) type XRectangle byaddr      /* rectangles */,
            fixed bin(31))                  /* nrectangles */
     options (byvalue nodescriptor linkage(cdecl))
     external('XDrawRectangles');

 dcl XDrawSegments
     entry (handle Display                  /* display */,
            type Drawable                   /* d */,
            type GC                         /* gc */,
            (*) type XSegment byaddr        /* segments */,
            fixed bin(31))                  /* nsegments */
     options (byvalue nodescriptor linkage(cdecl))
     external('XDrawSegments');

 dcl XDrawString
     entry (handle Display                  /* display */,
            type Drawable                   /* d */,
            type GC                         /* gc */,
            fixed bin(31)                   /* x */,
            fixed bin(31)                   /* y */,
            char (*) varz nonasgn byaddr    /* string */,
            fixed bin(31))                  /* length */
     options (byvalue nodescriptor linkage(cdecl))
     external('XDrawString');

 dcl XDrawString16
     entry (handle Display                  /* display */,
            type Drawable                   /* d */,
            type GC                         /* gc */,
            fixed bin(31)                   /* x */,
            fixed bin(31)                   /* y */,
            handle XChar2b,                 /* string */,
            fixed bin(31))                  /* length */
     options (byvalue nodescriptor linkage(cdecl))
     external('XDrawString16');

 dcl XDrawText
     entry (handle Display                  /* display */,
            type Drawable                   /* d */,
            type GC                         /* gc */,
            fixed bin(31)                   /* x */,
            fixed bin(31)                   /* y */,
            handle XTextItem                /* items */,
            fixed bin(31))                  /* nitems */
     options (byvalue nodescriptor linkage(cdecl))
     external('XDrawText');

 dcl XDrawText16
     entry (handle Display                  /* display */,
            type Drawable                   /* d */,
            type GC                         /* gc */,
            fixed bin(31)                   /* x */,
            fixed bin(31)                   /* y */,
            handle XTextItem16              /* items */,
            fixed bin(31))                  /* nitems */
     options (byvalue nodescriptor linkage(cdecl))
     external('XDrawText16');

 dcl XEnableAccessControl
     entry (handle Display)                 /* display */
     options (byvalue nodescriptor linkage(cdecl))
     external('XEnableAccessControl');

 dcl XEventsQueued
     entry (handle Display                  /* display */,
            fixed bin(31))                  /* mode */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XEventsQueued');

 dcl XFetchName
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            pointer byaddr)             /* window_name_return -> c(*)z*/
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XFetchName');

 dcl XFillArc
     entry (handle Display                  /* display */,
            type Drawable                   /* d */,
            type GC                         /* gc */,
            fixed bin(31)                   /* x */,
            fixed bin(31)                   /* y */,
            fixed bin(32) unsigned          /* width */,
            fixed bin(32) unsigned          /* height */,
            fixed bin(31)                   /* angle1 */,
            fixed bin(31))                  /* angle2 */
     options (byvalue nodescriptor linkage(cdecl))
     external('XFillArc');

 dcl XFillArcs
     entry (handle Display                  /* display */,
            type Drawable                   /* d */,
            type GC                         /* gc */,
            handle XArc                     /* arcs */,
            fixed bin(31))                  /* narcs */
     options (byvalue nodescriptor linkage(cdecl))
     external('XFillArcs');

 dcl XFillPolygon
     entry (handle Display                  /* display */,
            type Drawable                   /* d */,
            type GC                         /* gc */,
            handle XPoint                   /* points */,
            fixed bin(31)                   /* npoints */,
            fixed bin(31)                   /* shape */,
            fixed bin(31))                  /* mode */
     options (byvalue nodescriptor linkage(cdecl))
     external('XFillPolygon');

 dcl XFillRectangle
     entry (handle Display                  /* display */,
            type Drawable                   /* d */,
            type GC                         /* gc */,
            fixed bin(31)                   /* x */,
            fixed bin(31)                   /* y */,
            fixed bin(32) unsigned          /* width */,
            fixed bin(32) unsigned)         /* height */
     options (byvalue nodescriptor linkage(cdecl))
     external('XFillRectangle');

 dcl XFillRectangles
     entry (handle Display                  /* display */,
            type Drawable                   /* d */,
            type GC                         /* gc */,
            (*) type XRectangle byaddr      /* rectangles */,
            fixed bin(31))                  /* nrectangles */
     options (byvalue nodescriptor linkage(cdecl))
     external('XFillRectangles');

 dcl XFlush
     entry (handle Display)                 /* display */
     options (byvalue nodescriptor linkage(cdecl))
     external('XFlush');

 dcl XForceScreenSaver
     entry (handle Display                  /* display */,
            fixed bin(31))                  /* mode */
     options (byvalue nodescriptor linkage(cdecl))
     external('XForceScreenSaver');

 dcl XFree
     entry (pointer)                        /* data */
     options (byvalue nodescriptor linkage(cdecl))
     external('XFree');

 dcl XFreeColormap
     entry (handle Display                  /* display */,
            type XColormap)                 /* colormap */
     options (byvalue nodescriptor linkage(cdecl))
     external('XFreeColormap');

 dcl XFreeColors
     entry (handle Display                  /* display */,
            type XColormap                  /* colormap */,
            pointer                         /* pixels */,
            fixed bin(31)                   /* npixels */,
            fixed bin(32) unsigned)         /* planes */
     options (byvalue nodescriptor linkage(cdecl))
     external('XFreeColors');

 dcl XFreeCursor
     entry (handle Display                  /* display */,
            type Cursor)                    /* cursor */
     options (byvalue nodescriptor linkage(cdecl))
     external('XFreeCursor');

 dcl XFreeExtensionList
     entry ((*) pointer byaddr)             /* list */
     options (byvalue nodescriptor linkage(cdecl))
     external('XFreeExtensionList');

 dcl XFreeFont
     entry (handle Display                  /* display */,
            handle XFontStruct)             /* font_struct */
     options (byvalue nodescriptor linkage(cdecl))
     external('XFreeFont');

 dcl XFreeFontInfo entry (
        (*) pointer byaddr              /* names */,
        handle XFontStruct              /* free_info */,
        fixed bin(31))                  /* actual_count */
     options (byvalue nodescriptor linkage(cdecl))
     external('XFreeFontInfo');

 dcl XFreeFontNames
     entry ((*) pointer byaddr)             /* list */
     options (byvalue nodescriptor linkage(cdecl))
     external('XFreeFontNames');

 dcl XFreeFontPath
     entry ((*) pointer byaddr)             /* list */
     options (byvalue nodescriptor linkage(cdecl))
     external('XFreeFontPath');

 dcl XFreeGC
     entry (handle Display                  /* display */,
            type GC)                        /* gc */
     options (byvalue nodescriptor linkage(cdecl))
     external('XFreeGC');

 dcl XFreeModifiermap
     entry (handle XModifierKeymap)         /* modmap */
     options (byvalue nodescriptor linkage(cdecl))
     external('XFreeModifiermap');

 dcl XFreePixmap
     entry (handle Display                  /* display */,
            type Pixmap)                    /* pixmap */
     options (byvalue nodescriptor linkage(cdecl))
     external('XFreePixmap');

 dcl XGeometry
     entry (handle Display                  /* display */,
            fixed bin(31)                   /* screen */,
            char (*) varz nonasgn byaddr    /* position */,
            char (*) varz nonasgn byaddr    /* default_position */,
            fixed bin(31)                   /* bwidth */,
            fixed bin(31)                   /* fwidth */,
            fixed bin(31)                   /* fheight */,
            fixed bin(31)                   /* xadder */,
            fixed bin(31)                   /* yadder */,
            fixed bin(32) unsigned byaddr   /* x_return */,
            fixed bin(32) unsigned byaddr   /* y_return */,
            fixed bin(32) unsigned byaddr   /* width_return */,
            fixed bin(32) unsigned byaddr)  /* height_return */
     returns (fixed bin(31) byvalue optional)
     options (byvalue nodescriptor linkage(cdecl))
     external('XGeometry');

 dcl XGetErrorDatabaseText
     entry (handle Display                  /* display */,
            char (*) varz nonasgn byaddr    /* name */,
            char (*) varz nonasgn byaddr    /* message */,
            char (*) varz nonasgn byaddr    /* default_string */,
            char (*) varz byaddr            /* buffer_return */,
            fixed bin(31))                  /* length */
     options (byvalue nodescriptor linkage(cdecl))
     external('XGetErrorDatabaseText');

 dcl XGetErrorText
     entry (handle Display                  /* display */,
            fixed bin(31)                   /* code */,
            char (*) varz byaddr            /* buffer_return */,
            fixed bin(31))                  /* length */
     options (byvalue nodescriptor linkage(cdecl))
     external('XGetErrorText');

 dcl XGetFontProperty
     entry (handle XFontStruct              /* font_struct */,
            type XAtom                      /* atom */,
            fixed bin(31) byaddr)           /* value_return */
     returns (byvalue optional fixed bin(31))
     options (byvalue nodescriptor linkage(cdecl))
     external('XGetFontProperty');

 dcl XGetGCValues
     entry (handle Display                  /* display */,
            type GC                         /* gc */,
            fixed bin(32) unsigned          /* valuemask */,
            type XGCValues byaddr)          /* values_return */
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XGetGCValues');

 dcl XGetGeometry
     entry (handle Display                  /* display */,
            type Drawable                   /* d */,
            type Window byaddr              /* root_return */,
            fixed bin(31) byaddr            /* x_return */,
            fixed bin(31) byaddr            /* y_return */,
            fixed bin(32) unsigned byaddr   /* width_return */,
            fixed bin(32) unsigned byaddr   /* height_return */,
            fixed bin(31) byaddr            /* border_width_return */,
            fixed bin(31) byaddr)           /* depth_return */
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XGetGeometry');

 dcl XGetIconName
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            pointer byaddr)                 /* icon_name_return */
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XGetIconName');

 dcl XGetInputFocus
     entry (handle Display                  /* display */,
            type Window byaddr              /* focus_return */,
            fixed bin(31) byaddr)           /* revert_to_return */
     options (byvalue nodescriptor linkage(cdecl))
     external('XGetInputFocus');

 dcl XGetKeyboardControl
     entry (handle Display                  /* display */,
            type XKeyboardState byaddr)     /* values_return */
     options (byvalue nodescriptor linkage(cdecl))
     external('XGetKeyboardControl');

 dcl XGetPointerControl
     entry (handle Display                  /* display */,
            fixed bin(31) byaddr         /* accel_numerator_return */,
            fixed bin(31) byaddr         /* accel_denominator_return */,
            fixed bin(31) byaddr)           /* threshold_return */
     options (byvalue nodescriptor linkage(cdecl))
     external('XGetPointerControl');

 dcl XGetPointerMapping
     entry (handle Display                  /* display */,
            char (*) varz byaddr            /* map_return */,
            fixed bin(31))                  /* nmap */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XGetPointerMapping');

 dcl XGetScreenSaver
     entry (handle Display                  /* display */,
            fixed bin(31) byaddr            /* timeout_return */,
            fixed bin(31) byaddr            /* interval_return */,
            fixed bin(31) byaddr            /* prefer_blanking_return*/,
            fixed bin(31) byaddr)           /* allow_exposures_return*/
     options (byvalue nodescriptor linkage(cdecl))
     external('XGetScreenSaver');

 dcl XGetTransientForHint
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            type Window byaddr)             /* prop_window_return */
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XGetTransientForHint');

 dcl XGetWindowProperty
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            type XAtom                      /* property */,
            fixed bin(31)                   /* long_offset */,
            fixed bin(31)                   /* long_length */,
            fixed bin(31)                   /* delete */,
            type XAtom                      /* req_type */,
            type XAtom byaddr               /* actual_type_return */,
            fixed bin(31) byaddr            /* actual_format_return */,
            fixed bin(32) unsigned byaddr   /* nitems_return */,
            fixed bin(32) unsigned byaddr   /* bytes_after_return */,
            pointer byaddr)                 /* prop_return*/
     returns (fixed bin(31) byvalue optional)
     options (byvalue nodescriptor linkage(cdecl))
     external('XGetWindowProperty');

 dcl XGetWindowAttributes
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            type XWindowAttributes byaddr) /* window_attributes_return*/
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XGetWindowAttributes');

 dcl XGrabButton
     entry (handle Display                  /* display */,
            fixed bin(31)                   /* button */,
            fixed bin(31)                   /* modifiers */,
            type Window                     /* grab_window */,
            fixed bin(31)                   /* owner_events */,
            fixed bin(31)                   /* event_mask */,
            fixed bin(31)                   /* pointer_mode */,
            fixed bin(31)                   /* keyboard_mode */,
            type Window                     /* confine_to */,
            type Cursor)                    /* cursor */
     options (byvalue nodescriptor linkage(cdecl))
     external('XGrabButton');

 dcl XGrabKey
     entry (handle Display                  /* display */,
            fixed bin(31)                   /* keycode */,
            fixed bin(31)                   /* modifiers */,
            type Window                     /* grab_window */,
            fixed bin(31)                   /* owner_events */,
            fixed bin(31)                   /* pointer_mode */,
            fixed bin(31))                  /* keyboard_mode */
     options (byvalue nodescriptor linkage(cdecl))
     external('XGrabKey');

 dcl XGrabKeyboard
     entry (handle Display                  /* display */,
            type Window                     /* grab_window */,
            fixed bin(31)                   /* owner_events */,
            fixed bin(31)                   /* pointer_mode */,
            fixed bin(31)                   /* keyboard_mode */,
            type Time)                      /* time */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XGrabKeyboard');

 dcl XGrabPointer
     entry (handle Display                  /* display */,
            type Window                     /* grab_window */,
            fixed bin(31)                   /* owner_events */,
            fixed bin(32) unsigned          /* event_mask */,
            fixed bin(31)                   /* pointer_mode */,
            fixed bin(31)                   /* keyboard_mode */,
            type Window                     /* confine_to */,
            type Cursor                     /* cursor */,
            type Time)                      /* time */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XGrabPointer');

 dcl XGrabServer
     entry (handle Display)                 /* display */
     options (byvalue nodescriptor linkage(cdecl))
     external('XGrabServer');

 dcl XHeightMMOfScreen
     entry (handle Screen)                  /* screen */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XHeightMMOfScreen');

 dcl XHeightOfScreen
     entry (handle Screen)                  /* screen */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XHeightOfScreen');

 dcl XIfEvent
     entry (handle Display                  /* display */,
            handle XEvent                   /* event_return */,
            entry (                         /* predicate */
                   handle Display           /* display */,
                   handle XEvent            /* event */,
                   type   XPointer)         /* arg */
                  returns (fixed bin(31) byvalue optional)
                  options (byvalue nodescriptor linkage(cdecl)) limited,
            type XPointer)                  /* arg */
     options (byvalue nodescriptor linkage(cdecl))
     external('XIfEvent');

 dcl XImageByteOrder
     entry (handle Display)                 /* display */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XImageByteOrder');

 dcl XInstallColormap
     entry (handle Display                  /* display */,
            type XColormap)                 /* colormap */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XInstallColormap');

 dcl XKeysymToKeycode
     entry (handle Display                  /* display */,
            type KeySym)                    /* keysym */
     returns (byvalue optional type KeyCode)
     options (byvalue nodescriptor linkage(cdecl))
     external('XKeysymToKeycode');

 dcl XKillClient
     entry (handle Display                  /* display */,
            type XID)                       /* resource */
     options (byvalue nodescriptor linkage(cdecl))
     external('XKillClient');

 dcl XLookupColor
     entry (handle Display                  /* display */,
            type XColormap                  /* colormap */,
            char (*) varz nonasgn byaddr    /* color_name */,
            type XColor byaddr              /* exact_def_return */,
            type XColor byaddr)             /* screen_def_return */
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XLookupColor');

 dcl XLowerWindow
     entry (handle Display                  /* display */,
            type Window)                    /* w */
     options (byvalue nodescriptor linkage(cdecl))
     external('XLowerWindow');

 dcl XMapRaised
     entry (handle Display                  /* display */,
            type Window)                    /* w */
     options (byvalue nodescriptor linkage(cdecl))
     external('XMapRaised');

 dcl XMapSubwindows
     entry (handle Display                  /* display */,
            type Window)                    /* w */
     options (byvalue nodescriptor linkage(cdecl))
     external('XMapSubwindows');

 dcl XMapWindow
     entry (handle Display                  /* display */,
            type Window)                    /* w */
     options (byvalue nodescriptor linkage(cdecl))
     external('XMapWindow');

 dcl XMaskEvent
     entry (handle Display                  /* display */,
            fixed bin(31)                   /* event_mask */,
            handle Xevent)                  /* event_return */
     options (byvalue nodescriptor linkage(cdecl))
     external('XMaskEvent');

 dcl XMaxCmapsOfScreen
     entry (handle Screen)                  /* screen */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XMaxCmapsOfScreen');

 dcl XMinCmapsOfScreen
     entry (handle Screen)                  /* screen */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XMinCmapsOfScreen');

 dcl XMoveResizeWindow
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            fixed bin(31)                   /* x */,
            fixed bin(31)                   /* y */,
            fixed bin(32) unsigned          /* width */,
            fixed bin(32) unsigned)         /* height */
     options (byvalue nodescriptor linkage(cdecl))
     external('XMoveResizeWindow');

 dcl XMoveWindow
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            fixed bin(31)                   /* x */,
            fixed bin(31))                  /* y */
     options (byvalue nodescriptor linkage(cdecl))
     external('XMoveWindow');

 dcl XNextEvent
     entry (handle Display                  /* display */,
            handle Xevent)                  /* event_return */
     options (byvalue nodescriptor linkage(cdecl))
     external('XNextEvent');

 dcl XNoOp
     entry (handle Display)                 /* display */
     options (byvalue nodescriptor linkage(cdecl))
     external('XNoOp');

 dcl XParseColor
     entry (handle Display                  /* display */,
            type XColormap                  /* colormap */,
            char (*) varz nonasgn byaddr    /* spec */,
            type XColor byaddr)             /* exact_def_return */
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XParseColor');

 dcl XParseGeometry
     entry (char (*) varz nonasgn byaddr    /* parsestring */,
            fixed bin(31) byaddr            /* x_return */,
            fixed bin(31) byaddr            /* y_return */,
            fixed bin(32) unsigned byaddr   /* width_return */,
            fixed bin(32) unsigned byaddr)  /* height_return */
     returns (fixed bin(31) byvalue optional)
     options (byvalue nodescriptor linkage(cdecl))
     external('XParseGeometry');

 dcl XPeekEvent
     entry (handle Display                  /* display */,
            handle Xevent)                  /* event_return */
     options (byvalue nodescriptor linkage(cdecl))
     external('XPeekEvent');

 dcl XPeekIfEvent
     entry (handle Display                  /* display */,
            handle XEvent                   /* event_return */,
            entry (                         /* predicate */
                   handle Display           /* display */,
                   handle XEvent            /* event */,
                   type   XPointer)         /* arg */
                  returns (fixed bin(31) byvalue optional)
                  options (byvalue nodescriptor linkage(cdecl)) limited,
            type XPointer)                  /* arg */
     options (byvalue nodescriptor linkage(cdecl))
     external('XPeekIfEvent');

 dcl XPending
     entry (handle Display)                 /* display */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XPending');

 dcl XPlanesOfScreen
     entry (handle Screen)                  /* screen */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XPlanesOfScreen');

 dcl XProtocolRevision
     entry (handle Display)                 /* display */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XProtocolRevision');

 dcl XProtocolVersion
     entry (handle Display)                 /* display */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XProtocolVersion');

 dcl XPutBackEvent
     entry (handle Display                  /* display */,
            handle Xevent)                  /* event */
     options (byvalue nodescriptor linkage(cdecl))
     external('XPutBackEvent');

 dcl XPutImage
     entry (handle Display                  /* display */,
            type Drawable                   /* d */,
            type GC                         /* gc */,
            handle XImage                   /* image */,
            fixed bin(31)                   /* src_x */,
            fixed bin(31)                   /* src_y */,
            fixed bin(31)                   /* dest_x */,
            fixed bin(31)                   /* dest_y */,
            fixed bin(32) unsigned          /* width */,
            fixed bin(32) unsigned)         /* height */
     options (byvalue nodescriptor linkage(cdecl))
     external('XPutImage');

 dcl XQLength
     entry (handle Display)                 /* display */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XQLength');

 dcl XQueryBestCursor
     entry (handle Display                  /* display */,
            type Drawable                   /* d */,
            fixed bin(32) unsigned          /* width */,
            fixed bin(32) unsigned          /* height */,
            fixed bin(32) unsigned byaddr   /* width_return */,
            fixed bin(32) unsigned byaddr)  /* height_return */
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XQueryBestCursor');

 dcl XQueryBestSize
     entry (handle Display                  /* display */,
            fixed bin(31)                   /* class */,
            type Drawable                   /* which_screen */,
            fixed bin(32) unsigned          /* width */,
            fixed bin(32) unsigned          /* height */,
            fixed bin(32) unsigned byaddr   /* width_return */,
            fixed bin(32) unsigned byaddr)  /* height_return */
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XQueryBestSize');

 dcl XQueryBestStipple
     entry (handle Display                  /* display */,
            type Drawable                   /* which_screen */,
            fixed bin(32) unsigned          /* width */,
            fixed bin(32) unsigned          /* height */,
            fixed bin(32) unsigned byaddr   /* width_return */,
            fixed bin(32) unsigned byaddr)  /* height_return */
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XQueryBestStipple');

 dcl XQueryBestTile
     entry (handle Display                  /* display */,
            type Drawable                   /* which_screen */,
            fixed bin(32) unsigned          /* width */,
            fixed bin(32) unsigned          /* height */,
            fixed bin(32) unsigned byaddr   /* width_return */,
            fixed bin(32) unsigned byaddr)  /* height_return */
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XQueryBestTile');

 dcl XQueryColor
     entry (handle Display                  /* display */,
            type XColormap                  /* colormap */,
            type XColor byaddr)             /* def_in_out */
     options (byvalue nodescriptor linkage(cdecl))
     external('XQueryColor');

 dcl XQueryColors
     entry (handle Display                  /* display */,
            type XColormap                  /* colormap */,
            type XColor byaddr              /* defs_in_out */,
            fixed bin(31))                  /* ncolors */
     options (byvalue nodescriptor linkage(cdecl))
     external('XQueryColors');

 dcl XQueryExtension
     entry (handle Display                  /* display */,
            char (*) varz nonasgn byaddr    /* name */,
            fixed bin(31) byaddr            /* major_opcode_return */,
            fixed bin(31) byaddr            /* first_event_return */,
            fixed bin(31) byaddr)           /* first_error_return */
     returns (byvalue optional fixed bin(31))
     options (byvalue nodescriptor linkage(cdecl))
     external('XQueryExtension');

 dcl XQueryKeymap
     entry (handle Display                  /* display */,
            char(32-1) varz)                /* keys_return */
     options (byvalue nodescriptor linkage(cdecl))
     external('XQueryKeymap');

 dcl XQueryPointer
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            type Window byaddr              /* root_return */,
            type Window byaddr              /* child_return */,
            fixed bin(31) byaddr            /* root_x_return */,
            fixed bin(31) byaddr            /* root_y_return */,
            fixed bin(31) byaddr            /* win_x_return */,
            fixed bin(31) byaddr            /* win_y_return */,
            fixed bin(32) unsigned byaddr)  /* mask_return */
     returns (byvalue optional fixed bin(31))
     options (byvalue nodescriptor linkage(cdecl))
     external('XQueryPointer');

 dcl XQueryTextExtents
     entry (handle Display                  /* display */,
            type XID                        /* font_ID */,
            char (*) varz nonasgn byaddr    /* string */,
            fixed bin(31)                   /* nchars */,
            fixed bin(31) byaddr            /* direction_return */,
            fixed bin(31) byaddr            /* font_ascent_return */,
            fixed bin(31) byaddr            /* font_descent_return */,
            handle XCharStruct)             /* overall_return */
     options (byvalue nodescriptor linkage(cdecl))
     external('XQueryTextExtents');

 dcl XQueryTextExtents16
     entry (handle Display                  /* display */,
            type XID                        /* font_ID */,
            handle XChar2b                  /* string */,
            fixed bin(31)                   /* nchars */,
            fixed bin(31) byaddr            /* direction_return */,
            fixed bin(31) byaddr            /* font_ascent_return */,
            fixed bin(31) byaddr            /* font_descent_return */,
            handle XCharStruct)             /* overall_return */
     options (byvalue nodescriptor linkage(cdecl))
     external('XQueryTextExtents16');

 dcl XQueryTree
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            type Window byaddr              /* root_return */,
            type Window byaddr              /* parent_return */,
            (*) pointer byaddr          /* children_return (->Window)*/,
            fixed bin(31) byaddr)           /* nchildren_return */
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XQueryTree');

 dcl XRaiseWindow
     entry (handle Display                  /* display */,
            type Window)                    /* w */
     options (byvalue nodescriptor linkage(cdecl))
     external('XRaiseWindow');

 dcl XReadBitmapFile
     entry (handle Display                  /* display */,
            type Drawable                   /* d */,
            char (*) varz nonasgn byaddr    /* filename */,
            fixed bin(32) unsigned byaddr   /* width_return */,
            fixed bin(32) unsigned byaddr   /* height_return */,
            type Pixmap byaddr              /* bitmap_return */,
            fixed bin(31) byaddr            /* x_hot_return */,
            fixed bin(31) byaddr)           /* y_hot_return */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XReadBitmapFile');

 dcl XRebindKeysym
     entry (handle Display                  /* display */,
            type KeySym                     /* keysym */,
            type KeySym byaddr              /* list */,
            fixed bin(31)                   /* mod_count */,
            char (*) varz nonasgn byaddr    /* string */,
            fixed bin(31))                  /* bytes_string */
     options (byvalue nodescriptor linkage(cdecl))
     external('XRebindKeysym');

 dcl XRecolorCursor
     entry (handle Display                  /* display */,
            type Cursor                     /* cursor */,
            type XColor byaddr              /* foreground_color */,
            type XColor byaddr)             /* background_color */
     options (byvalue nodescriptor linkage(cdecl))
     external('XRecolorCursor');

 dcl XRefreshKeyboardMapping
     entry (handle XMappingEvent)           /* event_map */
     options (byvalue nodescriptor linkage(cdecl))
     external('XRefreshKeyboardMapping');

 dcl XRemoveFromSaveSet
     entry (handle Display                  /* display */,
            type Window)                    /* w */
     options (byvalue nodescriptor linkage(cdecl))
     external('XRemoveFromSaveSet');

 dcl XRemoveHost
     entry (handle Display                  /* display */,
            type XHostAddress byaddr)       /* host */
     options (byvalue nodescriptor linkage(cdecl))
     external('XRemoveHost');

 dcl XRemoveHosts
     entry (handle Display                  /* display */,
            (*) type XHostAddress byaddr    /* hosts */,
            fixed bin(31))                  /* num_hosts */
     options (byvalue nodescriptor linkage(cdecl))
     external('XRemoveHosts');

 dcl XReparentWindow
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            type Window                     /* parent */,
            fixed bin(31)                   /* x */,
            fixed bin(31))                  /* y */
     options (byvalue nodescriptor linkage(cdecl))
     external('XReparentWindow');

 dcl XResetScreenSaver
     entry (handle Display)                 /* display */
     options (byvalue nodescriptor linkage(cdecl))
     external('XResetScreenSaver');

 dcl XResizeWindow
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            fixed bin(32) unsigned          /* width */,
            fixed bin(32) unsigned)         /* height */
     options (byvalue nodescriptor linkage(cdecl))
     external('XResizeWindow');

 dcl XRestackWindows
     entry (handle Display                  /* display */,
            (*) type Window byaddr          /* windows */,
            fixed bin(31))                  /* nwindows */
     options (byvalue nodescriptor linkage(cdecl))
     external('XRestackWindows');

 dcl XRotateBuffers
     entry (handle Display                  /* display */,
            fixed bin(31))                  /* rotate */
     options (byvalue nodescriptor linkage(cdecl))
     external('XRotateBuffers');

 dcl XRotateWindowProperties
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            (*) type XAtom byaddr           /* properties */,
            fixed bin(31)                   /* num_prop */,
            fixed bin(31))                  /* npositions */
     options (byvalue nodescriptor linkage(cdecl))
     external('XRotateWindowProperties');

 dcl XScreenCount
     entry (handle Display)                 /* display */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XScreenCount');

 dcl XSelectInput
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            fixed bin(31))                  /* event_mask */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSelectInput');

 dcl XSendEvent
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            fixed bin(31)                   /* propagate */,
            fixed bin(31)                   /* event_mask */,
            handle Xevent)                  /* event_send */
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XSendEvent');

 dcl XSetAccessControl
     entry (handle Display                  /* display */,
            fixed bin(31))                  /* mode */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetAccessControl');

 dcl XSetArcMode
     entry (handle Display                  /* display */,
            type GC                         /* gc */,
            fixed bin(31))                  /* arc_mode */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetArcMode');

 dcl XSetBackground
     entry (handle Display                  /* display */,
            type GC                         /* gc */,
            fixed bin(32) unsigned)         /* background */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetBackground');

 dcl XSetClipMask
     entry (handle Display                  /* display */,
            type GC                         /* gc */,
            type Pixmap)                    /* pixmap */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetClipMask');

 dcl XSetClipOrigin
     entry (handle Display                  /* display */,
            type GC                         /* gc */,
            fixed bin(31)                   /* clip_x_origin */,
            fixed bin(31))                  /* clip_y_origin */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetClipOrigin');

 dcl XSetClipRectangles
     entry (handle Display                  /* display */,
            type GC                         /* gc */,
            fixed bin(31)                   /* clip_x_origin */,
            fixed bin(31)                   /* clip_y_origin */,
            (*) type XRectangle byaddr      /* rectangles */,
            fixed bin(31)                   /* n */,
            fixed bin(31))                  /* ordering */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetClipRectangles');

 dcl XSetCloseDownMode
     entry (handle Display                  /* display */,
            fixed bin(31))                  /* close_mode */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetCloseDownMode');

 dcl XSetCommand
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            (*) pointer byaddr              /* argv */,
            fixed bin(31))                  /* argc */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetCommand');

 dcl XSetDashes
     entry (handle Display                  /* display */,
            type GC                         /* gc */,
            fixed bin(31)                   /* dash_offset */,
            char (*) varz nonasgn byaddr    /* dash_list */,
            fixed bin(31))                  /* n */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetDashes');

 dcl XSetFillRule
     entry (handle Display                  /* display */,
            type GC                         /* gc */,
            fixed bin(31))                  /* fill_rule */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetFillRule');

 dcl XSetFillStyle
     entry (handle Display                  /* display */,
            type GC                         /* gc */,
            fixed bin(31))                  /* fill_style */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetFillStyle');

 dcl XSetFont
     entry (handle Display                  /* display */,
            type GC                         /* gc */,
            type Font)                      /* font */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetFont');

 dcl XSetFontPath
     entry (handle Display                  /* display */,
            (*) pointer byaddr          /* directories (char(*)varz) */,
            fixed bin(31))                  /* ndirs */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetFontPath');

 dcl XSetForeground
     entry (handle Display                  /* display */,
            type GC                         /* gc */,
            fixed bin(32) unsigned)         /* foreground */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetForeground');

 dcl XSetFunction
     entry (handle Display                  /* display */,
            type GC                         /* gc */,
            fixed bin(31))                  /* function */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetFunction');

 dcl XSetGraphicsExposures
     entry (handle Display                  /* display */,
            type GC                         /* gc */,
            fixed bin(31))                  /* graphics_exposures */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetGraphicsExposures');

 dcl XSetIconName
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            char (*) varz nonasgn byaddr)   /* icon_name */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetIconName');

 dcl XSetInputFocus
     entry (handle Display                  /* display */,
            type Window                     /* focus */,
            fixed bin(31)                   /* revert_to */,
            type Time)                      /* time */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetInputFocus');

 dcl XSetLineAttributes
     entry (handle Display                  /* display */,
            type GC                         /* gc */,
            fixed bin(32) unsigned          /* line_width */,
            fixed bin(31)                   /* line_style */,
            fixed bin(31)                   /* cap_style */,
            fixed bin(31))                  /* join_style */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetLineAttributes');

 dcl XSetModifierMapping
     entry (handle Display                  /* display */,
            handle XModifierKeymap)         /* modmap */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetModifierMapping');

 dcl XSetPlaneMask
     entry (handle Display                  /* display */,
            type GC                         /* gc */,
            fixed bin(32) unsigned)         /* plane_mask */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetPlaneMask');

 dcl XSetPointerMapping
     entry (handle Display                  /* display */,
            pointer                         /* map */,
            fixed bin(31))                  /* nmap */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetPointerMapping');

 dcl XSetScreenSaver
     entry (handle Display                  /* display */,
            fixed bin(31)                   /* timeout */,
            fixed bin(31)                   /* interval */,
            fixed bin(31)                   /* prefer_blanking */,
            fixed bin(31))                  /* allow_exposures */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetScreenSaver');

 dcl XSetSelectionOwner
     entry (handle Display                  /* display */,
            type XAtom                      /* selection */,
            type Window                     /* owner */,
            type Time)                      /* time */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetSelectionOwner');

 dcl XSetState
     entry (handle Display                  /* display */,
            type GC                         /* gc */,
            fixed bin(31)                   /* foreground */,
            fixed bin(31)                   /* background */,
            fixed bin(31)                   /* function */,
            fixed bin(32) unsigned)         /* plane_mask */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetState');

 dcl XSetStipple
     entry (handle Display                  /* display */,
            type GC                         /* gc */,
            type Pixmap)                    /* stipple */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetStipple');

 dcl XSetSubwindowMode
     entry (handle Display                  /* display */,
            type GC                         /* gc */,
            fixed bin(31))                  /* subwindow_mode */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetSubwindowMode');

 dcl XSetTSOrigin
     entry (handle Display                  /* display */,
            type GC                         /* gc */,
            fixed bin(31)                   /* ts_x_origin */,
            fixed bin(31))                  /* ts_y_origin */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetTSOrigin');

 dcl XSetTile
     entry (handle Display                  /* display */,
            type GC                         /* gc */,
            type Pixmap)                    /* tile */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetTile');

 dcl XSetWindowBackground
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            fixed bin(32) unsigned)         /* background_pixel */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetWindowBackground');

 dcl XSetWindowBackgroundPixmap
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            type Pixmap)                    /* background_pixmap */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetWindowBackgroundPixmap');

 dcl XSetWindowBorder
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            fixed bin(32) unsigned)         /* border_pixel */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetWindowBorder');

 dcl XSetWindowBorderPixmap
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            type Pixmap)                    /* border_pixmap */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetWindowBorderPixmap');

 dcl XSetWindowBorderWidth
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            fixed bin(32) unsigned)         /* width */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetWindowBorderWidth');

 dcl XSetWindowColormap
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            type XColormap)                 /* colormap */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetWindowColormap');

 dcl XStoreBuffer
     entry (handle Display                  /* display */,
            pointer                         /* bytes */,
            fixed bin(31)                   /* nbytes */,
            fixed bin(31))                  /* buffer */
     options (byvalue nodescriptor linkage(cdecl))
     external('XStoreBuffer');

 dcl XStoreBytes
     entry (handle Display                  /* display */,
            pointer                         /* bytes */,
            fixed bin(31))                  /* nbytes */
     options (byvalue nodescriptor linkage(cdecl))
     external('XStoreBytes');

 dcl XStoreColor
     entry (handle Display                  /* display */,
            type XColormap                  /* colormap */,
            type XColor byaddr)             /* color */
     options (byvalue nodescriptor linkage(cdecl))
     external('XStoreColor');

 dcl XStoreColors
     entry (handle Display                  /* display */,
            type XColormap                  /* colormap */,
            type XColor byaddr              /* color */,
            fixed bin(31))                  /* ncolors */
     options (byvalue nodescriptor linkage(cdecl))
     external('XStoreColors');

 dcl XStoreName
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            char (*) varz nonasgn byaddr)   /* window_name */
     options (byvalue nodescriptor linkage(cdecl))
     external('XStoreName');

 dcl XStoreNamedColor
     entry (handle Display                  /* display */,
            type XColormap                  /* colormap */,
            char (*) varz nonasgn byaddr    /* color */,
            fixed bin(31)                   /* pixel */,
            fixed bin(31))                  /* flags */
     options (byvalue nodescriptor linkage(cdecl))
     external('XStoreNamedColor');

 dcl XSync
     entry (handle Display                  /* display */,
            fixed bin(31))                  /* discard */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSync');

 dcl XTextExtents
     entry (handle XFontStruct              /* font_struct */,
            char (*) varz nonasgn byaddr    /* string */,
            fixed bin(31)                   /* nchars */,
            fixed bin(31) byaddr            /* direction_return */,
            fixed bin(31) byaddr            /* font_ascent_return */,
            fixed bin(31) byaddr            /* font_descent_return */,
            handle XCharStruct)             /* overall_return */
     options (byvalue nodescriptor linkage(cdecl))
     external('XTextExtents');

 dcl XTextExtents16
     entry (handle XFontStruct              /* font_struct */,
            handle XChar2b                  /* string */,
            fixed bin(31)                   /* nchars */,
            fixed bin(31) byaddr            /* direction_return */,
            fixed bin(31) byaddr            /* font_ascent_return */,
            fixed bin(31) byaddr            /* font_descent_return */,
            handle XCharStruct)             /* overall_return */
     options (byvalue nodescriptor linkage(cdecl))
     external('XTextExtents16');

 dcl XTextWidth
     entry (handle XFontStruct              /* font_struct */,
            char (*) varz nonasgn byaddr    /* string */,
            fixed bin(31))                  /* count */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XTextWidth');

 dcl XTextWidth16
     entry (handle XFontStruct              /* font_struct */,
            handle XChar2b                  /* string */,
            fixed bin(31))                  /* count */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XTextWidth16');

 dcl XTranslateCoordinates
     entry (handle Display                  /* display */,
            type Window                     /* src_w */,
            type Window                     /* dest_w */,
            fixed bin(31)                   /* src_x */,
            fixed bin(31)                   /* src_y */,
            fixed bin(31) byaddr            /* dest_x_return */,
            fixed bin(31) byaddr            /* dest_y_return */,
            type Window byaddr)             /* child_return */
     returns (byvalue optional fixed bin(31))
     options (byvalue nodescriptor linkage(cdecl))
     external('XTranslateCoordinates');

 dcl XUndefineCursor
     entry (handle Display                  /* display */,
            type Window)                    /* w */
     options (byvalue nodescriptor linkage(cdecl))
     external('XUndefineCursor');

 dcl XUngrabButton
     entry (handle Display                  /* display */,
            fixed bin(31)                   /* button */,
            fixed bin(31)                   /* modifiers */,
            type Window)                    /* grab_window */
     options (byvalue nodescriptor linkage(cdecl))
     external('XUngrabButton');

 dcl XUngrabKey
     entry (handle Display                  /* display */,
            fixed bin(31)                   /* keycode */,
            fixed bin(31)                   /* modifiers */,
            type Window)                    /* grab_window */
     options (byvalue nodescriptor linkage(cdecl))
     external('XUngrabKey');

 dcl XUngrabKeyboard
     entry (handle Display                  /* display */,
            type Time)                      /* time */
     options (byvalue nodescriptor linkage(cdecl))
     external('XUngrabKeyboard');

 dcl XUngrabPointer
     entry (handle Display                  /* display */,
            type Time)                      /* time */
     options (byvalue nodescriptor linkage(cdecl))
     external('XUngrabPointer');

 dcl XUngrabServer
     entry (handle Display)                 /* display */
     options (byvalue nodescriptor linkage(cdecl))
     external('XUngrabServer');

 dcl XUninstallColormap
     entry (handle Display                  /* display */,
            type XColormap)                 /* colormap */
     options (byvalue nodescriptor linkage(cdecl))
     external('XUninstallColormap');

 dcl XUnloadFont
     entry (handle Display                  /* display */,
            type Font)                      /* font */
     options (byvalue nodescriptor linkage(cdecl))
     external('XUnloadFont');

 dcl XUnmapSubwindows entry (
        handle Display                  /* display */,
        type Window)                    /* w */
     options (byvalue nodescriptor linkage(cdecl))
     external('XUnmapSubwindows');

 dcl XUnmapWindow
     entry (handle Display                  /* display */,
            type Window)                    /* w */
     options (byvalue nodescriptor linkage(cdecl))
     external('XUnmapWindow');

 dcl XVendorRelease
     entry (handle Display)                 /* display */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XVendorRelease');

 dcl XWarpPointer
     entry (handle Display                  /* display */,
            type Window                     /* src_w */,
            type Window                     /* dest_w */,
            fixed bin(31)                   /* src_x */,
            fixed bin(31)                   /* src_y */,
            fixed bin(31)                   /* src_width */,
            fixed bin(31)                   /* src_height */,
            fixed bin(31)                   /* dest_x */,
            fixed bin(31))                  /* dest_y */
     options (byvalue nodescriptor linkage(cdecl))
     external('XWarpPointer');

 dcl XWidthMMOfScreen
     entry (handle Screen)                  /* screen */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XWidthMMOfScreen');

 dcl XWidthOfScreen
     entry (handle Screen)                  /* screen */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XWidthOfScreen');

 dcl XWindowEvent
     entry (handle Display                  /* display */,
            type Window                     /* w */,
            fixed bin(31)                   /* event_mask */,
            handle Xevent)                  /* event_return */
     options (byvalue nodescriptor linkage(cdecl))
     external('XWindowEvent');

 dcl XWriteBitmapFile
     entry (handle Display                  /* display */,
            char (*) varz nonasgn byaddr    /* filename */,
            type Pixmap                     /* bitmap */,
            fixed bin(32) unsigned          /* width */,
            fixed bin(32) unsigned          /* height */,
            fixed bin(31)                   /* x_hot */,
            fixed bin(31))                  /* y_hot */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XWriteBitmapFile');

 dcl XSupportsLocale
     entry ()
     returns (byvalue optional fixed bin(31))
     options (byvalue nodescriptor linkage(cdecl))
     external('XSupportsLocale');

 dcl XSetLocaleModifiers
     entry (char (*) varz nonasgn byaddr)   /* modifier_list */
     returns (pointer byvalue optional)     /* to char (*) varz */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetLocaleModifiers');

 dcl XCreateFontSet
     entry (handle Display                  /* display */,
            char (*) varz nonasgn byaddr    /* base_font_name_list */,
            pointer byaddr                  /* missing_charset_list */,
            fixed bin(31) byaddr            /* missing_charset_count */,
            pointer byaddr)                 /* def_string */
     returns (byvalue optional type XFontSet)
     options (byvalue nodescriptor linkage(cdecl))
     external('XCreateFontSet');

 dcl XFreeFontSet
     entry (handle Display                  /* display */,
            type XFontSet)                  /* font_set */
     options (byvalue nodescriptor linkage(cdecl))
     external('XFreeFontSet');

 dcl XFontsOfFontSet
     entry (type XFontSet                   /* font_set */,
            (*) type XFontStruct byaddr     /* font_struct_list */,
            pointer byaddr)                 /* font_name_list */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XFontsOfFontSet');

 dcl XBaseFontNameListOfFontSet
     entry (type XFontSet)                  /* font_set */
     returns (pointer byvalue)              /* to char (*) varz */
     options (byvalue nodescriptor linkage(cdecl))
     external('XBaseFontNameListOfFontSet');

 dcl XLocaleOfFontSet
     entry (type XFontSet)                  /* font_set */
     returns (pointer byvalue)              /* to char (*) varz */
     options (byvalue nodescriptor linkage(cdecl))
     external('XLocaleOfFontSet');

 dcl XContextDependentDrawing
     entry (type XFontSet)                  /* font_set */
     returns (byvalue optional fixed bin(31))
     options (byvalue nodescriptor linkage(cdecl))
     external('XContextDependentDrawing');

 dcl XExtentsOfFontSet
     entry (type XFontSet)                  /* font_set */
     returns (handle XFontSetExtents byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XExtentsOfFontSet');

 dcl XmbTextEscapement
     entry (type XFontSet                   /* font_set */,
            char (*) varz nonasgn byaddr    /* text */,
            fixed bin(31))                  /* bytes_text */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XmbTextEscapement');

 dcl XwcTextEscapement
     entry (type XFontSet                   /* font_set */,
            pointer                      /* text as (*) type wchar_t */,
            fixed bin(31))                  /* num_wchars */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XwcTextEscapement');

 dcl XmbTextExtents
     entry (type XFontSet                   /* font_set */,
            char (*) varz nonasgn byaddr    /* text */,
            fixed bin(31)                   /* bytes_text */,
            type XRectangle byaddr          /* overall_ink_return */,
            type XRectangle byaddr)         /* overall_logical_return */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XmbTextExtents');

 dcl XwcTextExtents
     entry (type XFontSet                   /* font_set */,
            pointer                      /* text as (*) type wchar_t */,
            fixed bin(31)                   /* num_wchars */,
            type XRectangle byaddr          /* overall_ink_return */,
            type XRectangle byaddr)         /* overall_logical_return */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XwcTextExtents');

 dcl XmbTextPerCharExtents
     entry (type XFontSet                   /* font_set */,
            char (*) varz nonasgn byaddr    /* text */,
            fixed bin(31)                   /* bytes_text */,
            (*) type XRectangle byaddr optional /* ink_extents_buffer*/,
            (*) type XRectangle byaddr optional
                                            /* logical_extents_buffer*/,
            fixed bin(31)                   /* buffer_size */,
            fixed bin(31) byaddr            /* num_chars */,
            type XRectangle byaddr          /* overall_ink_return */,
            type XRectangle byaddr)         /* overall_logical_return */
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XmbTextPerCharExtents');

 dcl XwcTextPerCharExtents
     entry (type XFontSet                   /* font_set */,
            pointer                      /* text as (*) type wchar_t */,
            fixed bin(31)                   /* num_wchars */,
            (*) type XRectangle byaddr optional /* ink_extents_buffer*/,
            (*) type XRectangle byaddr optional
                                            /* logical_extents_buffer*/,
            fixed bin(31)                   /* buffer_size */,
            fixed bin(31) byaddr            /* num_chars */,
            type XRectangle byaddr          /* overall_ink_return */,
            type XRectangle byaddr)         /* overall_logical_return*/
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XwcTextPerCharExtents');

 dcl XmbDrawText
     entry (handle Display                  /* display */,
            type Drawable                   /* d */,
            type GC                         /* gc */,
            fixed bin(31)                   /* x */,
            fixed bin(31)                   /* y */,
            handle XmbTextItem              /* text_items */,
            fixed bin(31))                  /* nitems */
     options (byvalue nodescriptor linkage(cdecl))
     external('XmbDrawText');

 dcl XwcDrawText
     entry (handle Display                  /* display */,
            type Drawable                   /* d */,
            type GC                         /* gc */,
            fixed bin(31)                   /* x */,
            fixed bin(31)                   /* y */,
            handle XwcTextItem              /* text_items */,
            fixed bin(31))                  /* nitems */
     options (byvalue nodescriptor linkage(cdecl))
     external('XwcDrawText');

 dcl XmbDrawString
     entry (handle Display                  /* display */,
            type Drawable                   /* d */,
            type XFontSet                   /* font_set */,
            type GC                         /* gc */,
            fixed bin(31)                   /* x */,
            fixed bin(31)                   /* y */,
            char (*) varz nonasgn byaddr    /* text */,
            fixed bin(31))                  /* bytes_text */
     options (byvalue nodescriptor linkage(cdecl))
     external('XmbDrawString');

 dcl XwcDrawString
     entry (handle Display                  /* display */,
            type Drawable                   /* d */,
            type XFontSet                   /* font_set */,
            type GC                         /* gc */,
            fixed bin(31)                   /* x */,
            fixed bin(31)                   /* y */,
            pointer                      /* text as (*) type wchar_t */,
            fixed bin(31))                  /* num_wchars */
     options (byvalue nodescriptor linkage(cdecl))
     external('XwcDrawString');

 dcl XmbDrawImageString
     entry (handle Display                  /* display */,
            type Drawable                   /* d */,
            type XFontSet                   /* font_set */,
            type GC                         /* gc */,
            fixed bin(31)                   /* x */,
            fixed bin(31)                   /* y */,
            char (*) varz nonasgn byaddr    /* text */,
            fixed bin(31))                  /* bytes_text */
     options (byvalue nodescriptor linkage(cdecl))
     external('XmbDrawImageString');

 dcl XwcDrawImageString
     entry (handle Display                  /* display */,
            type Drawable                   /* d */,
            type XFontSet                   /* font_set */,
            type GC                         /* gc */,
            fixed bin(31)                   /* x */,
            fixed bin(31)                   /* y */,
            pointer                      /* text as (*) type wchar_t */,
            fixed bin(31))                  /* num_wchars */
     options (byvalue nodescriptor linkage(cdecl))
     external('XwcDrawImageString');

 dcl XOpenIM
     entry (handle Display                  /* dpy */,
            pointer                         /* rdb */,
            char (*) varz byaddr            /* res_name */,
            char (*) varz byaddr)           /* res_class */
     returns (byvalue optional type XIM)
     options (byvalue nodescriptor linkage(cdecl))
     external('XOpenIM');

 dcl XCloseIM
     entry (type XIM)                       /* im */
     returns (byvalue optional type Status)
     options (byvalue nodescriptor linkage(cdecl))
     external('XCloseIM');

 dcl XGetIMValues
     entry (type XIM list)                  /* im */
     returns (pointer byvalue)      /* to char (*) varz */
     options (byvalue nodescriptor linkage(cdecl))
     external('XGetIMValues');

 dcl XDisplayOfIM
     entry (type XIM)                       /* im */
     returns (handle Display byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XDisplayOfIM');

 dcl XLocaleOfIM
     entry (type XIM)                       /* im*/
     returns (pointer byvalue)       /* to char (*) varz */
     options (byvalue nodescriptor linkage(cdecl))
     external('XLocaleOfIM');

 dcl XCreateIC
     entry (type XIM list)                  /* im */
     returns (byvalue optional type XIC)
     options (byvalue nodescriptor linkage(cdecl))
     external('XCreateIC');

 dcl XDestroyIC
     entry (type XIC)                       /* ic */
     options (byvalue nodescriptor linkage(cdecl))
     external('XDestroyIC');

 dcl XSetICFocus
     entry (type XIC)                       /* ic */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetICFocus');

 dcl XUnsetICFocus
     entry (type XIC)                       /* ic */
     options (byvalue nodescriptor linkage(cdecl))
     external('XUnsetICFocus');

 dcl XwcResetIC
     entry (type XIC)                       /* ic */
     returns (pointer byvalue)              /* to wchar_t string */
     options (byvalue nodescriptor linkage(cdecl))
     external('XwcResetIC');

 dcl XmbResetIC
     entry (type XIC)                       /* ic */
     returns (pointer byvalue)              /* to char (*) varz */
     options (byvalue nodescriptor linkage(cdecl))
     external('XmbResetIC');

 dcl XSetICValues
     entry (type XIC list)                  /* ic */
     returns (pointer byvalue optional)     /* to char (*) varz */
     options (byvalue nodescriptor linkage(cdecl))
     external('XSetICValues');

 dcl XGetICValues
     entry (type XIC list)                  /* ic */
     returns (pointer byvalue)              /* to char (*) varz */
     options (byvalue nodescriptor linkage(cdecl))
     external('XGetICValues');

 dcl XIMOfIC
     entry (type XIC)                       /* ic */
     returns (byvalue optional type XIM)
     options (byvalue nodescriptor linkage(cdecl))
     external('XIMOfIC');

 dcl XFilterEvent
     entry (handle Xevent                   /* event */,
            type Window)                    /* window */
     returns (byvalue optional fixed bin(31))
     options (byvalue nodescriptor linkage(cdecl))
     external('XFilterEvent');

 dcl XmbLookupString
     entry (type XIC                        /* ic */,
            handle XKeyPressedEvent         /* event */,
            char (*) varz byaddr            /* buffer_return */,
            fixed bin(31)                   /* bytes_buffer */,
            type KeySym byaddr              /* keysym_return */,
            type Status byaddr)             /* status_return */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XmbLookupString');

 dcl XwcLookupString
     entry (type XIC                        /* ic */,
            handle XKeyPressedEvent         /* event */,
            pointer            /* buffer_return, as (*) type wchar_t */,
            fixed bin(31)                   /* wchars_buffer */,
            type KeySym byaddr              /* keysym_return */,
            type Status byaddr)             /* status_return */
     returns (fixed bin(31) byvalue)
     options (byvalue nodescriptor linkage(cdecl))
     external('XwcLookupString');

 dcl XVaCreateNestedList
     entry (fixed bin(31) list)             /*unused*/
     returns (byvalue optional type XVaNestedList)
     options (byvalue nodescriptor linkage(cdecl))
     external('XVaCreateNestedList');
 %end; /* #XLIB_H_ */
