 /*********************************************************************/
 /* XCMCEXT.CPY                                                       */
 /*                                                                   */
 /* Purpose:                                                          */
 /* Specifies constants and data structures for CMC Common extensions */
 /*********************************************************************/


 %dcl #XCMCEXT_H char ext;
 %if #XCMCEXT_H = '' %then %do;
 %#XCMCEXT_H = 'Y';

 /* COMMON EXTENSIONS DECLARATIONS */

 dcl CMC_XS_COM               type CMC_uint32 value(0);

 /* FUNCTION EXTENSIONS */

 /* Query for extension support in implementation */
 dcl CMC_X_COM_SUPPORT_EXT    type CMC_uint32 value(16);

 define structure
   1 CMC_X_COM_support,
     2 item_code type CMC_uint32,
     2 flags     type CMC_flags;

 dcl CMC_X_COM_SUPPORTED          type CMC_flags value(1);
 dcl CMC_X_COM_NOT_SUPPORTED      type CMC_flags value(2);
 dcl CMC_X_COM_DATA_EXT_SUPPORTED type CMC_flags value(4);
 dcl CMC_X_COM_FUNC_EXT_SUPPORTED type CMC_flags value(8);
 dcl CMC_X_COM_SUP_EXCLUDE        type CMC_flags value(16);

 /* Get back a structure with configuration data */

 dcl CMC_X_COM_CONFIG_DATA        type CMC_uint32 value(17);

 define structure
   1 CMC_X_COM_configuration,
     2 ver_spec         type CMC_uint16,
     2 ver_implem       type CMC_uint16,
     2 character_set    pointer,          /* to CMC_object_identifier */
     2 line_term        type CMC_enum,
     2 default_service  type CMC_string,
     2 default_user     type CMC_string,
     2 req_password     type CMC_enum,
     2 req_service      type CMC_enum,
     2 req_user         type CMC_enum,
     2 ui_avail         type CMC_boolean,
     2 sup_nomkmsgread  type CMC_boolean,
     2 sup_counted_str  type CMC_boolean;


 /* Check to see if/when a recipient can be sent */
 dcl CMC_X_COM_CAN_SEND_RECIP type CMC_uint32 value(18);

 dcl CMC_X_COM_READY     type CMC_enum value(0);
 dcl CMC_X_COM_NOT_READY type CMC_enum value(1);
 dcl CMC_X_COM_DEFER     type CMC_enum value(2);

 /* Save a message to the inbox */

 dcl CMC_X_COM_SAVE_MESSAGE   type CMC_uint32 value(19);

 /* Get back a message structure for the message just sent */

 dcl CMC_X_COM_SENT_MESSAGE   type CMC_uint32 value(20);

 /* DATA EXTENSIONS */

 /* attach a receive date to message and message summary structures */
 dcl CMC_X_COM_TIME_RECEIVED  type CMC_uint32 value(128);

 /* attach a unique id to resolved recipient structures */
 dcl CMC_X_COM_RECIP_ID       type CMC_uint32 value(129);

 /* set character position in the message text to display an icon */
 /* associated with a particular attachment */

 dcl CMC_X_COM_ATTACH_CHARPOS type CMC_uint32 value(130);

 dcl CMC_X_COM_PRIORITY       type CMC_uint32 value(131);

 dcl CMC_X_COM_NORMAL   type CMC_enum value(0);
 dcl CMC_X_COM_URGENT   type CMC_enum value(1);
 dcl CMC_X_COM_LOW      type CMC_enum value(2);

 %end; /* _XCMCEXT_H */

