import java.awt.*;
import java.awt.event.*;
import java.lang.*;
import java.util.*;
import java.text.*;

/* Simple Java programs that calls PL/I program for wine info */

/* Main class definition */

public class wineSamp  extends java.applet.Applet
                       implements ActionListener
  {

    static {
                System.loadLibrary("wineCelr");
        }

    private Button DoitButton;
    private Button DetButton;
    private Button QuitButton;
    private Choice myChoice;
    private int flag;
    private Label strlabel;
    private List myList;
    String string1;
    DetailFrame detFrame;
    wineSamp myApp;
    static DebugObject dbObj = new DebugObject();

    public static native String[] GetWine( String string1, boolean myBool );


    /* wineSamp.init() method */

    public void init()
      {
       /* Creates a GridBagLayout for setting objects pos. on the panel */

       GridBagLayout gridbag = new GridBagLayout();
       GridBagConstraints c =  new GridBagConstraints();
       setLayout( gridbag );
       c.fill = GridBagConstraints.HORIZONTAL;
       c.insets = new Insets( 10,20,10,20 );
       c.weightx = 100;
       c.weighty = 100;

       /* Please choose a wine type */
       strlabel = new Label( "Please choose a wine type: " );
       c.gridx = 0;
       c.gridy = 0;
       c.gridwidth = 2;
       c.gridheight = 1;
       gridbag.setConstraints( strlabel,c );
       add(strlabel);


       /* drop down listbox */
       c.gridx = 0;
       c.gridy = 1;
       c.gridwidth = 1;
       c.gridheight = 1;
       myChoice = new Choice();
       gridbag.setConstraints( myChoice,c );
       add( myChoice );

       /* Select Wine */
       c.gridx = 1;
       c.gridy = 1;
       c.gridwidth = 1;
       c.gridheight = 1;
       DoitButton = new Button( "Select Wine" );
       gridbag.setConstraints( DoitButton,c );
       add( DoitButton );
       DoitButton.addActionListener( this );

       /* List box */
       c.gridx = 0;
       c.gridy = 2;
       c.gridwidth = 1;
       c.gridheight = 3;
       myList = new List( 5, false );
       gridbag.setConstraints( myList,c );
       add( myList );

       /* Get Details */
       c.gridx = 1;
       c.gridy = 2;
       c.gridwidth = 1;
       c.gridheight = 1;
       DetButton = new Button( "Get Details" );
       gridbag.setConstraints( DetButton,c );
       add( DetButton );
       DetButton.addActionListener( this );

       /* Quit button */
       c.gridx = 0;
       c.gridy = 5;
       c.gridwidth = 3;
       c.gridheight = 1;
       c.gridwidth=GridBagConstraints.REMAINDER;
       QuitButton = new Button( "Quit" );
       gridbag.setConstraints( QuitButton,c );
       add( QuitButton );
       QuitButton.addActionListener( this );

       /* add items to choice component */
       myChoice.addItem( "Cabernet"     );
       myChoice.addItem( "Champagne"    );
       myChoice.addItem( "Chardonnay"   );
       myChoice.addItem( "Merlot"       );
       myChoice.addItem( "Petite Syrah" );
       myChoice.addItem( "Pinot Noir"   );
       myChoice.addItem( "Zinfandel"    );
       myChoice.select( 0 );

       /* misc initilizations */
       DetButton.setEnabled( false );
       flag = 0;

  }



  /* wineSamp.actionPerformed() method */

  public void actionPerformed( ActionEvent evt )
    {
      int   pli_result;
      if ( evt.getSource() == DoitButton )
          getVariety();
      else if ( evt.getSource() == DetButton )
          getDetails();
      else if ( evt.getSource() == QuitButton ) {
          System.exit( 0 );
    }

            } /*end method*/

  public void getVariety()
    {

     int   pli_result;
     String delim = new String("?");

     /* get winetype from choice */
     string1 = myChoice.getSelectedItem();
     myList.removeAll();

     /* Call the PL/I Native Method */

     String[] string2 = GetWine( string1, dbObj.getDeBug(dbObj) );
     for (int z = 0;z<string2.length;z++ ){
           myList.addItem( string2[z].toString() );
     }

     myList.select( 0 );
     DetButton.setEnabled( true );
   } /*end method*/

   public void getDetails()
     {
      String string1 = new String("");

      string1 = myList.getSelectedItem();

      if (dbObj.getDeBug(dbObj)) {
            System.out.println
              ("from Java: Wine name selected is:         "
                +string1);
      }


      /* create and show the frame */
      detFrame = new DetailFrame( this, string1, dbObj);
      detFrame.setBounds( 40,20,450,350 );
      detFrame.show();

     } /*end method*/

   public void closeFrame()
     {
      detFrame.dispose();
     } /*send method*/

  /* wineSamp.main() method */

   public static void main( String args[])
     {
      wineSamp myApp = new wineSamp();
    Frame myFrame = new Frame( "Manipulate a String Using Native PL/I" );

      /* see if any args were passed */
      if (args.length > 0 ) {
        System.out.println("from Java: number of args = "+args.length );
        dbObj.setDeBug(dbObj,true);
        }

      // run the app
      myApp.init();
      myApp.start();

      //  add app to frame
      myFrame.add( "Center", myApp );

      //  resize and make it visible
      myFrame.setSize( 600, 400 );
      myFrame.show();
     }


} /*end class */


class DetailFrame extends java.awt.Frame
                  implements ActionListener
  {
    static {
                System.loadLibrary("wineCelr");
        }

    public static native DetailObject GetDet( String wstring);
    private wineSamp myApplet = null;

    private Button fQuitButton = new Button( "Close" );
    private Label pLabel = new Label( "Number of Bottles:" );
    private Label mLabel = new Label( "Date to be consumed:" );
    private String wString;
    private TextArea myComments = new TextArea( 12,40 );
    private TextField mdText = new TextField( "",6 );
    private TextField pdText = new TextField( "",6 );
    private int numBottles;
    private String matureYear;

    public DetailFrame
         ( wineSamp anApplet, String aString, DebugObject dbObj )
      {

       myApplet = anApplet;
       wString = aString;
       setTitle( wString.trim() );
       String[] string2 = new String[3];
       String delim = new String("?");
       DetailObject dobj = new DetailObject();

       Panel p1 = new Panel();
       p1.add( pLabel );
       p1.add( pdText );
       p1.add( mLabel );
       p1.add( mdText );
       add( p1,"North" );

       Panel p2 = new Panel();
       p2.add( myComments );
       add( p2,"Center" );

       Panel p3 = new Panel();
       p3.add( fQuitButton );
       fQuitButton.addActionListener( this );
       add( p3,"South" );

       DetailObject myDO = new DetailObject();
       myDO = GetDet( wString  );

       if (dbObj.getDeBug(dbObj)) {
           System.out.println
              ("from Java: Number of Bottles =            "
                 +myDO.getNBttl(myDO) );
           System.out.println
              ("from Java: Date of Maturity  =            "
                 +myDO.getCDate(myDO) );
           System.out.println
              ("from Java: Wine comments     =            "
                 +myDO.getDesc(myDO) );
       }

       numBottles = myDO.getNBttl(myDO);
       Integer IntBottles = new Integer(numBottles);

       matureYear = myDO.getCDate(myDO);

       pdText.setText( IntBottles.toString() );
       mdText.setText( matureYear );

       StringTokenizer st =
            new StringTokenizer( myDO.getDesc(myDO),delim );
       while ( st.hasMoreTokens() ) {
         myComments.append( st.nextToken()+"\n" );
       }

      }  /* end constructor */


  public void actionPerformed( ActionEvent evt )
    {
      if ( evt.getSource() == fQuitButton ) {
        myApplet.closeFrame();
      }
    } /* end method */


}  /* end class */


class DetailObject {

        int nBttl;
        String myDesc;
        String cDate;

        DetailObject (int innBttl, String incDate, String instrDesc) {
                myDesc = instrDesc;
                nBttl = innBttl;
                cDate = incDate;
        }

        int getNBttl(DetailObject myDO) {
                return(myDO.nBttl);
        }

        String getCDate(DetailObject myDO) {
                return(myDO.cDate);
        }

        String getDesc(DetailObject myDO) {
                return(myDO.myDesc);
        }


        DetailObject () {
        }


}  /* end class */

class DebugObject {

        public boolean deBug;

        DebugObject (){
                deBug = false;
        }

        boolean getDeBug(DebugObject myDB) {
                return(myDB.deBug);
        }
        void setDeBug(DebugObject myDB, boolean dbBool) {
                myDB.deBug = dbBool;
                if (this.getDeBug(this)) {
                  System.out.println
                   ("from Java: Debug mode is "+myDB.deBug );
                  }
        }


}  /* end class */
